package binary_translations;
use 5.010;
use strictures 2;
use utf8;

1;

################################################################################
#                                                                              #
# see kc.po and readme files                                                   #
#                                                                              #
################################################################################

sub data {
    return (
        'Version 1.02' => { tr => "V1.02 + TR v0.4.306" . ( $ENV{DEV_VERSION} ? "_$ENV{DEV_VERSION}" : "" ) },

        # strings that show up in textures
        "制空権喪失" => { tr_tex => "Air Disadvantage", desc => 'Air Incapability or Air Superiority Lost' },
        "制空権確保" => { tr_tex => "Air Secured", desc => 'Air Supremacy or Air Superiority Ensured' },
        "対潜攻撃" => { tr_tex => "ASW", desc => 'Anti-submarine attack or Anti-submarine warfare(ASW)' },
        "残日数り" => { tr_tex => "Days Remaining", desc => 'Left Over Number of Days | factory time cost' },
        "突撃（接近+砲撃）" => { tr_tex => "Assault (Approach + Shelling)", desc => 'Charge, increase accuracy while decreasing evasion' },
        "航空優勢" => { tr_tex => "Air Advantage", desc => 'Air Superiority' },
        "航空攻撃" => { tr_tex => "Aerial Attack", desc => 'Air Strike' },
        "護衛艦" => { tr_tex => "Escort", desc => "could use the word 'ship' in there, but too long, need font replacement" },

        # strings that are as text in various files
        "選択" => { tr   => "Select", desc => "explains numpad" },
        "提督コマンド" => { tr => "Admiral Command", desc => "usually opens quick menu or changes the buttons to an alternate set, Arsenal.UIHowToArsenal" },
        "戦略へ" => { tr => "Strategy", desc => "leads to fleet strategy management screen, Arsenal.UIHowToArsenal" },
        "決定" => { tr => "Choose", desc => "select the currently chosen option, Arsenal.UIHowToArsenal" },
        "戻る" => { tr => "Back",   desc => "back out of the current screen, Arsenal.UIHowToArsenal" },
        "戻る　　決定"             => { tr => "Back  Choose", },
        "選択　　戻る　　決定" => { tr => "Select  Back  Choose", },

        "作戦難易度を選択してください" => { tr => "Please select strategy difficulty level", },
        "タイトルに戻る"                      => { tr => "Back to Title", desc => "name choosing menu" },
        "提督名入力" => { tr => "Admiral Name Entry", desc => "name choosing menu title, not sure if this one is used" },

        "  貴官の提督名をお知らせ下さい。(" => { tr => "Please choose your Admiral's name. (Up to ", desc => "TODO: verify the space at the start" },
        "文字まで入力可能です)"                  => { tr => " characters can be entered.)" },
        "貴官の提督名をお知らせ下さい。\n（１２文字まで入力可能です）" => { tr => "Please choose your Admiral's name.\n(Up to 12 characters can be entered.)" },
        "ゲーム開始" => { tr => "Game Starters", desc => "title of game starter set selection screen" },
        "初期艦選択" => { tr => "Starter Ship Selection", desc => "not sure, think title of the screen after the set" },
        "チュートリアル" => { tr => "Tutorial" },
        "チュートリアルを行いますか？" => { tr => "Would you like to do the tutorial?" },

        "配備輸送船数" => { tr => "Transports",    desc => "Number of deployed shipping vessels, Cargo ships in area" },
        "予想獲得資源" => { tr => "Expected Gain", desc => "Expected acquisition resources (Daily Resource Generation) Fuel, Ammo, Steel, Bauxite per map hex" },
        "海上護衛艦隊" => { tr => "Escort fleet",  desc => "Maritime Escort Fleet" },
        "回航中"          => { tr => "At Sea",        desc => "map screen, tankers at sea, apparently, but also used elsewhere" },
        "未配備"          => { tr => "Undeployed",    desc => "Undeployed - one char too long, really need to add glyph aliasing here too" },

        # 艦隊   状態   艦種   艦船名    Lv    耐久   火力   対空   速カ
        # ship table headers
        "艦隊"    => { tr => "Fleet",     desc => "Fleet Number. Defines which fleet the ship is assigned to. try with adding space at begin for formatting. further adjustements pending results." },
        "状態"    => { tr => "State",     desc => "Status/Condition of current fleet (red is has acted, blue is on expedition, blue is (maybe) 'on deployment', and blue is at sea again)" },
        "艦種"    => { tr => "Class",     desc => "Ship Class - maybe 'Hull'" },
        "艦船名" => { tr => "Ship Name", desc => 'prefer "Ship Name" over "name" - requires font substitution.' },
        # Lv - Obviously no need to translate
        "耐久" => {
            tr   => "Health",
            desc => 'Use Health for clarity as it is already used in other locations. is easier to use "Health" if we can resize it slightly than it would be for changing all the previous uses.'
        },
        "火力" => { tr => "ATK",   desc => "Firepower or ATK, I am still shying from FP or ATK though - Seriosuly this should be easy. The Kanji is literally Fire and Power" },
        "対空" => { tr => "AA",    desc => "Anti-air or Air Defense" },
        "速力" => { tr => "Speed", desc => "Try Speed instead of SPD as I would like to check table formatting." },

        "火力 -10" => { tr => "FP -10", desc => "see 火力" },

        #[1:06 AM] Knofbep: the damage shows up 2nd to last column
        #[1:06 AM] Knofbep: next to the heart lock
        # https://cdn.discordapp.com/attachments/235919493686231051/522193240510693396/2018-12-11-182050.png
        # https://cdn.discordapp.com/attachments/235919493686231051/522203328923435018/2017-05-02-221035.jpg

        # this.Title.text = monthName.Length != 2 ? "新しい月、　　　　となりました！" : "新しい月、　　　となりました！";
        "新しい月、　　　　となりました！" =>
          { tr => "A new month,　　　　, is here!", desc => "the month is rendered as a separate string into the gap" },
        "新しい月、　　　となりました！" => { tr => "A new month,　　　, is here!", desc => "the month is rendered as a separate string into the gap" },
        "新しい週になりました！"             => { tr => "A new week is here!",             desc => "weekly resource bonus" },

        "ターンを終了しますか？" => { tr => "Do you want to end your turn?", desc => "Quick Turn End by hitting Square - performed on Operations Screen." },
        "ターン終了" => { tr => "End of Turn", desc => "Quick Turn End, hit Square to confirm" },
        "[12c112]ターン終了[-]" => { tr => "[12c112]End of Turn[-]", desc => "Quick Turn End, hit Square to confirm" },

        # Enemy Raiding
        # these are embedded in sharedassets5/Atlas_RaderHukidashi.tex
        # 護衛艦損傷！        - Escort ship damage! #
        # 輸送船×1隻喪失！    - Transport ship x 1 lost!
        # 輸送船×13隻喪失！   - Transport ship x 13 lost!, example 2
        "輸送船" => { tr => "Transport", desc => "could use the word 'ship' in there, but too long, need font replacement" },

        # Expedition completion screen (these are probably art)
        # 獲得ボーナス        - Acquisition bonus # can't find as text
        # 海域EXP            - Marine area EXP # can't find as text
        # （基本経験値）       -(Basic experience value) # only as part of a longer text in Assembly-CSharp\local\models\battle\BattleResultModel.cs
        "獲得アイテム" => { tr => "Earned items", desc => "followed by icons and numbers which don't need translation" },

        "敵艦隊"             => { desc => "" },

        # https://www.thoughtco.com/can-you-tell-me-the-old-names-of-the-months-2027868
        #this.monthFormat.MonthNames = new string[13]
        #{ "睦月", "如月", "弥生", "卯月", "皐月", "水無月", "文月", "葉月", "長月", "神無月", "霜月", "師走", string.Empty };
        "睦月"    => { tr => "Jan" },
        "如月"    => { tr => "Feb" },
        "弥生"    => { tr => "Mar" },
        "卯月"    => { tr => "Apr" },
        "皐月"    => { tr => "May" },
        "水無月" => { tr => "Jun" },
        "文月"    => { tr => "Jul" },
        "葉月"    => { tr => "Aug" },
        "長月"    => { tr => "Sep" },
        "神無月" => { tr => "Oct" },
        "霜月"    => { tr => "Nov" },
        "師走"    => { tr => "Dec" },

        #this.yearFormat = new Dictionary<string, string>()
        #{ {"0","零"},{"1","壱"},{"2","弐"},{"3","参"},{"4","肆"},{"5","伍"},{"6","陸"},{"7","質"},{"8","捌"},{"9","玖"},{"10","拾"} };
        "零" => { tr => "0" },
        "壱" => { tr => "1" },
        "弐" => { tr => "2" },
        "参" => { tr => "3" },
        "肆" => { tr => "4" },
        "伍" => { tr => "5" },
        "陸" => { tr => "6" },
        "質" => { tr => "7" },
        "捌" => { tr => "8" },
        "玖" => { tr => "9" },
        "拾" => { tr => "10" },

        "獲得アイテム:{0}" => { tr => "Earned items:{0}", desc => "tbh not sure where exactly this is" },

        # Map screen
        "どこに進む？" => { tr => "Where to now?", desc => q["Where do you want to go?" or " Where to now?", SortieMap.Defines] },

        # Battle formation screen
        "陣形を選択してください。" => { tr => "Please select the formation.", desc => "SortieMap.Defines" },
        "単縦陣"                            => { tr => "Line Ahead" },
        "複縦陣"                            => { tr => "Double Line" },
        "輪形陣"                            => { tr => "Diamond" },
        "梯形陣"                            => { tr => "Echelon" },
        "単横陣" =>
          { tr => "Line\nAbreast", desc => "these are all the accepted translations already. so yes. See if you can do a carriage return after Line ina all of these." },

        "獲得可能資材" => { tr => "Materials Available",      desc => '[OC] that means out of context and i reserve the right to edit later.' },
        "残り輸送船数" => { tr => "Ships Remaining",          desc => '[OC]' },
        "必要輸送船数" => { tr => "Required Number of Ships", desc => '[OC]' },

        # Compass fairy with magic hat
        # https://cdn.discordapp.com/attachments/235919493686231051/523259704890097675/2018-12-05-071704.png
        "らしんばんをまわしてね！" => { tr => "Spin the compass please!", desc => "a compass fairy text. these are in csharp, but the decompiler doesn't see them. maybe these could default to a cute way of speaking?" },
        # Compass fairy with bob haircut
        # https://cdn.discordapp.com/attachments/235919493686231051/523259707331313713/2018-12-05-102944.png
        "ここっ" => { tr => "Here!", desc => 'but with exertion' },
        "よーし、らしんばんまわすよー！" => { tr => "Alright, I'll spin the compass!" },
        "えいっ" => { tr => "Ey!", desc => q[it is a sound uttered/made when someone is exerting force, or throwing something. you would be best ignoring the "っ" for now. It is not a tsu. "つ" is. I am nt reallt set to explain sokuon and glottal stops.] },
        "それっ" => { tr => "Take that!", desc => q["Take That!" or "That!" - can also use "This". remember implied words. once more with the っ. (i think it could also be "There!")] },
        # Compass fairy with chick on head
        # https://cdn.discordapp.com/attachments/235919493686231051/523259713480163328/2018-12-13-232523.png
        "はやくはやくー！" =>
          { tr => "Hurry! Hurry!", desc => q[i may localize it a little better. "C'mon! Hurry up!" alternate, more localized. Kind of like it myself.] },
        "えいえいえーいっ" => { tr => "Here!\x{200B}\x{200B}\x{200B}", desc => 'I need to see it in use for flavour. Knofbath translation does not feel right at this time. since the tr was VERY short i added zero width spaces' },
        "とまれーっ" => { tr => "And Another One", desc => 'i will come back to this one. more context needed.' },
        # Compass fairy who is sleepy
        # https://cdn.discordapp.com/attachments/235919493686231051/523259716009328658/2018-12-14-010022.png
        "えー？らしんばん、まわすのー？" => { tr => "Uh? You want me to spin the compass?", desc => 'or "Spin The Compass Please" - this is extremely localized. for a more literal use, "What? Spin the compass." or maybe, "What? Spin The Compass Already."', },
        # https://cdn.discordapp.com/attachments/235919493686231051/523021829737283585/2018-12-14-010344.png
        "……ん" => { tr => "...un!", desc => 'grunt like sound - [Previous is Depriciated - and context matters : "Huh?" -  Literally "....n." - Maybe use "Wha?" [t intentioanlly omitted]]' },
        # https://cdn.discordapp.com/attachments/235919493686231051/523021901270876172/2018-12-14-010056.png
        "……あい" => { tr => "...huhn", desc => 'Literally "...ai" - Or, maybe she is just making a sound. I am going to play with this some.' },

        "※艦娘保有数が上限に近いため、新しい艦娘と邂逅できない可能性があります。" =>
          { tr => "※If you have too many Ship Girls, there is a chance of not getting a Ship Girl reward.", desc => 'Edited for consistency.' },
        "※艦娘保有数が上限に達しているため、新しい艦娘との邂逅はできません。" =>
          { tr => "※You have reached your limit of Ship Girls and can not accept your reward.", desc => 'red, ships full' },

        # https://cdn.discordapp.com/attachments/235919493686231051/523300790283272234/2018-12-14-194114.png
        # I want to point out, the symbol ※ is used as a Bullet Point Mark.
        # Example: https://i.imgur.com/Z6yQfbF.png

        "接近"                    => { tr => "Approach", desc => "BattleCommand.Hougeki" },
        "離脱"                    => { tr => "Escape", desc => 'BattleCommand.Taisen | Withdraw, Escape or Retreat' },
        "砲撃"                    => { tr => "Shelling", desc => 'BattleCommand.Raigeki | Bombard could work as well. ' },
        "雷撃"                    => { tr => "Torpedo", desc => 'BattleCommand.Ridatu | can be opener and closer if ships have right equipment or are high-level subs' },
        "回避"                    => { tr => "Evade", desc => 'BattleCommand.Kouku | no attack, Evasion' },
        "統射" => {
            tr   => "CShelling",
            desc => 'BattleCommand.Hougeki (logical-or) BattleCommand.Tousha | Tough one. It literally breaks down into Unified Archery. For now, I am going to go with Coordinated Shelling to see how it fits - Radar-coordinated Shelling'
        },
        "対潜" => { tr => "Anti-Sub",      desc => 'BattleCommand.Kaihi' },
        "突撃" => { tr => "Assault",      desc => 'BattleCommand.Tousha' },
        "航空" => { tr => "Anti-Air",      desc => 'BattleCommand.Totugeki' },
        #           ** I have updated these to reflect \resources\Textures\info6_set.tex.png ** these are final translations between 接近 and 統射

        "装備数が保有上限に達し開発できません" =>
          { tr => "Equipment storage full, can not develop any more.", desc => 'warning message when constructing ships' },
        "装備の保有上限に達しています" => { tr => "Equipment storage full.", desc => 'warning message when claiming ships' },
        "艦が保有上限に達し建造できません" =>
          { tr => "Ship Girl storage full, can not construct any more.", desc => 'warning message when constructing ships' },

        "[E2E2E2][12c112]旗艦提督室[-]への移動[-]" => { desc => 'flagship admirals |map screen tutorial' },
        "      ボタンで\n旗艦提督室へ移動せよ！" => { tr => "      Press button to move\nto the Admiral's Room!", desc => "map screen tutorial | I prefer Admiral's Office, but Admiral's Room is already established in 0.4 and previous." },
        "戦略コマンド"         => { tr => "Strategy Command",      desc => 'Command|map screen circle' },
        "艦隊情報"               => { tr => "Fleet Information",      desc => 'Information|map screen triangle' },
        "艦隊選択"               => { tr => "Fleet Selection",      desc => 'Selection|map screen left right d-pad' },
        "海域選択"               => { tr => "Region Selection",      desc => 'Sea Area Selection | Selection|map screen right stick' },
        "○○○○艦隊旗艦\n" => { tr => "○○○○Fleet Flagship",      desc => 'Fleet |map screen fleet name, no idea if the circles can be touched' },

        # "第1艦隊旗艦" => { desc => 'map screen fleet name, the first char is gonna be a bit tricky to identify, leaving as is for now' },
        "[E2E2E2]はじめての[12c112]任務[-]！[-]" => { tr => "First Mission\x{200B}\x{200B}\x{200B}",      desc => 'admiral room tutorial for factory' },
        "[e2e2e2]はじめての[12c112]配備[-][-]" =>
          { tr => "First Deployment",      desc => 'tutorial text found via text matching, the achievements indicate this should have an exclamation mark' },
        "[E2E2E2]はじめての[12c112]建造[-]！[-]" => { tr => "First Construction",      desc => 'tutorial text found via text matching' },
        "任務を受託せよ！"                    => { tr => "Take Charge Of The Mission!",      desc => 'or offie or duty or task | admiral room tutorial for factory' },
        "新規に       任務を受託可能です" => { tr => "You can accept    new assignments.                  ",      desc => 'quests' },
        "任務内容確認"                          => { tr => "Task Confirmation",      desc => 'Task Content Confirmation | quests' },
        "設定"                                      => { tr => "Set",      desc => 'settings' },
        "操作ガイド"                             => { tr => "Operation Guide",      desc => 'settings' },
        "ロック"                                   => { tr => "Lock",      desc => 'ship list' },
        "ソート"                                   => { tr => "Sort",      desc => 'ship list' },

        "高速建造"                          => { tr => "Instant Build",      desc => 'High speed construction | factory tutorial' },
        "[E2E2E2][12c112]高速建造[-]！[-]" => { tr => "Instant Build",      desc => 'High speed construction | factory tutorial' },

        "高速建造材を使い、\n建造を完了せよ！" => { tr => "Using an Instant Build Bucket, \nComplete Construction!", desc => 'High speed construction | factory tutorial' },

        "「はじめての建造！」 達成" => { tr => "First Construction Get!", desc => '' },
        "「はじめての任務！」 達成" => { tr => "First Mission Get!", desc => '' },
        "「はじめての配備！」 達成" => { tr => "First Deployment Get!", desc => '' },
        "「高速建造！」 達成" => { tr => "Instant Build Get!", desc => "High speed construction | " },
        "「任務完了！」 達成" => { tr => "Mission End Get!", desc => 'Mission is Over' },
        "「艦隊を編成！」 達成" => { tr => "Fleet Organization Get!", desc => '' },
        "「旗艦提督室への移動」 達成" => { tr => "Go to the Flagship Office Get!", desc => '' },
        "「作戦海域への出撃！」 達成" => { tr => "Region Sortie Get!", desc => '' },
        "「ターン終了」 達成" => { tr => "Turn End Get!", desc => 'End of Turn' },

        "旗艦提督室で\n任務達成を\r確認せよ！\n"                                                => { tr => "Check your Quests in the Admiral's Room!",      desc => '' },
        "[000000][0055aa]戦略ポイント[-]は、任務達成及び\n海域攻略などで手に入ります。\n\n[0055aa]工廠[-]での輸送船建造や、\r\n[0055aa]アイテム屋さん[-]でのアイテム購入で\n使用します。" => { tr => "Earn Strategy Points for Quests and successful strategy. Use them for construction of Transport Ships in the factory, or item purchase in the store.",      desc => '' },
        "[000000]敵反攻迎撃戦は、[0055aa]連合艦隊[-]で出撃可能です。\n[0055aa]連合艦隊[-]は、\r\n・前衛主力艦隊\r\n・決戦主力艦隊\nの二艦隊で編成されます。\n\nさらに艦隊が居る場合は、\rそれぞれに\n[115511]支援艦隊[-]を向かわせることが可能です。\r\n" => { tr => "Counterattack the enemy with the allied fleet. The battle is divided into two parts, Vanguard Fleet and Battle Fleet. In addition, it is possible to direct support to each part",      desc => 'This is very rough, and may change | TODO: remind me to look at this one in game.', partial => "Interception, sortie is possible with an [0055aa]Allied Fleet[-].\n[0055aa]Allied Fleet[-] is, \r\n" },

        "被弾回避率補正" => { tr => "Evasion adjustment", desc => 'Evade Correction | literal hit avoidance rate correction' },
        "攻撃命中率補正" => { tr => "Attack Hit% adjustment", desc => 'Air Correction | literal attack hit ratio correction' },
        "雷撃命中率補正" => { tr => "Torpedo Hit% adjustment", desc => 'Torpedo Correction | literal lightning shot hit ratio correction, but lightning shot(雷撃) is torpedo' },
        "海上護衛艦隊の対潜/対空能力:{0}\n" => { tr => "Maritime Escort Fleet ASW/AA skill: {0}\n", desc => "Anti-Sub/Anti-Air Escort Fleet Capacity: {0}\n | for raiding defense I think | not in the source code?" },
        "\t海上護衛艦隊(MemId:{0})は{1}のダメージ({2})" => { tr => "\tEscort Fleet (MemId:{0}) deals {1} damage({2})", desc => '??? TODO this looks very dangerous, verify ingame' },
        "海上護衛艦隊名海上護衛艦隊名" => { tr => "Maritime Escort Fleet Name Escort Fleet Name",      desc => '???' },
        "[000000][0055aa]海上護衛艦隊[-]の配備について" => { tr => "About [000000][0055aa]Maritime Escort Fleet[-] deployment",      desc => '??? TODO concerned about the missing closing tag' }, 

        "廃棄は □ボタンで行います" => { tr => "Press □ to discard", desc => "Disposal | Arsenal.TaskArsenalListManager . delete equipment with square"}, # the square is a special char. not sure if it belongs in the string or was a separator. There is also one for the circle, and triangle, and cross somewhere in the way the Vita works.
        "解体は □ボタンで行います" => { tr => "Press □ to demolish", desc => "Dismantle | Arsenal.TaskArsenalListManager . delete ships with square"},    # Repeat, it is a Playstation thing. do not confuse it with ロ, which anyone who has even basic Japanese knowlege would know.
        "[000000]鎮守府海域から離れた海域であるほど、\n[0055aa]回航[-]にかかる日数（ターン数）は多くなります。\r\n\n鎮守府海域以外の輸送船団や海上護衛艦隊への\r\n配備を解除した場合も、同じく回航状態となり\nます。" => { tr => "The more Regions away from your base, the more days (turns) required. If you cancel a Transportation or Escort Fleet, it will also be in a round trip.",      desc => '' },
        "[000000][0055AA]高速建造材[-]を保有している場合、\r\n同投入で[006400]高速建造[-]が可能です。\r\n\n艦娘の建造は、それが大型艦であるほど\r\n建造日数が掛かりますが、[0055aa]高速建造材[-]を\r\n用いることで、これを一瞬に短縮するこ\nとが\r可能です。\r\n[-]" => { tr => "If you have Instant Build materials, high speed construction is possible. Construction of a Ship Girl takes longer for larger ships, but using Instant Build can shorten that to immediate.",      desc => '' },
        "[000000]作戦海域への出撃時に、マップ上で [006400]Lボタン[-]\n切り替え\rによって、戦闘演出をカットして\n戦闘時間を短縮する\r[0055aa]戦闘ショートカット[-]が\n可能です。\n\n出撃&戦闘\rに慣れてきたら、ご活用ください。\nただし、未攻略海域の最深部、敵主力艦隊\nとの交戦は、戦闘ショートカットできません。[-]" =>{ tr => "When you are used to how a map works, you may use Battle Shortcut. By pressing the L-Shoulder button during the Sortie Map, you can shorten battle times. However, in fleet battles with new areas, Battle Shortcut may not be used.", desc => '' },
        "海域の輸送船団に海上護衛艦隊を配備することで、\r\n敵通商破壊部隊から輸送船を護ることが可能です。\n\nまた、輸送船団の規模に対して十分な護衛艦艇を\r\n配備することで、より安定した船団護衛が可能\nです。" => { tr => "",      desc => 'By deploying an Escort Fleet, it is possible to protect Transport Fleets from enemy raids. Also, the larger the Escort Fleet, the more effective it can be.' },
        "未配備の輸送船数:{0}(この海域への移動中:{1}) - 総数:{2}" => { tr => "Number of Transports:{0} (moving to this area: {1})  - Total number: {2}",      desc => 'Number of Undeployed Vessels:{0}(Moving to this Region:{1}) - Total' },
        "輸送船 x {0}" => { tr => "Transport Ships x {0}", desc => '' },
        "ロック済艦娘を" => { tr => "Ship Girl is locked",      desc => "literal 'Locked ship daughter'" },
        "艦隊司令部情報" => { tr => "Fleet Headquarters Intelligence",      desc => 'Information, Data' },
        "艦隊切替" => { tr => "Switch Fleet",      desc => 'Change to, Conversion' },
        "　ボタンで戦略コマンド\nを開き、艦隊出撃せよ！" => { tr => "Press button to open Strategy map, and Sortie the Fleet!",      desc => '' },
        "[000000][0055aa]輸送船[-]の配備について" => { tr => "About [000000][0055aa]Transport Ship[-] Deployment",      desc => "may also be Per or About | My context may be off, but OC this is how I am reading it. Depriciated 'About deployment of Transports' alternate 'About Transport deployment'" },
        "[66ccff]全艦種出撃可能[-]です。"=>{ tr => "[66ccff]All classes of ships may sortie.[-]",      desc => "Context? All Ships That Can Sortie? | Depriciated 'All ship types can sortie.' alternate with color codes '[66ccff]All ship types[-] can sortie.'" },

        "Inspectorで設定して使用します。" => { tr => "", desc => "not used in game, silences the scanner" },
        "Inspector上でイベントを設定する為に使用するのでスクリプトないでは使用しないでください" => { tr => "", desc => "not used in game, silences the scanner" },
        "Inspector上でボタンに設定する為に使用します" => { tr => "", desc => "not used in game, silences the scanner" },
        "Inspector上で使用します。" => { tr => "", desc => "not used in game, silences the scanner" },
        "Inspector上で使用します" => { tr => "", desc => "not used in game, silences the scanner" },
        "Inspector上で使用するメソッドです" => { tr => "", desc => "not used in game, silences the scanner" },
        "Inspector上で設定して使用したい...." => { tr => "", desc => "not used in game, silences the scanner" },
        "Inspector上で設定して使用します。" => { tr => "", desc => "not used in game, silences the scanner" },
        "Inspector上で設定して使用します" => { tr => "", desc => "not used in game, silences the scanner" },
        "Inspector上で選択して使用します." => { tr => "", desc => "not used in game, silences the scanner" },
        "Inspector上に設定して使用します" => { tr => "", desc => "not used in game, silences the scanner" },

        "艦隊は遠征中です"=>{ tr => "Fleet is on Expedition", desc => "UIShortCutMenu" },
        "艦隊を編成する必要があります"=>{ tr => "Organize a Fleet", desc => "UIPortFrame, UIShortCutMenu" },
        "撤退中の艦が含まれています"=>{ tr => "Withdrawing Ships Included", desc => "UIShortCutMenu" },
        "鎮守府海域でのみ選択可能です"=>{ tr => "Only selectable at Main Base", desc => "UIShortCutMenu" },
        "旗艦が工作艦である必要があります"=>{ tr => "Akashi must be your Flagship", desc => "Your Flagship must be a Repair Ship | UIShortCutMenu" },
        "決戦！ショートカット不可"=>{ tr => "Decisive Battle! Shortcut not available", desc => "UIShortCutSwitch" },
        "戦闘ショートカット"=>{ tr => "Battle Shortcut", desc => "UIShortCutSwitch" },
        "開発資材のインデックスが不正です"=>{ tr => "Invalid Development Material Index", desc => "Arsenal.Arsenal_DevKit" },
        "戦略ポイントのインデックスが不正です"=>{ tr => "Invalid Strategy Point Index", desc => "Arsenal.Arsenal_SPoint" },
        "輸送船を"=>{ tr => "Transport Ship", desc => "を is not translated | Arsenal.ArsenalTankerDialog" },
        "隻入手しました"=>{ tr => "Ships Acquired", desc => "隻 is a counter for ships. this could be very different, | Arsenal.ArsenalTankerDialog" },
        "艦がロックされています"=>{ tr => "Ship is locked", desc => "Arsenal.TaskArsenalListManager" },
        "ロックされている装備があります"=>{ tr => "Equipment is locked", desc => "Arsenal.TaskArsenalListManager" },
        "建造"=>{ tr => "Construction",      desc => "Constructed? | .Arsenal.TaskConstructManager",},
        "大型建造"=>{ tr => "LSC\x{200B}",      desc => "Large Ship Construction | .Arsenal.TaskConstructManager" },
        "開発"=>{ tr => "Development",      desc => ".Arsenal.TaskConstructManager",},
        "輸送船建造"=>{ tr => "Transport Construction",      desc => ".Arsenal.TaskConstructManager",},
        "戦略ポイントが不足しています"=>{ tr => "Insufficient Strategy Points.", desc => "Not Enough | .Arsenal.TaskConstructManager | probably the shop error when you don't have enough points to buy" },
        "解体  艦種  艦名　　　　　      Lv"=>{ tr => "Dismantle  Class  Name", desc => "Arsenal.TaskMainArsenalManager" },
        "廃棄      装備名　　　　　　　　　 レア"=>{ tr => "Disposal      Name　　　　　　　　　 Rarity", desc => "Arsenal.TaskMainArsenalManager" },
        "燃料"=>{ tr => "Fuel",      desc => "Arsenal.UiArsenalMaterialDialog",},
        "弾薬"=>{ tr => "Ammunition",      desc => "Arsenal.UiArsenalMaterialDialog",},
        "鋼材"=>{ tr => "Steel",      desc => "Arsenal.UiArsenalMaterialDialog",},
        "ボーキサイト"=>{ tr => "Bauxite",      desc => "Arsenal.UiArsenalMaterialDialog",},
        "高速建造材"=>{ tr => "Instant Construction Materials",      desc => "Arsenal.UIHowToArsenal",},
        "随伴艦の"=>{ tr => "Accompanying Ship", desc => "の indicates a posessive | Battle.Production.ProdEscortShipEvacuation" },
        "を護衛につけて戦場から退避させますか？"=>{ tr => "Escape from battle with Escorts?", desc => "rough | Battle.Production.ProdEscortShipEvacuation" },
        "『{0}』艦隊<br>旗艦「{1}」が<br>大破しました。"=>{ tr => qq[The Fleet Flagship "{1}" is wrecked.], desc => "Battle.Production.ProdFlagshipWreck" },
        "進撃は困難です……帰投します。"=>{ tr => "Advance is impossible……returning to base.", desc => "Battle.Production.ProdFlagshipWreck" },
        "敵反攻作戦 迎撃成功!!"=>{ tr => "Enemy counterattack interception successful!!", desc => "Battle.Production.ProdThalassocracy" },
        "「{0}」リクエスト中♪"=>{ tr => qq["{0}" requested♪], desc => "Furniture.JukeBox.UIJukeBoxMusicPlayingDialog" },
        "家具コインが不足しています"=>{ tr => "Not enough furniture coins", desc => "Furniture.JukeBox.UserInterfaceJukeBoxManager" },
        "購入 - {0} - "=>{ tr => "Purchase - {0} - ", desc => "InteriorStore.UIFurniturePurchaseDialog" },
        "不要"=>{ tr => "Do not", desc => "InteriorStore.UIFurniturePurchaseDialog" },
        "必要"=>{ tr => "Need",      desc => "Required | InteriorStore.UIFurniturePurchaseDialog",},
        "給糧艦「間宮」を使用しますか？"=>{ tr => qq[Use "Mamiya"?"\x{200B}\x{200B}\x{200B}\x{200B}], desc => qq[Do you wish to use "Mamiya"? | Organize.OrganizeTender] },
        "給糧艦「伊良湖」を使用しますか？"=>{ tr => qq[Use "Irako"?"\x{200B}\x{200B}\x{200B}\x{200B}\x{200B}], desc => qq[Do you wish to use "Irako"? | Organize.OrganizeTender] },
        "艦隊名を入力してください。（12文字まで）"=>{ tr => "Please enter fleet name. (Up to 12 characters)", desc => "Organize.TaskOrganizeTop" },
        "♪「" =>{ tr => qq[♪"] },
        "「" =>{ tr => qq["], desc => "Production.ProdBattleRewardItem" },
        "」を" =>{ tr => qq["\x{200B}], desc => "Production.ProdBattleRewardItem" },
        "」" =>{ tr => qq["], skip => 'a-csharp 2416038' },
        "入手しました。"=>{ tr => "Acquired",      desc => "Production.ProdBattleRewardItem" },
        "」を入手しました。" =>{ tr => qq[" acquired. ],      desc => "Production.ProdBattleRewardItem" },
        " 装備の開発に失敗しました。\n\n『開発資材』は消費しませんでした。" =>{ tr => "Equipment Development failed. \n\nNo development materials consumed.", desc => "Production.ProdReceiveSlotItem" },
        "部隊再編中…"=>{ tr => "Force edit repeated…",      desc => "??? | Production.ProdRevampReceiveItem" },
        "装備改修中…"=>{ tr => "Equipment renovation…",      desc => "??? | Production.ProdRevampReceiveItem" },
        "{0}に装備が改修更新されました！"=>{ tr => "{0} was updated!\x{200B}\x{200B}",      desc => "Production.ProdRevampReceiveItem" },
        "{0}に部隊再編完了！"=>{ tr => "{0} task completed!",      desc => "Production.ProdRevampReceiveItem" },
        "艦が保有上限に達しています" =>{ tr => "Maximum Ship Girl Limit Reached",      desc => "Scene.Duty.UserInterfaceDutyManager" },
        "装備が保有上限に達しています"=>{ tr => "Maximum Equipment Limit Reached",      desc => "Scene.Duty.UserInterfaceDutyManager" },
        "該当装備がロックされています" =>{ tr => "Corresponding equipment has been locked.", desc => "this is more accurate | Scene.Duty.UserInterfaceDutyManager" },
        "撤退中の艦を含んでいます"=>{ tr => "Contains Withdrawing Ships",      desc => "Strategy.DeckStateViews" },
        "補給対象の艦が居ません" =>{ tr => "No Ship To Supply",      desc => "Strategy.DeckStateViews" },
        "資源が不足しています"  =>{ tr => "Resources Are Low",      desc => "Strategy.DeckStateViews" },
        "撤退中の艦は入渠出来ません"=>{ tr => "A withdrawing ship can not dock",      desc => "Strategy.DeckStateViews" },
        "高速修復材を持っていません" =>{ tr => "No Instant Repair Materials Available",      desc => "Strategy.DeckStateViews" },
        "この海域には入渠ドックがありません"=>{ tr => "There is no dock in this region",      desc => "UIShortCutMenu, Strategy.DeckStateViews" },
        "入渠ドックに空きがありません"  =>{ tr => "No Space In Docks",      desc => "Strategy.DeckStateViews" },
        "艦隊の前方にうずしおが発生しました！"=>{ tr => "A maelstrom has appeared in front of the fleet!",      desc => "SortieMap.Defines" },
        "{0}x{1}\nを入手しました！"=>{ tr => "{0}x{1}\nGained!\x{200B}",      desc => "SortieMap.Defines" },
        "{0}x{1}を\n落としてしまいました…。"=>{ tr => "{0}x{1}\nHas been lost….",      desc => "SortieMap.Defines" },
        "{0}x{1}を\n落としてしまいました…。\n(電探が役立って、被害を抑えられた！)"=>{ tr => "{0}x{1}\nHas been lost…. \n(Radar used, damage mitigated!)",      desc => "SortieMap.Defines" },
        "気のせいだった。"=>{ tr => "Nothing happened.",      desc => "SortieMap.Defines" },
        "敵影を見ず。"=>{ tr => "Enemy not sighted.",      desc => "SortieMap.Defines",},
        "艦隊の針路を選択できます。\n提督、どちらの針路を選択しますか？"=>{tr=>"Plot the fleet's course.\nAdmiral, pick a course?",desc => "SortieMap.Defines | could be 'Admiral, which course do you prefer?'" },
        "水上偵察機による\n航空偵察を実施します。"=>{ tr => "Conducting reconnaissance with Scout Aircraft.",      desc => "SortieMap.Defines" },
        "大型飛行艇による\n航空偵察を実施します。"=>{ tr => "Conducting reconnaissance with Flying Boat.",      desc => "Large Sized Aircraft | SortieMap.Defines" },
        "航空偵察予定地点に到着しましたが、\n稼働偵察機がないため、偵察を中止します。"=>{ tr => "Arrived at scheduled Aerial Recon Zone. No active aircraft available. Cancelling reconnaissance.",      desc => "SortieMap.Defines" },
        "艦隊に洋上補給を行います。"=>{ tr => "Carrying out deployed fleet supply.",      desc => "SortieMap.Defines" },
        "艦隊針路\n選択可能!"=>{ tr => "Fleet Course Selection Possible!",      desc => "SortieMap.Defines" },

        "廃棄      装備名　　　　　　　　　 レア度"=>{ tr => "",      desc => '' },
        "この海域には入渠ドックがありません。" => { tr => "",      desc => '' },
        "[000000][006400]戦闘ショートカット[-]について[-]"=>{ tr => "",      desc => '' },
        "輸送船を1隻入手しました"=>{ tr => "",      desc => '' },
        "戦略コマンドから配備を\n選択し、輸送船や海上護衛\n艦隊を配備せよ！"=>{ tr => "",      desc => '' },
        "高速建造材を使用しますか？" => { tr => "",      desc => '' },
        "\n旗艦提督室ＢＧＭ" => { tr => "",      desc => '' },


        # https://cdn.discordapp.com/attachments/235919493686231051/523030725616992267/2018-12-14-005011.png
        "補給してよろしいですか？" => { tr => "Resupply with the following?", desc => 'this is more localized.' },
        "必要燃料数\r"                      => { tr => "Fuel Required",                desc => 'maybe "Needed"?' },
        "必要弾薬数\r"                      => {
            tr   => "Ammunition Required",
            desc => 'maybe "Needed". If after testing "Ammunition Required" does not fit well, switch to "Ammo Required". I would prefer to not be sloppy if we do not have to be though.'
        },
        "必要鋼材数\r\n\r必要燃料数\r\n修 復 日 数                    日\r\n\r\r高速修復材\r"
          => {tr => "必要鋼材数\r\n\rFuel Required\r\nDays To Repair                  d\r\n\r\r高速修復材\r"},
        "修 復 日 数\r　　　日　　　　日\n\r \n高速修復材\r" => {},
        "修 復 日 数                     日\r\n\r\n必要鋼材数\r\n\r\n必要燃料数\r\n\r\n高速修復材\r"
          => {tr => "Days To Repair                   d\r\n\r\n必要鋼材数\r\n\r\nFuel Required\r\n\r\n高速修復材\r",},
        "修 復 日 数                    日\r\n\r必要鋼材数\r\n\r必要燃料数\r\n\r高速修復材\r"
          => {tr => "Days To Repair                  d\r\n\r必要鋼材数\r\n\rFuel Required\r\n\r高速修復材\r",},
        "修 復 日 数\r          日  ▶ 　   日\n\r\n高速修復材\r              ▶" => {desc => "triangle and square here might be bunk"},
        "修 復 日 数\r　　　 日  ▶　　 日\n\r \n高速修復材\r              ▶" => {},
        "必要鋼材数\r\n\r\n必要燃料数\r\n\r\n\r修 復 日 数　　　　　　　 日\r\n\r\n高速修復材\r" => {},

        # the versions without numbers show up in a file that contains preset-data. it has a list of sheets
        # those have a name and a list of structures
        # those are data structures that have a name, a deck, an area and what looks like loot sets
        # decks appear to contain lists of sheets with lists of ships
        # i have not attempted to fully deparse that file beyond that
        "1.鎮守府海域攻略データ" => { tr => "1.Chinjufu Area Conquest Data",      desc => 'Confidence in this use low.'},
        "鎮守府海域攻略データ" => { tr => "Chinjufu Area Strategy Data",      desc => ''},
        "2.初期海域攻略データ1" => { tr => "2.Early Area Conquest Data1",      desc => 'also low confidence'},
        "初期海域攻略データ1" => {},
        "3.初期海域攻略データ2" => { tr => "3.Early Area Conquest Data3",      desc => 'still low confidence'},
        "初期海域攻略データ2" => {},
        "4.中期海域攻略データ1" => { tr => "4.Middle Area Conquest Data1",      desc => 'may be medium term also'},
        "中期海域攻略データ1" => { tr => "Middle Area Conquest Data1",      desc => 'may be medium term also'},
        "5.中期海域攻略データ2" => { tr => "5.Middle Area Conquest Data2",      desc => 'may be medium term also'},
        "中期海域攻略データ2" => { tr => "Middle Area Conquest Data2",      desc => 'may be medium term also'},
        "6.最強データ" => { tr => "6.Strongest Data",      desc => 'there is a possibility these refer to difficulty not time'},
        "最強データ" => { tr => "Strongest data",      desc => '' },

        "\n\n\r\n[000000]我が輸送船団が、敵の[aa0000]通商破壊部隊[-]に\n襲撃を受け始めました。\r\n\n輸送船団に海上護衛部隊を配備して、\r\n敵の[aa0000]通商破壊部隊[-]に備えましょう。\n\n" => {},
        "   戦略画面に移動し、\nターンを終了せよ" => {},
        " ドック開放キーが必要です。\r" => { tr => "", desc => "" },
        "ドック開放\tキー\r" => { tr => "Dock Release\tKey\r", desc => "as in make open to public | no idea if the tab here is real or code"},
        "ドック開放キーがありません" => { tr => "", desc => "" },
        " 艦隊数\r\n 艦娘数\r\n 装備アイテム数\r\n 備蓄可能 各資材量\r\n 総入渠ドック数\r\n 海域内ドック数\n 総工廠ドック数" => {},
        "(最大)" => { tr => "(Max)",      desc => 'as in maximum'},
        "1.突撃" => { tr => "1.Charge",      desc => 'normally shown as 突撃（接近+砲撃）'},
        "10cm連装高角砲" => { tr => "10cm Twin High-angle Gun Mount",      desc => 'http://kancolle.wikia.com/wiki/10cm_Twin_High-angle_Gun_Mount'},
        "12.7cm単装砲" => { tr => "12cm Single Gun Mount",      desc => 'http://kancolle.wikia.com/wiki/12cm_Single_Gun_Mount'},
        "12.7cm連装砲B型改二" => { tr => "12.7cm Twin Gun Mount Model B Kai 2",      desc => 'http://kancolle.wikia.com/wiki/12.7cm_Twin_Gun_Mount_Model_B_Kai_2'},
        "12.7cm連装高角砲(後期型)" => { tr => "12.7cm Twin High-angle Gun Mount (Late Model)",      desc => 'http://kancolle.wikia.com/wiki/12.7cm_Twin_High-angle_Gun_Mount_(Late_Model)'},
        "35.6cm連装砲(ダズル迷彩)" => { tr => "35.6cm Twin Gun Mount (Dazzle Camouflage)",      desc => 'http://kancolle.wikia.com/wiki/35.6cm_Twin_Gun_Mount_(Dazzle_Camouflage)'},
        "43cm連装砲" => { tr => "43cm Single Gun Mount",      desc => 'Not finding a 43cm variant in the wiki either'},
        "61cm三連装砲" => { tr => "61cm Triple Gun Mount",      desc => 'Not found in wiki'},
        "9999\n9999\n99　\n使用しない" => { tr => "Do not use\x{200B}",      desc => '' },
        "999隻" => { tr => "999Ship",      desc => 'this is a counter for ships' },
        "BGM設定可能" => { tr => "BGM Setting",      desc => 'technically BGMConfigure' },
        "Bismarck改" => { tr => "Bismark Kai",      desc => '改 means Revision - I have decided to keep it as Kai'},
        "Graf Zeppelin改" => { tr => "Graf Zepplin Kai",      desc => '改 means Revision'},
        "Iowa改" => { tr => "Iowa Kai",      desc => '改 means Revision'},
        "Libeccio改" => { tr => "Libeccio Kai",      desc => '改 means Revision'},
        "Prinz Eugen改" => { tr => "Prinz Eugen Kai",      desc => '改 means Revision'},
        "Roma改" => { tr => "Roma Kai",      desc => '改 means Revision'},
        "SAVE/LOAD は VITA PKG でのみ動作します。" => { tr => "only works with.\x{200B}\x{200B}\x{200B}\x{200B}\x{200B}\x{200B}\x{200B}",      desc => '' },
        "SAVE/LOAD は VITA PKG でのみ動作すると思います。" => { tr => "Think that only works with.",      desc => 'i do hope this is a garbage string'},
        "U-511改" => { tr => "U-511 Kai",      desc => '改 means Revision'},
        "W島攻略作戦" => {},
        "Z1改" => { tr => "Z1 Kai",      desc => '改 means Revision'},
        "Z3改" => { tr => "z3 Kai",      desc => '改 means Revision'},
        "[000000][0055aa]戦略ポイント[-]について" => {},
        "[000000][0055aa]資源獲得[-]について" => {},
        "[000000][0055aa]輸送船団[-]による[0055aa]資源獲得[-]には、上限が\r\nあります。備蓄の上限は、提督レベルの\n上昇に\rよって、少しずつ増加していきます。\n\n各[0055aa]資源[-]は備蓄の上限に達すると、数字が[FFCC00]黄色[-]\nで表示されます。[-]" => {},
        "[000000][0055aa]連合艦隊[-]による迎撃では、進撃判断時に\n前衛と\r主力の艦隊の切り替えが可能です。\n\r\n前衛の被害状況や総合的な戦況判断で\r\nいつ主力を出すか決断をお願いします！" => {},
        "[000000][0055aa]連合艦隊[-]の編成" => {},
        "[000000][006400]補給[-]が必要な艦娘がいます。\n燃料・弾薬を[006400]補給[-]しましょう。\n\n艦娘にとって、[006400]補給[-]はとても大事です！" => {},
        "[000000][006400]高速建造[-]について[-]" => {},
        "[000000][329ad6]装備名装備名装備名装備名[-]\nを、改修しますね！\n\nこの改修には\n[329ad6]装備名装備名装備名装備名ｘ１[-]\nが必要です。\n\n[666666]（＊改修で消費します)" => {},
        "[000000]　(※改修で消費します)[-]" => { tr => "[000000] (※Repair consumed)[-]", desc => 'is this a bucket?' },
        "\n[666666](※改修で消費します)[-]" => { tr => "\n[666666](※Repair consumed)[-]", desc => 'is this a bucket?' },
        "[000000][aa0000]反攻迎撃戦[-]について\r" => {},
        "[000000][aa0000]敵反攻作戦[-]の迎撃に失敗しました。\r\n海域エリアが深海棲艦に制圧され\nました。\n\n我が艦隊は、撤退します。周囲の\n海域を再度制圧し、同海域の再攻略に\n臨みましょう！\n" => {},
        "[000000][aa0000]敵反攻作戦[-]迎撃戦敗北しました……。" => {},
        "[000000][aa0000]通商破壊戦[-] 発生！\n" => {},
        "[000000]　  　出撃を取りやめますか？\n\n\n迎撃戦に出撃しない場合、当海域は\n[FF0000]敵勢力により占領[-]されてしまいます。\n" => {},
        "[000000]このアイテムを使用しますか？[-]\n\n" => {},
        "[000000]このアイテムを開けると、資源や資材が[FF0000]蓄積上限[-]を超えるため\n一部または全て無駄になる可能性があります。\n\n　　　　　　　このアイテムを使用しますか？\n[-]\n\n" => {},
        "[000000]各海域に[0055aa]輸送船[-]を配備しておくことで、\n[0055aa]資源[-] (\r                 )\r が獲得できます。\n\n獲得できる[0055aa]資源量[-]は、海域によって\n異なります。\r\n\n多くの海域に輸送船団を配備して[0055aa]資源[-]を\n獲得、艦隊の兵站を拡充しましょう。" => {},
        "[000000]工廠では、艦娘の[006400]建造[-]が可能です。\n戦艦や重巡などの大型艦の建造には、\r\nより多くの[0055AA]鋼材[-]などの資源が必要です。\r\nまた、[0055AA]ボーキサイト[-]を多く投入すると\n航空母艦や\r同護衛艦艇が建造可能です。\n\n[0055AA]輸送船[-]の建造もここで可能です。\r\n\n" => {},
        "[000000]損傷を受けた艦がいます。\n入渠ドックで[006400]修理[-]を実施しましょう。\n\n損傷状態で出撃することは危険です。" => {},
        "[000000]敵の[aa0000]反攻作戦[-]について\r" => {},
        "[000000]敵深海棲艦が、反攻作戦実施海域に集結し、\r\n[aa0000]反攻作戦[-]の準備を進めている模様です。\r\n\nこれを迎撃、抑止するため、艦隊戦力を集め、\n\r同海域で出撃や敵を抑制する遠征を実施し、\n\r敵反攻作戦戦力の漸減を図りましょう。\n\n" => {},
        "[000000]敵深海棲艦が反攻作戦を開始しました。\n\nしかし、これを迎撃できる味方艦隊戦力は、\r\n同海域に存在しません。\n\r\n同海域は、再び敵制圧下となります……。" => {},
        "[000000]海域に[0055aa]輸送船[-]を配備することで、\nターン開始時に資源を獲得できます。\n\n獲得できる資源量は、その海域の特性と、\r\n海域に配備された[0055aa]輸送船団[-]の規模により\r\n変化します。" => {},
        "[000000]艦娘の[006400]修理[-]について" => {},
        "[000000]艦娘の[006400]補給[-]について" => {},
        "[000000]鎮守府海域以外で艦隊から艦娘を外した場合、\r\nその艦娘は自動的に鎮守府海域に[0055aa]回航[-]します。\n\r\n回航中の艦娘は、戦闘等に参加はできません。" => {},
        "[006400]建造[-][000000]について[-]" => {},
        "[12C112]艦隊[-]を編成！" => {},
        "[E2E2E2][12c112]任務[-]完了！[-]" => {},
        "[E2E2E2]作戦海域への[12c112]出撃[-]！[-]" => {},
        "○○艦隊が\nが開放されました！" => {},
        "♪「第三十駆逐隊、抜錨準備！」" => {},
        "　　艦隊最大\r数\n　　艦娘最大\r数\n　　装備アイテム最大数\r\n　　備蓄可能　各資材量\r\n選択難易度" => {},
        "　ボタンで戦略コマンドを\n開き、ターンを終了せよ！" => { tr => "Press button to open Strategy map, and End the Turn!" },
        "「だみはらだみこ」\nを入手しました" => {},
        "「第五航空戦隊」を編成せよ！" => {},
        "「補強装備の増設改修」を実施しますか？" => {},
        "「資源」や「改修資材」に交換出来ます。\nまた、勲章4個を「改修設計図」1枚に交換可能です。" => {},
        "ああああああああああ" => { tr => "AAAAAAAAAA",      desc => 'really?' },
        "ああああああああああああああああああああああああ\nああああああああああああああああああああああああ\nああああああああああああああああああああああああ\nああああああああああああああああああああああああ" => { tr => "AAAAAAAAAAAAAAAAAAAAAAAA\nAAAAAAAAAAAAAAAAAAAAAAAA\nAAAAAAAAAAAAAAAAAAAAAAAA\nAAAAAAAAAAAAAAAAAAAAAAAA",      desc => 'mind explaining this to me?' },
        "あいうえおかきくけこ" => { tr => "AIUEO KaKiKuKeKo",      desc => 'It is the alphabet' },
        "あきつ丸" => { tr => "Akitsu Maru",      desc => ''},
        "あきつ丸改" => { tr => "Akitsu Maru Kai",      desc => ''},
        "あと" => { tr => "after",      desc => '' },
        "いいえ" => { tr => "No\x{200B}",      desc => '' },
        "この艦隊で出撃しますか？" => { tr => "Would you like to sortie with this fleet?",      desc => 'could also be Would you like to sortie this fleet? if you wish to save characters' },
        "この艦隊で遠征しますか？" => { tr => "Would you like to send this fleet on an expedition?",      desc => 'or just, Send fleet on expedition?' },
        "これまでのデータを保存しますか？" => { tr => "Would you like to save your current data?",      desc => '' },
        "しばらくお待ち下さい。" => { tr => "Please wait a moment.",      desc => '' },
        "しばらくお待ち下さい。。" => { tr => "Please wait a moment..",      desc => '' },
        "その他" => { tr => "Other",      desc => 'Otherwise, in addition to, so forth, the rest' },
        "だみはらだみこだみはらだ" => {},
        "なし" => { tr_disabled => "unacceptable", desc => 'BattleCommandExtensions > print なし if BattleCommand.Sekkin | TaskStratgyDebug > ShipMode > ShipName[0].text != なし | MissionWithTankerDescriptionPopUp > print なし or 少量 or 普通 | Api_get_Member > furniture[x.Rid].Title.Equals("なし") | Mst_ship > set_property > Name.Equals("なし") | none, unsatisfactory | TODO: letting this be inserted into all fitting spaces causes savegame list loading to never finish, referenced *once* in CSharp (i.e. same memory address for all occurrences in script code), and in ship/furniture name lists in XML and asset object lists. could maaaaaybe be replaced with "NO", using custom glyphs for each?' },
        "のみ[66ccff]出撃可能[-]です。" => { tr => "[66ccff]Only listed ship classes can sortie[-].", desc => "literal 'Only sortie possible is.'" },
        "は[FF0000]出撃不可[-]です。" => { tr => "[FF0000]These ship classes unable to sortie[-].", desc => "literal 'No Sortie Is.'"  },
        "はい" => { tr => "Yes",      desc => '' },
        "はずす" => { tr => "Leave",      desc => 'Disengage, evade' },
        "まとめて選択" => { tr => "Select All",      desc => '' },
        "まるゆ" => { tr => "Maruyu",      desc => 'a submarine' },
        "まるゆ改" => { tr => "Maruyu Kai",      desc => '' },
        "アイテム名" => { tr => "Item Name",      desc => '' },
        "アイテム名アイテム名アイテム名" => { tr => "Item Name Item Name Item Name",      desc => '' },
        "アイテム詳細アイテム詳細アイテム詳細アイテム" => { tr => "Item Details Item Details Item Details Item",      desc => '' },
        "ケッコン書類一式を手に入れました。" => { tr => "Got Complete Set Of Kekkon Documents",      desc => 'Mariage paperwork' },
        "コマンドメニュー" => { tr => "Command Menu",      desc => '' },
        "コモン" => { tr => "Common",      desc => '' },
        "ステータス" => { tr => "Status",      desc => '' },
        "タイトル" => { tr => "Title",      desc => 'i tried to write that Taitle' },
        "タッチでボタン項目を選んで十字キーで操作してください" => { tr => "Select item with button and operate with D-Pad",      desc => 'this is a bit rough' },
        "ダイアログタイトル" => { tr => "Dialogue Title",      desc => '' },
        "デバッグモードA" => { tr => "Debug Mode A",      desc => 'Oh, look. A Debug Mode' },
        "デバッグモードB" => { tr => "Debug Mode B",      desc => 'wait, what? two debug modes?' },
        "データ保存中..." => { tr => "Saving Data...",      desc => '' },
        "ドックを開放しますか？" => { tr => "Would you like to release the dock?",      desc => '' },
        "ドックを開放できません" => { tr => "Can not release the dock.",      desc => '... open the dock' },
        "ナイトメアモード" => {},
        "プリセットデータ\n（タッチで選択してください）" => { tr => "Preset Data\n(Please select using touch)",      desc => '' },
        "ページ" => { tr => "page",      desc => '' },
        "メッセージ" => { tr => "message",      desc => '' },
        "モード" => { tr => "mode",      desc => '' },
        "リターン" => { tr => "return",      desc => '' },
        "レア度" => { tr => "Rarity",      desc => '' },
        "レベル" => { tr => "Level",      desc => '' },
        "レベル上位順で決定されますが、\nロック済み艦娘を優先して引き継ぐことも可能です。" => { tr => "",      desc => 'i will come back to this one,- remind me if i forget' },
        "三日月" => { tr => "Mikazuki",      desc => 'a destroyer' },
        "三日月1" => { tr => "Mikazuki1",      desc => '' },
        "三日月改" => { tr => "Mikazuki Kai",      desc => '' },
        "三隈" => { tr => "Mikuma",      desc => 'a heavy cruiser' },
        "三隈改" => { tr => "Mikuma Kai",      desc => '' },
        "下記艦隊は出撃できません" => {},
        "不知火" => { tr => "Shiranui",      desc => 'a destroyer' },
        "不知火改" => { tr => "Shiranui Kai",      desc => '' },
        "五十鈴" => { tr => "Isuzu",      desc => 'Light Cruiser' },
        "五十鈴1" => { tr => "Isuzu1",      desc => '' },
        "五十鈴改" => { tr => "Isuzu Kai",      desc => 'destroyer' },
        "五十鈴改二" => { tr => "Isuzu Kai Ni",      desc => '' },
        "五月雨" => { tr => "Samidare",      desc => '' },
        "五月雨改" => { tr => "Samidare Kai",      desc => '' },
        "以下のアイテムを購入しますか？" => { tr => "Would you like to purchase the following items?",      desc => '' },
        "以下の内容で入渠を開始します" => { tr => "Contents begin with the following.",      desc => 'rough translation - may need polish' },
        "以下の内容で開始しますか？" => { tr => "Start with the following?",      desc => 'Do you wish to start with the following contents?' },
        "伊168" => { tr => "I-168",      desc => 'submarine' },
        "伊168改" => { tr => "I-168 Kai",      desc => '' },
        "伊19" => { tr => "I-19",      desc => 'submarine' },
        "伊19改" => { tr => "I-19 Kai",      desc => '' },
        "伊401" => { tr => "I-401",      desc => 'submarine' },
        "伊401改" => { tr => "I-401 Kai",      desc => '' },
        "伊58" => { tr => "I-58",      desc => 'submarine' },
        "伊58改" => { tr => "I-58 Kai",      desc => '' },
        "伊8" => { tr => "I-8",      desc => 'submarine' },
        "伊8改" => { tr => "I-8 Kai",      desc => '' },
        "伊勢" => { tr => "Ise",      desc => 'battleship' },
        "伊勢改" => { tr => "Ise Kai",      desc => '' },
        "作戦名作戦名作戦名" => { tr => "Operation Name Operation Name Operation Name",      desc => '' },
        "作戦海域 攻略完了!" => { tr => "Operation in this area complete.",      desc => '' },
        "使用しない" => { tr => "Do Not Use",      desc => '' },
        "保存せずにタイトルに戻ります。\nよろしいですか？" => { tr => "Are you sure you wish to return to the title screen without saving?",      desc => '' },
        "保有アイテム一覧" => { tr => "Item List",      desc => '' },
        "保有艦隊数：{0}" => { tr => "Number of owned fleets：{0}", desc => '' },
        "保有艦隊数：999" => { tr => "Number of owned fleets:999", desc => '' },
        " | 保有艦隊数 : " => { tr => "", desc => "" },
        "提督名:{0}  提督レベル:{1}  保有艦隊数:{2}  ゲーム難易度:{3}  所有戦略P:{4} Tutorial:({5})" => { tr => "", desc => "" },
        "優先" => { tr => "priority",      desc => '' },
        "優先しない" => { tr => "Do not prioritize",      desc => '' },
        "入手する資材" => { tr => "Acquired resources",      desc => 'i do not know the tense of this entry, subject to change by tense' },
        "入渠" => { tr => "Entering Dock",      desc => '' },
        "入渠を開始しますか？" => { tr => "Commence docking?",      desc => '' },
        "全てはずす" => { tr => "Remove All",      desc => '' },
        "全アイテム  +" => { tr => "All Items +",      desc => '' },
        "全艦補給" => { tr => "Replenish all supplies",      desc => '' },
        "内容内容内容内容内容内容内容内容内容内容内容内容内容内容内容内容内容内容内容内容内容内容内容内容内容内容内容内容内容内容内容内容内容内容内容内容内容内容内容内容内内容" => { tr => "ContentContentContentContentContentContentContentContentContentContentContentContentContentContentContentContentContentContentContentContentContentContentContentContentContentContentContentContentContentContentContentContentContentContentContentContentContentContentContentContentContent",      desc => 'is this a joke? it just says content over and over' },
        "出撃\r\n\n演習" => { tr => "Sortie \r\n\nExercise",      desc => '' },
        "出撃数\n\r\n勝利数\n\r\n迎撃成功\n\n勝率\n\n\n\n演習数\n\n対抗演習数\r\n" => { tr => "Number of Sorties\n\r\nNumber of Wins\n\r\nInterception of Success\n\nWin Rate\n\n\nExercise Number\n\nNumber of Counter Exercises\r\n",      desc => '' },
        "出撃状況" => { tr => "Sortie Circumstance",      desc => 'Sortie Situation?' },
        "出撃艦隊" => { tr => "Sortie Fleet",      desc => '' },
        "切替" => { tr => "Switching",      desc => 'maybe Exchange' },
        "初春" => { tr => "Hatsuharu",      desc => 'destroyer' },
        "初春改" => { tr => "Hatsuharu Kai",      desc => '' },
        "初春改二" => { tr => "Hatsuharu Kai Ni",      desc => '' },
        "初期艦" => { tr => "Initial Ship",      desc => '' },
        "初雪" => { tr => "Hatsuyuki",      desc => 'destroyer' },
        "初雪1" => { tr => "Hatsuyuki1",      desc => '' },
        "初雪改" => { tr => "Hatsuyuki Kai",      desc => '' },
        "初霜" => { tr => "Hatsushimo",      desc => 'destroyer' },
        "初霜改" => { tr => "Hatsushimo Kai",      desc => '' },
        "初風" => { tr => "Hatsukaze",      desc => 'destroyer' },
        "初風改" => { tr => "Hatsukaze Kai",      desc => '' },
        "利根" => { tr => "Tone",      desc => 'heavy cruiser' },
        "利根改" => { tr => "Tone Kai",      desc => '' },
        "利根改二" => { tr => "Tone Kai Ni",      desc => '' },
        "前衛艦隊" => { tr => "Vanguard Fleet",      desc => '前 In Front or Before 衛 Defense or Protection' },
        "加古" => { tr => "Kako",      desc => 'heavy cruiser' },
        "加古1" => { tr => "Kako1",      desc => '' },
        "加古改" => { tr => "Kako Kai",      desc => '' },
        "加古改二" => { tr => "Kako Kai Ni",      desc => '' },
        "加賀" => { tr => "Kaga",      desc => 'aircraft carrier' },
        "加賀改" => { tr => "Kaga Kai",      desc => '' },
        "勲章" => { tr => "Takao",      desc => 'heavy cruiser' },
        "北上" => { tr => "Kitakami",      desc => 'light cruiser [torpedo cruiser]' },
        "北上1" => { tr => "Kitakami1",      desc => '' },
        "北上改" => { tr => "Kitakami Kai",      desc => '' },
        "北上改二" => { tr => "Kitakami Kai Ni",      desc => '' },
        "千代田" => { tr => "Chiyoda",      desc => 'seaplane tender' },
        "千代田改" => { tr => "Chiyoda Kai",      desc => '' },
        "千代田甲" => { tr => "Chiyoda A",      desc => 'seaplane tender' },
        "千代田航" => { tr => "Chiyoda Carrier",      desc => 'light carrier' },
        "千代田航改" => { tr => "Chiyoa Carrier Kai",      desc => '' },
        "千代田航改二" => { tr => "Chiyoda Carrier Kai Ni",      desc => '' },
        "千歳" => { tr => "Chitose",      desc => 'seaplane tender' },
        "千歳改" => { tr => "Chitose Kai",      desc => '' },
        "千歳甲" => { tr => "Chitose A",      desc => '' },
        "千歳航" => { tr => "Chitose Carrier",      desc => 'light carrier' },
        "千歳航改" => { tr => "Chitose Kai",      desc => '' },
        "千歳航改二" => { tr => "Chitose Kai Ni",      desc => '' },
        "卯月改" => { tr => "Uzuki Kai",      desc => 'destroyer' },
        "叢雲" => { tr => "Murakumo",      desc => 'destroyer' },
        "叢雲改" => { tr => "Murakumo Kai",      desc => '' },
        "叢雲改二" => { tr => "Murakumo Kai Ni",      desc => '' },
        "古鷹" => { tr => "Furutaka",      desc => 'heavy cruiser' },
        "古鷹1" => { tr => "Furutaka1",      desc => '' },
        "古鷹改" => { tr => "Furutaka Kai",      desc => '' },
        "古鷹改二" => { tr => "Furutaka Kai Ni",      desc => '' },
        "司令部LV：999" => { tr => "Command LV:999", desc => '' },
        "司令部LV：{0}" => { tr => "Command LV:{0}", desc => "Headquarters Level" },
        "合成素材の艦船" => { tr => "Synthesize Ship Materials",      desc => 'out of context, this may be off' },
        "名前名前名前名前名前名前" => { tr => "NameNameNameNameNameName",      desc => 'is what it says...' },
        "名取" => { tr => "Natori",      desc => 'light cruiser' },
        "名取改" => { tr => "Natori Kai",      desc => '' },
        "吹雪" => { tr => "Fubuki",      desc => 'destroyer' },
        "吹雪改" => { tr => "Fubuki Kai",      desc => '' },
        "吹雪改二" => { tr => "Fubuli Kai Ni",      desc => '' },
        "呂500" => { tr => "Ro-500",      desc => 'second upgrade to U-500' },
        "回航について" => { tr => "Regarding Navigation",      desc => 'can also be used as a [per]' },
        "増設改修しました！" => { tr => "Expanded and repaired!",      desc => 'renovated?' },
        "壁紙" => { tr => "Wallpaper",      desc => 'store thing?' },
        "売り切れ" => { tr => "Sold out",      desc => '' },
        "売切" => { tr => "Sold out",      desc => '' },
        "売切御礼" => { tr => "Sold out rewards",      desc => '' },
        "夕張" => { tr => "Yuubari",      desc => 'light cruiser' },
        "夕張改" => { tr => "Yuubari Nai",      desc => '' },
        "夕立" => { tr => "Yuudachi",      desc => 'destroyer' },
        "夕立1" => { tr => "Yuudachi1",      desc => '' },
        "夕立改" => { tr => "Yuudachi Kai",      desc => '' },
        "夕立改二" => { tr => "Yuudachi Kai Ni",      desc => '' },
        "夕雲" => { tr => "Yuugumo",      desc => '' },
        "夕雲改" => { tr => "Yuugumo Kai",      desc => 'destroyer' },
        "多摩" => { tr => "Tama",      desc => 'light cruiser' },
        "多摩1" => { tr => "Tama1",      desc => '' },
        "多摩改" => { tr => "Tama Kai",      desc => '' },
        "夜戦突入" => { tr => "Night Battle Start",      desc => '[night battle][embarking on]' },
        "大井" => { tr => "Ooi",      desc => 'light cruiser' },
        "大井改" => { tr => "Ooi Kai",      desc => 'torpedo cruiser' },
        "大井改二" => { tr => "Ooi Kai Ni",      desc => '' },
        "大和" => { tr => "Yamato",      desc => 'battleship' },
        "大和改" => { tr => "Yamato Kai",      desc => '' },
        "大型艦建造\nが開放されました！" => { tr => "LSC is now available!",      desc => 'Large Ship Construction Has Been Released!' },
        "大淀" => { tr => "Ooyodo",      desc => 'light cruiser' },
        "大淀改" => { tr => "Ooyodo Kai",      desc => '' },
        "大潮" => { tr => "Ooshio",      desc => 'destroyer' },
        "大潮改" => { tr => "Ooshio Kai",      desc => '' },
        "大鯨" => { tr => "Taigei",      desc => 'submarine tender' },
        "大鳳" => { tr => "Taihou",      desc => 'Armoured Carrier' },
        "大鳳改" => { tr => "Taihou Kai",      desc => 'Proper Waifu' },
        "天城" => { tr => "Amagi",      desc => 'standard carrier' },
        "天城改" => { tr => "Amagi Kai",      desc => '' },
        "天津風" => { tr => "Amatsukaze",      desc => 'destroyer' },
        "天津風改" => { tr => "Amatsukaze Kai",      desc => '' },
        "天龍" => { tr => "Tenryuu",      desc => 'light cruiser' },
        "天龍1" => { tr => "Tenryuu1",      desc => '' },
        "天龍改" => { tr => "Tenryuu Kai",      desc => '' },
        "失敗" => { tr => "Failure",      desc => 'this is not a ship name' },
        "如月1" => { tr => "Kisaragi1",      desc => 'destroyer' },
        "如月改" => { tr => "Kisaragi Kai",      desc => '' },
        "如月改二" => { tr => "Kisaragi Kai Ni",      desc => '' },
        "妙高" => { tr => "Myoukou",      desc => 'heavy cruiser' },
        "妙高改" => { tr => "Myoukou Kai",      desc => '' },
        "妙高改二" => { tr => "Myoukou Kai Ni",      desc => '' },
        "子日" => { tr => "Nenohi",      desc => 'destroyer' },
        "子日改" => { tr => "Nenohi Kai",      desc => '' },
        "完全勝利!!" => { tr => "Complete Victory!!",      desc => 'i prefer Decisive, but Total also works' },
        "家具コイン　×" => { tr => "Furniture Coin x", desc => 'is what i am using in .tex files' },
        "家具コイン ✕ " => { tr => "Furniture Coin ✕ ", desc => "" },
        "家具コイン☓999999" => { tr => "Furniture Coins☓999999", desc => '' },
        "JUKE{0} {1} 家具コイン:{2} ループ:{3} BGM設定:{4} {5}\n" => { tr => "", desc => "" },
        "{0}\n{1} 所持家具コイン:{2}\n" => { tr => "", desc => "" },
        qq["家具職人"所有数:{0} "家具コイン"所有数:{1}\n] => { tr => "", desc => "" },
        "家具名家具名家具名" => { tr => "Furniture Name Furniture Name Furniture Name",      desc => '' },
        "家具名家具名家具名家具名" => { tr => "Furniture Name Furniture Name Furniture Name Furniture Name",      desc => '' },
        "家具屋R" => { tr => "Furniture Store R",      desc => '' },
        "家具詳細" => { tr => "Furniture Details",      desc => '' },
        "家具詳細家具詳細家具詳細家具詳細家具詳細\n家具詳細家具詳細家具詳細家具詳細家具詳細" => { tr => "FurnitureDetailsFurnitureDetailsFurnitureDetailsFurnitureDetailsFurnitureDetails\nFurnitureDetailsFurnitureDetailsFurnitureDetailsFurnitureDetailsFurnitureDetails ",      desc => 'i used copy/paste on this one' },
        "対抗演習できません" => { tr => "Unable to do Rival Exercise",      desc => 'out of context, this one may be off' },
        "対抗演習を行いますか？" => { tr => "Would you like to do Rival Exercise?",      desc => 'also out of context. reserve right to revise.' },
        "対潜\n999" => { tr => "Anti-Sub\n999",      desc => '' },
        "対空\n999" => { tr => "Anti-Air\n999",      desc => '' },
        "対空+2" => { tr => "Anti-Air+2",      desc => '' },
        "射程" => { tr => "Range",      desc => '' },
        "山城" => { tr => "Yamashiro",      desc => 'battleship' },
        "山城1" => { tr => "Yamashiro1",      desc => '' },
        "山城改" => { tr => "Yamashiro Kai",      desc => '' },
        "山城改二" => { tr => "Yamashiro Kai Ni",      desc => '' },
        "山雲" => { tr => "Yamagumo",      desc => 'destroyer' },
        "山雲改" => { tr => "Yamagumo Kai",      desc => '' },
        "島風" => { tr => "Shimakaze",      desc => 'destroyer' },
        "島風改" => { tr => "Shimakaze Kai",      desc => '' },
        "嵐改" => { tr => "Arashi Kai",      desc => 'destroyer' },
        "川内" => { tr => "Sendai",      desc => 'light cruiser' },
        "川内改" => { tr => "Sendai Kai",      desc => '' },
        "川内改二" => { tr => "Sendai Kai Ni",      desc => '' },
        "工廠" => { tr => "factory",      desc => '' },
        "工廠で建造を実施せよ！" => { tr => "Lets build something in the factory!",      desc => '' },
        "巻雲" => { tr => "Makigumo",      desc => 'destroyer' },
        "巻雲改" => { tr => "Makigumo Kai",      desc => '' },
        "引継ぎをしてゲームを開始します" => { tr => "take over and begin the game",      desc => 'very rough' },
        "弥生改" => { tr => "Yaoyi Kai",      desc => 'destroyer' },
        "強化する艦船" => { tr => "Ship to be reinforced",      desc => 'enhanced?' },
        "強化値" => { tr => "Reinforcement value",      desc => 'enhancement value?' },
        "弾着観測射撃！" => { tr => "Observation Fire Hit!",      desc => '' },
        "必要な弾薬数" => { tr => "Ammunition Required",      desc => '' },
        "必要な鋼材数" => { tr => "Steel Required",      desc => '' },
        "必要な開発資材数" => { tr => "Dev Mats Required",      desc => 'Development Materials' },
        "応急修理女神" => { tr => "Emergency Repair Goddess",      desc => '' },
        "応急修理女神\nを使用して進撃" => { tr => "Proceed with using \n Emergency Repair Goddess",      desc => '' },
        "応急修理要員\nを使用して進撃" => { tr => "Proceed with using \n Emergency Repair Personel",      desc => '' },
        "情報切替" => { tr => "Intelligence Exchange",      desc => 'rough : information, news' },
        "愛宕" => { tr => "Atago",      desc => 'heavy cruiser' },
        "愛宕1" => { tr => "Atago1",      desc => '' },
        "愛宕改" => { tr => "Atago Kai",      desc => '' },
        "成功" => { tr => "Success",      desc => '' },
        "成功時最大値" => { tr => "Great Success",      desc => 'Success Maximum, Maximum Success' },
        "戦況確認" => { tr => "Confirm battle",      desc => 'Confirm War?' },
        "戦略ポイント" => { tr => "Strategy Points",      desc => '' },
        "戦略ポイントの所持上限値が上がりました。" => { tr => "Strategy point limit has risen.",      desc => '' },
        "戦略物資\nサブコマンド" => { tr => "Strategic resources\nsubcommand",      desc => 'Strategi materials?' },
        "戦闘指揮入力" => { tr => "Battle Command Input",      desc => 'data entry' },
        "戦闘省略モード" => { tr => "Default Battle Mode",      desc => 'combat?' },
        "戦闘開始" => { tr => "Combat Start",      desc => '' },
        "扶桑" => { tr => "Fusou",      desc => 'battleship' },
        "扶桑1" => { tr => "Fusou1",      desc => '' },
        "扶桑改" => { tr => "Fusou Kai",      desc => 'aviation battleship' },
        "扶桑改二" => { tr => "Fusou Kai Ni",      desc => '' },
        "扶桑祭り" => { tr => "Fusou Festival",      desc => 'okay, what? TODO' },
        "提督名を入力してください\n（１２文字まで）" => { tr => "Please Enter Admiral's Name (Up To 12 Characters)",      desc => 'i thought you did this one already?' },
        "提督名提督名提督名" => { tr => "Admiral Name Admiral Name Admiral Name",      desc => 'why?' },
        "提督経験値" => { tr => "Admiral Experience",      desc => 'Admiral Experience Points' },
        "搭載" => { tr => "Loading",      desc => 'Equipping, equipped (with), as in built-in' },
        "摩耶" => { tr => "Maya",      desc => 'heavy cruiser' },
        "摩耶1" => { tr => "Maya1",      desc => '' },
        "摩耶改" => { tr => "Maya Kai",      desc => '' },
        "摩耶改二" => { tr => "Maya Kai Ni",      desc => '' },
        "撤退" => { tr => "Withdraw",      desc => 'Retreat?' },
        "支援物資が届きました。\n\n" => { tr => "Support supplies arrived. \n\n",      desc => '' },
        "支援艦隊が到着しました！" => { tr => "Support Fleet has arrived!",      desc => '' },
        "改修" => { tr => "Repair",      desc => 'duh...' },
        "改修前" => { tr => "Before repair",      desc => 'may also mean improvement' },
        "改修後" => { tr => "After repair",      desc => 'improvement?' },
        "改修確実" => { tr => "Refurbishment",      desc => 'Repair/Improvement Certainty?' },
        "改装" => { tr => "Refit",      desc => '' },
        "攻撃命中補正" => { tr => "Attack hit compensation",      desc => 'correction?' },
        "攻略海域数：{0}" => { tr => "Area captured：{0}",      desc => 'there is a term in english, out of right field. this is kind of a wild guess' },
        "攻略海域数：999" => { tr => "Sea Regions Captured:999",      desc => '攻略 [capture (of enemy territory)] 海域数 [number of sea regions/areas]' },
        "放   置\r\nボイス" => { tr => "Abandon Voice",      desc => 'whaaaaaa?  Fire/Shoot/Liberate/SetFree Placement/LeaveBehind/Keep - CONTEXT!!!?!? TODO' },
        "敵深海棲艦が反攻作戦を開始しました。\n\n同海域に展開する我が艦隊は直ちに\nこれを迎撃！\n\n敵反攻作戦迎撃戦を展開しましょう！" => { tr => "The enemy deep sea ship launched a counteroffensive.\n\nOur fleet deployed to the same region\nand intercepted!\n\nLets develop an interception strategy!",      desc => '' },
        "敷波" => { tr => "Shikinami",      desc => 'destroyer' },
        "敷波改" => { tr => "Shikinami Kai",      desc => '' },
        "文月1" => { tr => "Fumizuki1",      desc => 'destroyer' },
        "文月改" => { tr => "Fumizuki Kai",      desc => '' },
        "新たな難易度が解放されました" => { tr => "A new difficulty level is available.",      desc => '' },
        "日向" => { tr => "Hyuuga",      desc => 'battleship' },
        "日向改" => { tr => "Hyuuga Kai",      desc => 'aviation battleship' },
        "早霜" => { tr => "Hayashimo",      desc => 'destroyer' },
        "早霜改" => { tr => "Hayashimo Kai",      desc => '' },
        "明石" => { tr => "Akashi",      desc => 'repair ship' },
        "明石改" => { tr => "Akashi Kai",      desc => '' },
        "明石艦隊" => { tr => "Akashi Fleet",      desc => '' },
        "春雨" => { tr => "Harusame",      desc => 'destroyer' },
        "春雨改" => { tr => "Harusame Kai",      desc => '' },
        "時津風" => { tr => "Tokitsukaze",      desc => 'destroyer' },
        "時津風改" => { tr => "Tokitsukaze Kai",      desc => '' },
        "時雨" => { tr => "Shigure",      desc => 'destroyer' },
        "時雨1" => { tr => "Shigure1",      desc => '' },
        "時雨改" => { tr => "Shigure Kai",      desc => '' },
        "時雨改二" => { tr => "Shigure Kai Ni",      desc => '' },
        "普通" => { tr => "Common",      desc => 'Ordinary' },
        "暁改" => { tr => "Akatsuki Kai",      desc => 'destroyer  - *where is 暁?*' },
        "暁改二" => { tr => "Akatsuki Kai ni",      desc => '' },
        "曙改" => { tr => "Akebono Kai",      desc => 'destroyer   - *where is 曙?*' },
        "書類一式にサインしますか？" => { tr => "Sign the official papers?",      desc => 'is a complete set of official papers, sign, yes?' },
        "最上" => { tr => "Mogami",      desc => 'heavy cruiser' },
        "最上1" => { tr => "Mogami1",      desc => '' },
        "最上改" => { tr => "Mogami Kai",      desc => 'aviation cruiser' },
        "最上改1" => { tr => "Mogami Kai1",      desc => '' },
        "望月" => { tr => "Mochizuki ",      desc => 'destroyer' },
        "望月1" => { tr => "Mochizuki 1",      desc => '' },
        "望月改" => { tr => "Mochizuki  Kai",      desc => '' },
        "朝潮" => { tr => "Asashio",      desc => 'destroyer' },
        "朝潮改" => { tr => "Asashio Kai",      desc => '' },
        "朝雲" => { tr => "Asagumo",      desc => 'destroyer' },
        "朝雲改" => { tr => "Asagumo Kai",      desc => '' },
        "朝霜" => { tr => "Asashimo",      desc => 'destroyer' },
        "朝霜改" => { tr => "Asashimo Kai",      desc => '' },
        "朧改" => { tr => "Oboro Kai",      desc => '    - *where is 朧?*' },
        "木曽1" => { tr => "Kiso1",      desc => '' },
        "木曾" => { tr => "Kiso",      desc => 'light cruiser' },
        "木曾改" => { tr => "Kiso Kai",      desc => '' },
        "木曾改二" => { tr => "Kiso Kai Ni",      desc => 'torpedo cruiser' },
        "村雨" => { tr => "Murasame",      desc => 'destroyer' },
        "村雨改" => { tr => "Murasame Kai",      desc => '' },
        "椅子を\n手に入れました" => { tr => "Chair\nacquired",      desc => 'Got a chair.' },
        "榛名" => { tr => "Haruna",      desc => 'fast battleship' },
        "榛名改" => { tr => "Haruna Kai",      desc => '' },
        "榛名改二" => { tr => "Haruna Kai Ni",      desc => '' },
        "模様替えL" => { tr => "RemodelingL",      desc => '' },
        "武蔵" => { tr => "Musashi",      desc => 'battleship' },
        "武蔵改" => { tr => "Musashi Kai",      desc => '' },
        "残り継戦時間[F9C66CFF]100[-]日" => { tr => "100 days of war remain.",      desc => '' },
        "母港へ" => { tr => "To Home Port",      desc => '' },
        "母港コマンド" => { tr => "Home Port Command",      desc => '' },
        "比叡" => { tr => "Hiei",      desc => 'fast battleship' },
        "比叡改" => { tr => "Hiei Kai",      desc => '' },
        "比叡改二" => { tr => "Hiei Kai Ni",      desc => '' },
        "江風" => { tr => "Kawakaze",      desc => 'destroyer' },
        "江風改" => { tr => "Kawakaze Kai",      desc => '' },
        "決定せずに戻ると変更は破棄されます。\n配備設定を中止してもよろしいですか？" => { tr => "Backing out will result in no changes being made.\nAre you sure you wish to cancel?",      desc => '' },
        "浜風" => { tr => "Hamakaze",      desc => 'destroyer' },
        "浜風改" => { tr => "Hamakaze Kai",      desc => '' },
        "浦風" => { tr => "Urakaze",      desc => 'destroyer' },
        "浦風改" => { tr => "Urakaze Kai",      desc => '' },
        "海域" => { tr => "Region",      desc => 'Sea Area - i wonder if we can get away with globally using Area or Region for this' },
        "海域名海域名海域名海域名海域名" => { tr => "SeaAreaNameSeaAreaNameSeaAreaNameSeaAreaNameSeaAreaName",      desc => 'this again?' },
        "海風" => { tr => "Umikaze",      desc => 'destroyer' },
        "海風改" => { tr => "Umikaze Kai",      desc => '' },
        "消費する艦娘" => { tr => "Consume Ship Girl",      desc => 'Consuming or Usung?' },
        "消費コイン" => { tr => "Coins used",      desc => 'Consumption Coin' },
        "涼風" => { tr => "Suzukaze",      desc => 'destroyer' },
        "涼風改" => { tr => "Suzukaze Kai",      desc => '' },
        "深雪" => { tr => "Miyuki",      desc => 'destroyer' },
        "深雪改" => { tr => "Miyuki Kai",      desc => '' },
        "清霜" => { tr => "Kiyoshimo",      desc => 'destroyer' },
        "清霜改" => { tr => "Kiyoshimo Kai",      desc => '' },
        "満潮" => { tr => "Michishio",      desc => 'destroyer' },
        "満潮改" => { tr => "Michishio Kai",      desc => '' },
        "演習選択" => { tr => "Selection",      desc => '' },
        "漣改" => { tr => "Sazanami Kai",      desc => 'destroyer    - *where is 漣?*' },
        "潮改" => { tr => "Ushio Kai",      desc => 'destroyer    - *where is 潮?*' },
        "潮改二" => { tr => "Ushio Kai Ni",      desc => '' },
        "潮祭り" => { tr => "Ushio Festival",      desc => 'Current/Tide/SeaWater/Chance/Opportunity Festival - good luck' },
        "火力\n999" => { tr => "Firepower\n999",      desc => '' },
        "火力\n雷装\n対空\n装甲\n運" => { tr => "Firepower\nTorpedo\nAnti-Air\nArmor\nLuck",      desc => '' },
        "照月" => { tr => "Teruzuki",      desc => 'destroyer' },
        "照月改" => { tr => "Teruzuki Kai",      desc => '' },
        "熊野" => { tr => "Kumano",      desc => 'heavy cruiser' },
        "熊野改" => { tr => "Kumano Kai",      desc => '' },
        "燃 料　　　　弾 薬" => { tr => "Fuel　　　　Ammunition",      desc => 'may shorten to Ammo if needed' },
        "燃料が不足しています" => { tr => "Fuel is running low",      desc => '' },
        "物資" => { tr => "Resources",      desc => 'also Materials, even Supplies' },
        "特注家具職人" => { tr => "Custom Furniture Crafting",      desc => 'Artisan? - ..\resources\Textures\popup_set.tex' },
        "獲得可能資源" => { tr => "Possible Resource Gain",      desc => '' },
        "獲得資材" => { tr => "Resource Gain",      desc => 'Gained?' },
        "現　在　地：{0}" => { tr => "Current Location：{0}", desc => 'Present Location' },
        "現　在　地：鎮守府海域" => { tr => "Present Location:Chinjufu Region", desc => '' },
        "現在ターン：{0}" => { tr => "Current Turn：{0}", desc => 'Present Turn' },
        "現在ターン：零の年 睦月17日" => { tr => "Current Turn:Year0 Day17", desc => 'why? | start of the game? possibly a buffer to be filled?' },
        "現在値" => { tr => "Current Value",      desc => 'Present Value' },
        "球磨" => { tr => "Kuma",      desc => 'light cruiser' },
        "球磨改" => { tr => "Kuma Kai",      desc => '' },
        "理由" => { tr => "Reason",      desc => 'as in motive' },
        "瑞穂" => { tr => "Mizuho",      desc => 'seaplane tender' },
        "瑞穂改" => { tr => "Mizuho Kai",      desc => '' },
        "瑞鳳" => { tr => "Zuihou",      desc => 'light carrier' },
        "瑞鳳改" => { tr => "Zuihou Kai",      desc => '' },
        "瑞鶴" => { tr => "Zuikaku",      desc => 'standard carrier' },
        "瑞鶴改" => { tr => "Zuikaku Kai",      desc => '' },
        "瑞鶴改二" => { tr => "Zuikaku Kai Ni",      desc => '' },
        "瑞鶴改二甲" => { tr => "Zuikaku Kai Ni A",      desc => 'armoured carrier' },
        "由良" => { tr => "Yura",      desc => 'light cruiser' },
        "由良改" => { tr => "Yura Kai",      desc => '' },
        "画面内選択" => { tr => "On screen selection",      desc => 'In Picture Selection/Choice?' },
        "画面切替" => { tr => "Change Screen",      desc => 'Terminal Screen or Picture' },
        "疲労しています" => { tr => "Fatigued",      desc => '' },
        "白雪" => { tr => "Shirayuki",      desc => 'destroyer' },
        "白雪改" => { tr => "Shirayuki Kai",      desc => '' },
        "白露" => { tr => "Shiratsuyu",      desc => 'destroyer' },
        "白露1" => { tr => "Shiratsuyu1",      desc => '' },
        "白露改" => { tr => "Shiratsuyu Kai",      desc => '' },
        "皐月1" => { tr => "Satsuki1",      desc => 'destroyer' },
        "皐月改" => { tr => "Satsuki Kai",      desc => '' },
        "睦月1" => { tr => "Mutsuki1",      desc => 'destroyer' },
        "睦月改" => { tr => "Mutsuki Kai",      desc => '' },
        "睦月改二" => { tr => "Mutsuki Kai Ni",      desc => '' },
        "矢矧" => { tr => "Yahagi",      desc => 'light cruiser' },
        "矢矧改" => { tr => "Yahagi Kai",      desc => '' },
        "磯波" => { tr => "Isonami",      desc => 'destroyer' },
        "磯波1" => { tr => "Isonami1",      desc => '' },
        "磯波改" => { tr => "Isonami Kai",      desc => '' },
        "磯風" => { tr => "Isokaze",      desc => 'destroyer' },
        "磯風改" => { tr => "Isokaze Kai",      desc => '' },
        "神通" => { tr => "Jintsuu",      desc => 'light cruiser' },
        "神通改" => { tr => "Jintsuu Kai",      desc => '' },
        "神通改二" => { tr => "Jintsuu Kai Ni",      desc => '' },
        "祥鳳" => { tr => "Shouhou",      desc => 'light carrier' },
        "祥鳳1" => { tr => "Shouhou1",      desc => '' },
        "祥鳳改" => { tr => "Shouhou Kai",      desc => '' },
        "秋月" => { tr => "Akizuki",      desc => 'destroyer' },
        "秋月改" => { tr => "Akizuki Kai",      desc => '' },
        "秋津洲" => { tr => "Akitsushima",      desc => 'seaplane tender' },
        "秋津洲改" => { tr => "Akitsushima Kai",      desc => '' },
        "秋雲" => { tr => "Akigumo",      desc => 'destroyer' },
        "秋雲改" => { tr => "Akigumo Kai",      desc => '' },
        "第一艦隊" => { tr => "First Fleet",      desc => '' },
        "第一艦隊所属" => { tr => "First Fleet",      desc => 'technically [First Fleet][Belonging (to)] as in under control of' },
        "第一艦隊第一艦隊第一艦隊" => { tr => "FirstFleetFirstFleetFirstFleet",      desc => 'we get it, you vape' },
        "筑摩" => { tr => "Chikuma",      desc => 'heavy cruiser' },
        "筑摩改" => { tr => "Chikuma Kai",      desc => '' },
        "筑摩改二" => { tr => "Chikuma Kai Ni",      desc => 'aviation cruiser' },
        "素材となる艦娘" => { tr => "Resources to become Ship Girl",      desc => 'CONTEXT!?!?' },
        "索敵" => { tr => "Enemy Search",      desc => 'searching for the enemy' },
        "給糧艦「間宮」を使用します" => { tr => qq[Use "Mamiya"\x{200B}],      desc => '' },
        "綾波" => { tr => "Ayanami",      desc => 'destroyer' },
        "綾波1" => { tr => "Ayanami1",      desc => '' },
        "綾波改" => { tr => "Ayanami Kai",      desc => '' },
        "綾波改二" => { tr => "Ayanami Kai Ni",      desc => '' },
        "編成" => { tr => "Formation",      desc => 'Organization/Composition' },
        "練度 150" => { tr => "Proficiency 150",      desc => 'Skill/Experience' },
        "練習航海" => { tr => "Practice Navigation",      desc => 'Sailing?' },
        "羽黒" => { tr => "Haguro",      desc => 'heavy cruiser' },
        "羽黒1" => { tr => "Haguro1",      desc => '' },
        "羽黒改" => { tr => "Haguro Kai",      desc => '' },
        "羽黒改二" => { tr => "Haguro Kai Ni",      desc => '' },
        "翔鶴" => { tr => "Shoukaku",      desc => 'standard carrier' },
        "翔鶴改" => { tr => "Shoukaku Kai",      desc => '' },
        "翔鶴改二" => { tr => "ShoukakuKai Ni",      desc => '' },
        "翔鶴改二甲" => { tr => "Shoukaku Kai Ni A",      desc => 'armoured carrier' },
        "耐久\n999" => { tr => "Health\n999",      desc => 'Endurance' },
        "耐久力" => { tr => "Stamina",      desc => '' },
        "能代" => { tr => "Noshiro",      desc => 'light cruiser' },
        "能代改" => { tr => "Noshiro Kai",      desc => '' },
        "舞風" => { tr => "Maikaze",      desc => 'destroyer' },
        "舞風改" => { tr => "Maikaze Kai",      desc => '' },
        "■艦娘" => { tr => "■Ship Girl",      desc => '' },
        "艦娘からチョコが贈られました！" => { tr => "A Ship Girl gave you chocolate as a gift!",      desc => 'Chocolate given by Ship Girl as gift!' },
        "艦娘を　　　隻引き継ぎ可能です。" => { tr => "Control of Ship Girl now possible.",      desc => 'rough' },
        "艦娘保有数：{0}" => { tr => "Number of Ship Girls：{0}",      desc => 'rough' },
        "艦娘保有数：999" => { tr => "Ship Girl Number:999",      desc => 'Number of Ship Girls' },
        "艦娘保有数:" => { tr => "", desc => "" },
        " | 艦娘保有数 : " => { tr => "", desc => "" },
        "艦娘名" => { tr => "Ship Girl Name",      desc => '' },
        "艦娘名艦娘名艦娘名艦娘名" => { tr => "ShipGirlNameShipGirlNameShipGirlNameShipGirlName",      desc => 'is this a hidden camera show?' },
        "艦娘選択" => { tr => "Ship Girl Selection",      desc => 'Option/Choice' },
        "艦娘関連" => { tr => "Ship Girl Relation",      desc => 'Relevance' },
        "艦種  艦船名                 Lv　　　  耐久" => { tr => "Class  Name                 Lv　　　  Health",      desc => 'Ship Class  Ship Name                 Lv　　　  Health' },
        "艦種/艦船名" => { tr => "Class/Name",      desc => 'Ship Class/Ship Name' },
        "艦選択" => { tr => "Ship Selection",      desc => '' },
        "艦隊  艦種  艦船名             　        Lv　　  耐久" => { tr => "Fleet Class  Name                 Lv　　　  Health",      desc => '' },
        "艦隊1" => { tr => "Fleet1",      desc => '' },
        "艦隊10" => { tr => "Fleet10",      desc => '' },
        "艦隊11" => { tr => "Fleet11",      desc => '' },
        "艦隊12" => { tr => "Fleet12",      desc => '' },
        "艦隊13" => { tr => "Fleet13",      desc => '' },
        "艦隊14" => { tr => "Fleet14",      desc => '' },
        "艦隊15" => { tr => "Fleet15",      desc => '' },
        "艦隊16" => { tr => "Fleet16",      desc => '' },
        "艦隊17" => { tr => "Fleet17",      desc => '' },
        "艦隊18" => { tr => "Fleet18",      desc => '' },
        "艦隊19" => { tr => "Fleet19",      desc => '' },
        "艦隊2" => { tr => "Fleet2",      desc => '' },
        "艦隊3" => { tr => "Fleet3",      desc => '' },
        "艦隊4" => { tr => "Fleet4",      desc => '' },
        "艦隊5" => { tr => "Fleet5",      desc => '' },
        "艦隊6" => { tr => "Fleet6",      desc => '' },
        "艦隊7" => { tr => "Fleet7",      desc => '' },
        "艦隊8" => { tr => "Fleet8",      desc => '' },
        "艦隊9" => { tr => "Fleet9",      desc => '' },
        "艦隊、出撃せよ！" => { tr => "Sortie Fleet!",      desc => '' },
        "艦隊名" => { tr => "Fleet Name",      desc => '' },
        "艦隊数\r\n艦娘\r数\n装備アイテム\r数\n総入渠ドック数\r\n総工廠ドック\r数\nドック開放キー数\n家具数" => { tr => "Fleet Number\r\nShip Girl\rNumber\nEquipment Item\rNumber\nDocked Number Total\r\nTotal Factory Dock\rNumber\nNumber of Dock Open Keys\nNumber of Furniture",      desc => 'let me come back to this if i must' },
        "艦隊編成を実施せよ！" => { tr => "Carry out Fleet composition!",      desc => 'okay?' },
        "若葉" => { tr => "Wakaba",      desc => 'destroyer' },
        "若葉1" => { tr => "Wakaba1",      desc => '' },
        "若葉改" => { tr => "Wakaba Kai",      desc => '' },
        "荒潮" => { tr => "Arashio",      desc => 'destroyer' },
        "荒潮改" => { tr => "Arashio Kai",      desc => '' },
        "菊月" => { tr => "Kikuzuki",      desc => 'destroyer' },
        "菊月1" => { tr => "Kikuzuki1",      desc => '' },
        "菊月改" => { tr => "Kikuzuki Kai",      desc => '' },
        "萩風" => { tr => "Hagikaze ",      desc => 'destroyer' },
        "萩風改" => { tr => "Hagikaze  Kai",      desc => '' },
        "葛城" => { tr => "Katsuragi",      desc => 'standard carrier' },
        "葛城改" => { tr => "Katsuragi Kai",      desc => '' },
        "蒼龍" => { tr => "Souryuu",      desc => 'standard carrier' },
        "蒼龍改" => { tr => "Souryuu Kai",      desc => '' },
        "蒼龍改二" => { tr => "Souryuu Kai Ni",      desc => '' },
        "衣笠" => { tr => "Kinugasa",      desc => 'heavy cruiser' },
        "衣笠改" => { tr => "Kinugasa Kai",      desc => '' },
        "衣笠改二" => { tr => "Kinugasa Kai Ni",      desc => '' },
        "装備名装備名装備名装備名" => { tr => "EquipmentNameEquipmentNameEquipmentNameEquipmentName",      desc => '' },
        "装備名装備名装備名装備名装備名" => { tr => "EquipmentNameEquipmentNameEquipmentNameEquipmentNameEquipmentName",      desc => '' },
        "装備変更 確認" => { tr => "Confirm Equipment Change",      desc => '' },
        "装甲" => { tr => "Armor",      desc => '' },
        "補給" => { tr => "Supply",      desc => '' },
        "補給がされていません" => { tr => "Unsupplied\x{200B}",      desc => 'Supply has not happened.' },
        "補給する資源" => { tr => "Resources to be supplied",      desc => '' },
        "視聴ショートカットバージョン" => { tr => "Viewing Shortcut Version",      desc => '' },
        "設　定" => { tr => "Configuration",      desc => '' },
        "試製FaT仕様九五式酸素魚雷改" => { tr => "Trial Manufacture of FaT Type 93 Kai Torpedo",      desc => 'please tell me this is not actually in the game' },
        "谷風" => { tr => "Tanikaze",      desc => 'destroyer' },
        "谷風改" => { tr => "Tanikaze Kai",      desc => '' },
        "購入 - 壁紙 - " => { tr => "Purchase - Wallpaper - ",      desc => '' },
        "赤城" => { tr => "Akagi",      desc => 'standard carrier' },
        "赤城1" => { tr => "Akagi1",      desc => '' },
        "赤城改" => { tr => "Akagi Kai",      desc => '' },
        "足柄" => { tr => "Ashigara",      desc => 'heavy cruiser' },
        "足柄1" => { tr => "Ashigara1",      desc => '' },
        "足柄改" => { tr => "Ashigara Kai",      desc => '' },
        "足柄改二" => { tr => "Ashigara Kai Ni",      desc => '' },
        "輸送船 x 1" => { tr => "Transport Ship x 1",      desc => '' },
        "迎撃連合艦隊出撃序列" => { tr => "Interception Fleet Score",      desc => 'Interception Combined Fleet Scoring Ranking Order' },
        "近海警備" => { tr => "Costal Defense",      desc => 'Offshore Garrison' },
        "追撃せず" => { tr => "Do Not Persue",      desc => '' },
        "退避" => { tr => "Evacuate",      desc => '' },
        "退避せず" => { tr => "Do Not Evacuate",      desc => '' },
        "速吸" => { tr => "Hayasui",      desc => 'fleet oiler' },
        "速吸改" => { tr => "Hayasui Kai",      desc => '' },
        "進撃" => { tr => "Charge",      desc => '' },
        "進撃\n決戦主力艦隊を\n前へ！" => { tr => "Advance to the final battle!",      desc => 'Charge ahead to the...' },
        "遂行中作戦：{0}" => { tr => "Execute Middle Strategy：{0}", desc => 'very rough, i need context for this one' },
        "遂行中作戦：第*海域**作戦" => { tr => "Operation:Number*Region**Strategy", desc => "Operation (in progress) | no idea if the asteriskses are string part or code-important"},
        "運\n999" => { tr => "Luck\n999",      desc => '' },
        "遠征を中止しますか？" => { tr => "Stop the expedition?",      desc => 'Would you like to stop the expedition?' },
        "遠征名" => { tr => "Expedition Name",      desc => '' },
        "遠征名遠征名遠征名遠征名" => { tr => "ExpeditionNameExpeditionNameExpeditionNameExpeditionName",      desc => '' },
        "遷移メニュー" => { tr => "Transition Menu",      desc => '' },
        "那智" => { tr => "Nachi",      desc => 'heavy cruiser' },
        "那智改" => { tr => "Nachi Kai",      desc => '' },
        "那智改二" => { tr => "Nachi Kai Ni",      desc => '' },
        "那珂" => { tr => "Naka",      desc => 'light cruiser' },
        "那珂改" => { tr => "Naka Kai",      desc => '' },
        "那珂改二" => { tr => "Naka Kai Ni",      desc => '' },
        "配備設定を中止してもよろしいですか？" => { tr => "Confirm canceling deploment settings?",      desc => 'Are you certian you wish to cancel deployment settings?' },
        "酒匂" => { tr => "Sakawa",      desc => 'light cruiser' },
        "酒匂改" => { tr => "Sakawa Kai",      desc => '' },
        "重巡洋艦　利根改二" => { tr => "Heavy Cruiser Tone Kai Ni",      desc => '' },
        "重来荘巡洋艦" => { tr => "Heavenly Cruiser",      desc => 'this makes no sense to me at all - maybe i am tired?' },
        "野分" => { tr => "Nowaki",      desc => 'destroyer' },
        "野分改" => { tr => "Nowaki Kai",      desc => '' },
        "金剛" => { tr => "Kongou",      desc => 'fast battleship' },
        "金剛1" => { tr => "Kongou1",      desc => '' },
        "金剛改" => { tr => "Kongou Kai",      desc => '' },
        "金剛改二" => { tr => "Kongou Kai Ni",      desc => '' },
        "鈴谷" => { tr => "Suzuya",      desc => 'heavy cruiser' },
        "鈴谷1" => { tr => "Suzuya1",      desc => '' },
        "鈴谷改" => { tr => "Suzuya Kai",      desc => 'aviation cruiser' },
        "鎮守府正面海域" => { tr => "Chinjufu Region",      desc => 'Chinjufu [Navy Base] Front Area' },
        "鎮守府正面海域鎮守府正面海域鎮守府正面海域" => { tr => "ChinjufuRegionChinjufuRegionChinjufuRegion",      desc => '' },
        "鎮守府正面近海の警備に出動せよ！" => { tr => "Defend Chinjufu Region's waters!",      desc => 'Go out to the Chinjufu Region front area!' },
        "鎮守府海域" => { tr => "Chinjufu Region",      desc => '' },
        "長月1" => { tr => "Nagatsuki",      desc => 'destroyer' },
        "長月改" => { tr => "Nagatsuki Kai",      desc => '' },
        "長波" => { tr => "Naganami",      desc => 'destroyer' },
        "長波改" => { tr => "Naganami Kai",      desc => '' },
        "長良" => { tr => "Nagara",      desc => 'light cruiser' },
        "長良改" => { tr => "Nagara Kai",      desc => '' },
        "長門" => { tr => "Nagato",      desc => 'battleship' },
        "長門改" => { tr => "Nagato Kai",      desc => '' },
        "開放キーを持っていません" => { tr => "You do not posess an Open Key",      desc => '' },
        "開発資材" => { tr => "Development Materials",      desc => '' },
        "阿武隈" => { tr => "Abukuma",      desc => 'light cruiser' },
        "阿武隈改" => { tr => "Abukuma Kai",      desc => '' },
        "阿武隈改二" => { tr => "Abukuma Kai Ni",      desc => '' },
        "阿賀野" => { tr => "Agano",      desc => 'light cruiser' },
        "阿賀野改" => { tr => "Agano Kai",      desc => '' },
        "陸奥" => { tr => "Mutsu",      desc => 'battleship SNAAAAIL!!!!!' },
        "陸奥改" => { tr => "Mutsu Kai",      desc => '' },
        "陽炎" => { tr => "Kagerou",      desc => 'destroyer' },
        "陽炎改" => { tr => "Kagerou Kai",      desc => '' },
        "隼鷹" => { tr => "Junyou",      desc => 'light carrier' },
        "隼鷹改" => { tr => "Junyou Kai",      desc => '' },
        "隼鷹改二" => { tr => "Junyou Kai Ni",      desc => '' },
        "難　易　度：{0}" => { tr => "Difficulty level:{0}", desc => "Degree of difficulty'" },
        "難　易　度：ナイトメアモード" => { tr => "Difficulty Level:Nightmare Mode", desc => '' },
        "雪風" => { tr => "Yukikaze",      desc => 'destroyer - you really need this one' },
        "雪風改" => { tr => "Yukikaze Kai",      desc => '' },
        "雲龍" => { tr => "Unryuu",      desc => 'standard carrier' },
        "雲龍改" => { tr => "Unryuu Kai",      desc => '' },
        "零の年" => { tr => "Year Zero",      desc => 'Zero of the year' },
        "雷1" => { tr => "Ikazuchi1",      desc => 'destroyer' },
        "雷撃演習\nが開放されました！" => { tr => "Torpedo Exercises now open!",      desc => '' },
        "雷改" => { tr => "Ikazuchi Kai",      desc => '' },
        "雷装" => { tr => "Torpedo",      desc => '' },
        "電1" => { tr => "Inazuma1",      desc => 'destroyer' },
        "電改" => { tr => "Inazuma Kai",      desc => '' },
        "霞改" => { tr => "Kasumi Kai",      desc => 'destroyer  -  *where is 霞?*' },
        "霧島" => { tr => "Kirishima",      desc => 'fast battleship' },
        "霧島改" => { tr => "Kirishima Kai",      desc => '' },
        "霧島改二" => { tr => "Kirishima Kai Ni",      desc => '' },
        "霰改" => { tr => "Arare Kai",      desc => 'destroyer  -  *where is 霰?*' },
        "青葉" => { tr => "Aoba",      desc => 'heavy cruiser' },
        "青葉1" => { tr => "Aoba1",      desc => '' },
        "青葉改" => { tr => "Aoba Kai",      desc => '' },
        "響改" => { tr => "Hibiki Kai",      desc => 'destroyer  -  *where is 響?*' },
        "風雲" => { tr => "Kazagumo",      desc => 'destroyer' },
        "風雲改" => { tr => "Kazagumo Kai",      desc => '' },
        "飛鷹" => { tr => "Hiyou",      desc => 'light carrier' },
        "飛鷹改" => { tr => "Hiyou Kai",      desc => '' },
        "飛龍" => { tr => "Hiryuu",      desc => 'standard carrier' },
        "飛龍改" => { tr => "Hiryuu Kai",      desc => '' },
        "飛龍改二" => { tr => "Hiryuu Kai Ni",      desc => '' },
        "香取" => { tr => "Katori",      desc => 'training cruiser' },
        "香取改" => { tr => "Katori Kai",      desc => '' },
        "駆逐ニ級後期型\r" => { tr => "",      desc => 'this makes no sense to me 駆逐 [destroy] ニ級 [second degree/level/class] 後期型 [late type]' },
        "高波" => { tr => "Takanami",      desc => 'destroyer' },
        "高波改" => { tr => "Takanami Kai",      desc => '' },
        "高速" => { tr => "Instant",      desc => 'High-speed' },
        "高速修復材" => { tr => "Instant Repair",      desc => 'high-speed repair material' },
        "高速修復材を使用します" => { tr => "Using instant repair",      desc => 'context may be - Use instant repair' },
        "高速修復材を使用しますか？" => { tr => "Use instant repair?",      desc => 'Would you like to use instant repair?' },
        "高雄" => { tr => "Takao",      desc => 'heavy cruiser' },
        "高雄改" => { tr => "Takao Kai",      desc => '' },
        "鬼怒" => { tr => "Kinu",      desc => "light cruiser - 鬼怒 literally means Ogre's Rage" },
        "鬼怒改" => { tr => "Kinu Kai",      desc => '' },
        "鳥海" => { tr => "Choukai",      desc => 'heavy cruiser' },
        "鳥海改" => { tr => "Choukai Kai",      desc => '' },
        "鳥海改二" => { tr => "Choukai Kai Ni",      desc => '' },
        "鳳翔" => { tr => "Houshou",      desc => 'light carrier' },
        "鳳翔改" => { tr => "Houshou Kai",      desc => '' },
        "鹿島" => { tr => "Kashima",      desc => 'training cruiser' },
        "鹿島改" => { tr => "Kashima Kai",      desc => '' },
        "黒潮" => { tr => "Kuroshio",      desc => 'destroyer' },
        "黒潮改" => { tr => "Kuroshio Kai",      desc => '' },
        "龍田" => { tr => "Tatsuta",      desc => 'light cruiser' },
        "龍田改" => { tr => "Tatsuta Kai",      desc => '' },
        "龍驤" => { tr => "Ryuujou",      desc => 'light carrier' },
        "龍驤1" => { tr => "Ryuujou1",      desc => '' },
        "龍驤改" => { tr => "Ryuujou Kai",      desc => '' },
        "龍驤改二" => { tr => "Ryuujou Kai Ni",      desc => '' },
        "龍鳳" => { tr => "Taigei",      desc => 'light carrier' },
        "龍鳳改" => { tr => "Taigei Kai",      desc => '' },
        "改修資材　×" => { tr => "Improvement Material",      desc => '' },
        "ボーキ　×" => { tr => "Bauxite x",      desc => 'ボーキサイト is Bauxite' },
        "弾薬　×" => { tr => "Ammunition x",      desc => '' },
        "戦略P　×" => { tr => "StrategyP x",      desc => '' },
        "燃料　×" => { tr => "Fuel x",      desc => '' },
        "輸送船　×" => { tr => "Transport Ship x",      desc => '' },
        "鋼材　×" => { tr => "Steel x",      desc => '' },
        "開発資材　×" => { tr => "Development Materials x",      desc => '' },
        "高速修復　×" => { tr => "Instant Repair x",      desc => '' },
        "高速建造　×" => { tr => "Instant Construction  x",      desc => '' },
        "給糧艦「間宮＆伊良湖」を使用します" => { tr => qq[Use "Mamiya & Irako"],      desc => '' },
        "給糧艦「間宮＆伊良湖」を使用しますか？" => { tr => qq[Use "Mamiya & Irako"?],      desc => '' },
        "クリア状況：未" => { tr => "Clear Status:Not Completed",      desc => 'Not Yet Completed' },
        "難易度：" => { tr => "Difficulty Level",      desc => '' },
        "10ｃｍ連装高角砲" => { tr => "10cm Twin High-angle Gun Mount",      desc => 'http://kancolle.wikia.com/wiki/10cm_Twin_High-angle_Gun_Mount' },
        "窓枠＋カーテン" => { tr => "Window Frame + Curtain",      desc => 'i think this is a shop thing' },
        "■全回復（選択中の艦隊）" => {  tr => "■Full Recovery (Selected Fleet)",      desc => "no idea if the black blocks are really part of the string, but it makes scanning easier"},
        "■反攻無視" => { tr => "■Counterattack",      desc => '' },
        "■大型艦建造" => { tr => "■LSC\x{200B}\x{200B}",      desc => 'Large Ship Construction' },
        "■強制クリア" => { tr => "■Forced Clear",      desc => '' },
        "■艦隊数" => { tr => "■Number of Fleets",      desc => '' },
        "■装備" => { tr => "■Equipment",      desc => '' },
        "■資材" => { tr => "■Material",      desc => 'Materials/Resources' },
        "零の年　師走８日" => { tr => "Year Zero December 8",      desc => "'Zero of the year'- editing out word day"},
        "戦略へ\t" => { tr => "To Strategy\t",      desc => "no idea if the tab here is real or code"},
        "「資源」や「改修資材」に交換出来ます。\nまた、勲章4個を「改装設計図」1枚に交換可能です。" => { tr => "", desc => "" },
        "この改装には「改装設計図」が" => { tr => "", desc => "" },
        "この海域には配備出来ません" => { tr => "", desc => "" },
        "この海域の遠征任務は解放されていません" => { tr => "", desc => "" },
        "どの演習を行いますか？" => { tr => "", desc => "" },
        "どの装備の改修を試みますか？" => { tr => "", desc => "" },
        "に参加できる編成ではありません" => { tr => "", desc => "" },
        "まとめて補給ボタン押下" => { tr => "", desc => "" },
        "を改修しますね！[-]" => { tr => "", desc => "" },
        "アイテム「補強増設」を持っていません" => { tr => "", desc => "" },
        "クリア状態:" => { tr => "", desc => "" },
        "ケッコン指輪が必要です" => { tr => "", desc => "" },
        "タイトルに戻ります。" => { tr => "", desc => "" },
        "ダメージ状態変更(D)" => { tr => "", desc => "" },
        "ダメージ状態:{0}" => { tr => "", desc => "" },
        "ダメージ状態:{0}(D)" => { tr => "", desc => "" },
        "ダメージ" => { tr => "", desc => "" },
        "ドックが満杯で建造できません" => { tr => "", desc => "" },
        "子要素のプレハブを設定してください。" => { tr => "", desc => "" },
        "ボーキサイト:" => { tr => "", desc => "" },
        "マップが存在しません" => { tr => "", desc => "" },
        "メニュー選択" => { tr => "", desc => "" },
        "モード変更(E)" => { tr => "", desc => "" },
        "モード:{0}" => { tr => "", desc => "" },
        "レベル:{0}    取得可能アイテム:" => { tr => "", desc => "" },
        "カットインチェック状態" => { tr => "", desc => "" },
        "今の編成ではこのマップに出撃できません" => { tr => "", desc => "" },
        "他艦選択中\n" => { tr => "", desc => "" },
        "任務受託数がupしました！" => { tr => "", desc => "" },
        "任務拡張報酬: 最大同時遂行数:{0}" => { tr => "", desc => "" },
        "作戦内容:" => { tr => "", desc => "" },
        "作戦日数 : {0}日\n" => { tr => "", desc => "" },
        "修復中の艦娘がいます" => { tr => "", desc => "" },
        "入渠します Dock:" => { tr => "", desc => "" },
        "入渠の必要はありません" => { tr => "", desc => "" },
        "入渠ドック: {0} " => { tr => "", desc => "" },
        "入渠中の艦です" => { tr => "", desc => "" },
        "出撃艦隊:{0}\n" => { tr => "", desc => "" },
        "初期状態:{0}\n" => { tr => "", desc => "" },
        "初速力方向ランダム度数" => { tr => "", desc => "" },
        "前衛支援艦隊" => { tr => "", desc => "" },
        "勝利ランク：{0}   提督名：{1}   戦闘後の提督レベル：{2}\n" => { tr => "", desc => "" },
        "勝利!!" => { tr => "", desc => "" },
        "勝利" => { tr => "", desc => "" },
        "反抗編成ナビ設定:" => { tr => "", desc => "" },
        "可変オフセット:{0}" => { tr => "", desc => "" },
        "可能" => { tr => "", desc => "" },
        "味方側カットイン対象艦:{0} " => { tr => "", desc => "" },
        "味方側 夜間触接使用:{0}\n" => { tr => "", desc => "" },
        "味方側 探照灯使用:{0}\n" => { tr => "", desc => "" },
        "味方側 照明弾使用:{0}\n" => { tr => "", desc => "" },
        "味方側 航空機無し\n" => { tr => "", desc => "" },
        "味方側 " => { tr => "", desc => "" },
        "味方艦隊" => { tr => "", desc => "" },
        "命中" => { tr => "", desc => "" },
        "喪失艦娘 : {0}隻\n" => { tr => "", desc => "" },
        "回航中の艦です" => { tr => "", desc => "" },
        "回航艦を含んでいます" => { tr => "", desc => "" },
        "図鑑ID:{0} --- " => { tr => "", desc => "" },
        "図鑑ID:{0} {1}(MstId:{2}) {3}" => { tr => "", desc => "" },
        "売り切れです" => { tr => "", desc => "" },
        "大型艦建造開放" => { tr => "", desc => "" },
        "大型" => { tr => "", desc => "" },
        "対潜戦演習" => { tr => "", desc => "" },
        "対潜戦" => { tr => "", desc => "" },
        "対潜\n" => { tr => "", desc => "" },
        "対空\n" => { tr => "", desc => "" },
        "対象の艦隊:{0}" => { tr => "", desc => "" },
        "対象艦のステータス\n" => { tr => "", desc => "" },
        "対象艦: 未設定\n" => { tr => "", desc => "" },
        "対象艦: {0} Lv{1}(必要レベル:{2}) 所持弾薬:{3}(必要弾薬:{4}) 所持鋼材:{5}(必要鋼材:{6}) 所持開発資材:{7}(必要開発資材:{8}) \n" => { tr => "", desc => "" },
        "対象艦: {0}\n" => { tr => "", desc => "" },
        "射程：" => { tr => "", desc => "" },
        "帰還艦隊 ID:{0}\n" => { tr => "", desc => "" },
        "建造数:{0} 開始:{1} 終了:{2} [輸送船建造]" => { tr => "", desc => "" },
        "弾薬:" => { tr => "", desc => "" },
        "必要な資材が不足しています" => { tr => "", desc => "" },
        "戦略ポイント報酬: {0}" => { tr => "", desc => "" },
        "戦略ポイント:" => { tr => "", desc => "" },
        "戦闘ルート種別" => { tr => "", desc => "" },
        "提督、明石の工廠へようこそ！" => { tr => "", desc => "" },
        "提督レベル:" => { tr => "", desc => "" },
        "搭載:{0}/{1} " => { tr => "", desc => "" },
        "改装開始可能:{0} 改造チェック:{1}\n" => { tr => "", desc => "" },
        "改造" => { tr => "", desc => "" },
        "旗艦が大破しています" => { tr => "", desc => "" },
        "既に他の艦隊が遠征しています" => { tr => "", desc => "" },
        "既に入渠している艦です" => { tr => "", desc => "" },
        "日 " => { tr => "", desc => "" },
        "日" => { tr => "", desc => "" },
        "暫定編成:{0}\n" => { tr => "", desc => "" },
        "未婚" => { tr => "", desc => "" },
        "枚必要です" => { tr => "", desc => "" },
        "残り継戦時間 " => { tr => "", desc => "" },
        "残り遠征日数" => { tr => "", desc => "" },
        "母港拡張報酬: 最大艦数:{0} 最大装備数:{1}" => { tr => "", desc => "" },
        "水上機" => { tr => "", desc => "" },
        "決戦主力艦隊" => { tr => "", desc => "" },
        "決戦支援艦隊" => { tr => "", desc => "" },
        "注視点変更(P)" => { tr => "", desc => "" },
        "注視点状態:" => { tr => "", desc => "" },
        "注視点" => { tr => "", desc => "" },
        "注視点:{0}" => { tr => "", desc => "" },
        "注視点[{1}]:{0}" => { tr => "", desc => "" },
        "海上護衛艦です" => { tr => "", desc => "" },
        "海域に未配備の輸送船数:{0}(帰港中:{1})\n" => { tr => "", desc => "" },
        "海域に艦隊無し" => { tr => "", desc => "" },
        "海域オブジェクト破棄" => { tr => "", desc => "" },
        "海域ベース生成" => { tr => "", desc => "" },
        "海域ルートスクリプト追加" => { tr => "", desc => "" },
        "海域名：{0} 味方艦隊名：{1}  敵艦隊名：{2}   海域基本経験値：{3}\n" => { tr => "", desc => "" },
        "海域詳細情報" => { tr => "", desc => "" },
        "海域読み込み" => { tr => "", desc => "" },
        "海域:{0}\n" => { tr => "", desc => "" },
        "海域ID:{0}\n" => { tr => "", desc => "" },
        "海域{0}に{1}隻" => { tr => "", desc => "" },
        "海域{0}の護衛艦隊" => { tr => "", desc => "" },
        "演習　参加中" => { tr => "", desc => "" },
        "演習可能な艦隊がありません" => { tr => "", desc => "" },
        "火力:{0} 雷装:{1} 対空:{2} 回避:{3} 耐久:{4}" => { tr => "", desc => "" },
        "火力:{0}({1:f}) 雷装:{2}({3:f}) 対空:{4}({5:f}) 回避:{6}({7:f}) 耐久:{8}({9:f})" => { tr => "", desc => "" },
        "火力:{0}->{1}(+{2}) 雷装:{3}->{4}(+{5}) 対空:{6}->{7}(+{8}) 装甲:{9}->{10}(+{11}) 運:{12}->{13}(+{14})" => { tr => "", desc => "" },
        "火力\n" => { tr => "", desc => "" },
        "無敵モード" => { tr => "", desc => "" },
        "燃料・弾薬が最大の必要があります" => { tr => "", desc => "" },
        "燃料補給:{0} 弾薬補給:{1} まとめて補給:{2}\n" => { tr => "", desc => "" },
        "燃料/弾薬が最大の必要があります" => { tr => "", desc => "" },
        "燃料/弾薬が0の艦を含んでいます(補給が必要です)" => { tr => "", desc => "" },
        "燃料:" => { tr => "", desc => "" },
        "特定の艦種が必要です" => { tr => "", desc => "" },
        "状態：クリア済み" => { tr => "", desc => "" },
        "状態：未クリア" => { tr => "", desc => "" },
        "状態:{0}\n" => { tr => "", desc => "" },
        "獲得戦略ポイント:{0} " => { tr => "", desc => "" },
        "獲得経験値:{0} 獲得資材:燃/弾/鋼/ボ {1}/{2}/{3}/{4}" => { tr => "", desc => "" },
        "獲得経験値:{0} 経験値:{1}=>{2}" => { tr => "", desc => "" },
        "獲得資材:{0}/{1}/{2}/{3}" => { tr => "", desc => "" },
        "現在、改装が出来ません" => { tr => "", desc => "" },
        "画像設定" => { tr => "", desc => "" },
        "番が入渠を終えた。" => { tr => "", desc => "" },
        "疲労度の高い艦がいます" => { tr => "", desc => "" },
        "疲労度-赤の艦を含んでいます" => { tr => "", desc => "" },
        "相手側カットイン対象艦:{0}\n" => { tr => "", desc => "" },
        "相手側 夜間触接使用:{0}\n" => { tr => "", desc => "" },
        "相手側 照明弾使用:{0}\n" => { tr => "", desc => "" },
        "相手側 航空機無し\n" => { tr => "", desc => "" },
        "相手側 " => { tr => "", desc => "" },
        "相手側HP {0}->{1}\n" => { tr => "", desc => "" },
        "砲戦演習" => { tr => "", desc => "" },
        "砲戦" => { tr => "", desc => "" },
        "第一艦隊です" => { tr => "", desc => "" },
        "第一艦隊では実行できません" => { tr => "", desc => "" },
        "第17海域あ号作戦" => { tr => "", desc => "" },
        "第{0}艦隊" => { tr => "", desc => "" },
        "第{0}艦隊\nが開放されました！" => { tr => "", desc => "" },
        "索敵結果[{0}]" => { tr => "", desc => "" },
        "結婚" => { tr => "", desc => "" },
        "総ターン数:{0}\t日時:{1}" => { tr => "", desc => "" },
        "総合演習" => { tr => "", desc => "" },
        "総合" => { tr => "", desc => "" },
        "耐久:{0}->{1}(+{2}) " => { tr => "", desc => "" },
        "耐久\n" => { tr => "", desc => "" },
        "自動配備しました" => { tr => "", desc => "" },
        "航空偵察ポイントオブジェクト生成" => { tr => "", desc => "" },
        "航空偵察" => { tr => "", desc => "" },
        "航空戦マス" => { tr => "", desc => "" },
        "航空戦演習" => { tr => "", desc => "" },
        "航空戦" => { tr => "", desc => "" },
        "航空機無し" => { tr => "", desc => "" },
        "艦娘と装備を一部引き継いで、ゲームを開始します。" => { tr => "", desc => "" },
        "艦娘ドロップ演出終了" => { tr => "", desc => "" },
        "艦娘選択 - その他 -" => { tr => "", desc => "" },
        "艦娘選択 - 第" => { tr => "", desc => "" },
        "艦娘選択 -" => { tr => "", desc => "" },
        "艦隊が編成されていません" => { tr => "", desc => "" },
        "艦隊に入渠中の艦がいます" => { tr => "", desc => "" },
        "艦隊の編成は条件を満たしていません" => { tr => "", desc => "" },
        "艦隊は他の海域にいます" => { tr => "", desc => "" },
        "艦隊は他の海域に居ます" => { tr => "", desc => "" },
        "艦隊は入渠中の艦を含んでいます" => { tr => "", desc => "" },
        "艦隊保有数:" => { tr => "", desc => "" },
        "艦隊行動演習" => { tr => "", desc => "" },
        "艦隊行動" => { tr => "", desc => "" },
        "艦隊 -" => { tr => "", desc => "" },
        "艦:{0} 開始:{1} 終了:{2}" => { tr => "", desc => "" },
        "艦:{0} 開始:{1} 終了:{2}{3}" => { tr => "", desc => "" },
        "艦ID" => { tr => "", desc => "" },
        "艦ID:" => { tr => "", desc => "" },
        "行動終了しています" => { tr => "", desc => "" },
        "行動終了している艦隊です" => { tr => "", desc => "" },
        "行動終了" => { tr => "", desc => "" },
        "装備スロットがありません" => { tr => "", desc => "" },
        "装備ロック" => { tr => "", desc => "" },
        "装備可能なカテゴリ:" => { tr => "", desc => "" },
        "装備変更" => { tr => "", desc => "" },
        "装備選択　- " => { tr => "", desc => "" },
        "補給が必要な艦がいます" => { tr => "", desc => "" },
        "補給が必要な艦娘がいます" => { tr => "", desc => "" },
        "補給EO" => { tr => "", desc => "" },
        "資材が不足しています" => { tr => "", desc => "" },
        "輸送船が不足しています" => { tr => "", desc => "" },
        "輸送船報酬: {0}隻" => { tr => "", desc => "" },
        "近代化改修（合成）に失敗しました。" => { tr => "", desc => "" },
        "近代化改修" => { tr => "", desc => "" },
        "運\n" => { tr => "", desc => "" },
        "遠征中です" => { tr => "", desc => "" },
        "遠征中の艦です" => { tr => "", desc => "" },
        "遠征中止" => { tr => "", desc => "" },
        "遠征中 残り" => { tr => "", desc => "" },
        "遠征中" => { tr => "", desc => "" },
        "遠征帰還中" => { tr => "", desc => "" },
        "選択中の艦隊-{0}\n" => { tr => "", desc => "" },
        "選択中の艦隊ID:{0}\n" => { tr => "", desc => "" },
        "鋼材:" => { tr => "", desc => "" },
        "難易度:" => { tr => "", desc => "" },
        "零の年 睦月17日" => { tr => "", desc => "" },
        "雷撃戦演習" => { tr => "", desc => "" },
        "雷撃戦" => { tr => "", desc => "" },
        "{0}({1}) へ雷撃 (ダメージ:{2} {3}{4}) {5}{6}\n" => { tr => "", desc => "" },
        "{0}({1}) から {2}({3}) へ雷撃 (ダメージ:{4}(c:{7}) {5}{6})\n" => { tr => "", desc => "" },
        "電探" => { tr => "", desc => "" },
        "駆逐艦:装備{0}" => { tr => "", desc => "" },
        "高速修復剤" => { tr => "", desc => "" },
        "高速修復材が不足しています" => { tr => "", desc => "" },
        "高速建造材が不足しています" => { tr => "", desc => "" },
        "高速建造材/高速修復材/開発資材/改修資材: {0}/{1}/{2}/{3}" => { tr => "", desc => "" },
        " レア度:{0} 必要コイン数:{1}" => { tr => "", desc => "" },
        " 回避バフ:{0}%" => { tr => "", desc => "" },
        " 回避:{0} 索敵:{1} 射程:{2}\n" => { tr => "", desc => "" },
        " 必要輸送船数:{0}-{1}" => { tr => "", desc => "" },
        " 戦艦:装備{0}" => { tr => "", desc => "" },
        " 改修必要資材 燃/弾/鋼/ボ:{0}/{1}/{2}/{3}" => { tr => "", desc => "" },
        " 正規空母:装備{0}" => { tr => "", desc => "" },
        " 水上機母艦:装備{0}" => { tr => "", desc => "" },
        " 獲得戦略ポイント:{0}\n" => { tr => "", desc => "" },
        " 耐久度率：" => { tr => "", desc => "" },
        " 航空戦艦:装備{0}\n" => { tr => "", desc => "" },
        " 護衛艦隊無し" => { tr => "", desc => "" },
        " 軽巡洋艦:装備{0}" => { tr => "", desc => "" },
        " 軽空母:装備{0}" => { tr => "", desc => "" },
        " 輸送船団全滅" => { tr => "", desc => "" },
        " 輸送船団遭難" => { tr => "", desc => "" },
        " 輸送船:{0}/{1}(移動中:{2},遠征中:{3}) " => { tr => "", desc => "" },
        " 進行度:{0} " => { tr => "", desc => "" },
        " 重巡洋艦:装備{0}" => { tr => "", desc => "" },
        " 開発資材:{0} 改修資材:{1}" => { tr => "", desc => "" },
        " 高速建造:{0} 高速修復:{1} 開発資材:{2} 改修資材:{3}" => { tr => "", desc => "" },
        " 高速:" => { tr => "", desc => "" },
        "  マップ番号:" => { tr => "", desc => "" },
        "  地名:" => { tr => "", desc => "" },
        "  海域ID:" => { tr => "", desc => "" },
        "  移動中:残り{0}ターン" => { tr => "", desc => "" },
        "   名前の長さ：result.text.Length: " => { tr => "", desc => "" },
        "   火力上昇:{0} 雷装上昇:{1} 対空上昇:{2} 対潜上昇:{3} 装甲上昇:{4} 回避上昇:{5} 運上昇:{6}" => { tr => "", desc => "" },
        "    エリア情報:" => { tr => "", desc => "" },
        "    入渠ドック数 : " => { tr => "", desc => "" },
        "    出撃可能なマップ(マップ表示の有無):" => { tr => "", desc => "" },
        "    回避:" => { tr => "", desc => "" },
        "    家具保有数 : " => { tr => "", desc => "" },
        "    対潜:" => { tr => "", desc => "" },
        "    対空:" => { tr => "", desc => "" },
        "    射程:" => { tr => "", desc => "" },
        "    工廠ドック数 : " => { tr => "", desc => "" },
        "    搭載:" => { tr => "", desc => "" },
        "    最大備蓄可能各資材量 : " => { tr => "", desc => "" },
        "    最大所有可能艦娘数 : " => { tr => "", desc => "" },
        "    火力:" => { tr => "", desc => "" },
        "    索的:" => { tr => "", desc => "" },
        "    装備アイテム保有数 : " => { tr => "", desc => "" },
        "    装甲:" => { tr => "", desc => "" },
        "    速力:" => { tr => "", desc => "" },
        "    運  :" => { tr => "", desc => "" },
        "    雷装:" => { tr => "", desc => "" },
        "    Lov値:" => { tr => "", desc => "" },
        " - 表示する艦ID:{0}({3}) ダメージ絵:{1} {2}\n" => { tr => "", desc => "" },
        " - 遂行中の任務数:{0}\n" => { tr => "", desc => "" },
        " -- 移動完了した艦[" => { tr => "", desc => "" },
        " -- 移動完了した護衛艦隊[" => { tr => "", desc => "" },
        " -- 移動完了した輸送船[" => { tr => "", desc => "" },
        " [大型艦建造]" => { tr => "", desc => "" },
        " [改修確定化]" => { tr => "", desc => "" },
        " [艦隊ID:{0}{1}に編成中]" => { tr => "", desc => "" },
        " [護衛艦隊{0}に編成中]" => { tr => "", desc => "" },
        " mstID:{0} memID:{1}" => { tr => "", desc => "" },
        " | クリア実勢: " => { tr => "", desc => "" },
        " | クリア実績: 無し\n" => { tr => "", desc => "" },
        " | 提督名 / レベル / 階級 : " => { tr => "", desc => "" },
        " | 提督経験値 / 次レベル : " => { tr => "", desc => "" },
        " | 最大所有可能艦隊数 : " => { tr => "", desc => "" },
        " | 最大所有可能装備アイテム数 : " => { tr => "", desc => "" },
        " | [出撃] 勝利数 / 敗北数 / 勝率 : " => { tr => "", desc => "" },
        "#{0}-{1} セル{2}({3})" => { tr => "", desc => "" },
        "#{0}-{1}(Id:{2})  {3} {4} {5} {6}" => { tr => "", desc => "" },
        "(マスタ未ロード)" => { tr => "", desc => "" },
        "(中破絵)" => { tr => "", desc => "" },
        "(土)" => { tr => "", desc => "" },
        "(建造艦:{0})" => { tr => "", desc => "" },
        "(日)" => { tr => "", desc => "" },
        "(月)" => { tr => "", desc => "" },
        "(木)" => { tr => "", desc => "" },
        "(未)" => { tr => "", desc => "" },
        "(水)" => { tr => "", desc => "" },
        "(済)" => { tr => "", desc => "" },
        "(火)" => { tr => "", desc => "" },
        "(結婚済)" => { tr => "", desc => "" },
        "(行動終了済)" => { tr => "", desc => "" },
        "(金)" => { tr => "", desc => "" },
        "(Lv:{0} 経験値:{1}({2}%)))" => { tr => "", desc => "" },
        "({0}年{1} {2}日 {3})\n" => { tr => "", desc => "" },
        "-新開放マップ-\n" => { tr => "", desc => "" },
        "-新開放海域-\n" => { tr => "", desc => "" },
        "-獲得戦略ポイント:{0}\n" => { tr => "", desc => "" },
        "--制空権:{0} " => { tr => "", desc => "" },
        "--味方側航空機\n" => { tr => "", desc => "" },
        "--相手側航空機\n" => { tr => "", desc => "" },
        "--選択可能な艦隊演習--\n" => { tr => "", desc => "" },
        "--雷撃を行った艦載機(味方側)--\n" => { tr => "", desc => "" },
        "--雷撃を行った艦載機(相手側)--\n" => { tr => "", desc => "" },
        "-- アイテム屋商品 --\n" => { tr => "", desc => "" },
        "=通商破壊=\n" => { tr => "", desc => "" },
        "= 引き継ぎ未選択 =\n" => { tr => "", desc => "" },
        "= 引き継ぎ選択済 =\n" => { tr => "", desc => "" },
        "== 「{0}」 ==\n" => { tr => "", desc => "" },
        "== トロフィーデータ ==\n" => { tr => "", desc => "" },
        "== 改造マネージャ ==\n" => { tr => "", desc => "" },
        "== 艦隊:{0} (母港BGMID:{1})==\n" => { tr => "", desc => "" },
        "==[遠征結果]==\n" => { tr => "", desc => "" },
        "DBG: 母港へ行きます。" => { tr => "", desc => "" },
        "ID:{0} 状態:{1} " => { tr => "", desc => "" },
        "ID:{0} 解除開始" => { tr => "", desc => "" },
        "ID:{0} StandingID:{1}" => { tr => "", desc => "" },
        "図鑑ID:{0} {1}(MstId:{2})" => { tr => "", desc => "" },
        " 図鑑背景タイプ:{0}  装備タイプ:{1}  装備アイコンタイプ:{2}\n" => { tr => "", desc => "" },
        "[かばう]" => { tr => "", desc => "" },
        "[ガード]" => { tr => "", desc => "" },
        "[ターン終了フェーズ]: \n" => { tr => "", desc => "" },
        "[ユーザー行動フェーズ]: " => { tr => "", desc => "" },
        "[ロック]" => { tr => "", desc => "" },
        "[主主主左上]\n通常:{0}\nダメージ:{1}" => { tr => "", desc => "" },
        "[使用可能]" => { tr => "", desc => "" },
        "[入渠中]" => { tr => "", desc => "" },
        "[出撃不可]" => { tr => "", desc => "" },
        "[初回マップクリア]" => { tr => "", desc => "" },
        "[初回海域クリア]" => { tr => "", desc => "" },
        "[味方側への爆撃] {0} " => { tr => "", desc => "" },
        "[味方側 対空カットイン] {0}\n" => { tr => "", desc => "" },
        "[味方側 索敵{0} 索敵機{1} 未帰投機{2}]\n" => { tr => "", desc => "" },
        "[味方側] Count:{0}-{1} Lost:{2} " => { tr => "", desc => "" },
        "[回航中] " => { tr => "", desc => "" },
        "[回航中]" => { tr => "", desc => "" },
        "[回航待ち中(Area:{0})]" => { tr => "", desc => "" },
        "[夜戦演出]\n" => { tr => "", desc => "" },
        "[対地演出]" => { tr => "", desc => "" },
        "[戦闘指揮による行動]\n" => { tr => "", desc => "" },
        "[戦闘指揮] {0} {1}" => { tr => "", desc => "" },
        "[戦闘糧食 使用艦]{0}\n" => { tr => "", desc => "" },
        "[戦闘糧食 分配艦]{0}\n" => { tr => "", desc => "" },
        "[所持] " => { tr => "", desc => "" },
        "[撤退中]" => { tr => "", desc => "" },
        "[敵事前行動フェーズ]: " => { tr => "", desc => "" },
        "[敵行動フェーズ]: " => { tr => "", desc => "" },
        "[未開放]" => { tr => "", desc => "" },
        "[海域{0}:{1}]" => { tr => "", desc => "" },
        "[演出/効果] {0}" => { tr => "", desc => "" },
        "[熟練搭乗員使用]" => { tr => "", desc => "" },
        "[爆]" => { tr => "", desc => "" },
        "[特別ボーナス] " => { tr => "", desc => "" },
        "[特殊注視点{0}]\nMst:{1}\n---Edit---\nW:{2}\nL:{3}" => { tr => "", desc => "" },
        "[相手側への爆撃] {0}\n" => { tr => "", desc => "" },
        "[相手側 対空カットイン] {0}\n" => { tr => "", desc => "" },
        "[相手側 索敵{0} 索敵機{1} 未帰投機{2}]\n" => { tr => "", desc => "" },
        "[相手側] Count:{0}-{1} Lost:{2}\n" => { tr => "", desc => "" },
        "[砲撃支援]\n" => { tr => "", desc => "" },
        "[航空偵察] {0} 偵察機:{1} 結果:{2}" => { tr => "", desc => "" },
        "[航空戦データ]\n" => { tr => "", desc => "" },
        "[艦載機]" => { tr => "", desc => "" },
        "[行動終了]" => { tr => "", desc => "" },
        "[設定]BGM/SE/ボイス:" => { tr => "", desc => "" },
        "[資材]燃/弾/鋼/ボ: {0}/{1}/{2}/{3}\t" => { tr => "", desc => "" },
        "[足元座標({0})]\n{1}" => { tr => "", desc => "" },
        "[通商破壊結果]\n海域{0} 攻撃種別:{1} 輸送船{2}隻(移動中の船を除く)から{3}隻ロスト" => { tr => "", desc => "" },
        "[通商破壊結果]\n海域{0} 攻撃種別:{1} 輸送船{2}隻(移動中の船を除く)から{3}隻ロスト\n" => { tr => "", desc => "" },
        "[遠征中]" => { tr => "", desc => "" },
        "[遠征終了]:{0}\n" => { tr => "", desc => "" },
        "[選択不可]" => { tr => "", desc => "" },
        "[選択艦 総数:{0}] " => { tr => "", desc => "" },
        "[離脱成功]" => { tr => "", desc => "" },
        "[雷撃支援]\n" => { tr => "", desc => "" },
        "[雷雷中心]\n通常:{0}\nダメージ:{1}" => { tr => "", desc => "" },
        "[雷]" => { tr => "", desc => "" },
        "[ == 戦闘糧食フェーズ == ]\n" => { tr => "", desc => "" },
        "[--海域一覧--]" => { tr => "", desc => "" },
        "[--海域一覧--]\n" => { tr => "", desc => "" },
        "[--餌艦--]\n" => { tr => "", desc => "" },
        "[-]日" => { tr => "", desc => "" },
        "[000000]　この改修には、無改修の\n[1DBDC0]{0}×{1}[-]\nが必要です。[-]" => { tr => "", desc => "" },
        "[000000]　一覧から選択してください。\n" => { tr => "", desc => "" },
        "[000000]　提督、明石の工廠へようこそ！\n　どの装備の改修を試みますか？[-]" => { tr => "", desc => "" },
        "[000000]　改修に失敗しました。\n" => { tr => "", desc => "" },
        "[000000]　改修に成功しました。\n" => { tr => "", desc => "" },
        "[000000]この改修には、無改修の\n" => { tr => "", desc => "" },
        "[000000]どの装備の改修を試みますか？" => { tr => "", desc => "" },
        "[000000]改修中・・・[-]" => { tr => "", desc => "" },
        "[000000]改修失敗しました。" => { tr => "", desc => "" },
        "[000000]改修成功しました。" => { tr => "", desc => "" },
        "[323232]{0}の年 {1}[b]{2}[/b]日 {3}[-]" => { tr => "", desc => "" },
        "[BGM - 昼] {0}{1}\t[BGM - 夜] {2}{3}\n" => { tr => "", desc => "" },
        "[FF0000]　が足りません。[-]" => { tr => "", desc => "" },
        "[FF0000]　現在、選択された装備[-]\n" => { tr => "", desc => "" },
        "[FF0000]　資材が足りません。" => { tr => "", desc => "" },
        "[FF0000]が足りません。[-]" => { tr => "", desc => "" },
        "[FF0000]現在、選択された装備[-]\n" => { tr => "", desc => "" },
        "[MapHP{0}]イベント系ボスHP: {1}/{2}" => { tr => "", desc => "" },
        "[MapHP{0}]ボスHP: {1}/{2}" => { tr => "", desc => "" },
        "[MapHP{0}]討伐系ボスHP: {1}/{2}" => { tr => "", desc => "" },
        "[MapHP{0}]通常ボスHP: {1}/{2}" => { tr => "", desc => "" },
        "[{0}({1})]艦ID:{2} GraphicID:{3}" => { tr => "", desc => "" },
        "[{0}] Category:{1} Type:{2} 状態:{3} {4}\n" => { tr => "", desc => "" },
        "[{0}] ID:({1}) {2} 状態:{3}  種類(読み): {4} {5}\n" => { tr => "", desc => "" },
        "[{0}] ID:({1}) {2} 状態:{3} {4} {5}\n" => { tr => "", desc => "" },
        "[{0}][残{3}]{1}  価格{2}" => { tr => "", desc => "" },
        "[{0}][購入不可]{1}  価格{2}" => { tr => "", desc => "" },
        "[{0}]{1}  価格{2}" => { tr => "", desc => "" },
        "[{0}]{1} {2}個所有" => { tr => "", desc => "" },
        "\n--この海域のマップ一覧--\n" => { tr => "", desc => "" },
        "\n--この海域の艦隊一覧--\n" => { tr => "", desc => "" },
        "\n[補給に必要な資材数]燃料/弾薬:" => { tr => "", desc => "" },
        "\n\nが必要です。[-]" => { tr => "", desc => "" },
        "{0}を\n入手しました" => { tr => "", desc => "" },
        "{0}を\n手に入れました" => { tr => "", desc => "" },
        "{0}を\n{1}個 入手しました" => { tr => "", desc => "" },
        "{0}作戦 勝利\n" => { tr => "", desc => "" },
        "{0}側触接:無し " => { tr => "", desc => "" },
        "{0}側触接:{1} " => { tr => "", desc => "" },
        "{0}年{1} {2}日" => { tr => "", desc => "" },
        "{0}演習\nが開放されました！" => { tr => "", desc => "" },
        "{0} 餌艦効果(火:{1} 雷:{2} 空:{3} 装:{4})\n" => { tr => "", desc => "" },
        "{0} {1}個" => { tr => "", desc => "" },
        "{0} {1}番艦" => { tr => "", desc => "" },
        "{0} {1}(ID:{2}) レア度:{3} 個数:{4}" => { tr => "", desc => "" },
        "{0} {1}(ID:{2}) レア度:{3}" => { tr => "", desc => "" },
        "{0} {1}[#{2}-{3}]({4}) 攻略開始" => { tr => "", desc => "" },
        "{0}(ID:{1}) 個数:{2}" => { tr => "", desc => "" },
        "{0}(ID:{1}) 状態:{2} 海域:{3} {4}ターン" => { tr => "", desc => "" },
        "{0}(MstId:{1}) 艦種:{2}\n" => { tr => "", desc => "" },
        "{0}(c:{2})のダメージ({1})" => { tr => "", desc => "" },
        "{0}(id:{1}) Count:{2} 電探効果:{3}" => { tr => "", desc => "" },
        "{0}({1})の攻撃 {2}" => { tr => "", desc => "" },
        "{0}({1})は" => { tr => "", desc => "" },
        "{0}({1})へダメージ:{2}(r:{5}) {3}{4}\n" => { tr => "", desc => "" },
        "{0}({1}) 未配備" => { tr => "", desc => "" },
        "と{0}({2})のダメージ({1})" => { tr => "", desc => "" },
        "{0},{1}で" => { tr => "", desc => "" },
        "{0},{1},{2}で" => { tr => "", desc => "" },
        "[注視点{0}]\nMst:{1}\n---Edit---\nW:{2}\nL:{3}" => { tr => "", desc => "" },
        "{0}{1}の年 {2} {3}日" => { tr => "", desc => "" },
        '外部UI[輸送船団ボタン]から参照して使用します' => { tr => "", desc => "" },
        '外部UI[輸送船増ボタン]から参照して使用します' => { tr => "", desc => "" },
        '外部UI[輸送船減ボタン]から参照して使用します' => { tr => "", desc => "" },
        "装飾" => { tr => "", desc => "" },
        '"{0}({1})は' => { tr => "", desc => "" },
        "特殊注視点注視点[{1}]:{0}" => { tr => "", desc => "" },
        "演習特殊注視点[{1}]:{0}" => { tr => "", desc => "" },
        "特殊注視点:{0} - {1}" => { tr => "", desc => "" },
        "デッキ開放 第{0}艦隊" => { tr => "", desc => "" },
        "引き継ぎ可能な艦:{0}隻, 装備:{1}個\n" => { tr => "", desc => "" },
        " [未開放] " => { tr => "", desc => "" },
        "戦術的勝利!!" => { tr => "", desc => "" },
        "立ち絵のID:{0}" => { tr => "", desc => "" },
        "未登録ID: " => { tr => "", desc => "" },
        "マスタID:" => { tr => "", desc => "" },
        "\t使用した装備: " => { tr => "", desc => "" },
        "《ドロップなし》\n" => { tr => "", desc => "" },
        "※大破している艦娘がいます。（被弾により喪失の危険があります）" => { tr => "", desc => "" },
        "※十分な補給を受けていない艦娘がいます。（本来の戦闘力を発揮できません）" => { tr => "", desc => "" },
        "\t総合評価 : {0}{1}\n" => { tr => "", desc => "" },
        "\t装備のデータ列の最後のNo." => { tr => "", desc => "" },
        "{0}({2})のダメージ({1})" => { tr => "", desc => "" },
        "所持改装設計書:{0}(必要改装設計書:{1})\n" => { tr => "", desc => "" },
        "[FF0000]　は、これ以上の改修ができません。[-]" => { tr => "", desc => "" },
        "[1DBDC0]　{0}[-]\nを改修しますね！\n\n" => { tr => "", desc => "" },
        "[FF0000]　この改修に必要となる\n(無改修)\n[-]" => { tr => "", desc => "" },
        "[1DBDC0]　{0}[-]\nを改修しますね！[-]\n\n" => { tr => "", desc => "" },
        "==[艦隊演習結果]==\n" => { tr => "", desc => "" },
        "艦隊 ID:{0}({1}) 艦隊演習タイプ:{2}\n" => { tr => "", desc => "" },
        "提督名:{0} Lv{1}  獲得提督経験値:{2}\n" => { tr => "", desc => "" },
        "提督名:{0} Lv{1} [{2}] 艦隊名:{3}\n" => { tr => "", desc => "" },
        " 次行動艦:{0}" => { tr => "", desc => "" },
        " [難易度] 新しい難易度{0}が開放しました。\n" => { tr => "", desc => "" },
        "リスト下にフォーカスが入った時にフォーカス位置を底上げします" => { tr => "", desc => "" },
        "フラッシュ" => { tr => "", desc => "" },
        "ユーザが１度に見ることができる要素の最大数を設定してください。予備のオブジェクトの事は考えないでください" => { tr => "", desc => "" },
        " 資源回収:燃/弾/鋼/ボ:{0}/{1}/{2}/{3} 高速建造/高速修復/開発資材/改修資材:{4}/{5}/{6}/{7}\n" => { tr => "", desc => "" },
        " 月頭ボーナス:燃/弾/鋼/ボ:{0}/{1}/{2}/{3} 高速建造/高速修復/開発資材/改修資材:{4}/{5}/{6}/{7}\n" => { tr => "", desc => "" },
        " 週頭ボーナス:燃/弾/鋼/ボ:{0}/{1}/{2}/{3} 高速建造/高速修復/開発資材/改修資材:{4}/{5}/{6}/{7}\n" => { tr => "", desc => "" },
        "遠征結果:{0} 遠征名:{1}\n" => { tr => "", desc => "" },
        "[FF0000]この改修に必要となる\n(無改修)\n[-]" => { tr => "", desc => "" },
        "提督名を入力してください。（" => { tr => "", desc => "" },
        "--爆撃を行った艦載機(味方側)--\n" => { tr => "", desc => "" },
        "上限を超えている資材があります" => { tr => "", desc => "" },
        "エラー：次のシーンが設定されていません" => { tr => "", desc => "" },
        "ビュワー" => { tr => "", desc => "" },
        "特殊注視点" => { tr => "", desc => "" },
        "演習注視点" => { tr => "", desc => "" },
        "文字まで）" => { tr => "", desc => "" },
        "戦闘スキップを使用するか否か" => { tr => "", desc => "" },
        "艦隊出現後のフェーズ" => { tr => "", desc => "" },
        " [[艦隊{0} {1} 終了ターン:{2}]]\n" => { tr => "", desc => "" },
        "\t難易度:{0} 消費資材:{1}/{2}  " => { tr => "", desc => "" },
        "報酬４資材 {0}/{1}/{2}/{3}  " => { tr => "", desc => "" },
        "報酬アイテム{0}:{1}  " => { tr => "", desc => "" },
        "[ユーザー事前行動フェーズ]:\n" => { tr => "", desc => "" },
        "[FF0000]は、これ以上の改修ができません。[-]" => { tr => "", desc => "" },
        "--爆撃を行った艦載機(相手側)--\n" => { tr => "", desc => "" },
        "外部UI[決定ボタン]から参照して使用します" => { tr => "", desc => "" },
        "爆発初速" => { tr => "", desc => "" },
        "未登録マテリアルID: " => { tr => "", desc => "" },
        "---[マップ{0}-{1}(ID:{2}) - 「{3}」への出撃]---\n" => { tr => "", desc => "" },
        "外部UI[海上護衛部隊ボタン]から参照して使用します" => { tr => "", desc => "" },
        "外部UI[バックボタン（背景）]から参照して使用します" => { tr => "", desc => "" },
        "UI側から呼ぶためのメソッドです" => { tr => "", desc => "" },
        "インスペクタ上のUIButtonに紐付けて使用します。" => { tr => "", desc => "" },
        "行動が終了している艦隊です" => { tr => "", desc => "" },
        "《海域クリア報酬あり》\n" => { tr => "", desc => "" },
        "《海域クリア報酬なし》\n" => { tr => "", desc => "" },
        "UIButtonのSerializeFieldに設定します." => { tr => "", desc => "" },
        " 要求スロットアイテム:{0}(MstId:{1}) × {2}" => { tr => "", desc => "" },
        "装甲:{0} 火力:{1} 雷装:{2} 爆撃:{3} 対空:{4} 対潜:{5} 命中(砲):{6}" => { tr => "", desc => "" },
        "累計データ:[出撃-{0}, S勝利-{1}, 応急修理-{2}, 改修工廠-{3}\n" => { tr => "", desc => "" },
        "艦の保有上限に達しています" => { tr => "", desc => "" },
        " 雷命中バフ:{0}%" => { tr => "", desc => "" },
        "--選択可能な対抗演習相手--\n" => { tr => "", desc => "" },
        "\t給糧艦(伊良湖)の所有数:{0}" => { tr => "", desc => "" },
        "選択可能な項目がありません。" => { tr => "", desc => "" },
        "保有上限を超えています" => { tr => "", desc => "" },
        "保有上限に達しています" => { tr => "", desc => "" },
        "戦略マップへ進みます。" => { tr => "", desc => "" },
        "]　{0}[-]\n　[000000]を、改修しますね！[-]" => { tr => "", desc => "" },
        "high_repair.cs 高速修復が押された!" => { tr => "", desc => "" },
        "大破" => { tr => "", desc => "" },
        "-- 保有アイテム棚 --\n" => { tr => "", desc => "" },
        "※装備保有数が上限に達しているため、新しい艦娘との邂逅はできません。" => { tr => "", desc => "" },
        "※装備保有数が上限に近いため、新規獲得できない可能性があります。" => { tr => "", desc => "" },
        "※装備保有数が上限に近いため、新しい艦娘と邂逅できない可能性があります。" => { tr => "", desc => "" },
        "[FF0000]　この装備を改修するには\n　同装備のロック解除が必要です。[-]" => { tr => "", desc => "" },
        "[FF0000]この装備を改修するには\n　同装備のロック解除が必要です。[-]" => { tr => "", desc => "" },
        "ひびき" => { tr => "", desc => "" },
        "ちとせ" => { tr => "", desc => "" },
        "きそ" => { tr => "", desc => "" },
        "やましろ" => { tr => "", desc => "" },
        "きりしま" => { tr => "", desc => "" },
        "ほうしょう" => { tr => "", desc => "" },
        "ずいほう" => { tr => "", desc => "" },
        "やまと" => { tr => "", desc => "" },
        "かが" => { tr => "", desc => "" },
        "うんりゅう" => { tr => "", desc => "" },
        "ひりゅう" => { tr => "", desc => "" },
        "みょうこう" => { tr => "", desc => "" },
        "はつはる" => { tr => "", desc => "" },
        "あかし" => { tr => "", desc => "" },
        "しょうほう" => { tr => "", desc => "" },
        "あきつまる" => { tr => "", desc => "" },
        "きくづき" => { tr => "", desc => "" },
        "あまぎ" => { tr => "", desc => "" },
        "いせ" => { tr => "", desc => "" },
        "ひゅうが" => { tr => "", desc => "" },
        "じんつう" => { tr => "", desc => "" },
        "たいげい・りゅうほう" => { tr => "", desc => "" },
        "なち" => { tr => "", desc => "" },
        "あしがら" => { tr => "", desc => "" },
        "むつ" => { tr => "", desc => "" },
        "はやしも" => { tr => "", desc => "" },
        "こんごう" => { tr => "", desc => "" },
        "ちくま" => { tr => "", desc => "" },
        "きさらぎ" => { tr => "", desc => "" },
        "おおよど" => { tr => "", desc => "" },
        "たいほう" => { tr => "", desc => "" },
        "ゆうぐも" => { tr => "", desc => "" },
        "ながなみ" => { tr => "", desc => "" },
        "もがみ" => { tr => "", desc => "" },
        "いそかぜ" => { tr => "", desc => "" },
        "やはぎ" => { tr => "", desc => "" },
        "ビスマルク" => { tr => "", desc => "" },
        "かとり" => { tr => "", desc => "" },
        "い8" => { tr => "", desc => "" },
        "むらさめ" => { tr => "", desc => "" },
        "たつた" => { tr => "", desc => "" },
        "はるな" => { tr => "", desc => "" },
        "ひよう" => { tr => "", desc => "" },
        "くまの" => { tr => "", desc => "" },
        "すずや" => { tr => "", desc => "" },
        "そうりゅう" => { tr => "", desc => "" },
        "ゆうばり" => { tr => "", desc => "" },
        "むらくも" => { tr => "", desc => "" },
        "あまつかぜ" => { tr => "", desc => "" },
        "プリンツ・オイゲン" => { tr => "", desc => "" },
        "ゆー511・ろ500" => { tr => "", desc => "" },
        "じゅんよう" => { tr => "", desc => "" },
        "むさし" => { tr => "", desc => "" },
        "かこ" => { tr => "", desc => "" },
        "あさしも" => { tr => "", desc => "" },
        "い19" => { tr => "", desc => "" },
        "むつき" => { tr => "", desc => "" },
        "やよい" => { tr => "", desc => "" },
        "うづき" => { tr => "", desc => "" },
        "ふみづき" => { tr => "", desc => "" },
        "あかつき" => { tr => "", desc => "" },
        "いかづち" => { tr => "", desc => "" },
        "いなづま" => { tr => "", desc => "" },
        "あけぼの" => { tr => "", desc => "" },
        "おぼろ" => { tr => "", desc => "" },
        "あさしお" => { tr => "", desc => "" },
        "おおしお" => { tr => "", desc => "" },
        "てんりゅう" => { tr => "", desc => "" },
        "しらつゆ" => { tr => "", desc => "" },
        "はるさめ" => { tr => "", desc => "" },
        "あさぐも" => { tr => "", desc => "" },
        "やまぐも" => { tr => "", desc => "" },
        "まいかぜ" => { tr => "", desc => "" },
        "きよしも" => { tr => "", desc => "" },
        "まきぐも" => { tr => "", desc => "" },
        "ながと" => { tr => "", desc => "" },
        "しまかぜ" => { tr => "", desc => "" },
        "ゆきかぜ" => { tr => "", desc => "" },
        "さかわ" => { tr => "", desc => "" },
        "たかなみ" => { tr => "", desc => "" },
        "リットリオ・イタリア" => { tr => "", desc => "" },
        "ローマ" => { tr => "", desc => "" },
        "あきづき" => { tr => "", desc => "" },
        "かすみ" => { tr => "", desc => "" },
        "しぐれ" => { tr => "", desc => "" },
        "あかぎ" => { tr => "", desc => "" },
        "あぶくま" => { tr => "", desc => "" },
        "あきつしま" => { tr => "", desc => "" },
        "かつらぎ" => { tr => "", desc => "" },
        "家具選択が不正" => { tr => "", desc => "" },
        "指揮ボックス選択" => { tr => "", desc => "" },
        "外す" => { tr => "", desc => "" },
        "指揮コマンド選択" => { tr => "", desc => "" },
        " 攻略開始" => { tr => "", desc => "" },
        "本土沖海戦 敗北（艦隊壊滅）" => { tr => "", desc => "" },
        "終戦" => { tr => "", desc => "" },
        " [結婚]" => { tr => "", desc => "" },
        " [未婚]" => { tr => "", desc => "" },
        "  同時遂行最大数:{0}\n" => { tr => "", desc => "" },
        "--[任務一覧]--\n" => { tr => "", desc => "" },
        "[設定家具]\n" => { tr => "", desc => "" },
        "床:{0}\t壁紙:{1}\t窓:{2}\n" => { tr => "", desc => "" },
        " 命中バフ:{0}%" => { tr => "", desc => "" },
        "壁掛け:{0}\t棚:{1}\t机:{2}\n" => { tr => "", desc => "" },
        "旗艦以外大破にするか否か" => { tr => "", desc => "" },
        "Sprite設定" => { tr => "", desc => "" },
        "TODO:選択不可時のHover表示" => { tr => "", desc => "" },
        "TODO:選択不可時のRemoveHover表示" => { tr => "", desc => "" },
        "行動可能" => { tr => "", desc => "" },
        "給糧艦(間宮)の所有数:{0}" => { tr => "", desc => "" },
        "の年　" => { tr => "", desc => "" },
        " 日" => { tr => "", desc => "" },
        " 隻" => { tr => "", desc => "" },
        "不可" => { tr => "", desc => "" },
        " 疲労度:{0}" => { tr => "", desc => "" },
        "/BattleTaskManager/Stage/BattleField/FriendFleetAnchor/吹雪/ShipTexture/Object3D" => { tr => "", desc => "" },
        "/BattleTaskManager/Stage/BattleField/FriendFleetAnchor/吹雪" => { tr => "", desc => "" },
        " 速:{0} " => { tr => "", desc => "" },
        " 燃/弾:{0}/{1} " => { tr => "", desc => "" },

        "×　9"                                                                                  => {},
        "× 9"                                                                                  => {},
        "× 999"                                                                                => {},
        "×1"                                                                                   => {},
        "×10"                                                                                  => {},
        "×100"                                                                                 => {},
        "×1000\n"                                                                              => {},
        "×999"                                                                                 => {},
        "■Slog"                                                                               => {},
        "▲ x10    ■ x100   R x1000   L x10000"                                              => {},
        "▶"                                                                                   => {},
        "▶\n\r \n▶"                                                                         => {},
        "★★★★★"                                                                       => {},
        "低"                                                                                   => {},
        "撃"                                                                                   => {},
        "民"                                                                                   => {},
        "迎"                                                                                   => {},
        "運"                                                                                   => {},
        "隻"                                                                                   => {},
        "高"                                                                                   => {},
        "＋2"                                                                                  => {},
        "ｘ 10"                                                                                => {},
        "         Fleet Girls Collection\n                            Shortcut Battle Sequence" => {},
        " 999"                                                                                  => {},
        "#1"                                                                                    => {no_tr => 1},
        "+7%"                                                                                   => {},
        "/"                                                                                     => {no_tr => 1},
        "0"                                                                                     => {no_tr => 1},
        "00"                                                                                    => {no_tr => 1},
        "000％"                                                                                => {},
        "000000  \n\n000000  \n\n000000  \n\n100%\n\n\n\n00000  \n\n00000  "                    => {},
        "001"                                                                                   => {no_tr => 1},
        "1  →  2"                                                                             => {},
        "1  ▶  2"                                                                             => {},
        "1"                                                                                     => { no_tr => 1 },
        "10"                                                                                    => {no_tr => 1},
        "10/10"                                                                                 => {no_tr => 1},
        "100"                                                                                   => {no_tr => 1},
        "100/100"                                                                               => {no_tr => 1},
        "10000"                                                                                 => {no_tr => 1},
        "111/111"                                                                               => {no_tr => 1},
        "12"                                                                                    => {no_tr => 1},
        "12/12"                                                                                 => {no_tr => 1},
        "120"                                                                                   => {no_tr => 1},
        "123"                                                                                   => {no_tr => 1},
        "123/123"                                                                               => {no_tr => 1},
        "1234"                                                                                  => {no_tr => 1},
        "12345"                                                                                 => {no_tr => 1},
        "12345678/99999999"                                                                     => {no_tr => 1},
        "13/13"                                                                                 => {no_tr => 1},
        "15"                                                                                    => {no_tr => 1},
        "15/15"                                                                                 => {no_tr => 1},
        "150"                                                                                   => {no_tr => 1},
        "18"                                                                                    => {no_tr => 1},
        "19300"                                                                                 => {no_tr => 1},
        "2  →  1"                                                                             => {},
        "2"                                                                                     => { no_tr => 1 },
        "20"                                                                                    => {no_tr => 1},
        "20000"                                                                                 => {no_tr => 1},
        "2000000"                                                                               => {no_tr => 1},
        "22"                                                                                    => {no_tr => 1},
        "250"                                                                                   => {no_tr => 1},
        "3"                                                                                     => { no_tr => 1 },
        "30"                                                                                    => {no_tr => 1},
        "31"                                                                                    => {no_tr => 1},
        "4 / 4\n100 / 100\n400 / 400\n999999\n4\n4 / 4\n4"                                      => {no_tr => 1},
        "4"                                                                                     => {no_tr => 1},
        "400"                                                                                   => {no_tr => 1},
        "4\n100\n400\n999999\n\n"                                                               => {no_tr => 1},
        "4\n99\n100\n4\n4\n99\n999"                                                             => {no_tr => 1},
        "5"                                                                                     => {no_tr => 1},
        "50"                                                                                    => {no_tr => 1},
        "503"                                                                                   => {no_tr => 1},
        "6"                                                                                     => {no_tr => 1},
        "60 / 60"                                                                               => {no_tr => 1},
        "600"                                                                                   => {no_tr => 1},
        "62"                                                                                    => {no_tr => 1},
        "7"                                                                                     => {no_tr => 1},
        "79"                                                                                    => {no_tr => 1},
        "8"                                                                                     => {no_tr => 1},
        "88888888"                                                                              => {no_tr => 1},
        "9"                                                                                     => {no_tr => 1},
        "99  \n9999\n9999\n9999"                                                                => {no_tr => 1},
        "99"                                                                                    => {no_tr => 1},
        "99/99"                                                                                 => {no_tr => 1},
        "999          0\n\n9999    9998"                                                        => {no_tr => 1},
        "999         0\n\n9999    9998"                                                         => {no_tr => 1},
        "999 "                                                                                  => {no_tr => 1},
        "999"                                                                                   => {no_tr => 1},
        "999/999"                                                                               => {no_tr => 1},
        "9998"                                                                                  => {no_tr => 1},
        "9999"                                                                                  => {no_tr => 1},
        "9999/9999"                                                                             => {no_tr => 1},
        "99999"                                                                                 => {no_tr => 1},
        "999999"                                                                                => {no_tr => 1},
        "9999999"                                                                               => {no_tr => 1},
        "AreaNo"                                                                                => {no_tr => 1},
        "BGM"                                                                                   => {no_tr => 1},
        "BGM\nSE\nVoice"                                                                        => {},
        "Backend Program"                                                                       => {},
        "Bismarck Drei"                                                                         => {},
        "Bismarck drei"                                                                         => {},
        "Bismarck zwei"                                                                         => {},
        "Bismarck"                                                                              => {},
        "CAST"                                                                                  => {},
        "Cast Recording"                                                                        => {},
        "Choice"                                                                                => {no_tr => 1},
        "Command"                                                                               => {no_tr => 1},
        "DEBUG"                                                                                 => {no_tr => 1},
        "DMM.com Executive Producer"                                                            => {},
        "Debug"                                                                                 => {no_tr => 1},
        "Debug\n(Unlock)"                                                                       => {},
        "Deep Sea Queens Design"                                                                => {},
        "Drill Movie"                                                                           => {},
        "ENEMY FLEET AREA"                                                                      => {},
        "EXP"                                                                                   => {no_tr => 1},
        "Executive Producer Publishment"                                                        => {},
        "FRIEND FLEET AREA"                                                                     => {},
        "Graphics"                                                                              => {no_tr => 1},
        "HP\n"                                                                                  => {},
        "Illustration"                                                                          => {},
        "Item Name"                                                                             => {},
        "KADOKAWA Support Management"                                                           => {},
        "KK"                                                                                    => {no_tr => 1},
        "KanColle"                                                                              => {},
        "Kanmusu Concept/Script"                                                                => {},
        "Key Visual/USS BB61 Design"                                                            => {},
        "L"                                                                                     => {no_tr => 1},
        "LV 150"                                                                                => {},
        "LV"                                                                                    => {no_tr => 1},
        "Live2D Motion"                                                                         => {},
        "Live2D"                                                                                => {no_tr => 1},
        "Loading"                                                                               => {no_tr => 1},
        "Lv 23"                                                                                 => {},
        "Lv"                                                                                    => {no_tr => 1},
        "Lv100"                                                                                 => {},
        "Lv150"                                                                                 => {},
        "Lv\t"                                                                                  => {},
        "Main Composer"                                                                         => {},
        "Main Program"                                                                          => {},
        "MapNo"                                                                                 => {no_tr => 1},
        "MemID"                                                                                 => {no_tr => 1},
        "MstID"                                                                                 => {no_tr => 1},
        "Music"                                                                                 => {no_tr => 1},
        "NAME"                                                                                  => {no_tr => 1},
        "NEXT TURN → "                                                                        => {},
        "NEXT TURN"                                                                             => {},
        "Name"                                                                                  => {no_tr => 1},
        "New Label"                                                                             => {},
        "OFF"                                                                                   => {no_tr => 1},
        "OP/ED Movie"                                                                           => {},
        "Press □ button to get damage!"                                                       => {},
        "Producer/Director\r"                                                                   => {},
        "Program"                                                                               => {},
        "Project Manager"                                                                       => {},
        "Project Support"                                                                       => {},
        "Publisher Project Management"                                                          => {},
        "Publishment"                                                                           => {},
        "R"                                                                                     => {no_tr => 1},
        "REA"                                                                                   => {no_tr => 1},
        "Result"                                                                                => {no_tr => 1},
        "STAFF"                                                                                 => {},
        "SUMIRE UESAKA\r\n\r\nSAKI FUJITA\r\n\r\nYUKA IGUCHI\r\n\r\nNAO TOYAMA\r\n\r\nAYANE SAKURA\r\n\r\nYUKA OTSUBO\r\n\r\nRINA HIDAKA\r\n\r\nAYA SUZAKI\r\n\r\nRISA TANEDA\r\n\r\nIORI NOMIZU\r\n\r\nYUMI TANIBE\r\n\r\nSARAH EMI BRIDCUTT\r\n\r\nMOTOKO KOBAYASHI\r\n\r\nKOZUE HAYASAKA\r\n\r\nMANA KOMATSU\r\n\r\nWAKANA MIYAKAWA\r\n\r\nYUKI YAMADA\r\n\r\nAYA ENDO\r\n\r\nAYANA TAKETATSU\r\n\r\nMISATO\r\n\r\nMEGUMI NAKAJIMA\r\n\r\nMARIYA ISE\r\n\r\nHISAKO KANEMOTO\r\n\r\nYUI OGURA\r\n\r\nARI OZAWA\r\n\r\nMIKAKO KOMATSU\r\n\r\nMISAKI KUNO\r\n\r\nSHIZUKA ISHIGAMI\r\n\r\nAKARI KITO\r\n\r\nSAORI HAYAMI\r\n\r\nAI KAYANO\r\n\r\nMAMIKO NOTO\r\n\nCHINAMI HASHIMOTO\n\r\nAYAKO KAWASUMI\r\n\r\nYUI HORIE\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\nKENSUKE TANAKA\r\n\r\n\r\n\r\nHIROSHI MIZUNASHI\r\nKYOKO SAITO\r\n\r\n\r\n\r\nKAORI OHKOSHI\r\n\r\n\r\n\r\nKAORI OHKOSHI\r\nHIROSHI USAMI\r\nMICHIO OKAMIYA\r\n\r\n\r\n\r\nYOSHINORI SHIZUMA\r\n\r\n\r\n\r\nYUKI TSUNOKAWA(DREW)\r\nSHIORI FUJIKAWA(FUJIKAWA)\r\nMAYU OIKAWA(AKIRA)\r\nTAKARA KUMAGAI(RIKKA)\r\nRURIKO KAMO\r\n\r\n\r\n\r\nYUTA IWAMA\r\n\r\n\r\n\nNAOKI\r KATO\r\nYUDAI FUKUDA\r\nKOUHEI IWASA\r\nTAMI NEMOTO\r\n\r\n\r\n\r\nYOSHIYUKI WAGA\r\nMASAYOSHI KURITA\r\nKEN SATO\r\nRYO ITO\r\n\r\n\r\n\r\nMASAKI TERAI\r\nTAKARA KUMAGAI(RIKKA)\r\nYUKI TSUNOKAWA(DREW)\r\n\r\n\r\n\r\nSHIBAFU\r\nYOSHINORI SHIZUMA\r\nCONISHI\r\nBOB\r\nICHISO KUJOU\r\r\nKU-RO-KURO\r\nPARSLEY\r\nUGUME\r\nYADKARI\r\nOGUCHI\r\nAYAKI\r\nCHIHARU AMAMIYA\r\nSYOBON\r\nHATSUKO\r\nAKEMI MIKOTO\r\nSOTA\r\nJIJI\r\nRIKKA\r\nDREW\r\nAKIRA\r\nFUJIKAWA\r\nFUMIKANE SHIMADA\r\n\r\n\r\n\r\nKENSUKE TANAKA\r\n\r\n\r\n\r\nMAYU OIKAWA(AKIRA)\r\n\r\n\r\n\r\nSHIORI FUJIKAWA(FUJIKAWA) \r\n\r\n\r\n\r\nSATOSHI MATSUMOTO\r\n\r\n\n\nLIVE2D INC.\nGENJIRO ISHIKAWA\n\n\r\n\r\nYUKI NAKATORI\r\nEMI MARUNAKA\r\nHIROKI MARUBASHI\r\nHAJIME YOKOTA\r\nYUKA MASUMOTO\r\nAMANUKI\r\nRIKA KAMEO\r\nTSUTOMU SUMIDA\r\nHIDEAKI KUMAZAWA\r\nZENTA YAMAZAKI\r\r\n\n\n\r\n\rZOZI\r\nSATOSHI OKANO\r\n\n\r\n\r\nKAORI OHKOSHI\r\nT-A-K\r\n\r\n\r\n\n\rHIROSHI NISHIMOTO\r\nMANABU IIYAMA\r\nDAISUKE FUJIMOTO\r\n\r\n\r\n\r\nMIRAI TAKAHASHI\r\n\rYUMI TANIBE\r\n\n\r\n\r\nKOICHI KONDO\r\nKYOHEI TANIMOTO\r\nSHII ADACHI\r\nTSUBASA YAMASHITA\r\nYUKI TOYAMA\r\nMAMI HISAKI\r\nSHO YOSHIMURA\r\nKOICHI TAGO\r\nERIKO ABE\r\nHARUKA OISHI\r\n\r\n\r\n\r\nSHINICHIRO INOUE\r\nTAKESHI YASUDA\r\nTOSHIYUKI HIKI\r\nKENICHI TAKANO\r\nSATOSHI MOTONAGA\r\nJOTARO ISHIGAMI\r\nKADOKAWA CORPORATION\r\nC2KIKAN\r\nDMM.COM\nSONY COMPUTER ENTERTAINMENT INC.\r\n\r\n\r\n\nYOSHIMASA MORI\r\n\r\n\r\n\r\nMICHIO OKAMIYA\r\n\r\n\r\n\r\nKADOKAWA GAMES\r\n\r\n\r\n\r\nKOICHI KONDO\r\nMASATO TAKASAWA\r\n\r\n\r\n\r\nJUNTARO KOUNO\r\nMAIKO UESUGI\r\n\r\n\r\n\r\nYOSHIMI YASUDA"
        => {},
        "Sales & Promotion"                               => {},
        "Sound"                                           => {no_tr => 1},
        "Special Thanks"                                  => {},
        "Touch to redraw"                                 => {},
        "UI Design"                                       => {},
        "Utility Fleet Girls Design"                      => {},
        "Version 99.99"                                   => {},
        "[000000]99  [-]\n[000000]999[-]\n[000000]999[-]" => {},
        "[404040]999[-]\n[404040]999[-]\n[404040]99  [-]" => {},
        "[ffffff]--"                                      => {},
        "\t"                                              => {no_tr => 1},
        "asdasdad"                                        => {},
        "delete"                                          => {no_tr => 1},
        "exp"                                             => {no_tr => 1},
        "forever with you"                                => {},
        "memory"                                          => {},
        "mode"                                            => {no_tr => 1},
        "pt"                                              => {no_tr => 1},
        "v"                                               => {no_tr => 1},
        "x200"                                            => {},
        "x999"                                            => {},

        "通常" => {},
        "足元位置:{0}" => {},
        "足元座標[{1}]:{0}" => {},
        "味方/敵切り替え" => {},
        "味方艦(1)" => {},
        "敵艦(2)" => {},
        "フォーカス[{0}](F)" => {},
        "格子表示切り替え(A)" => {},
        "座標コピー[{0}](C)" => {},
        "無" => {},
        "短" => {},
        "中" => {},
        "長" => {},
        "超長" => {},
        "、。！？」』)" => {},
        " □□□ 既に存在しているため生成しません □□□" => {},
        "表示完了" => {},
        "表示終了" => {},
        "%)    艦星数:" => {},
        "レア" => {},
        "ホロ" => {},
        "Sホロ" => {},
        "SSホロ" => {},
        "丁" => {},
        "丙" => {},
        "乙" => {},
        "甲" => {},
        "史" => {},
        "新米少佐" => {},
        "中堅少佐" => {},
        "少佐" => {},
        "新米中佐" => {},
        "中佐" => {},
        "大佐" => {},
        "少将" => {},
        "中将" => {},
        "大将" => {},
        "元帥" => {},
        "に該当するファイルは複数存在します。" => {},
        "行動が終了している艦です" => {},
        "リソースマネージャーが存在しません。" => {},
        "横須賀提督" => {},
        "旗艦" => {},
        "所属" => {},
        "練度 " => {},
        "エンディングムービー" => {},
        "引継ぎをしないでゲームを開始します" => {},
        "　　　　　　 敗戦" => {},
        "第二次" => {},
        "第三次" => {},
        "年" => {},
        " 旗艦 " => {},
        "床" => {},
        "椅子＋机" => {},
        "家具" => {},
        "これ以上拡張できません" => {},
        "低速" => {},
        "★ IME から得た名前： result.text: " => {},
        "｡" => {},
        "。" => {},
        "｢" => {},
        "｣" => {},
        "､" => {},
        "、" => {},
        "･" => {},
        "・" => {},
        "ｶﾞ" => {},
        "ガ" => {},
        "ｷﾞ" => {},
        "ギ" => {},
        "ｸﾞ" => {},
        "グ" => {},
        "ｹﾞ" => {},
        "ゲ" => {},
        "ｺﾞ" => {},
        "ゴ" => {},
        "ｻﾞ" => {},
        "ザ" => {},
        "ｼﾞ" => {},
        "ジ" => {},
        "ｽﾞ" => {},
        "ズ" => {},
        "ｾﾞ" => {},
        "ゼ" => {},
        "ｿﾞ" => {},
        "ゾ" => {},
        "ﾀﾞ" => {},
        "ダ" => {},
        "ﾁﾞ" => {},
        "ヂ" => {},
        "ﾂﾞ" => {},
        "ヅ" => {},
        "ﾃﾞ" => {},
        "デ" => {},
        "ﾄﾞ" => {},
        "ド" => {},
        "ﾊﾞ" => {},
        "バ" => {},
        "ﾋﾞ" => {},
        "ビ" => {},
        "ﾌﾞ" => {},
        "ブ" => {},
        "ﾍﾞ" => {},
        "ベ" => {},
        "ﾎﾞ" => {},
        "ボ" => {},
        "ｳﾞ" => {},
        "ヴ" => {},
        "ﾜﾞ" => {},
        "ｲﾞ" => {},
        "ｴﾞ" => {},
        "ｦﾞ" => {},
        "ﾊﾟ" => {},
        "パ" => {},
        "ﾋﾟ" => {},
        "ピ" => {},
        "ﾌﾟ" => {},
        "プ" => {},
        "ﾍﾟ" => {},
        "ペ" => {},
        "ﾎﾟ" => {},
        "ポ" => {},
        "ｦ" => {},
        "ヲ" => {},
        "ｧ" => {},
        "ァ" => {},
        "ｨ" => {},
        "ィ" => {},
        "ｩ" => {},
        "ゥ" => {},
        "ｪ" => {},
        "ェ" => {},
        "ｫ" => {},
        "ォ" => {},
        "ｬ" => {},
        "ャ" => {},
        "ｭ" => {},
        "ュ" => {},
        "ｮ" => {},
        "ョ" => {},
        "ｯ" => {},
        "ッ" => {},
        "ｰ" => {},
        "ー" => {},
        "ｱ" => {},
        "ア" => {},
        "ｲ" => {},
        "イ" => {},
        "ｳ" => {},
        "ウ" => {},
        "ｴ" => {},
        "エ" => {},
        "ｵ" => {},
        "オ" => {},
        "ｶ" => {},
        "カ" => {},
        "ｷ" => {},
        "キ" => {},
        "ｸ" => {},
        "ク" => {},
        "ｹ" => {},
        "ケ" => {},
        "ｺ" => {},
        "コ" => {},
        "ｻ" => {},
        "サ" => {},
        "ｼ" => {},
        "シ" => {},
        "ｽ" => {},
        "ス" => {},
        "ｾ" => {},
        "セ" => {},
        "ｿ" => {},
        "ソ" => {},
        "ﾀ" => {},
        "タ" => {},
        "ﾁ" => {},
        "チ" => {},
        "ﾂ" => {},
        "ツ" => {},
        "ﾃ" => {},
        "テ" => {},
        "ﾄ" => {},
        "ト" => {},
        "ﾅ" => {},
        "ナ" => {},
        "ﾆ" => {},
        "ニ" => {},
        "ﾇ" => {},
        "ヌ" => {},
        "ﾈ" => {},
        "ネ" => {},
        "ﾉ" => {},
        "ノ" => {},
        "ﾊ" => {},
        "ハ" => {},
        "ﾋ" => {},
        "ヒ" => {},
        "ﾌ" => {},
        "フ" => {},
        "ﾍ" => {},
        "ヘ" => {},
        "ﾎ" => {},
        "ホ" => {},
        "ﾏ" => {},
        "マ" => {},
        "ﾐ" => {},
        "ミ" => {},
        "ﾑ" => {},
        "ム" => {},
        "ﾒ" => {},
        "メ" => {},
        "ﾓ" => {},
        "モ" => {},
        "ﾔ" => {},
        "ヤ" => {},
        "ﾕ" => {},
        "ユ" => {},
        "ﾖ" => {},
        "ヨ" => {},
        "ﾗ" => {},
        "ラ" => {},
        "ﾘ" => {},
        "リ" => {},
        "ﾙ" => {},
        "ル" => {},
        "ﾚ" => {},
        "レ" => {},
        "ﾛ" => {},
        "ロ" => {},
        "ﾜ" => {},
        "ワ" => {},
        "ﾝ" => {},
        "ン" => {},
        "ﾞ" => {},
        "゛" => {},
        "ﾟ" => {},
        "゜" => {},
        "一括解除" => {},
        "航路護衛隊" => {},
        "爆装" => {},
        "爆撃" => {},
        "mask2に触られた。" => {},
        "を退場させます。" => {},
        "　\n使用" => {},
        "する" => {},
        "しない" => {},
        "押された番号：" => {},
        "ロードを実行します" => {},
        "セーブを実行します" => {},
        "saveする" => {},
        "Loadする" => {},
        "Deleteする" => {},
        "デリートdialog" => {},
        "引継ぎ判定" => {},
        "通常データ" => {},
        "セーブ時にエラーが発生しました。" => {},
        "ロード時に内部エラーが発生しました。" => {},
        "ロードデータがありません。" => {},
        "データを削除しました。" => {},
        "MstID:{0}|反転:{1}|回転:{2}|位置:{3}" => {},
        "敗北" => {},
        "戦術的敗北!!" => {},
        "グラーフ・ツェッペリン" => {},
        "高さ補正:{0}|{1}" => {},
        "魚雷戦用意" => {},
        "が大きく損傷しています。" => {},
        " 制海権確保!!" => {},
        "次へ" => {},
        "家具箱(小)" => {},
        "家具箱(中)" => {},
        "家具箱(大)" => {},
        "ヷ" => {},
        "ヸ" => {},
        "ヹ" => {},
        "ヺ" => {},
        "変更がありません" => {},
        "リクエストされたフェーズ:" => {},
        "演習相手を選んでください" => {},
        "陣形を選んでください" => {},
        "演習-結果" => {},
        "戦う相手がいません" => {},
        "反攻発生: 発生エリア" => {},
        " 矢印エリア" => {},
        "詳細をみる" => {},
        "出撃中止" => {},
        "データロード中です" => {},
        "旗艦 " => {},
        "旗艦\n" => {},
        "の年" => {},
        "の年 " => {},
        "ターンエンド" => {},
        "ゲームクリア！！" => {},
        "モーション名表示:" => {},
        "nullじゃない" => {},
        "flag の型が、現在のインスタンスの型と異なっています。" => {},
        "前線反抗支援" => {},
        "決戦反抗支援" => {},
        "アイオワ" => {},
        "せんだい" => {},
        "なか" => {},
        "はぐろ" => {},
        "ふそう" => {},
        "ひえい" => {},
        "ちょうかい" => {},
        "あおば" => {},
        "ふるたか" => {},
        "あたご" => {},
        "たかお" => {},
        "まや" => {},
        "しょうかく" => {},
        "ずいかく" => {},
        "きぬがさ" => {},
        "たま" => {},
        "うしお" => {},
        "しらぬい" => {},
        "みちしお" => {},
        "あらしお" => {},
        "あられ" => {},
        "かげろう" => {},
        "もちづき" => {},
        "ふぶき" => {},
        "しらゆき" => {},
        "はつゆき" => {},
        "ねのひ" => {},
        "わかば" => {},
        "はつしも" => {},
        "さつき" => {},
        "ながつき" => {},
        "ながら" => {},
        "さみだれ" => {},
        "あきぐも" => {},
        "くま" => {},
        "いすず" => {},
        "きぬ" => {},
        "なとり" => {},
        "\n艦のデータ列の最後のNo." => {},
        "所持している開放キー:{0}\n" => {},
        "敗戦" => {},
        " == 年表 ==\n" => {},
        " == 年表終わり ==\n" => {},
        " == 上位20隻の艦 ==\n" => {},
        " == 上位20隻の艦終わり ==\n" => {},
        "棚{0} - {1}{2}\n" => {},
        "指輪の数(ケッコンカッコカリ):{0}\n" => {},
        "-- 戦績画面 --\n" => {},
        "丁-{0}回  丙-{1}回  乙-{2}回  甲-{3}回  史-{4}回\n" => {},
        "-- 戦績画面 --" => {},
        "レシピ数:{0}\n" => {},
        "可" => {},
        "自側陣形:{0} 敵側陣形:{1} 交戦体系:{2}" => {},
        "セル総数:{0} BGM:{1}" => {},
        "アリ" => {},
        "ナシ" => {},
        "\tガイド表示:" => {},
        " [家具職人]" => {},
        "白" => {},
        "青" => {},
        "緑" => {},
        "紫" => {},
        "赤" => {},
        "赤(BOSS)" => {},
        "通過済" => {},
        "未通過" => {},
        "使用アイテム:{0}(id:{1}) Count:{2}" => {},
        "有" => {},
        "遠征完了" => {},
        " 変化{0}" => {},
        "複数使用アイテム:[ " => {},
        "演習タイプ開放報酬: {0}" => {},
        "機種転換報酬: {0} -> {1}{2}" => {},
        " (Lv:{0} 経験値:{1}({2}%))" => {},
        "戦闘BGM {0}-{1}" => {},
        "ザコ戦(昼:{0} 夜:{1})" => {},
        "ボス戦(昼:{0} 夜:{1})" => {},
        "自分側HP {0}->{1}\n" => {},
        "《ドロップあり》\n" => {},
        "指揮済" => {},
        "未指揮" => {},
        "味方" => {},
        "相手" => {},
        "・{0})" => {},
        "少量" => {},
        "回復アニメーション" => {},
        "オート戦闘キャンセル" => {},
        "主砲" => {},
        "機銃" => {},
        "艦上機" => {},
        "]【" => {},
        "】" => {},
        "쳍㽌" => {no_tr => 1},
        "晦㽦" => {no_tr => 1},
        "쳍㾌" => {no_tr => 1},
        "銀㿪" => {no_tr => 1},
        "贷㾧" => {no_tr => 1},
        "슏㷵" => {no_tr => 1},
        "馚㼙" => {no_tr => 1},
        "ﾜ�" => {no_tr => 1},
        "㌳㽳" => {no_tr => 1},
        "馚㿹" => {no_tr => 1},
        "쳍䀬" => {no_tr => 1},
        "㌳㼳" => {no_tr => 1},
        "⬂㴇" => {no_tr => 1},
        "㽺" => {no_tr => 1},
        "晦㼦" => {no_tr => 1},
        "馚㾙" => {no_tr => 1},
        "绺㼪" => {no_tr => 1},
        "⼛㾕" => {no_tr => 1},
        "馚㻙" => {no_tr => 1},
        "竡㼔" => {no_tr => 1},
        "馚䀩" => {no_tr => 1},
        "쳍㵌" => {no_tr => 1},
        "䀀쎭" => {no_tr => 1},
        "䄜" => {no_tr => 1},
        "スワイプイベントを受け取る為のオブジェクト" => {},
        "作った要素を入れる場所" => {},
        "マスクエフェクト" => {},
        "プレハブ生成" => {},
        "ポップアップIN" => {},
        "フェードIN" => {},
        "ポップアップOUT" => {},
        "フェードOUT" => {},
        "UserInterfacePortManagerで使用します。" => {},
        "妖精" => {},
        "削除予定のメソッドです" => {},
        "コマンドプレハブ読み込み" => {},
        "破片回転速度" => {},
        "重力加速度" => {},
        "上方向へのふっとび補正" => {},
        "デバッグ用にループ起動するか" => {},
        "アニメーションクリップ用スケール" => {},
        "シェイクのパワーパラメータ" => {},
        "マテリアル反映" => {},
        "ゆらゆらアイコンオブジェジェクト生成" => {},
        "KCV.Utils.SoundUtils::PlaySwotchBGM()を使用してください" => {},
        "KCV.Utils.SoundUtilsに追加して使用してください。" => {},
        "GetDutyList(is_sorted) を使用してください" => {},
        "local.utils.Utils.GetAreaResource(int area_id, int tanker_count, EscortDeckManager eManager) を使用してください" => {},
        "GetItems()を使用してください" => {},
        "非推奨  GetInvalidTypes()を使用してください。" => {},
        "[デバッグ用] 表示の確認等の為に一時的にモデルを生成したい場合に使用してください。" => {},
        "Ship から取得してください" => {},
        "IsPlane()引数無しを使用してください" => {},
        "GetDamage(int ship_tmp_id) を使用してください" => {},
        "GetHitState(int attacker_tmp_id) を使用してください" => {},
        "GetProtectEffect を使用してください" => {},
        "GetAttackTo(int attacker_tmp_id) を使用してください" => {},
        "value_f を使用してください" => {},
        "ExpInfo を使用してください" => {},
        "SerializeField上で使用" => {},
        "キラキラ" => {},

        "Z1" => {},
        "Z3" => {},
        "Prinz Eugen" => {},
        "Z1 zwei" => {},
        "Z3 zwei" => {},
        "U-511" => {},
        "Graf Zeppelin" => {},
        "Littorio" => {},
        "Roma" => {},
        "Libeccio" => {},
        "Italia" => {},
        "Iowa" => {},

        # !!! these below may not contain commas
        "冬の抜錨" => { tr => "A Winter's Voyage", desc => "mst_bgm.xml" },
        "冬の艦隊" => { tr => "Winter's Ship", desc => "mst_bgm.xml" },
        "加賀岬改(母港ver)" => { tr => "Kaga Cape Kai (Home Port ver.)", desc => "mst_bgm.xml" },
        "加賀岬" => { tr => "Cape Kaga", desc => "mst_bgm.xml | http://kancolle.wikia.com/wiki/Merchandise/Audio KanColle Vocal Collection Volume 3, Track 02" },
        "士魂の護り" => { tr => "Grace of the Bushi's Soul", desc => "mst_bgm.xml" },
        "提督との絆" => { tr => "Our Bond with the Admiral", desc => "mst_bgm.xml" },
        "明石の工廠" => { tr => "Akashi's Armory", desc => "mst_bgm.xml" },
        "暁の水平線に" => { tr => "On the Dawn's Horizon", desc => "mst_bgm.xml" },
        "桃の節句と艦娘" => { tr => "Hinamatsuri and the Shipgirls", desc => "mst_bgm.xml" },
        "武蔵の帰投" => { tr => "Musashi's Return", desc => "mst_bgm.xml | Return of Musashi" },
        "母港" => { tr => "Home Port", desc => "mst_bgm.xml" },
        "浜辺の艦娘" => { tr => "Shipgirls on the Beach", desc => "mst_bgm.xml" },
        "海上護衛戦" => { tr => "Marine Escort Warfare", desc => "mst_bgm.xml" },
        "特型駆逐艦" => { tr => "Special-type Destroyer", desc => "mst_bgm.xml" },
        "秋の鎮守府" => { tr => "Autumn at the Naval Base", desc => "mst_bgm.xml" },
        "秋月の空" => { tr => "Autumn Moon in the Sky", desc => "mst_bgm.xml" },
        "第三十駆逐隊、抜錨準備！" => { tr => "30th Destroyer Division, Prepare to Sortie!", desc => "mst_bgm.xml" },
        "第五戦隊の出撃" => { tr => "Sortie of the Fifth Squad", desc => "mst_bgm.xml" },
        "節分の鎮守府" => { tr => "Setsubun at the Naval Base", desc => "mst_bgm.xml" },
        "索敵機、発艦始め！" => { tr => "Spotter Planes, Begin Departure!", desc => "mst_bgm.xml" },
        "聖夜の母港" => { tr => "Home Port on Christmas Eve", desc => "mst_bgm.xml" },
        "艦娘のお菓子作り" => { tr => "Candy-making by the Shipgirls", desc => "mst_bgm.xml" },
        "華の二水戦" => { tr => "The Splendid Second Torpedo Squadron", desc => "mst_bgm.xml" },
        "迎春の鎮守府" => { tr => "New Year Greetings from the Naval District", desc => "mst_bgm.xml" },
        "連合艦隊の出撃" => { tr => "Sortie the Combined fleet", desc => "mst_bgm.xml" },
        "鎮守府の朝" => { tr => "Morning at the Naval Base", desc => "mst_bgm.xml" },
        "鎮守府の秋祭り" => { tr => "Autumn Festival at the Naval Base", desc => "mst_bgm.xml" },
        "雨とお酒と艦娘" => { tr => "Rain and Sake and Shipgirls", desc => "Rain, Sake and Shipgirls | mst_bgm.xml" },
        "雨音の鎮守府" => { tr => "The Sound of Rain at the Navy Base", desc => "mst_bgm.xml" },
        "同曲母港BGMバージョン" => { tr => "Homeport BGM version of Kaga Cape", desc => "mst_bgm_jukebox.xml" },
        "母港BGM設定可能" => { tr => "Can be set for homeport BGM", desc => "mst_bgm_jukebox.xml" },
        "視聴ロングバージョン" => { tr => "Long Version", desc => "mst_bgm_jukebox.xml" },
        "試製ショートバージョン" => { tr => "Short Version", desc => "mst_bgm_jukebox.xml" },
        "試製新曲先行公開" => { tr => "Experimental new song early release", desc => "mst_bgm_jukebox.xml" },
        # !!! these above may not contain commas
        
        "「ありがとう」掛け軸" => { tr => qq["Arigatou" Scroll], desc => "mst_furniture.xml" },
        "「なのです」掛け軸" => { tr => qq["Nanodesu" Scroll], desc => "mst_furniture.xml" },
        "「ブイン基地」掛け軸" => { tr => qq["Buin Base" Scroll], desc => "mst_furniture.xml" },
        "「ラバウル基地」掛け軸" => { tr => qq["Rabaul Base" Scroll], desc => "mst_furniture.xml" },
        "「一周年記念」掛け軸" => { tr => qq["First anniversary" Scroll], desc => "mst_furniture.xml" },
        "「二周年記念」掛け軸" => { tr => "Kancolle 2nd Anniversary Scroll", desc => "mst_furniture.xml" },
        "「加賀」模型と桐箪笥" => { tr => qq[Kimono Chest and "Kaga" Model], desc => "mst_furniture.xml" },
        "「夜戦」掛け軸" => { tr => qq["Night Battle" Scroll], desc => "mst_furniture.xml" },
        "「横須賀鎮守府」掛け軸" => { tr => qq["Yokosuka Naval District" Scroll], desc => "mst_furniture.xml" },
        "「武蔵」模型と桐箪笥" => { tr => qq[Kimono Chest and "Musashi" Model], desc => "mst_furniture.xml" },
        "「海上護衛」掛け軸" => { tr => qq["Marine Guarding" Scroll], desc => "mst_furniture.xml" },
        "「第六駆逐隊」掛け軸" => { tr => qq["Destroyer Division 6th" Scroll], desc => "mst_furniture.xml" },
        "「舞鶴鎮守府」掛け軸" => { tr => qq["Maizuru Naval District" Scroll], desc => "mst_furniture.xml" },
        "「観艦式」掛け軸" => { tr => "Naval Review Banner", desc => "mst_furniture.xml" },
        "「謹賀新年」掛け軸" => { tr => qq["Happy New Year" Scroll], desc => "mst_furniture.xml" },
        "「赤城」模型と桐箪笥" => { tr => qq[Kimono Chest and "Akagi" Model], desc => "mst_furniture.xml" },
        "「迷彩主義」掛け軸" => { tr => qq["Camouflage doctrine" Scroll], desc => "mst_furniture.xml" },
        "「長門」「陸奥」の雛人形" => { tr => qq[King doll "Nagato" and Queen doll "Mutsu"], desc => "mst_furniture.xml" },
        "「長門」模型と桐箪笥" => { tr => qq[Kimono Chest and "Nagato" Model], desc => "mst_furniture.xml" },
        "「霧」の桐箪笥" => { tr => qq[Kimono Chest and "Fog" Ship Model], desc => "mst_furniture.xml" },
        "「100万の感謝」掛け軸" => { tr => qq["Thanks to 1,000,000" Scroll], desc => "mst_furniture.xml" },
        "「150万の感謝」掛け軸" => { tr => qq["Thanks to 1,500,000" Scroll], desc => "mst_furniture.xml" },
        "「180万の感謝」掛け軸" => { tr => qq["Thanks to 1,800,000" Scroll], desc => "mst_furniture.xml" },
        "「20万の感謝」掛け軸" => { tr => qq["Thanks to 200,000" Scroll], desc => "mst_furniture.xml" },
        "「200万の感謝」掛け軸" => { tr => qq["Thanks to 2,000,000" Scroll], desc => "mst_furniture.xml" },
        "「250万の感謝」掛け軸" => { tr => qq["Thanks to 2,500,000 players!" Scroll], desc => "mst_furniture.xml" },
        "「300万の感謝」掛け軸" => { tr => qq["Thanks to 3,000,000" Scroll], desc => "mst_furniture.xml" },
        "「50万の感謝」掛け軸" => { tr => qq["Thanks to 500,000" Scroll], desc => "mst_furniture.xml" },
        "「80万の感謝」掛け軸" => { tr => qq["Thanks to 800,000" Scroll], desc => "mst_furniture.xml" },
        "い草の畳" => { tr => "Grassy Tatami", desc => "mst_furniture.xml" },
        "おいしそうなスツール" => { tr => "Delicious Looking Stool", desc => "mst_furniture.xml" },
        "おさがりの机" => { tr => "Second-hand Desk", desc => "mst_furniture.xml" },
        "おしゃれな格子窓" => { tr => "Stylish Barred Window", desc => "mst_furniture.xml" },
        "お月見窓" => { tr => "Moon-viewing Window", desc => "mst_furniture.xml" },
        "お花見窓" => { tr => "Cherry Blossom-viewing Window", desc => "mst_furniture.xml" },
        "お菓子作りの壁紙" => { tr => "Candy-making Wallpaper", desc => "mst_furniture.xml" },
        "お詫び掛け軸" => { tr => "Apology Scroll", desc => "mst_furniture.xml" },
        "ご家庭用プール" => { tr => "Indoor Pool", desc => "mst_furniture.xml" },
        "しめ飾り" => { tr => "Shimekazari", desc => "mst_furniture.xml" },
        "しょうぶ和箪笥" => { tr => "Japanese Iris Cabinet", desc => "mst_furniture.xml" },
        "すだれ窓" => { tr => "Window with Bamboo Blind", desc => "mst_furniture.xml" },
        "ただの段ボール" => { tr => "Common Cardboard", desc => "mst_furniture.xml" },
        "だるま" => { tr => "Daruma", desc => "mst_furniture.xml" },
        "ちゃぶ台セット" => { tr => "Low Dining Table Set", desc => "mst_furniture.xml" },
        "ちょっとゴージャスな窓" => { tr => "Slightly Gorgeous Window", desc => "mst_furniture.xml" },
        "てるてる坊主の窓" => { tr => "Window with Teru teru Bōzu Dolls", desc => "mst_furniture.xml" },
        "やかんストーブ" => { tr => "Stove with Kettle", desc => "mst_furniture.xml" },
        "アレンジメント" => { tr => "Flower Arrangement", desc => "mst_furniture.xml" },
        "インテリア椅子" => { tr => "Stylish Chair", desc => "mst_furniture.xml" },
        "ウッディな執務机" => { tr => qq["Woody" Mahogany Desk], desc => "mst_furniture.xml" },
        "エスニックなマット" => { tr => "Ethnic Mat", desc => "mst_furniture.xml" },
        "エレガントボード" => { tr => "Elegant Board", desc => "mst_furniture.xml" },
        "ガラステーブル" => { tr => "Glass Table", desc => "mst_furniture.xml" },
        "クラシックシェルフ" => { tr => "Classic Shelf", desc => "mst_furniture.xml" },
        "コンクリート壁" => { tr => "Concrete Wall", desc => "mst_furniture.xml" },
        "コンクリート床" => { tr => "Concrete Floor", desc => "mst_furniture.xml" },
        "サイドボード" => { tr => "Sideboard", desc => "mst_furniture.xml" },
        "シングルベッド" => { tr => "Single Bed", desc => "mst_furniture.xml" },
        "シンプルなすだれ窓" => { tr => "Window with Simple Bamboo Blind", desc => "mst_furniture.xml" },
        "シンプルな観葉植物" => { tr => "Simple Foliage Plant", desc => "mst_furniture.xml" },
        "シンプルフレーム" => { tr => "Simple Window Frame", desc => "mst_furniture.xml" },
        "シンプルフレーム2型" => { tr => "Simple Window Frame no.2", desc => "mst_furniture.xml" },
        "シンプルモダン壁紙" => { tr => "Simple Modern Wallpaper", desc => "mst_furniture.xml" },
        "ジュークボックス改" => { tr => "Jukebox Kai", desc => "mst_furniture.xml" },
        "ジュークボックス" => { tr => "Jukebox", desc => "mst_furniture.xml" },
        "ステンドグラス" => { tr => "Stained Glass Screen", desc => "mst_furniture.xml" },
        "ダンディな机" => { tr => "Dandy Desk", desc => "mst_furniture.xml" },
        "チェック＆リーフ壁紙" => { tr => "Wallpaper with Plaid and Leaf Motif", desc => "mst_furniture.xml" },
        "チョコケーキと紅茶セット" => { tr => "Chocolate and Tea Set", desc => "mst_furniture.xml" },
        "チョコレートの壁紙" => { tr => "Chocolate Wallpaper", desc => "mst_furniture.xml" },
        "チョコレートキッチン" => { tr => "Chocolate Kitchen", desc => "mst_furniture.xml" },
        "ドレッサー" => { tr => "Dresser", desc => "mst_furniture.xml" },
        "ナチュラルな床" => { tr => "Natural Floor", desc => "mst_furniture.xml" },
        "ナチュラルな椅子" => { tr => "Natural Chair", desc => "mst_furniture.xml" },
        "ハンガーラック" => { tr => "Hanger Rack", desc => "mst_furniture.xml" },
        "バー仕様の壁" => { tr => "Bar Wall", desc => "mst_furniture.xml" },
        "パーティの飾り付け" => { tr => "Party Decoration", desc => "mst_furniture.xml" },
        "ビニールプール" => { tr => "Paddling Pool", desc => "mst_furniture.xml" },
        "ピンクの床" => { tr => "Pink Floor", desc => "mst_furniture.xml" },
        "ピンクコンクリ壁" => { tr => "Pink Concrete Wall", desc => "mst_furniture.xml" },
        "ピンクドット壁紙" => { tr => "Pink Dot Wallpaper", desc => "mst_furniture.xml" },
        "フェミニンなマット" => { tr => "Feminine Mat", desc => "mst_furniture.xml" },
        "フェミニンガラステーブル" => { tr => "Feminine Glass Table", desc => "mst_furniture.xml" },
        "フレーム付地図" => { tr => "Map with Frame", desc => "mst_furniture.xml" },
        "ブルーカーペット" => { tr => "Blue Carpet", desc => "mst_furniture.xml" },
        "ブルードットな壁紙" => { tr => "Blue Dot Wallpaper", desc => "mst_furniture.xml" },
        "ポップな壁紙" => { tr => "Pop Wallpaper", desc => "mst_furniture.xml" },
        "メルヘンシェルフ" => { tr => "Fairytale Shelf", desc => "mst_furniture.xml" },
        "モダンなテーブル" => { tr => "Modern Table", desc => "mst_furniture.xml" },
        "モダンな床" => { tr => "Modern Floor", desc => "mst_furniture.xml" },
        "モダンチェア" => { tr => "Modern Chair", desc => "mst_furniture.xml" },
        "ラクガキ床" => { tr => "Graffiti Floor", desc => "mst_furniture.xml" },
        "リゾートセット" => { tr => "Resort Set", desc => "mst_furniture.xml" },
        "レインコート＆傘掛け" => { tr => "Raincoat and Umbrella Hanger", desc => "mst_furniture.xml" },
        "七夕飾りの窓" => { tr => "Window with Tanabata Decorations", desc => "mst_furniture.xml" },
        "七面鳥のご馳走" => { tr => "Dinner of Turkey", desc => "mst_furniture.xml" },
        "低予算な壁紙" => { tr => "Inexpensive Wallpaper", desc => "mst_furniture.xml" },
        "冬のステンドグラス" => { tr => "Winter Stained Glass", desc => "mst_furniture.xml" },
        "冬のモダンアート壁紙" => { tr => "Modern Winter Art Wallpaper", desc => "mst_furniture.xml" },
        "北方迷彩な桐箪笥" => { tr => "Arctic Camouflaged Paulownia Cabinet", desc => "mst_furniture.xml" },
        "原稿机" => { tr => "Manuscript Desk", desc => "mst_furniture.xml" },
        "古い世界地図" => { tr => "Old World Map", desc => "mst_furniture.xml" },
        "合宿セット・布団" => { tr => "Camping Set: Futon", desc => "mst_furniture.xml" },
        "和のシンプル壁紙" => { tr => "Japanese-style Simple Wallpaper", desc => "mst_furniture.xml" },
        "和モダンアート壁紙" => { tr => "Modern Japanese Art Wallpaper", desc => "mst_furniture.xml" },
        "執務机" => { tr => "Mahogany Desk", desc => "mst_furniture.xml" },
        "壁掛け古時計" => { tr => "Old Wall Clock", desc => "mst_furniture.xml" },
        "壁掛け図上演習セット" => { tr => "Wall-mounted Practice Map Set", desc => "mst_furniture.xml" },
        "夏先取りセット" => { tr => "Pre-ordered Summer Set", desc => "mst_furniture.xml" },
        "大きな古時計" => { tr => "Big Antique Clock", desc => "mst_furniture.xml" },
        "大人の節分セット" => { tr => "Adult's Setsubun Set", desc => "mst_furniture.xml" },
        "大将の机" => { tr => "General's Desk", desc => "mst_furniture.xml" },
        "女の子のポスター" => { tr => "Girl Poster", desc => "mst_furniture.xml" },
        "家具職人の壁紙" => { tr => "Furniture Craftsman's Wallpaper", desc => "mst_furniture.xml" },
        "富士山の壁画" => { tr => "Wall Painting of Mt. Fuji", desc => "mst_furniture.xml" },
        "富嶽タイル画" => { tr => "Mt.Fuji Tile Painting", desc => "mst_furniture.xml" },
        "小さなウッドベージュの椅子" => { tr => "Little Beige Wooden Chair", desc => "mst_furniture.xml" },
        "小さな観葉植物" => { tr => "Little Foliage Plant", desc => "mst_furniture.xml" },
        "小花柄カーペット" => { tr => "Carpet with Floral Pattern", desc => "mst_furniture.xml" },
        "布団と枕" => { tr => "Futon and Pillow", desc => "mst_furniture.xml" },
        "年越し蕎麦" => { tr => "New Year's Soba", desc => "mst_furniture.xml" },
        "広く開いた大窓" => { tr => "Wide-open large Window", desc => "mst_furniture.xml" },
        "床の間" => { tr => "Tokonoma", desc => "mst_furniture.xml" },
        "怪獣映画ポスター" => { tr => "Monster-movie Poster", desc => "mst_furniture.xml" },
        "戦艦タイルの床" => { tr => "Floor with Battleship-motif Tiles", desc => "mst_furniture.xml" },
        "戦艦映画ポスター" => { tr => "Battleship Movie Poster", desc => "mst_furniture.xml" },
        "折り畳み机" => { tr => "Folding Desk", desc => "mst_furniture.xml" },
        "折鶴の壁紙" => { tr => "Wallpaper with Origami Crane Motif", desc => "mst_furniture.xml" },
        "提督の書斎机" => { tr => "Admiral's Study Desk", desc => "mst_furniture.xml" },
        "提督の机" => { tr => "Admiral's Desk", desc => "mst_furniture.xml" },
        "提督の麻雀卓" => { tr => "Admiral's Mahjong Table", desc => "mst_furniture.xml" },
        "撮影セット" => { tr => "Photostudio Set", desc => "mst_furniture.xml" },
        "教室セット「教卓」" => { tr => "Classroom Set: Teacher's Desk", desc => "mst_furniture.xml" },
        "教室セット「机」" => { tr => "Classroom Set: Desk", desc => "mst_furniture.xml" },
        "教室セット「黒板」" => { tr => "Classroom Set: Blackboard", desc => "mst_furniture.xml" },
        "新春の壁紙" => { tr => "New Year Wallpaper", desc => "mst_furniture.xml" },
        "新春掛け軸二〇一五" => { tr => "New Year Scroll 2015", desc => "mst_furniture.xml" },
        "新生だるま" => { tr => "Newborn daruma", desc => "mst_furniture.xml" },
        "新緑のフローリング" => { tr => "Fresh Green Floor", desc => "mst_furniture.xml" },
        "新緑の壁紙" => { tr => "Fresh Green Wallpaper", desc => "mst_furniture.xml" },
        "日本酒＆ウィスキー棚" => { tr => "Sake and Whiskey Shelf", desc => "mst_furniture.xml" },
        "早く出しすぎた炬燵" => { tr => "Prematurely Evacuated Kotatsu", desc => "mst_furniture.xml" },
        "明るいウッドタイルの床" => { tr => "Bright Wood Tile Floor", desc => "mst_furniture.xml" },
        "昔ながらのすりガラス" => { tr => "Old-fashioned Frosted Glass", desc => "mst_furniture.xml" },
        "昔ながらの箪笥" => { tr => "Good Old Chest", desc => "mst_furniture.xml" },
        "春仕様の壁紙" => { tr => "Spring-themed Wallpaper", desc => "mst_furniture.xml" },
        "春色の壁紙" => { tr => "Spring-colored Wallpaper", desc => "mst_furniture.xml" },
        "春色の床" => { tr => "Spring Scenery Flooring", desc => "mst_furniture.xml" },
        "昭和レトロな壁紙" => { tr => "Showa Retro Wallpaper", desc => "mst_furniture.xml" },
        "晩秋の高級和窓" => { tr => "Late Autumn High-grade Japanese-style Window", desc => "mst_furniture.xml" },
        "普通の壁紙" => { tr => "Common Wallpaper", desc => "mst_furniture.xml" },
        "暖炉" => { tr => "Fireplace", desc => "mst_furniture.xml" },
        "暗めのウッドタイルの床" => { tr => "Dark-colored Wood Tile Floor", desc => "mst_furniture.xml" },
        "書斎本棚" => { tr => "Study Bookshelf", desc => "mst_furniture.xml" },
        "木板の壁" => { tr => "Wooden Board Wall", desc => "mst_furniture.xml" },
        "朱色の床" => { tr => "Vermilion Floor", desc => "mst_furniture.xml" },
        "板チョコ型の机" => { tr => "Chocolate-bar-shaped Desk", desc => "mst_furniture.xml" },
        "桃の節句の壁紙" => { tr => "HinaMatsuri Wallpaper", desc => "mst_furniture.xml" },
        "桃の節句の窓" => { tr => "Lovely Small Window", desc => "mst_furniture.xml" },
        "桜の床" => { tr => "Sakura Flooring", desc => "mst_furniture.xml" },
        "桜の高級窓" => { tr => "Sakura High-grade Window", desc => "mst_furniture.xml" },
        "桜舞う春のフローリング" => { tr => "Spring Floor with Cherry Blossom Design", desc => "mst_furniture.xml" },
        "梅紫の壁紙" => { tr => "Plum Purple Wallpaper", desc => "mst_furniture.xml" },
        "梅雨の壁紙" => { tr => "Rainy-season Wallpaper", desc => "mst_furniture.xml" },
        "梅雨の緑カーテン窓" => { tr => "Rainy-season Window with Green Curtain", desc => "mst_furniture.xml" },
        "椅子" => { tr => "Chair", desc => "mst_furniture.xml" },
        "業務用かき氷器" => { tr => "Commercial Shaved Ice Maker", desc => "mst_furniture.xml" },
        "模様替えお掃除セット" => { tr => "Room-rearranging Cleaning Instruments Set", desc => "mst_furniture.xml" },
        "武蔵の掛け軸" => { tr => "Musashi's Wall Scroll", desc => "mst_furniture.xml" },
        "水風呂" => { tr => "Cold Water Bath", desc => "mst_furniture.xml" },
        "洋酒＆ワイン棚" => { tr => "Liquor and Wine Shelf", desc => "mst_furniture.xml" },
        "浜茶屋の仮設壁板" => { tr => "Beach Teahouse Provisional Board Wall ", desc => "mst_furniture.xml" },
        "浜茶屋の床" => { tr => "Beach Teahouse Flooring", desc => "mst_furniture.xml" },
        "浜茶屋の窓" => { tr => "Beach Teahouse Window", desc => "mst_furniture.xml" },
        "温泉岩風呂" => { tr => "Hot Spring Bath", desc => "mst_furniture.xml" },
        "温泉檜風呂" => { tr => "Hinoki Wood Hot Spring Bath", desc => "mst_furniture.xml" },
        "煎餅布団" => { tr => "Thin Futon", desc => "mst_furniture.xml" },
        "照れ屋なお面" => { tr => "Shy Mask", desc => "mst_furniture.xml" },
        "爽やかな窓" => { tr => "Clear Window", desc => "mst_furniture.xml" },
        "白いカーテンの小窓" => { tr => "Small Window with White Curtain", desc => "mst_furniture.xml" },
        "白い冬の壁紙" => { tr => "White Winter Wallpaper", desc => "mst_furniture.xml" },
        "白い石板タイル" => { tr => "White Tile Floor", desc => "mst_furniture.xml" },
        "白い高級大理石床" => { tr => "High Quality White Marble Flooring", desc => "mst_furniture.xml" },
        "白と青のツリー" => { tr => "White and Blue Christmas Tree", desc => "mst_furniture.xml" },
        "真っ白なフワフワ絨毯" => { tr => "Fluffy Pure White Carpet", desc => "mst_furniture.xml" },
        "真っ赤な高級絨毯" => { tr => "High-grade Crimson Carpet", desc => "mst_furniture.xml" },
        "真っ青な床" => { tr => "Pure Blue Floor", desc => "mst_furniture.xml" },
        "砂浜の床" => { tr => "Sandy Beach Floor", desc => "mst_furniture.xml" },
        "破魔矢の窓" => { tr => "Hamaya Window", desc => "mst_furniture.xml" },
        "社長の机" => { tr => "President Desk", desc => "mst_furniture.xml" },
        "秋の気配な窓" => { tr => "Autumn Window", desc => "mst_furniture.xml" },
        "秋仕様の壁紙" => { tr => "Autumn-themed Wallpaper", desc => "mst_furniture.xml" },
        "秋刀魚の食卓" => { tr => "Autumn Feast Table", desc => "mst_furniture.xml" },
        "穏やかな壁紙" => { tr => "Serene Wallpaper", desc => "mst_furniture.xml" },
        "節分「豆まき」セット" => { tr => qq[Setsubun "Mamemaki" Set], desc => "mst_furniture.xml" },
        "紅葉の壁紙" => { tr => "Autumn Leaves Wallpaper", desc => "mst_furniture.xml" },
        "紫の小花柄のカーペット" => { tr => "Carpet with Purple Floral Pattern", desc => "mst_furniture.xml" },
        "紫陽花の窓" => { tr => "Window with Hydrangeas", desc => "mst_furniture.xml" },
        "紫陽花鉢の提督机" => { tr => "Admiral's Desk with Hydrangea Bowl", desc => "mst_furniture.xml" },
        "紳士な帽子掛け" => { tr => "Gentleman Hat Rack", desc => "mst_furniture.xml" },
        "緑のプランター" => { tr => "Green Planter", desc => "mst_furniture.xml" },
        "緑の和壁紙" => { tr => "Japanese-style Green Wallpaper", desc => "mst_furniture.xml" },
        "緑の壁紙" => { tr => "Green Wallpaper", desc => "mst_furniture.xml" },
        "緑の床" => { tr => "Green Floor", desc => "mst_furniture.xml" },
        "緑カーテンの窓" => { tr => "Window with Green Curtain", desc => "mst_furniture.xml" },
        "羽毛布団と枕" => { tr => "Duvets and Pillows", desc => "mst_furniture.xml" },
        "脱衣所" => { tr => "Dressing Room", desc => "mst_furniture.xml" },
        "艦娘による冬の窓" => { tr => "Winter Window Decorated by Fleet Girls", desc => "mst_furniture.xml" },
        "艦娘専用デスク" => { tr => "Fleet Girls' Private Desk", desc => "mst_furniture.xml" },
        "艦隊大漁旗" => { tr => "Fleet Fishery Banner", desc => "mst_furniture.xml" },
        "艦隊氷旗" => { tr => "Fleet Shaved Ice Flag", desc => "mst_furniture.xml" },
        "花の絵画" => { tr => "Flower Painting", desc => "mst_furniture.xml" },
        "花火の窓" => { tr => "Fireworks Window", desc => "mst_furniture.xml" },
        "蚊取り線香の窓" => { tr => "Window with Anti-mosquito Incense", desc => "mst_furniture.xml" },
        "西欧風カーペット" => { tr => "European Carpet", desc => "mst_furniture.xml" },
        "西瓜割りセット" => { tr => "Watermelon Splitting Set", desc => "mst_furniture.xml" },
        "診療台セット" => { tr => "Clinical Table Set", desc => "mst_furniture.xml" },
        "試作艦戦ポスター" => { tr => "Prototype Fighter Poster", desc => "mst_furniture.xml" },
        "豪華なお月見窓" => { tr => "Gorgeous moon-viewing Window", desc => "mst_furniture.xml" },
        "赤カーテンの窓" => { tr => "Window with Red Curtain", desc => "mst_furniture.xml" },
        "軍艦色の壁" => { tr => "Battleship-style Dark Grey Wall", desc => "mst_furniture.xml" },
        "重巡模型と桐箪笥" => { tr => "Kimono Chest and Heavy Cruiser Model", desc => "mst_furniture.xml" },
        "金剛の紅茶セット" => { tr => "Kongou's Tea Set", desc => "mst_furniture.xml" },
        "鉄格子の窓" => { tr => "Iron-barred Window", desc => "mst_furniture.xml" },
        "鎮守府のツリー" => { tr => "Christmas Tree of the Naval District", desc => "mst_furniture.xml" },
        "鎮守府の床" => { tr => "Naval District Standard Floor", desc => "mst_furniture.xml" },
        "鎮守府カウンターバー" => { tr => "Anchorage Counter Bar", desc => "mst_furniture.xml" },
        "鎮守府初詣セット" => { tr => "Naval District's Shrine Visit Set", desc => "mst_furniture.xml" },
        "鎮守府新年飾り" => { tr => "Naval District's New Year Decoration", desc => "mst_furniture.xml" },
        "鎮守府浜茶屋" => { tr => "Anchorage Beach Teahouse", desc => "mst_furniture.xml" },
        "鎮守府秋刀魚祭り" => { tr => "Anchorage Mackerel Festival", desc => "mst_furniture.xml" },
        "鎮守府秋祭りの射的" => { tr => "Anchorage Autumn Festival Target Practice", desc => "mst_furniture.xml" },
        "鎮守府秋祭りの屋台" => { tr => "Anchorage Autumn Festival Food Cart", desc => "mst_furniture.xml" },
        "鎮守府風鈴" => { tr => "Naval District Wind Chime", desc => "mst_furniture.xml" },
        "門松" => { tr => "Kadomatsu", desc => "mst_furniture.xml" },
        "防空加工窓" => { tr => "Air Raid Resistant Window", desc => "mst_furniture.xml" },
        "障子デラックス" => { tr => "Deluxe Shoji", desc => "mst_furniture.xml" },
        "障子" => { tr => "Shoji", desc => "mst_furniture.xml" },
        "雛人形豪華四段飾り" => { tr => "Gorgeous Hina-ningyou doll set with 4-step Stand", desc => "mst_furniture.xml" },
        "雪原の床" => { tr => "Snowfield Floor", desc => "mst_furniture.xml" },
        "青い上品な大窓" => { tr => "Elegant Large Blue Window", desc => "mst_furniture.xml" },
        "青い壁紙" => { tr => "Blue Wallpaper", desc => "mst_furniture.xml" },
        "青の小花柄のカーペット" => { tr => "Carpet with Blue Floral Pattern", desc => "mst_furniture.xml" },
        "青カーテンの窓" => { tr => "Window with Blue Curtain", desc => "mst_furniture.xml" },
        "青畳" => { tr => "Green Tatami", desc => "mst_furniture.xml" },
        "飛行甲板" => { tr => "Carrier Flight Deck", desc => "mst_furniture.xml" },
        "駆逐艦娘のツリー" => { tr => "Christmas Tree of Destroyer Fleet Girls", desc => "mst_furniture.xml" },
        "高級フローリング" => { tr => "High-grade Floor", desc => "mst_furniture.xml" },
        "高級ミシン" => { tr => "High-grade Sewing Machine", desc => "mst_furniture.xml" },
        "高級和風壁紙" => { tr => "High-grade Japanese-style Wallpaper", desc => "mst_furniture.xml" },
        "高級木材の壁" => { tr => "High-Quality Wood Wall", desc => "mst_furniture.xml" },
        "高級赤煉瓦の壁" => { tr => "High-Quality Red Brick Wall", desc => "mst_furniture.xml" },
        "鬼灯の花の窓" => { tr => "Ground Cherry Flower Window", desc => "mst_furniture.xml" },
        "鮮やかな畳" => { tr => "Vivid Green Tatami", desc => "mst_furniture.xml" },
        "鹿のオブジェ" => { tr => "Deer Objet d'art", desc => "mst_furniture.xml" },
        "黄緑の床" => { tr => "Yellow-Green Floor", desc => "mst_furniture.xml" },
        "黒いタイルの床" => { tr => "Black Tile Floor", desc => "mst_furniture.xml" },
        "龍の壁紙" => { tr => "Dragon Wallpaper", desc => "mst_furniture.xml" },
        "Ｚ旗の暖炉" => { tr => "Fireplace with Z Flag", desc => "mst_furniture.xml" },

        "中部海域" => { tr => "Central Sea", desc => "mst_maparea.xml" },
        "中部西海域" => { tr => "Central Western Sea", desc => "mst_maparea.xml" },
        "予備マップ１" => { tr => "Reserve Map 1", desc => "mst_maparea.xml" },
        "予備マップ２" => { tr => "Reserve Map 2", desc => "mst_maparea.xml" },
        "予備マップ３" => { tr => "Reserve Map 3", desc => "mst_maparea.xml" },
        "北方泊地海域" => { tr => "North Anchorage Sea", desc => "mst_maparea.xml" },
        "北方海域" => { tr => "Northern Sea", desc => "mst_maparea.xml" },
        "南方泊地海域" => { tr => "South Anchorage Sea", desc => "mst_maparea.xml" },
        "南方海域" => { tr => "Southern Sea", desc => "mst_maparea.xml" },
        "南方連絡海域" => { tr => "South Connecting Sea", desc => "mst_maparea.xml" },
        "南西諸島海域" => { tr => "Nansei Islands", desc => "mst_maparea.xml" },
        "深海中枢海域" => { tr => "Deep Sea Central Ocean", desc => "mst_maparea.xml" },
        "深海後方海域" => { tr => "Deep Sea Rear Ocean", desc => "mst_maparea.xml" },
        "深海運河海域" => { tr => "Deep Sea Canal", desc => "mst_maparea.xml" },
        "西南海域" => { tr => "Southwest Sea", desc => "mst_maparea.xml" },
        "西方海域" => { tr => "Western Sea", desc => "mst_maparea.xml" },
        "AL海域" => { tr => "AL Sea", desc => "mst_maparea.xml" },
        "FS海域" => { tr => "FS Sea", desc => "mst_maparea.xml" },
        "MI海域" => { tr => "MI Sea", desc => "mst_maparea.xml" },

        "アイアンボトムサウンド深部" => { tr => "Ironbottom Sound: Final Stage", desc => "mst_mapinfo.xml" },
        "アイアンボトムサウンド" => { tr => "Ironbottom Sound", desc => "mst_mapinfo.xml" },
        "アンズ環礁秘匿泊地攻撃" => { tr => "Attack on Secret Anchorage in Apricot Atoll", desc => "mst_mapinfo.xml" },
        "オリョール海あ号作戦" => { tr => "Orel Sea: Operation A-Gou", desc => "mst_mapinfo.xml" },
        "オリョール海東部" => { tr => "Eastern Orel Sea", desc => "mst_mapinfo.xml" },
        "オリョール海西部" => { tr => "North Pacific Sea: MI Islands", desc => "mst_mapinfo.xml" },
        "オリョール海進出" => { tr => "Operation MI", desc => "mst_mapinfo.xml" },
        "カレー洋リランカ島沖" => { tr => "Ri Lanka Island: Coast Area", desc => "mst_mapinfo.xml" },
        "カレー洋作戦" => { tr => "Curry Ocean Operation", desc => "mst_mapinfo.xml" },
        "カレー洋正面海域" => { tr => "Curry Ocean: Front Area", desc => "mst_mapinfo.xml" },
        "キス島撤退作戦" => { tr => "Kis Island Withdrawal Tactics", desc => "mst_mapinfo.xml" },
        "キス島沖海戦" => { tr => "Battle of Kis Island's Coast", desc => "mst_mapinfo.xml" },
        "サメワニ沖海戦" => { tr => "Battle of the Samewani Coast", desc => "mst_mapinfo.xml" },
        "ショートランド沖" => { tr => "Shortland Islands: Coast Area", desc => "mst_mapinfo.xml" },
        "ステビア海アンズ諸島沖" => { tr => "Stebia Sea off Apricot Coast", desc => "mst_mapinfo.xml" },
        "ズンダ海峡を越えて" => { tr => "Across the Zunda Strait", desc => "mst_mapinfo.xml" },
        "トラック泊地周辺警備" => { tr => "Patrol Around Truk Anchorage", desc => "mst_mapinfo.xml" },
        "トラック泊地周辺部" => { tr => "Perimeter of Truk Anchorage", desc => "mst_mapinfo.xml" },
        "トラック泊地対潜哨戒" => { tr => "Truk Anchorage Anti-submarine Patrol", desc => "mst_mapinfo.xml" },
        "トラック泊地沖" => { tr => "Truk Anchorage Coast", desc => "mst_mapinfo.xml" },
        "トラック泊地" => { tr => "Truk Anchorage", desc => "mst_mapinfo.xml" },
        "トラック諸島海域東部" => { tr => "Truk: Islands off the Eastern Sea", desc => "mst_mapinfo.xml" },
        "バシー島沖" => { tr => "Bashi Island", desc => "mst_mapinfo.xml" },
        "ベーグル湾沖" => { tr => "Bagel Bay", desc => "mst_mapinfo.xml" },
        "ベーグル湾通商破壊戦" => { tr => "Bagel Bay Commerce Raiding", desc => "mst_mapinfo.xml" },
        "ポートワイン沖" => { tr => "Port Wine Area", desc => "mst_mapinfo.xml" },
        "リランカ島強襲作戦" => { tr => "Ri Lanka Island Assault Operation", desc => "mst_mapinfo.xml" },
        "中部太平洋海域深部" => { tr => "Central Pacific Sea: Final Stage", desc => "mst_mapinfo.xml" },
        "中部太平洋海域" => { tr => "Central Pacific Sea", desc => "mst_mapinfo.xml" },
        "中部太平洋MS諸島沖" => { tr => "Central Pacific Sea: MS Islands", desc => "mst_mapinfo.xml" },
        "中部海域哨戒域" => { tr => "Central Area: Patrol Line", desc => "mst_mapinfo.xml" },
        "中部海域水上偵察" => { tr => "Central Area Reconnaissance", desc => "mst_mapinfo.xml" },
        "北太平洋海域" => { tr => "North Pacific Sea", desc => "mst_mapinfo.xml" },
        "北太平洋MI諸島沖" => { tr => "North Pacific Sea: MI Islands", desc => "mst_mapinfo.xml" },
        "北方アルフォンシーノ列島沖" => { tr => "North Sea: Alfonsino Coast", desc => "mst_mapinfo.xml" },
        "北方キス島後方海域" => { tr => "North Sea: Kis Island Rear Area", desc => "mst_mapinfo.xml" },
        "北方キス島沖" => { tr => "North Sea: Kis Island Coast", desc => "mst_mapinfo.xml" },
        "北方モーレイ海" => { tr => "North Sea: Moray", desc => "mst_mapinfo.xml" },
        "北方列島沖艦隊決戦" => { tr => "Decisive Battle of the Northern Archipelago", desc => "mst_mapinfo.xml" },
        "北方海域哨戒" => { tr => "North Sea Patrol", desc => "mst_mapinfo.xml" },
        "北方海域－作戦５" => { tr => "Northern Sea Combat Patrol", desc => "mst_mapinfo.xml" },
        "北方海域－EO1" => { tr => "Extra Operation", desc => "mst_mapinfo.xml" },
        "北方海峡警備" => { tr => "Northern Strait Security Operation", desc => "mst_mapinfo.xml" },
        "北方海峡" => { tr => "Northern Strait", desc => "mst_mapinfo.xml" },
        "北方連絡海域" => { tr => "Northern Seafront Area", desc => "mst_mapinfo.xml" },
        "北方連絡線哨戒" => { tr => "Northern Seafront Line Patrol", desc => "mst_mapinfo.xml" },
        "北方AL列島沖" => { tr => "Northern AL Area: Archipelago", desc => "mst_mapinfo.xml" },
        "北方AL海域中心部" => { tr => "Northern AL Area: Center Area", desc => "mst_mapinfo.xml" },
        "北方AL海域前縁部" => { tr => "Northern AL Area: Front Edge", desc => "mst_mapinfo.xml" },
        "北方AL海域最深部" => { tr => "Northern AL Area: Probing Area", desc => "mst_mapinfo.xml" },
        "南太平洋FS海域前縁部" => { tr => "FS Strait: South Pacific Ocean Front Area", desc => "mst_mapinfo.xml" },
        "南太平洋FS海域" => { tr => "FS Strait: South Pacific Ocean", desc => "mst_mapinfo.xml" },
        "南方海域珊瑚諸島沖" => { tr => "Southern Sea off the Coral Islands", desc => "mst_mapinfo.xml" },
        "南方海域進出作戦" => { tr => "Southern Sea Advance Operation", desc => "mst_mapinfo.xml" },
        "南方海域－作戦５" => { tr => "Second Battle of the Salmon Sea", desc => "mst_mapinfo.xml" },
        "南方海域－EO1" => { tr => "Extra Operation", desc => "mst_mapinfo.xml" },
        "南方航路方面警備" => { tr => "Southern Route Security Operation", desc => "mst_mapinfo.xml" },
        "南方航路西部" => { tr => "Southern Route West", desc => "mst_mapinfo.xml" },
        "南方航路" => { tr => "Southern Route", desc => "mst_mapinfo.xml" },
        "南方通商航路護衛" => { tr => "Southern Trade Route Escort Operation", desc => "mst_mapinfo.xml" },
        "南方通商航路" => { tr => "Southern Trade Route", desc => "mst_mapinfo.xml" },
        "南方連絡海域正面" => { tr => "South Connecting Sea: Front Area", desc => "mst_mapinfo.xml" },
        "南方連絡線制海権確保" => { tr => "Battle for Naval Supremacy of the Southern Connecting Sea", desc => "mst_mapinfo.xml" },
        "南方連絡航路対潜哨戒" => { tr => "Southern Connecting Sea Anti-submarine Patrol", desc => "mst_mapinfo.xml" },
        "南西諸島サメワニ沖" => { tr => "Nansei Islands: Samewani Coast", desc => "mst_mapinfo.xml" },
        "南西諸島ズンダ海峡" => { tr => "Nansei Islands: Zunda Strait", desc => "mst_mapinfo.xml" },
        "南西諸島沖" => { tr => "Nansei Islands: Approach", desc => "mst_mapinfo.xml" },
        "南西諸島海域進出" => { tr => "Advance on the Nansei Islands", desc => "mst_mapinfo.xml" },
        "南西諸島－作戦５" => { tr => "Okinoshima Combat Patrol", desc => "mst_mapinfo.xml" },
        "南西諸島－EO1" => { tr => "Extra Operation", desc => "mst_mapinfo.xml" },
        "完遂！FS作戦" => { tr => "Operation FS: Complete!", desc => "mst_mapinfo.xml" },
        "幌筵沖泊地沖海戦" => { tr => "Battle of Paramushir Anchorage Coast", desc => "mst_mapinfo.xml" },
        "幌筵泊地正面海域" => { tr => "Paramushir Anchorage: Front Area", desc => "mst_mapinfo.xml" },
        "幌筵泊地沖" => { tr => "Paramushir Anchorage: Coast Area", desc => "mst_mapinfo.xml" },
        "幌筵泊地警備" => { tr => "Paramushiru Anchorage Security Operation", desc => "mst_mapinfo.xml" },
        "強襲！ポートワイン破壊作戦" => { tr => "Assault! Destroy Port Wine Operation", desc => "mst_mapinfo.xml" },
        "強襲！北方港湾を叩け！" => { tr => "Assault! Hit the Northern Port!", desc => "mst_mapinfo.xml" },
        "敵機動部隊迎撃戦" => { tr => "Enemy Task Force Interception", desc => "mst_mapinfo.xml" },
        "暁の水平線に勝利を刻め！" => { tr => "Cut Victory into the Dawn!", desc => "mst_mapinfo.xml" },
        "東京急行" => { tr => "Tokyo Express", desc => "mst_mapinfo.xml" },
        "東洋艦隊追撃戦" => { tr => "Pursuit of the Eastern Fleet", desc => "mst_mapinfo.xml" },
        "柳輸送作戦" => { tr => "Narrow Transport Operation", desc => "mst_mapinfo.xml" },
        "沖ノ島沖海戦" => { tr => "Naval Battle of Okinoshima", desc => "mst_mapinfo.xml" },
        "沖ノ島海域" => { tr => "Okinoshima Island", desc => "mst_mapinfo.xml" },
        "泊地沖制海権確保" => { tr => "Battle for Naval Supremacy near the Anchorage", desc => "mst_mapinfo.xml" },
        "海上通商護衛路" => { tr => "Maritime Trade Route Escort", desc => "mst_mapinfo.xml" },
        "深海中枢前縁部強行偵察" => { tr => "Forced Recon of the Central Area: Front Edge", desc => "mst_mapinfo.xml" },
        "深海中枢泊地攻撃" => { tr => "Anchorage Attack of the Central Area in the Deep Sea", desc => "mst_mapinfo.xml" },
        "深海中枢泊地沖" => { tr => "Central Area in the Deep Sea: Central Anchorage", desc => "mst_mapinfo.xml" },
        "深海中枢泊地" => { tr => "Central Area in the Deep Sea: Anchorage", desc => "mst_mapinfo.xml" },
        "深海中枢海域侵攻作戦" => { tr => "Invasion of the Central Area in the Deep Sea", desc => "mst_mapinfo.xml" },
        "深海中枢海域前縁部" => { tr => "Central Area in the Deep Sea: Front Area", desc => "mst_mapinfo.xml" },
        "深海後方最終防衛線突破！" => { tr => "Breakthrough! The Rear Area's Final Line of Defense", desc => "mst_mapinfo.xml" },
        "深海後方最終防衛線" => { tr => "Rear Area in the Deep Sea: Last Line of Defense", desc => "mst_mapinfo.xml" },
        "深海後方海域北部" => { tr => "Rear Area in the Deep Sea: Northern Sea Area", desc => "mst_mapinfo.xml" },
        "深海後方海域強行偵察" => { tr => "Forced Recon of the Rear Area in the Deep Sea", desc => "mst_mapinfo.xml" },
        "深海後方海域西海岸沖" => { tr => "Rear Area in the Deep Sea: Waters Off the West Coast", desc => "mst_mapinfo.xml" },
        "深海後方西海岸基地" => { tr => "Rear Area in the Deep Sea: West Coast Base", desc => "mst_mapinfo.xml" },
        "深海棲艦最終艦隊" => { tr => "Central Area in the Deep Sea: Final Fleet", desc => "mst_mapinfo.xml" },
        "深海西海岸基地攻略戦" => { tr => "Invasion of the West Coast Base of the Rear Area in the Deep Sea", desc => "mst_mapinfo.xml" },
        "深海西海岸沖海戦" => { tr => "Battle off the West Coast of the Rear Area in the Deep Sea", desc => "mst_mapinfo.xml" },
        "深海運河哨戒線を抜けて" => { tr => "Through the Patrol Line of the Canal in the Deep Sea", desc => "mst_mapinfo.xml" },
        "深海運河攻撃作戦" => { tr => "Attack on the Canal in the Deep Sea", desc => "mst_mapinfo.xml" },
        "深海運河方面偵察作戦" => { tr => "Recon of the Canal in the Deep Sea", desc => "mst_mapinfo.xml" },
        "深海運河最終防衛線" => { tr => "Canal Area in the Deep Sea: Last Line of Defense", desc => "mst_mapinfo.xml" },
        "深海運河沖" => { tr => "Canal Area in the Deep Sea: Off the Coast", desc => "mst_mapinfo.xml" },
        "深海運河海域前縁部" => { tr => "Canal Area in the Deep Sea: Front Area", desc => "mst_mapinfo.xml" },
        "深海運河海域哨戒線" => { tr => "Canal Area in the Deep Sea: Patrol Line", desc => "mst_mapinfo.xml" },
        "深海運河閘門破壊作戦" => { tr => "Destruction of the Canal Locks", desc => "mst_mapinfo.xml" },
        "潜水艦隊哨戒作戦" => { tr => "Submarine Fleet Patrol", desc => "mst_mapinfo.xml" },
        "珊瑚諸島沖海戦" => { tr => "Battle off the Coral Islands", desc => "mst_mapinfo.xml" },
        "発動！ FS作戦" => { tr => "Operation FS: First Steps!", desc => "mst_mapinfo.xml" },
        "発動！AL作戦" => { tr => "Operation AL: First Steps!", desc => "mst_mapinfo.xml" },
        "突入！鉄底海峡" => { tr => "Rush! Ironbottom Sound", desc => "mst_mapinfo.xml" },
        "航空偵察 K作戦" => { tr => "Air Reconnaissance: Operation K", desc => "mst_mapinfo.xml" },
        "艦隊を編成し、鎮守府正面近海の警備を実施せよ！" => { tr => "Organize the fleet and patrol in the vicinity of the Naval Base!", desc => "mst_mapinfo.xml" },
        "艦隊 南へ！" => { tr => "Fleet to the South!", desc => "mst_mapinfo.xml" },
        "西南海域沿岸部" => { tr => "Southwestern Operation: Coast Area", desc => "mst_mapinfo.xml" },
        "西南海域要塞沖" => { tr => "Southwestern Sea: Fortress Area", desc => "mst_mapinfo.xml" },
        "西南海域通商破壊戦" => { tr => "Southwestern Sea Commerce Raiding", desc => "mst_mapinfo.xml" },
        "要塞攻略戦" => { tr => "Fortress Capture Game", desc => "mst_mapinfo.xml" },
        "近海制海権確保" => { tr => "Naval Supremacy of the Adjacent Sea", desc => "mst_mapinfo.xml" },
        "近海海上護衛" => { tr => "Adjacent Sea Maritime Escort Operation", desc => "mst_mapinfo.xml" },
        "近海諸島防衛線支援" => { tr => "Reinforcing the Nearby Islands Defense Line", desc => "mst_mapinfo.xml" },
        "近海諸島防衛線" => { tr => "Nearby Islands Defense Line", desc => "mst_mapinfo.xml" },
        "鎮守府海域沖" => { tr => "Naval Base: Coast Area", desc => "mst_mapinfo.xml" },
        "鎮守府警備" => { tr => "Naval Base Defense", desc => "mst_mapinfo.xml" },
        "AL作戦方面進出" => { tr => "The Advance for Operation AL", desc => "mst_mapinfo.xml" },
        "AL作戦" => { tr => "Operation AL", desc => "mst_mapinfo.xml" },
        "FS作戦 上陸攻略戦" => { tr => "Operation FS: Amphibious Invasion", desc => "mst_mapinfo.xml" },
        "FS作戦 発動準備" => { tr => "Prepare for Operation FS", desc => "mst_mapinfo.xml" },
        "FS海域F諸島沖" => { tr => "FS Strait: F Islands Coast Area", desc => "mst_mapinfo.xml" },
        "FS海域S諸島沖" => { tr => "FS Strait: S Islands Coast Area", desc => "mst_mapinfo.xml" },
        "MI作戦前路哨戒" => { tr => "Patrol Before Operation MI", desc => "mst_mapinfo.xml" },
        "MI作戦" => { tr => "Operation MI", desc => "mst_mapinfo.xml" },
        "MI島攻略作戦" => { tr => "Invasion of Midway Island", desc => "mst_mapinfo.xml" },
        "MI島確保作戦" => { tr => "Securing the MI Islands", desc => "mst_mapinfo.xml" },
        "MI諸島東部海域" => { tr => "East off the MI Islands", desc => "mst_mapinfo.xml" },
        "MI諸島近海" => { tr => "MI Islands", desc => "mst_mapinfo.xml" },
        "MS諸島沖海戦" => { tr => "Battle of the MS Archipelago", desc => "mst_mapinfo.xml" },
        "いよいよカレー洋方面の主目標であるリランカ島攻撃を実施\\nする。精強な機動部隊を以て、同島の敵艦隊及び基地施設へ\\nの攻撃を実施、カレー洋方面の制海権を確立せよ！" => { tr => "", desc => "mst_mapinfo.xml" },
        "いよいよ南方海域での艦隊決戦を図る！同方面に主力艦隊を\\n投入、鉄底海峡を抜け、暁の水平線に勝利を掴め！" => { tr => "", desc => "mst_mapinfo.xml" },
        "いよいよ戦いは最終局面に突入した。我が艦隊は、敵の中枢\\n海域への侵攻が可能となった。この戦いを終わらせるため、\\n深海中枢海域侵攻への橋頭堡を確保せよ！艦隊、抜錨！" => { tr => "", desc => "mst_mapinfo.xml" },
        "いよいよ深海運河への戦略攻撃を実施する！攻撃機を搭載した\\n潜水空母艦隊または水上突入艦隊により、深海運河への攻撃を\\n敢行せよ！" => { tr => "", desc => "mst_mapinfo.xml" },
        "いよいよMI作戦が発動された！主力機動部隊の進出の前に\\n前衛部隊を展開し、MI作戦の前路索敵哨戒を実施せよ！" => { tr => "", desc => "mst_mapinfo.xml" },
        "アルフォンシーノ列島沖海戦" => { tr => "", desc => "mst_mapinfo.xml" },
        "エリア情報" => { tr => "", desc => "mst_mapinfo.xml" },
        "オリョール海東部に有力な艦隊を進出させ、同方面に遊弋する\\n敵艦隊を捕捉、これと交戦し、敵戦力の漸減を図れ！" => { tr => "", desc => "mst_mapinfo.xml" },
        "カレー洋からステビア海を臨む海域に敵秘匿艦隊泊地が発見\\nされた！精鋭艦隊による同泊地への殴り込みを敢行し、敵残\\n存戦力の活動を封殺せよ！" => { tr => "", desc => "mst_mapinfo.xml" },
        "カレー洋作戦が発令された！艦隊はカレー洋方面へ進出し、\\n同方面の敵艦隊と交戦、同海域の制海権確保に努めよ！" => { tr => "", desc => "mst_mapinfo.xml" },
        "カレー洋作戦の支作戦として、ベーグル湾の通商破壊戦を\\n展開する。巡洋艦などを基幹戦力とした通商破壊艦隊で、\\n敵海上補給路を叩け！" => { tr => "", desc => "mst_mapinfo.xml" },
        "カレー洋海戦" => { tr => "", desc => "mst_mapinfo.xml" },
        "サメワニ沖海戦の残敵を掃射しつつ、接近中の敵増援艦隊を\\n捕捉撃滅し、南西諸島ズンダ海峡方面の制海権を確保せよ！" => { tr => "", desc => "mst_mapinfo.xml" },
        "ソロモン海戦" => { tr => "", desc => "mst_mapinfo.xml" },
        "トラック泊地防衛戦" => { tr => "", desc => "mst_mapinfo.xml" },
        "ポートワインに存在する深海棲艦の南西諸島方面戦力の根拠\\n地を強襲し、敵港湾基地機能を破壊、同制海権を確立せよ！" => { tr => "", desc => "mst_mapinfo.xml" },
        "レイテ沖海戦" => { tr => "", desc => "mst_mapinfo.xml" },
        "中部海域における敵艦隊の活動が活発になっている。水雷戦隊\\nを基幹とした水上部隊を展開し、敵艦隊の動向を偵察せよ！" => { tr => "", desc => "mst_mapinfo.xml" },
        "中部海域－作戦５" => { tr => "", desc => "mst_mapinfo.xml" },
        "中部海域－作戦６" => { tr => "", desc => "mst_mapinfo.xml" },
        "中部海域－EO1" => { tr => "", desc => "mst_mapinfo.xml" },
        "中部海域－EO2" => { tr => "", desc => "mst_mapinfo.xml" },
        "中部西海域のオリョール海に進出し、敵通商破壊艦隊を捕捉、\\nこれを撃滅して、同方面の我が海上兵站ラインを防衛せよ！" => { tr => "", desc => "mst_mapinfo.xml" },
        "中部西海域のバシー島沖に展開、同方面に敵艦隊を排除し、\\nバシー島に集積されたボーキサイト及び資材を輸送せよ！" => { tr => "", desc => "mst_mapinfo.xml" },
        "中部西海域沖ノ島沖に敵侵攻艦隊接近の兆候が報告された！\\n精強な我が主力艦隊を出撃させ、敵侵攻艦隊を捕捉、これを\\n完膚なきまでに撃滅せよ！" => { tr => "", desc => "mst_mapinfo.xml" },
        "中部西海域－作戦５" => { tr => "", desc => "mst_mapinfo.xml" },
        "中部西海域－作戦６" => { tr => "", desc => "mst_mapinfo.xml" },
        "中部西海域－EO1" => { tr => "", desc => "mst_mapinfo.xml" },
        "中部西海域－EO2" => { tr => "", desc => "mst_mapinfo.xml" },
        "中部諸島防衛戦" => { tr => "", desc => "mst_mapinfo.xml" },
        "主力艦艇を含む有力な我が艦隊を南方航路西部に展開、同方面\\nに来襲する敵艦隊を撃破、南方連絡線の制海権を確保せよ！" => { tr => "", desc => "mst_mapinfo.xml" },
        "予備マップ１－作戦１" => { tr => "", desc => "mst_mapinfo.xml" },
        "予備マップ１－作戦２" => { tr => "", desc => "mst_mapinfo.xml" },
        "予備マップ１－作戦３" => { tr => "", desc => "mst_mapinfo.xml" },
        "予備マップ１－作戦４" => { tr => "", desc => "mst_mapinfo.xml" },
        "予備マップ１－作戦５" => { tr => "", desc => "mst_mapinfo.xml" },
        "予備マップ１－作戦６" => { tr => "", desc => "mst_mapinfo.xml" },
        "予備マップ１－作戦CA" => { tr => "", desc => "mst_mapinfo.xml" },
        "予備マップ１－１" => { tr => "", desc => "mst_mapinfo.xml" },
        "予備マップ１－２" => { tr => "", desc => "mst_mapinfo.xml" },
        "予備マップ１－３" => { tr => "", desc => "mst_mapinfo.xml" },
        "予備マップ１－４" => { tr => "", desc => "mst_mapinfo.xml" },
        "予備マップ１－CA" => { tr => "", desc => "mst_mapinfo.xml" },
        "予備マップ１－EO1" => { tr => "", desc => "mst_mapinfo.xml" },
        "予備マップ１－EO2" => { tr => "", desc => "mst_mapinfo.xml" },
        "予備マップ２－作戦１" => { tr => "", desc => "mst_mapinfo.xml" },
        "予備マップ２－作戦２" => { tr => "", desc => "mst_mapinfo.xml" },
        "予備マップ２－作戦３" => { tr => "", desc => "mst_mapinfo.xml" },
        "予備マップ２－作戦４" => { tr => "", desc => "mst_mapinfo.xml" },
        "予備マップ２－作戦５" => { tr => "", desc => "mst_mapinfo.xml" },
        "予備マップ２－作戦６" => { tr => "", desc => "mst_mapinfo.xml" },
        "予備マップ２－作戦CA" => { tr => "", desc => "mst_mapinfo.xml" },
        "予備マップ２－１" => { tr => "", desc => "mst_mapinfo.xml" },
        "予備マップ２－２" => { tr => "", desc => "mst_mapinfo.xml" },
        "予備マップ２－３" => { tr => "", desc => "mst_mapinfo.xml" },
        "予備マップ２－４" => { tr => "", desc => "mst_mapinfo.xml" },
        "予備マップ２－CA" => { tr => "", desc => "mst_mapinfo.xml" },
        "予備マップ２－EO1" => { tr => "", desc => "mst_mapinfo.xml" },
        "予備マップ２－EO2" => { tr => "", desc => "mst_mapinfo.xml" },
        "予備マップ３－作戦１" => { tr => "", desc => "mst_mapinfo.xml" },
        "予備マップ３－作戦２" => { tr => "", desc => "mst_mapinfo.xml" },
        "予備マップ３－作戦３" => { tr => "", desc => "mst_mapinfo.xml" },
        "予備マップ３－作戦４" => { tr => "", desc => "mst_mapinfo.xml" },
        "予備マップ３－作戦５" => { tr => "", desc => "mst_mapinfo.xml" },
        "予備マップ３－作戦６" => { tr => "", desc => "mst_mapinfo.xml" },
        "予備マップ３－作戦CA" => { tr => "", desc => "mst_mapinfo.xml" },
        "予備マップ３－１" => { tr => "", desc => "mst_mapinfo.xml" },
        "予備マップ３－２" => { tr => "", desc => "mst_mapinfo.xml" },
        "予備マップ３－３" => { tr => "", desc => "mst_mapinfo.xml" },
        "予備マップ３－４" => { tr => "", desc => "mst_mapinfo.xml" },
        "予備マップ３－CA" => { tr => "", desc => "mst_mapinfo.xml" },
        "予備マップ３－EO1" => { tr => "", desc => "mst_mapinfo.xml" },
        "予備マップ３－EO2" => { tr => "", desc => "mst_mapinfo.xml" },
        "北方の我が重要拠点、幌筵泊地方面に敵の大規模な艦隊の接近\\nが確認された。北方艦隊全力を以て出撃し、これを撃滅せよ！" => { tr => "", desc => "mst_mapinfo.xml" },
        "北方泊地より艦隊を展開し、\\n北方連絡線哨戒を実施せよ。対潜警戒も厳となせ！" => { tr => "", desc => "mst_mapinfo.xml" },
        "北方泊地海域の要衝、幌筵泊地周辺の前方警戒を行う。\\n有力な艦隊を泊地より出撃させ、同海域の前方に展開させよ！" => { tr => "", desc => "mst_mapinfo.xml" },
        "北方泊地海域－作戦５" => { tr => "", desc => "mst_mapinfo.xml" },
        "北方泊地海域－作戦６" => { tr => "", desc => "mst_mapinfo.xml" },
        "北方泊地海域－EO1" => { tr => "", desc => "mst_mapinfo.xml" },
        "北方泊地海域－EO2" => { tr => "", desc => "mst_mapinfo.xml" },
        "北方海域に艦隊を進出させ、北方モーレイ海の哨戒を実施せよ！" => { tr => "", desc => "mst_mapinfo.xml" },
        "北方海域深部に敵艦隊が集結中の大規模泊地を発見した。\\n我が艦隊の総力を挙げて、同方面の敵艦隊を撃滅せよ！" => { tr => "", desc => "mst_mapinfo.xml" },
        "北方海域－作戦６" => { tr => "", desc => "mst_mapinfo.xml" },
        "北方海域－EO2" => { tr => "", desc => "mst_mapinfo.xml" },
        "北方海峡警備を実施する！\\n艦隊を展開し、北方海峡への侵入を図る敵艦隊を警戒せよ！" => { tr => "", desc => "mst_mapinfo.xml" },
        "北方AL列島沖海戦" => { tr => "", desc => "mst_mapinfo.xml" },
        "南方の資源地帯との需要な輸送路となる南方連絡海域の正面に\\n艦隊を展開し、南方航路方面の警備を実施せよ！" => { tr => "", desc => "mst_mapinfo.xml" },
        "南方トラック泊地に対する敵の有力な攻略部隊が、同泊地沖に\\n展開中だ。我が主力艦隊は直ちに出撃！泊地沖洋上に集結中の\\n敵艦隊と交戦、これを撃滅せよ！" => { tr => "", desc => "mst_mapinfo.xml" },
        "南方トラック泊地に敵艦隊接近の情報が入った！\\n有力な艦隊を編成し、トラック泊地周辺の警備に出動せよ！" => { tr => "", desc => "mst_mapinfo.xml" },
        "南方方面の重要根拠地であるトラック泊地。同泊地周辺に敵の\\n潜水艦が出没しつつある。軽巡・駆逐艦等で編成された有力な\\n対潜部隊を展開し、敵潜水艦を捕捉、これを掃討せよ！" => { tr => "", desc => "mst_mapinfo.xml" },
        "南方泊地海域－作戦５" => { tr => "", desc => "mst_mapinfo.xml" },
        "南方泊地海域－作戦６" => { tr => "", desc => "mst_mapinfo.xml" },
        "南方泊地海域－EO1" => { tr => "", desc => "mst_mapinfo.xml" },
        "南方泊地海域－EO2" => { tr => "", desc => "mst_mapinfo.xml" },
        "南方海域進出への橋頭堡確立を図る。練度の高い水上打撃艦隊\\nを編成、同方面に投入し、南方海域への進出を図れ！" => { tr => "", desc => "mst_mapinfo.xml" },
        "南方海域－作戦６" => { tr => "", desc => "mst_mapinfo.xml" },
        "南方海域－EO2" => { tr => "", desc => "mst_mapinfo.xml" },
        "南方資源輸送ルートを確保し、兵站を安定させるため、西南\\n海域への艦隊進出を図る。艦隊を南下させ、同方面の制海権\\n確保に着手せよ！" => { tr => "", desc => "mst_mapinfo.xml" },
        "南方連絡海域－作戦５" => { tr => "", desc => "mst_mapinfo.xml" },
        "南方連絡海域－作戦６" => { tr => "", desc => "mst_mapinfo.xml" },
        "南方連絡海域－EO1" => { tr => "", desc => "mst_mapinfo.xml" },
        "南方連絡海域－EO2" => { tr => "", desc => "mst_mapinfo.xml" },
        "南西諸島サメワニ沖に多方面から集結した深海棲艦寄せ集め\\n艦隊の存在を確認した。同敵艦隊を捕捉、これを撃滅せよ！" => { tr => "", desc => "mst_mapinfo.xml" },
        "南西諸島－作戦６" => { tr => "", desc => "mst_mapinfo.xml" },
        "南西諸島－EO2" => { tr => "", desc => "mst_mapinfo.xml" },
        "大西洋方面からの敵艦隊の侵入を阻止するため、戦略攻撃作戦\\nを準備する。艦隊を派遣し、深海運河方面の敵情を偵察せよ！" => { tr => "", desc => "mst_mapinfo.xml" },
        "対潜及び防空能力に優れた艦艇を基幹戦力とした艦隊を編成、\\n輸送船団を護衛し、南方通商航路の海上輸送強化にあたれ！" => { tr => "", desc => "mst_mapinfo.xml" },
        "小数編成の対潜哨戒部隊を展開し、鎮守府近海に出没する敵の\\n潜水艦隊を発見・制圧せよ。南方連絡航路の安全強化を図れ！" => { tr => "", desc => "mst_mapinfo.xml" },
        "幌筵泊地防衛戦" => { tr => "", desc => "mst_mapinfo.xml" },
        "快速な水上打撃部隊を以て、南方鉄底海峡に突入！同方面の\\n友軍を支援しつつ、敵飛行場を砲撃、これを無力化せよ！" => { tr => "", desc => "mst_mapinfo.xml" },
        "我が鎮守府海域に侵入を図る敵偵察艦隊を捕捉、\\nこれを迎撃、撃滅せよ！" => { tr => "", desc => "mst_mapinfo.xml" },
        "敵の残存戦力が結集し、深海後方海域における最終防衛線を\\n形成しつつある。精鋭艦隊を投入し、同方面の敵の残存戦力\\nを撃破、同海域の制海権を確保せよ！" => { tr => "", desc => "mst_mapinfo.xml" },
        "敵中枢泊地への殴り込みは成功した。敵泊地は瓦解していく。\\n崩れゆく泊地から展開した、深海棲艦最終艦隊群と対峙する。\\n全艦隊、突撃せよ！　暁の水平線に勝利を刻め！" => { tr => "", desc => "mst_mapinfo.xml" },
        "敵空母機動部隊主力が我が南方泊地海域の要衝、トラック泊地\\nに接近中だ。主力艦隊を出撃させ、敵機動部隊を捕捉、これを\\n迎撃、トラック泊地を防衛せよ！" => { tr => "", desc => "mst_mapinfo.xml" },
        "有力な北方艦隊を編成し、北方AL海域へ出撃、同方面進出の\\n橋頭堡を確立せよ！AL作戦を発動する。北方艦隊、抜錨！" => { tr => "", desc => "mst_mapinfo.xml" },
        "有力な潜水艦隊を編成し、同潜水艦隊を以て、中部海域哨戒線\\nに進出せよ。敵有力艦を発見次第、これを攻撃、敵艦隊戦力の\\n漸減を図れ！" => { tr => "", desc => "mst_mapinfo.xml" },
        "有力な艦隊を以て、北方海域へ再展開、敵情の強行偵察を\\n敢行し、可能であれば敵戦力の漸減に努めよ！" => { tr => "", desc => "mst_mapinfo.xml" },
        "有力な艦隊を鎮守府近海に展開させ、\\n海上通商輸送ラインを防衛せよ！" => { tr => "", desc => "mst_mapinfo.xml" },
        "有力な艦隊戦力を以て、南西諸島海域への進出を図る。水上\\n打撃部隊、または空母機動部隊を南西諸島方面へ展開、敵の\\n動向を探りつつ、同海域進出の橋頭堡を確立せよ！" => { tr => "", desc => "mst_mapinfo.xml" },
        "本土沖海戦" => { tr => "", desc => "mst_mapinfo.xml" },
        "正規空母を基幹戦力とした有力なる空母機動部隊を以て、\\nMI島の航空基地を無力化しつつ、邀撃してくるであろう\\n敵機動部隊を撃破、同方面の制海権を確立せよ！" => { tr => "", desc => "mst_mapinfo.xml" },
        "水上偵察機部隊または大型飛行艇を搭載した水上機母艦及び直\\n衛の水雷戦隊で構成された艦隊を中部海域に進出し、航空偵察\\n作戦「K作戦」を実施せよ！" => { tr => "", desc => "mst_mapinfo.xml" },
        "深海中枢海域前縁部における艦隊戦の勝利により、敵中枢泊地\\n沖への進出が可能となった。最精鋭の艦隊を投入し、深海中枢\\n泊地前面に展開する敵主力艦隊群と交戦、これを撃滅せよ！" => { tr => "", desc => "mst_mapinfo.xml" },
        "深海後方海域における艦隊決戦勝利における戦果を拡張する！\\n同方面の深海棲艦群を撃滅し、西海岸基地を開放せよ！" => { tr => "", desc => "mst_mapinfo.xml" },
        "深海棲地中枢部－作戦５" => { tr => "", desc => "mst_mapinfo.xml" },
        "深海棲地中枢部－作戦６" => { tr => "", desc => "mst_mapinfo.xml" },
        "深海棲地中枢部－作戦CA" => { tr => "", desc => "mst_mapinfo.xml" },
        "深海棲地中枢部－CA" => { tr => "", desc => "mst_mapinfo.xml" },
        "深海棲地中枢部－EO1" => { tr => "", desc => "mst_mapinfo.xml" },
        "深海棲地中枢部－EO2" => { tr => "", desc => "mst_mapinfo.xml" },
        "深海棲地後方－作戦５" => { tr => "", desc => "mst_mapinfo.xml" },
        "深海棲地後方－作戦６" => { tr => "", desc => "mst_mapinfo.xml" },
        "深海棲地後方－EO1" => { tr => "", desc => "mst_mapinfo.xml" },
        "深海棲地後方－EO2" => { tr => "", desc => "mst_mapinfo.xml" },
        "深海棲艦後方海域へ精鋭なる主力艦隊を投入、同海域の制海権\\nを巡る艦隊決戦を試みる。艦隊抜錨！暁の水平線に勝利を刻め！" => { tr => "", desc => "mst_mapinfo.xml" },
        "深海棲艦艦隊の支配する領域に対する反攻作戦を開始する。\\n深海棲艦の集結している中枢海域を大きく迂回して、同後方\\n海域への強行偵察を実施せよ！" => { tr => "", desc => "mst_mapinfo.xml" },
        "深海棲艦防衛ラインは突破した！いよいよ、深海中枢泊地への\\n最後の殴り込みを敢行する。全艦隊、出撃！敵泊地に突入せよ！" => { tr => "", desc => "mst_mapinfo.xml" },
        "深海運河方面の偵察は成功した。戦略特殊攻撃、深海運河攻撃\\n作戦を実施する。艦隊を派遣し、深海運河哨戒線を突破せよ！" => { tr => "", desc => "mst_mapinfo.xml" },
        "深海運河沖海戦" => { tr => "", desc => "mst_mapinfo.xml" },
        "深海運河海域－作戦５" => { tr => "", desc => "mst_mapinfo.xml" },
        "深海運河海域－作戦６" => { tr => "", desc => "mst_mapinfo.xml" },
        "深海運河海域－EO1" => { tr => "", desc => "mst_mapinfo.xml" },
        "深海運河海域－EO2" => { tr => "", desc => "mst_mapinfo.xml" },
        "渾作戦" => { tr => "", desc => "mst_mapinfo.xml" },
        "第一次運河攻撃により、敵は大幅に防衛態勢を強化した。その\\n防衛線を突破し、深海運河を攻撃、同運河の閘門を完全に破壊\\nせよ！第二次深海運河攻撃作戦、潜水空母艦隊、出撃せよ！" => { tr => "", desc => "mst_mapinfo.xml" },
        "西南海域の要衝、西南要塞。精強な艦隊を同要塞攻撃に投入、\\nこれを無力化し、西南海域の敵戦力中枢を撃破せよ！" => { tr => "", desc => "mst_mapinfo.xml" },
        "西南海域－作戦５" => { tr => "", desc => "mst_mapinfo.xml" },
        "西南海域－作戦６" => { tr => "", desc => "mst_mapinfo.xml" },
        "西南海域－EO1" => { tr => "", desc => "mst_mapinfo.xml" },
        "西南海域－EO2" => { tr => "", desc => "mst_mapinfo.xml" },
        "西南要塞の撃破に成功した！この戦果を拡大するため、艦隊を\\n追撃に向かわせ、脱出する敵東洋艦隊を捕捉、これを撃滅せよ！" => { tr => "", desc => "mst_mapinfo.xml" },
        "西南要塞沖海戦" => { tr => "", desc => "mst_mapinfo.xml" },
        "西方海域－作戦５" => { tr => "", desc => "mst_mapinfo.xml" },
        "西方海域－作戦６" => { tr => "", desc => "mst_mapinfo.xml" },
        "西方海域－EO1" => { tr => "", desc => "mst_mapinfo.xml" },
        "西方海域－EO2" => { tr => "", desc => "mst_mapinfo.xml" },
        "西海岸沖海戦" => { tr => "", desc => "mst_mapinfo.xml" },
        "軽巡または駆逐艦を旗艦とした水雷戦隊で、敵包囲下の北方\\n海域キス島に突入！同島の守備隊を無事収容、撤収せよ！" => { tr => "", desc => "mst_mapinfo.xml" },
        "近海諸島防衛線に我が艦隊を投入、\\n同防衛線を支援、敵侵攻艦隊を迎撃せよ！" => { tr => "", desc => "mst_mapinfo.xml" },
        "通商破壊艦隊を展開し、西南海域における敵の海上補給路を\\n叩き、深海棲艦戦力の拡大を阻止、抑制せよ！艦隊、出撃！" => { tr => "", desc => "mst_mapinfo.xml" },
        "遂にMI島攻略作戦は成功した！同島奪還を目的として接近\\nする増援艦隊を捕捉、これを撃滅し、MI島を確保せよ！" => { tr => "", desc => "mst_mapinfo.xml" },
        "鎮守府海域－作戦５" => { tr => "", desc => "mst_mapinfo.xml" },
        "鎮守府海域－作戦６" => { tr => "", desc => "mst_mapinfo.xml" },
        "鎮守府海域－EO1" => { tr => "", desc => "mst_mapinfo.xml" },
        "鎮守府海域－EO2" => { tr => "", desc => "mst_mapinfo.xml" },
        "AL作戦が発動された。少数の航空母艦を伴う有力な艦隊を\\n北方AL海域中心部に投入し、同方面の敵艦隊及び諸施設を\\n攻撃せよ！" => { tr => "", desc => "mst_mapinfo.xml" },
        "AL作戦発動の準備行動として、北方AL海域前縁部に艦隊を\\n進出し、同方面の偵察、AL作戦開始の準備を実施せよ！" => { tr => "", desc => "mst_mapinfo.xml" },
        "AL海域－作戦５" => { tr => "", desc => "mst_mapinfo.xml" },
        "AL海域－作戦６" => { tr => "", desc => "mst_mapinfo.xml" },
        "AL海域－EO1" => { tr => "", desc => "mst_mapinfo.xml" },
        "AL海域－EO2" => { tr => "", desc => "mst_mapinfo.xml" },
        "FS作戦が発動された！精強な主力艦隊を以て、FS諸島敵泊地\\n攻撃を実施せよ！FS作戦主力艦隊、抜錨！" => { tr => "", desc => "mst_mapinfo.xml" },
        "FS作戦も最終段階となった。敵の残存戦力が集結するFS諸島\\n港湾司令部を攻略、同方面の敵残存戦力を撃滅し、FS作戦を\\n完遂せよ！" => { tr => "", desc => "mst_mapinfo.xml" },
        "FS作戦を継続実施する。FS諸島泊地沖に攻略艦隊を投入し、\\n同泊地を攻撃、これを攻略せよ！FS諸島攻略艦隊、出撃！" => { tr => "", desc => "mst_mapinfo.xml" },
        "FS方面隣接海域の制海権確保により、FS作戦の実施が可能と\\nなった。FS海域に有力な艦隊を投入、同方面の作戦橋頭堡を\\n確保せよ！" => { tr => "", desc => "mst_mapinfo.xml" },
        "FS海域－作戦５" => { tr => "", desc => "mst_mapinfo.xml" },
        "FS海域－作戦６" => { tr => "", desc => "mst_mapinfo.xml" },
        "FS海域－EO1" => { tr => "", desc => "mst_mapinfo.xml" },
        "FS海域－EO2" => { tr => "", desc => "mst_mapinfo.xml" },
        "FS諸島沖海戦" => { tr => "", desc => "mst_mapinfo.xml" },
        "MI島海域に展開する敵機動部隊を捕捉撃滅しつつ、同島の\\n攻略作戦を実施、MI作戦を完遂せよ！" => { tr => "", desc => "mst_mapinfo.xml" },
        "MI方面の陽動支援作戦として、航空母艦を基幹とした機動\\n部隊で敵北方港湾基地を強襲！AL最深部の敵戦力を叩け！\\nAL作戦を完遂せよ！" => { tr => "", desc => "mst_mapinfo.xml" },
        "MI海域－作戦５" => { tr => "", desc => "mst_mapinfo.xml" },
        "MI海域－作戦６" => { tr => "", desc => "mst_mapinfo.xml" },
        "MI海域－EO1" => { tr => "", desc => "mst_mapinfo.xml" },
        "MI海域－EO2" => { tr => "", desc => "mst_mapinfo.xml" },
        "MI諸島防衛戦" => { tr => "", desc => "mst_mapinfo.xml" },
        "MO作戦を実施する！南方海域へ空母機動部隊を展開、同方面\\nに出没する敵機動部隊を叩き、同方面の航空優勢を確立せよ！" => { tr => "", desc => "mst_mapinfo.xml" },
        "MS諸島沖前面に主力艦隊を展開し、同諸島方面に接近しつつ\\nある敵攻略部隊を洋上で邀撃、これを全力で撃滅せよ！" => { tr => "", desc => "mst_mapinfo.xml" },
        "MS諸島防衛戦" => { tr => "", desc => "mst_mapinfo.xml" },
        
        "タンカー船団護衛任務" => { tr => "Oil Tanker Fleet Escort \\nMission", desc => "mst_mission2.xml" },
        "ボーキサイト輸送任務" => { tr => "Bauxite Transport Mission", desc => "mst_mission2.xml" },
        "三隻以上の艦隊を編成し、鎮守府海域の領海警備を実施せよ！" => { tr => "Organize a fleet of 3 or more ships, and \\npatrol around the Naval District!", desc => "mst_mission2.xml" },
        "中部海域に支援艦隊を出撃させ、主力艦隊の進撃を援護せよ！" => { tr => "Send the Support Fleet to the Central Sea \\nand cover the advance of the main fleet!", desc => "mst_mission2.xml" },
        "中部海域に決戦支援を行う別動隊を出撃させ、主力艦隊の艦隊決戦突入を援護せよ！" => { tr => "Send another fleet to the Central Sea and \\nsupport the main fleet at the entrance of \\nthe decisive fleet battle!", desc => "mst_mission2.xml" },
        "中部海域偵察任務" => { tr => "Central Sea Recon Mission", desc => "mst_mission2.xml" },
        "中部西海域偵察任務" => { tr => "Central Western Sea Recon \\nMission", desc => "mst_mission2.xml" },
        "中部西海域潜水艦哨戒" => { tr => "Submarine Patrol of \\nCentral Western Sea", desc => "mst_mission2.xml" },
        "中部西諸島鼠輸送" => { tr => "Central Western Islands \\nTokyo Express", desc => "mst_mission2.xml" },
        "今こそ日頃の訓練の成果を見せるとき！空母含む艦隊で「観艦式」を挙行せよ！" => { tr => "Now is the time to show the result \\nof our training efforts every day! \\nHold a fleet review with a fleet that \\nincludes at least one CV!", desc => "mst_mission2.xml" },
        "前衛支援任務" => { tr => "Support Mission for the \\nPrelude", desc => "mst_mission2.xml" },
        "包囲陸戦隊撤収作戦" => { tr => "Surrounded Marines \\nRecover Operation", desc => "mst_mission2.xml" },
        "北号作戦" => { tr => "Operation Hoku-Gou", desc => "mst_mission2.xml" },
        "北方哨戒任務" => { tr => "Patrol Mission on the North", desc => "mst_mission2.xml" },
        "北方敵拠点攻撃作戦" => { tr => "Attack on Enemy Northern Base", desc => "mst_mission2.xml" },
        "北方方面強行偵察作戦" => { tr => "Northern Area Force Recon \\nOperation", desc => "mst_mission2.xml" },
        "北方海域に支援艦隊を出撃させ、主力艦隊の進撃を援護せよ！" => { tr => "Send the Support Fleet to the Northern Sea \\nand cover the advance of the main fleet!", desc => "mst_mission2.xml" },
        "北方海域に決戦支援を行う別動隊を出撃させ、主力艦隊の艦隊決戦突入を援護せよ！" => { tr => "Send another fleet to the Northern Sea and \\nsupport the main fleet at the entrance \\nof the decisive fleet battle!", desc => "mst_mission2.xml" },
        "北方海域へ重巡を旗艦とした水上打撃艦隊を展開、同海域の状況を威力偵察せよ！" => { tr => "Deploy a surface fleet with a CA \\nas the flagship to the Northern Sea \\nand carry out force recon on \\nthe area!", desc => "mst_mission2.xml" },
        "北方海域威力偵察" => { tr => "Northern Sea Force Recon", desc => "mst_mission2.xml" },
        "北方海域航空戦略偵察" => { tr => "Northern Sea Aerial Strategic \\nRecon", desc => "mst_mission2.xml" },
        "北方海域警備" => { tr => "Northern Sea Security", desc => "mst_mission2.xml" },
        "北方漁場方面に艦隊を派遣、同方面を警備し漁船群の安全を図れ！" => { tr => "Send a fleet to the Northern Fishing Area, \\nand provide security support for \\nfishing boats in the area!", desc => "mst_mission2.xml" },
        "北方漁場警備任務" => { tr => "Northern Fishing Area \\nSecurity Mission", desc => "mst_mission2.xml" },
        "北方演習" => { tr => "The Northern Drill", desc => "mst_mission2.xml" },
        "北方潜水艦哨戒任務" => { tr => "Northern Submarine Patrol \\nMission", desc => "mst_mission2.xml" },
        "北方航路海上護衛" => { tr => "Maritime Escort on Northern \\nRoute", desc => "mst_mission2.xml" },
        "北方陽動作戦" => { tr => "Northern Feign Attack \\nOperation", desc => "mst_mission2.xml" },
        "南方泊地周辺に駆逐艦などの艦艇を展開し、泊地の安全を確保せよ！" => { tr => "Deploy ships like DDs around \\nthe Southern Anchorage and \\nensure its safety!", desc => "mst_mission2.xml" },
        "南方泊地沖対潜哨戒" => { tr => "Southern Anchorage Area \\nAnti-sub Patrol", desc => "mst_mission2.xml" },
        "南方泊地沖戦闘哨戒" => { tr => "Southern Anchorage Area \\nCombat Patrol", desc => "mst_mission2.xml" },
        "南方泊地海域を起点に長距離練習航海を実施、艦隊の練度を高めよ！" => { tr => "Execute long-distance training from the \\nSouthern Anchorage Area, and raise the \\nproficiency of the fleet!", desc => "mst_mission2.xml" },
        "南方泊地警備" => { tr => "Southern Anchorage Security", desc => "mst_mission2.xml" },
        "南方海域に支援艦隊を出撃させ、主力艦隊の進撃を援護せよ！" => { tr => "Send the Support Fleet and cover \\nthe advance of the main fleet!", desc => "mst_mission2.xml" },
        "南方海域に決戦支援を行う別動隊を出撃させ、主力艦隊の艦隊決戦突入を援護せよ！" => { tr => "Send another fleet and support the \\nmain fleet at the entrance of the decisive \\nfleet battle!", desc => "mst_mission2.xml" },
        "南方海域へ軽巡を旗艦とした有力な艦隊を展開させ、同海域の状況を偵察せよ！" => { tr => "Deploy a strong fleet with a CL \\nas the flagship in the Southern Sea, \\nand run a recon there!", desc => "mst_mission2.xml" },
        "南方海域偵察任務" => { tr => "Southern Sea Recon \\nMission", desc => "mst_mission2.xml" },
        "南方資源集積地から母港にボーキサイトを輸送する船団を護衛せよ！" => { tr => "Escort the transport fleet carrying \\nbauxite from the southern supply depot to the homeport!", desc => "mst_mission2.xml" },
        "南方鼠輸送" => { tr => "Southern Tokyo Express", desc => "mst_mission2.xml" },
        "南洋方面遠洋練習航海" => { tr => "South-East Asian Cross-oceanic \\nTraining Trip", desc => "mst_mission2.xml" },
        "南西諸島偵察任務" => { tr => "Southwestern Islands Recon \\nMission", desc => "mst_mission2.xml" },
        "南西諸島海域に支援艦隊を出撃させ、主力艦隊の進撃を援護せよ！" => { tr => "Send the Support Fleet to the Southwestern \\nIslands and cover the advance of \\nthe main fleet!", desc => "mst_mission2.xml" },
        "南西諸島海域に決戦支援を行う別動隊を出撃させ、主力艦隊の艦隊決戦突入を援護せよ！" => { tr => "Send another fleet to the Southwestern Islands \\nand support the main fleet at the \\nentrance of the decisive fleet battle!", desc => "mst_mission2.xml" },
        "南西諸島海域へ軽巡を旗艦とした艦隊を展開し、同海域の状況を偵察せよ！" => { tr => "Deploy a strong fleet with a \\nCL as the flagship in the \\nSouthwestern Islands, and run a recon there!", desc => "mst_mission2.xml" },
        "四隻以上の艦隊規模で、敵機襲来に備えた対空射撃及び回避運動の訓練を実施せよ！" => { tr => "Prepare for incoming hostile aircraft, undergo \\na training exercise about AA fire and evasive \\nmaneuvers with a fleet of 4 or more!", desc => "mst_mission2.xml" },
        "囮機動部隊支援作戦" => { tr => "Decoy Mobile Fleet Support \\nOperation", desc => "mst_mission2.xml" },
        "大規模輸送船団" => { tr => "Large-scale Transport Fleet", desc => "mst_mission2.xml" },
        "対潜警戒任務" => { tr => "Anti-sub Patrol Mission", desc => "mst_mission2.xml" },
        "強力な航空戦艦戦隊を基幹とした艦隊を出撃させ、北方の敵拠点を撃滅せよ！" => { tr => "Send a fleet with a strong BBV \\nfleet as its core and destroy the \\nenemy base on the north!", desc => "mst_mission2.xml" },
        "強襲輸送作戦" => { tr => "Force Transport Operation", desc => "mst_mission2.xml" },
        "快速かつ打撃力のある重巡を中心とした艦隊によって、敵後方補給線を遮断せよ!" => { tr => "Cut off the enemy supply line with \\na fleet backboned by fast, \\nwell-armed CAs!!", desc => "mst_mission2.xml" },
        "快速の駆逐艦を集中運用して、激戦の諸島へ物資を輸送せよ！" => { tr => "Concentrate fast DDs in one fleet \\nand transport supplies to the islands of \\nfierce combat!", desc => "mst_mission2.xml" },
        "支援艦隊を出撃させ、主力艦隊の進撃を援護せよ！" => { tr => "Send the Support Fleet and cover\\nthe advance of the main fleet!", desc => "mst_mission2.xml" },
        "敵後方海域潜水艦作戦" => { tr => "Submarine Operation in \\nEnemy Rear Area", desc => "mst_mission2.xml" },
        "敵拠点母港空襲作戦" => { tr => "Airstrike Operation Against \\nEnemy Homeport", desc => "mst_mission2.xml" },
        "敵最深部強行偵察作戦" => { tr => "Force Recon Operation on the \\nDeepest Enemy Territory", desc => "mst_mission2.xml" },
        "敵機動部隊の戦力を誘引する航空母艦を含む囮部隊で、主力艦隊を支援せよ！" => { tr => "Send a decoy force with a CV \\nand lure the enemy mobile fleet away, \\ntherefore supporting the main fleet!", desc => "mst_mission2.xml" },
        "敵水上部隊探索迎撃" => { tr => "Seach and Destroy the Enemy \\nSurface Force", desc => "mst_mission2.xml" },
        "敵泊地潜水艦封鎖作戦" => { tr => "Submarine Blockade Operation \\non Enemy Anchorage", desc => "mst_mission2.xml" },
        "敵泊地突入作戦" => { tr => "Attack on Enemy Anchorage", desc => "mst_mission2.xml" },
        "敵運河潜水艦封鎖作戦" => { tr => "Submarine Blockade Operation \\non Enemy Canal", desc => "mst_mission2.xml" },
        "有力な別働艦隊を編成し、敵艦隊側面に回り込み、主力の艦隊決戦を援護せよ！" => { tr => "Organize a strong side fleet, flank the enemy, \\nand support the main force on the \\ndecisive fleet battle!", desc => "mst_mission2.xml" },
        "有力な機動部隊をMI海域方面に展開、敵機動部隊の活動を制圧せよ！" => { tr => "Deploy a strong mobile fleet at MI Area \\nand surpress enemy mobile fleet activities!", desc => "mst_mission2.xml" },
        "有力な軽空母を基幹とした艦隊を投入、南方連絡海域の海上護衛戦力を強化せよ！" => { tr => "Send a fleet with a strong CVL \\nand support the maritime escort \\nforce of the South Connecing Sea!", desc => "mst_mission2.xml" },
        "東京急行(弐)" => { tr => "Tokyo Express (II)", desc => "mst_mission2.xml" },
        "機動部隊哨戒任務" => { tr => "Mobile Fleet Patrol Mission", desc => "mst_mission2.xml" },
        "水上機基地建設" => { tr => "Construction of Seaplane Base", desc => "mst_mission2.xml" },
        "水上機母艦を旗艦とした有力な航空偵察艦隊を展開、北方/AL海域方面を戦略偵察せよ！" => { tr => "Deploy a powerful aerial recon fleet with \\na AV as the flagship and carry out \\nstrategic recon on the Northern/AL Area!", desc => "mst_mission2.xml" },
        "水上機母艦2隻を基幹とする艦隊を展開、南方海域に哨戒用水上機基地を建設せよ！" => { tr => "Deploy a fleet with 2 AVs \\nand construct a seaplane base for \\nscout planes in the Southern Sea!", desc => "mst_mission2.xml" },
        "水上機長距離偵察任務" => { tr => "Seaplane Long-distance Recon \\nMission", desc => "mst_mission2.xml" },
        "水上通商破壊作戦" => { tr => "Surface Commerce Raiding \\nOperation", desc => "mst_mission2.xml" },
        "水雷戦隊にドラム缶(輸送用)を満載し、南方方面友軍への鼠輸送作戦を遂行せよ！" => { tr => "Load a torpedo division with Drum Canisters \\n(Transport Use) and initiate Tokyo Express \\nto friendly troops to the south!", desc => "mst_mission2.xml" },
        "水雷戦隊を基幹とした有力な艦隊を北方に展開し、同海域の警備に努めよ！" => { tr => "Deploy a strong fleet based on an torpedo \\ndivision and ensure the security \\nof the Northern Sea!", desc => "mst_mission2.xml" },
        "水雷戦隊を基幹とした艦隊を展開し、西南海域の警備を実施せよ！" => { tr => "Deploy a fleet based on an torpedo division \\nand ensure the security of the \\nSouthwestern Sea!", desc => "mst_mission2.xml" },
        "決戦支援を行う別動隊を出撃させ、主力艦隊の艦隊決戦突入を援護せよ！" => { tr => "Send another fleet and support the \\nmain fleet at the entrance of \\nthe decisive fleet battle!", desc => "mst_mission2.xml" },
        "海の一大ページェント、「観艦式」の予行航海を実施せよ！" => { tr => "Prepare for the fleet review, \\nand send a fleet to its rehearsal!", desc => "mst_mission2.xml" },
        "海上護衛任務" => { tr => "Maritime Escort Mission", desc => "mst_mission2.xml" },
        "海外艦との接触" => { tr => "Contacting Foreign Ship", desc => "mst_mission2.xml" },
        "深海中枢海域に最精鋭の別動隊を出撃させ、主力艦隊の艦隊決戦突入を援護せよ！" => { tr => "Send another fleet to the Central Area of the \\nDeep Sea and support the main fleet at the \\nentrance of the decisive fleet battle!", desc => "mst_mission2.xml" },
        "深海中枢海域に練度の高い支援艦隊を出撃させ、主力艦隊の進撃を援護せよ！" => { tr => "Send the Support Fleet to the Central Area \\nof the Deep Sea and cover the advance \\nof the main fleet!", desc => "mst_mission2.xml" },
        "深海中枢海域偵察任務" => { tr => "Recon Mission on the Central \\nArea of the Deep Sea", desc => "mst_mission2.xml" },
        "深海後方海域に精鋭の別動隊を出撃させ、主力艦隊の艦隊決戦突入を援護せよ！" => { tr => "Send another fleet to the Rear Area \\nof the Deep Sea and support the main fleet \\nat the entrance of the decisive fleet battle!", desc => "mst_mission2.xml" },
        "深海後方海域に練度の高い支援艦隊を出撃させ、主力艦隊の進撃を援護せよ！" => { tr => "Send the Support Fleet to the Rear Area \\nof the Deep Sea and cover the \\nadvance of the main fleet!", desc => "mst_mission2.xml" },
        "深海後方海域偵察任務" => { tr => "Recon Mission on the Rear \\nArea of the Deep Sea", desc => "mst_mission2.xml" },
        "深海運河海域に精鋭の別動隊を出撃させ、主力艦隊の艦隊決戦突入を援護せよ！" => { tr => "Send another fleet to the Canal Area of the \\nDeep Sea and support the main fleet at \\nthe entrance of the decisive fleet battle!", desc => "mst_mission2.xml" },
        "深海運河海域に練度の高い支援艦隊を出撃させ、主力艦隊の進撃を援護せよ！" => { tr => "Send the Support Fleet to the Canal Area \\nof the Deep Sea and cover the advance \\nof the main fleet!", desc => "mst_mission2.xml" },
        "深海運河海域偵察任務" => { tr => "Recon Mission on the Canal \\nArea of the Deep Sea", desc => "mst_mission2.xml" },
        "潜水艦とその支援艦艇によって構成された艦隊で、北方海域正面の哨戒任務に当たれ!" => { tr => "Send a fleet of SSs and their \\nsupport ship to patrol around the front \\narea of the Northern Area!!", desc => "mst_mission2.xml" },
        "潜水艦派遣作戦" => { tr => "Submarine Voyage", desc => "mst_mission2.xml" },
        "潜水艦派遣演習" => { tr => "Submarine Voyage Drill", desc => "mst_mission2.xml" },
        "潜水艦通商破壊作戦" => { tr => "Submarine Commerce Raiding \\nOperation", desc => "mst_mission2.xml" },
        "潜水艦2隻以上を配備した艦隊で、中部西海域を哨戒せよ！" => { tr => "Patrol around the Central Western Sea \\nwith a fleet with 2 or more SSs!", desc => "mst_mission2.xml" },
        "潜水艦3隻以上で構成される潜水艦隊を編成、長距離派遣の演習を実施せよ！" => { tr => "Organize a submarine fleet with 3 \\nor more SSs and execute long-range \\nvoyage drill!", desc => "mst_mission2.xml" },
        "潜水艦3隻以上と支援艦艇で構成される潜水艦隊で、FS方面における敵兵站を遮断せよ！" => { tr => "Disrupt enemy logistics effort around FS Area \\nwith a submarine fleet of 3 or more \\nSSs and support vessels!", desc => "mst_mission2.xml" },
        "潜水艦4隻以上で構成される潜水艦隊を編成し、遠方の友軍勢力との連絡を試みよ！" => { tr => "Organize a submarine fleet with \\n4 or more SSs and try to contact \\nfriendly forces from afar!", desc => "mst_mission2.xml" },
        "潜水艦4隻以上で構成される潜水艦隊を編成・派遣し、海外艦との邂逅を試みよ！" => { tr => "Organize and deploy a submarine fleet of \\n4 or more SSs and intend \\nto meet a foreign ship!", desc => "mst_mission2.xml" },
        "潜水艦4隻以上と支援艦艇から成る潜水艦隊で、深海中枢泊地の封鎖作戦を実施せよ！" => { tr => "Commence blockade on the Central Anchorage \\nof the Deep Sea with a submarine fleet of \\n4 or more SSs and support vessels!", desc => "mst_mission2.xml" },
        "潜水艦4隻以上と支援艦艇から成る潜水艦隊で、深海後方海域の敵兵站線を遮断せよ！" => { tr => "Disrupt enemy logistics efforts in the \\nRear Area of the Deep Sea with a submarine fleet of \\n4 or more SSs and support vessels!", desc => "mst_mission2.xml" },
        "潜水艦4隻以上と支援艦艇から成る潜水艦隊で、深海運河海域の封鎖作戦を実施せよ！" => { tr => "Commence blockade of the Canal Area of \\nthe Deep Sea with a submarine fleet of 4 \\nor more SSs and supportive vessels!", desc => "mst_mission2.xml" },
        "空母2隻を基幹戦力とし輸送船多数を伴うMO攻略部隊によって、MO作戦を実施せよ！" => { tr => "Execute operation MO with a MO invasion \\nforce consisting 2 CVs \\nand multiple transport ships!", desc => "mst_mission2.xml" },
        "精鋭の水雷戦隊を中部海域に展開し、同海域の敵情偵察を実施せよ！" => { tr => "Deploy an elite Torpedo Division to the \\nCentral Sea and carry out recon on the area!", desc => "mst_mission2.xml" },
        "精鋭の水雷戦隊を編成し、南方泊地海域沖の対潜哨戒を実施せよ！" => { tr => "Organize an elite torpedo division and \\nenforce anti-sub patrol around the \\nSouthern Anchorage Area!", desc => "mst_mission2.xml" },
        "精鋭の航空戦隊を伴う強力な機動部隊を編成、同艦隊によりFS作戦を実施せよ！" => { tr => "Compose a strong mobile fleet with elite \\ncarrier divisions and commence \\nOperation FS with the fleet!", desc => "mst_mission2.xml" },
        "精鋭の軽空母を中核とした機動部隊を展開、AL海域方面敵情の航空攻撃を実施せよ！" => { tr => "Deploy a mobile fleet with elite \\nCVL as its core and attack the \\nenemy at AL Area from the air!", desc => "mst_mission2.xml" },
        "精鋭の軽空母戦隊を基幹戦力とした有力な機動部隊を出撃、AL作戦を実施せよ！" => { tr => "Send a strong mobile fleet with a fleet \\nof elite CVL as its \\ncore and commence Operation AL!", desc => "mst_mission2.xml" },
        "精鋭の重巡戦隊を中核とした有力艦隊を展開、MI海域方面の敵情偵察を実施せよ！" => { tr => "Deploy a strong fleet with an elite CA \\nfleet as its core, and carry out recon \\nmission on MI Area!", desc => "mst_mission2.xml" },
        "精鋭航空母艦を基幹戦力とした艦隊で、深海中枢泊地の航空偵察を実施せよ！" => { tr => "Carry out aerial recon on the Central Anchorage \\nof the Deep Sea with a fleet based on \\nelite CVs!", desc => "mst_mission2.xml" },
        "練度の高い「航空戦艦」複数と多数の輸送船による、強行輸送船団を出航させよ！" => { tr => "Sortie a force transport fleet with \\nmultiple highly proficient BBV \\nand some transport ships!", desc => "mst_mission2.xml" },
        "練度の高い機動力のある小艦艇部隊を結集し、包囲下の部隊を収容せよ！" => { tr => "Rally up the highly proficent and \\nmaneuverable smaller ships and recover \\nthe troops under siege!", desc => "mst_mission2.xml" },
        "練度の高い水上機母艦を旗艦とする艦隊をMI方面に派遣、長距離戦略偵察を実施せよ！" => { tr => "Send a fleet led by a highly proficient AV \\nto MI Area, and carry out long-range \\nstrategic recon!", desc => "mst_mission2.xml" },
        "練度の高い水雷戦隊に護衛された複数の空母群を以て、前線に補充航空機を輸送せよ！" => { tr => "Send a Carrier group with multiple CVs, \\nescorted by a highly proficient Torpedo division, \\nand transport replacement aircrafts to the front line!", desc => "mst_mission2.xml" },
        "練度の高い潜水艦と水雷戦隊を投入し、AL海域方面の哨戒任務を実施せよ！" => { tr => "Deploy highly proficient SSs and \\na Torpedo Division, and patrol around \\nAL Area!", desc => "mst_mission2.xml" },
        "練度の高い複数の水上機母艦を基幹とする艦隊を投入し、FS方面の偵察を実施せよ！" => { tr => "Send a fleet with multiple highly proficient \\nAVs as its core and \\nrecon around FS Area!", desc => "mst_mission2.xml" },
        "練度の高い複数の航空戦艦を基幹戦力とした艦隊による総合演習を実施せよ！" => { tr => "Send a fleet with numerous highly \\nproficient BBV as its core force, \\nand carry out an all-round drill!", desc => "mst_mission2.xml" },
        "練度の高い軽巡が率いる精鋭の北方護衛艦隊で、北方航路の海上護衛を実施せよ！" => { tr => "Send an elite northern escort fleet led \\nby a CL with high proficiency and \\ncarry out maritime escort on the northern route!", desc => "mst_mission2.xml" },
        "練度の高い重巡が率いる巡洋艦戦隊で、南方泊地沖に接近する敵艦隊を迎撃せよ！" => { tr => "Intercept enemy fleet near the Southern Anchorage Area \\nwith a Cruiser fleet led by a \\nhighly proficient CA!", desc => "mst_mission2.xml" },
        "練度の高い重巡が率いる精鋭の北方艦隊で出撃、同方面の敵情を強行偵察せよ！" => { tr => "Sortie with an elite northern fleet led by \\na highly proficient CA and \\ncarry out force recon on the area!", desc => "mst_mission2.xml" },
        "練習巡洋艦を旗艦とした練習艦隊で南洋練習航海を実施、さらなる練度向上に努めよ！" => { tr => "Commence South-East Asian training ship \\nwith a training fleet led by a Training Cruiser, \\nand further raise the fleet's proficiency!", desc => "mst_mission2.xml" },
        "練習巡洋艦を旗艦とした練習艦隊で遠洋練習航海を実施、艦隊の基礎練度向上に努めよ！" => { tr => "Carry out cross-oceanic training trip with a \\ntraining fleet led by a Training Cruiser \\nand raise the proficiency of the fleet!", desc => "mst_mission2.xml" },
        "航空戦力前線輸送" => { tr => "Transporting Naval Aviation \\nForce to the Front Line", desc => "mst_mission2.xml" },
        "航空戦艦を中核とした戦闘艦艇による強行輸送船団を編成、資源の輸送に投入せよ！" => { tr => "Organize a force transport fleet with \\ncombatant ships and BBVs as its core, \\nand engage in transport \\nof resources!", desc => "mst_mission2.xml" },
        "航空機南方輸送作戦" => { tr => "Southern Aircraft Transport \\nOperation", desc => "mst_mission2.xml" },
        "航空母艦及び水上機母艦、輸送船複数によって南方方面への航空戦力を実施せよ！" => { tr => "Reinforce air power to the south with \\nCVs, AVs and \\nmultiple Transport Ships!", desc => "mst_mission2.xml" },
        "艦隊決戦援護作戦" => { tr => "Support Operation for the \\nDecisive Fleet Battle", desc => "mst_mission2.xml" },
        "艦隊決戦支援任務" => { tr => "Support Mission for the \\nDecisive Fleet Battle", desc => "mst_mission2.xml" },
        "複数の水上機母艦を基幹とする有力な航空偵察部隊によって、長距離偵察を実施せよ！" => { tr => "Execute long-distance recon with a strong \\naerial recon fleet with multiple \\nAVs!", desc => "mst_mission2.xml" },
        "複数の水上機母艦を基幹とする艦隊を投入し、深海運河海域方面の敵情を偵察せよ！" => { tr => "Send a fleet with multiple AVs \\nas its core and recon around the \\nCanal Area of the Deep Sea!", desc => "mst_mission2.xml" },
        "複数の潜水艦から成る潜水艦隊を敵後方へ進出させ、通商破壊作戦を実施せよ!" => { tr => "Send a submarine fleet of multiple \\nSSs behind enemy lines and \\ncommence commerce raiding!!", desc => "mst_mission2.xml" },
        "複数の潜水艦と水上艦隊による混成艦隊で、西方海域の敵水上艦の活動を封鎖せよ!" => { tr => "Put enemy ships in the Western Sea under \\nblockade by a mixed fleet of multiple \\nSubmarines and a surface fleet!!", desc => "mst_mission2.xml" },
        "複数の空母を基幹とした有力な機動部隊で、西方海域の敵拠点母港を攻撃せよ！" => { tr => "Attack the enemy homeport at the \\nWestern Sea with a strong mobile fleet \\nincluding multiple Aircraft Carriers!", desc => "mst_mission2.xml" },
        "複数の精鋭潜水艦によって編成された潜水艦隊により、MI海域方面の哨戒を実施せよ！" => { tr => "Patrol around MI Area with a fleet of \\nmultiple elite SSs!", desc => "mst_mission2.xml" },
        "複数の精鋭航空戦艦を基幹とする艦隊を投入し、深海中枢海域の偵察を敢行せよ！" => { tr => "Send a fleet with multiple elite BBV \\nas its core and recon around the \\nCentral Area of the Deep Sea!", desc => "mst_mission2.xml" },
        "複数の精鋭航空母艦を基幹とする艦隊を投入し、深海後方海域方面の偵察を実施せよ！" => { tr => "Send a fleet with multiple elite CVs \\nas its core, and recon around the \\nRear Area of the Deep Sea!", desc => "mst_mission2.xml" },
        "複数の艦で鎮守府近海を航海し、艦隊練度を高めよ！" => { tr => "Sail around the Naval District with 2 or more \\nships, and raise the proficiency of \\nthe fleet members!", desc => "mst_mission2.xml" },
        "西南海域に支援艦隊を出撃させ、主力艦隊の進撃を援護せよ！" => { tr => "Send the Support Fleet to the \\nSouthwestern Sea and cover the \\nadvance of the main fleet!", desc => "mst_mission2.xml" },
        "西南海域に決戦支援を行う別動隊を出撃させ、主力艦隊の艦隊決戦突入を援護せよ！" => { tr => "Send another fleet to the Southwestern Sea \\nand support the main fleet at the \\nentrance of the decisive fleet battle!", desc => "mst_mission2.xml" },
        "西南海域警備任務" => { tr => "Southwestern Sea Security \\nMission", desc => "mst_mission2.xml" },
        "西方海域に支援艦隊を出撃させ、主力艦隊の進撃を援護せよ！" => { tr => "Send the Support Fleet to the \\nWestern Sea and cover the advance \\nof the main fleet!", desc => "mst_mission2.xml" },
        "西方海域に決戦支援を行う別動隊を出撃させ、主力艦隊の艦隊決戦突入を援護せよ！" => { tr => "Send another fleet to the Western Sea and \\nsupport the main fleet at the entrance \\nof the decisive fleet battle!", desc => "mst_mission2.xml" },
        "西方海域封鎖作戦" => { tr => "Blockade Operation for the \\nWestern Sea", desc => "mst_mission2.xml" },
        "観艦式予行" => { tr => "Fleet Review Rehearsal", desc => "mst_mission2.xml" },
        "観艦式" => { tr => "Fleet Review", desc => "mst_mission2.xml" },
        "警備任務" => { tr => "Security Mission", desc => "mst_mission2.xml" },
        "護衛の軽空母と駆逐艦、多数の輸送船による南西諸島航路タンカー船団を出航させよ！" => { tr => "Send a tanker fleet with CVL, DDs \\nand multiple transport ships to \\nthe Southwestern Island \\nroute!", desc => "mst_mission2.xml" },
        "資源輸送船団護衛任務" => { tr => "Resource Transportation \\nFleet Escort", desc => "mst_mission2.xml" },
        "軽巡旗艦と複数の駆逐艦等から構成された艦隊で、輸送船団航路の安全を図れ！" => { tr => "Send a fleet with a CL as the flagship and 2 \\nor more DDs to keep the route of \\nthe transport fleet safe!", desc => "mst_mission2.xml" },
        "軽巡旗艦の有力な水雷戦隊を投入し、南方連絡海域の対潜哨戒を実施せよ！" => { tr => "Send a powerful torpedo division with a \\nCL as the flagship, and patrol around \\nthe South Connecting Sea for enemy submarines!", desc => "mst_mission2.xml" },
        "軽巡旗艦の水雷戦隊を中核とした北方艦隊で、北方泊地の哨戒任務を実施せよ！" => { tr => "Send a northern fleet with its core \\na torpedo division under the command of a \\nCL as the flagship, and patrol \\naround the Northern Anchorage!", desc => "mst_mission2.xml" },
        "軽巡旗艦の艦隊で水上偵察機搭載艦などを展開、中部西海域の状況を偵察せよ！" => { tr => "Deploy a fleet with a CL as the \\nflagship, along with some seaplane-carrying \\nships, and carry out a recon run around the \\nCentral Western Sea!", desc => "mst_mission2.xml" },
        "軽空母を旗艦とした空母機動部隊を北方海域へ展開、敵戦力への陽動作戦を実施せよ！" => { tr => "Deploy a carrier mobile fleet with a \\nCVL as the flagship to the Northern Sea \\nand carry out a feint attack \\ntoward the enemy!", desc => "mst_mission2.xml" },
        "軽空母海上護衛任務" => { tr => "Light Aircraft Carrier \\nMaritime Escort Mission", desc => "mst_mission2.xml" },
        "輸送船多数と護衛艦隊から成る輸送船団を資源産出地に派遣、資源を輸送せよ！" => { tr => "Send a transportation fleet of multiple \\ntransport ships and an escort fleet to \\nresource production areas and \\ntransport the resources!", desc => "mst_mission2.xml" },
        "輸送船複数と護衛艦隊で構成されたタンカー船団を南方油田地帯に派遣せよ！" => { tr => "Send a oil tanker fleet of numerous \\ntransport ships and an escort fleet to \\nthe southern oilfield area!", desc => "mst_mission2.xml" },
        "輸送船5隻以上と駆逐艦等の護衛艦で構成される大輸送船団で内地に資源を輸送せよ！" => { tr => "Transport resources to homeland with \\na large transport fleet consisting 5 or \\nmore transport ships and escorting DDs!", desc => "mst_mission2.xml" },
        "遠洋潜水艦作戦" => { tr => "Cross-oceanic Submarine \\nOperation", desc => "mst_mission2.xml" },
        "遠洋練習航海" => { tr => "Cross-oceanic Training Trip", desc => "mst_mission2.xml" },
        "重巡洋艦を主力にした有力な水上艦隊を出撃し、敵水上部隊を探索、これを迎撃せよ！" => { tr => "Sortie with a strong surface fleet with \\nCAs as the main force, then \\nsearch and destroy the enemy \\nsurface force!", desc => "mst_mission2.xml" },
        "重巡洋艦を主力にした艦隊を敵泊地に突入させ、集結中の敵輸送船団を撃滅せよ！" => { tr => "Attack the enemy Anchorage with a \\nCA-centered fleet and eliminate \\nthe enemy transport fleet while \\nit's still gathering!", desc => "mst_mission2.xml" },
        "長距離練習航海" => { tr => "Long-distance Training Trip", desc => "mst_mission2.xml" },
        "防空射撃演習" => { tr => "Anti-aircraft Drill", desc => "mst_mission2.xml" },
        "駆逐艦旗艦の水雷戦隊にドラム缶(輸送用)を積載し、友軍への糧食補給を図れ！" => { tr => "Send a torpedo division carrying Drum Canisters \\n(transport use) with a DD as the flagship \\nto resupply friendly forces with \\nfood!", desc => "mst_mission2.xml" },
        "駆逐隊にドラム缶(輸送用)を可能な限り満載し、南方鼠輸送作戦を続行せよ！" => { tr => "Load a destroyer division with as many \\nDrum Canisters (Transport Use) as possible, \\nand continue southern Tokyo Express!", desc => "mst_mission2.xml" },
        "AL方面偵察任務" => { tr => "Recon Mission on AL Area", desc => "mst_mission2.xml" },
        "AL方面哨戒任務" => { tr => "Patrol Mission on AI Area", desc => "mst_mission2.xml" },
        "AL海域に支援艦隊を出撃させ、主力艦隊の進撃を援護せよ！" => { tr => "Send the Support Fleet to the AL Islands \\nand cover the advance of the main fleet!", desc => "mst_mission2.xml" },
        "AL海域に決戦支援を行う別動隊を出撃させ、主力艦隊の艦隊決戦突入を援護せよ！" => { tr => "Send another fleet to the AL Islands and \\nsupport the main fleet at the entrance \\nof the decisive fleet battle!", desc => "mst_mission2.xml" },
        "FS作戦" => { tr => "Operation FS", desc => "mst_mission2.xml" },
        "FS方面偵察任務" => { tr => "Recon Mission on FS Area", desc => "mst_mission2.xml" },
        "FS海域に支援艦隊を出撃させ、主力艦隊の進撃を援護せよ！" => { tr => "Send the Support Fleet to the FS Islands \\nand cover the advance of the main fleet!", desc => "mst_mission2.xml" },
        "FS海域に決戦支援を行う別動隊を出撃させ、主力艦隊の艦隊決戦突入を援護せよ！" => { tr => "Send another fleet to the FS Islands \\nand support the main fleet at the entrance \\nof the decisive fleet battle!", desc => "mst_mission2.xml" },
        "K作戦" => { tr => "Operation K", desc => "mst_mission2.xml" },
        "MI方面偵察任務" => { tr => "Recon Mission on MI Area", desc => "mst_mission2.xml" },
        "MI方面潜水艦哨戒" => { tr => "Submarine Patrol on MI Area", desc => "mst_mission2.xml" },
        "MI海域に支援艦隊を出撃させ、主力艦隊の進撃を援護せよ！" => { tr => "Send the Support Fleet to the MI Islands \\nand cover the advance of the main fleet!", desc => "mst_mission2.xml" },
        "MI海域に決戦支援を行う別動隊を出撃させ、主力艦隊の艦隊決戦突入を援護せよ！" => { tr => "Send another fleet to the MI Islands and support \\nthe main fleet at the entrance of the \\ndecisive fleet battle!", desc => "mst_mission2.xml" },
        "MO作戦" => { tr => "Operation MO", desc => "mst_mission2.xml" },

        "アルミ大量産" => { tr => "Bauxite Pack", desc => "mst_payitem.xml" },
        "タンカー徴用" => { tr => "Fuel Pack", desc => "mst_payitem.xml" },
        "ドック増設" => { tr => "Dock Extension Set", desc => "mst_payitem.xml" },
        "ボーキサイト増産" => { tr => "Bauxite", desc => "mst_payitem.xml" },
        "修理工員増強" => { tr => "Instant Repairs", desc => "mst_payitem.xml" },
        "兵站強化" => { tr => "Bargain Sortie Set", desc => "mst_payitem.xml" },
        "工廠強化" => { tr => "Bargain Resources Set", desc => "mst_payitem.xml" },
        "建造工員増強" => { tr => "Instant Construction", desc => "mst_payitem.xml" },
        "弾薬増産" => { tr => "Ammo", desc => "mst_payitem.xml" },
        "応急修理要員" => { tr => "Repair Member", desc => "mst_payitem.xml" },
        "書類一式＆指輪" => { tr => "Marriage Ring and Documents", desc => "mst_payitem.xml" },
        "母港拡張" => { tr => "Port Extension", desc => "mst_payitem.xml" },
        "洋上補給" => { tr => "Underway Replenishment", desc => "mst_payitem.xml" },
        "炊き出し" => { tr => "Combat Ration", desc => "mst_payitem.xml" },
        "燃料増産" => { tr => "Fuel", desc => "mst_payitem.xml" },
        "給糧艦「伊良湖」" => { tr => "Food Set 「Irako」", desc => "mst_payitem.xml" },
        "給糧艦「間宮」" => { tr => "Food Set 「Mamiya」", desc => "mst_payitem.xml" },
        "艦娘補強増設" => { tr => "Reinforcement Expansion", desc => "mst_payitem.xml" },
        "装備改修強化" => { tr => "Improvement Pack", desc => "mst_payitem.xml" },
        "装備研究開発" => { tr => "Dev Materials", desc => "mst_payitem.xml" },
        "鋼材増産" => { tr => "Steel", desc => "mst_payitem.xml" },

        "ジュラルミンで航空機大増産！\\nボーキサイトを500入手します。" => { tr => "Here’s a big increase in bauxite!\\nGives 500 Bauxite", desc => "mst_payitemtext.xml" },
        "ダメージコントロール！\\n応急修理要員x2" => { tr => "A Professional Damage Control Team!\\nRepair Team x2", desc => "mst_payitemtext.xml" },
        "ドック増設キーx1\\n高速修復材x2 高速建造材x2" => { tr => "Dock Extension Key x1\\nInstant Repair x2 Instant Construction x2", desc => "mst_payitemtext.xml" },
        "レベルが99になった艦娘とケッコンカッコカリ！\\n書類一式＆指輪(1回分)" => { tr => "Your Ship must reach Level 99\\nRing and Documents (Set of 1)", desc => "mst_payitemtext.xml" },
        "上級ダメコンを艦娘に！\\n応急修理女神x2" => { tr => "The Best Group of Damage Control Team!\\nRepair Goddess x2", desc => "mst_payitemtext.xml" },
        "使用には「給油艦/補給艦」の運用が必要です。(2回分)" => { tr => "Replenishes fuel and ammo of your fleet when low (Set of 2)", desc => "mst_payitemtext.xml" },
        "修理、お待たせしません！\\n高速修復材x4" => { tr => "Repair your ships without the wait!\\nInstant Repair Buckets x4", desc => "mst_payitemtext.xml" },
        "建造、劇的に時間を短縮！\\n高速建造材x4" => { tr => "Dramatically shorten the time of your construction!\\nInstant Construction x4", desc => "mst_payitemtext.xml" },
        "明石さんの「改修工廠」で装備を改修！\\n改修資材x8" => { tr => "For Akashi's 「Improvement Arsenal」!\\nImprovement Materials x8", desc => "mst_payitemtext.xml" },
        "母港拡張！\\n艦娘保有数+10拡張可能！(max{0}隻)" => { tr => "Increase your ship capacity by 10! (max{0}Ships)", desc => "mst_payitemtext.xml" },
        "油の一滴は…燃料不足解消に！\\n燃料を1200入手します。" => { tr => "Time to eliminate fuel shortage!\\nGives 1200 Fuel", desc => "mst_payitemtext.xml" },
        "激しい戦闘のお供に！\\n心尽くしの「戦闘糧食」をどうぞ！x3" => { tr => "To accompany You in battle!\\nBoost your morale with a Combat Ration! x3", desc => "mst_payitemtext.xml" },
        "燃料x200  弾薬x200\\n鋼材x1000  高速建造材x1" => { tr => "Fuel x200  Ammo x200\\nSteel x1000  Instant Construction x1", desc => "mst_payitemtext.xml" },
        "燃料x500  弾薬x500\\n鋼材x300  高速修復材x1" => { tr => "Fuel x500  Ammo x500\\nSteel x300  Instant Repairs x1", desc => "mst_payitemtext.xml" },
        "特注家具を執務室に！\\n特注家具要員x1" => { tr => "Custom-made Furniture for the Office！\\nFurniture Fairy x1", desc => "mst_payitemtext.xml" },
        "給糧艦「伊良湖」召喚！\\n何人かの艦娘の疲労を甘味で回復！(4回分)" => { tr => "Food Supply Ship 「Irako」!\\nInstant Fatigue Recovery for a Whole Fleet! (Set of 4)", desc => "mst_payitemtext.xml" },
        "給糧艦「間宮」召喚！\\n艦隊の疲労を甘味で回復！(2艦隊分)" => { tr => "Food Supply Ship 「Mamiya」!\\nInstant Fatigue Recovery for a Whole Fleet! (Set of 2)", desc => "mst_payitemtext.xml" },
        "練度30以上の艦娘に！\\n補強増設改修が可能です(1回分)" => { tr => "Your Ship must be at least Level 30\\nReinforce a ship with a Reinforcement Expansion (Set of 1)", desc => "mst_payitemtext.xml" },
        "航空機関連に！\\nボーキサイトx100" => { tr => "To resupply your carriers！\\nBauxite x100", desc => "mst_payitemtext.xml" },
        "艦娘の建造に！\\n鋼材x200" => { tr => "To build your ships!\\nSteel x200", desc => "mst_payitemtext.xml" },
        "装備の研究開発を！\\n開発資材x4" => { tr => "For crafting ships and equipments\\nDev Materials x4", desc => "mst_payitemtext.xml" },
        "補給のお供に！\\n弾薬x300" => { tr => "To resupply your ships!\\nAmmo x300", desc => "mst_payitemtext.xml" },
        "補給のお供に！\\n燃料x300" => { tr => "To refuel your ships!\\nFuel x300", desc => "mst_payitemtext.xml" },


        "「三川艦隊」を新編、突入準備せよ！" => { tr => "Organise the New Edition of the \\nMikawa Fleet!", desc => "mst_quest.xml" },
        "「三川艦隊」を編成せよ！" => { tr => "Form the Mikawa Fleet!", desc => "mst_quest.xml" },
        "「三川艦隊」出撃せよ！" => { tr => "Deploy the Mikawa Fleet!", desc => "mst_quest.xml" },
        "「中部西海域潜水艦哨戒」を反復実施し、哨戒と潜水艦隊練度向上に努めよ！" => { tr => "Send a fleet of 3 submarines to \\nthe 4th expedition [Submarine Patrol] of \\nthe Central Western Sea twice", desc => "mst_quest.xml" },
        "「九七式艦攻(友永隊)」搭載空母を第一艦隊旗艦に配備した状態で、新たに「天山」を2つ廃棄せよ！" => { tr => "Have flagship equipped with Type 97 \\nTorpedo Bomber (Tomonaga Squadron), \\nthen scrap 2 Tenzan.", desc => "mst_quest.xml" },
        "「九七式艦攻(村田隊)」搭載「翔鶴」を第一艦隊旗艦にした状態で、新たに「天山」を2つ廃棄せよ！" => { tr => "Have Shoukaku equipped with Type 97 \\nTorpedo Bomber (Murata Squadron) as \\nflagship and then scrap 2 Tenzan \\n(Heavenly Mountain)", desc => "mst_quest.xml" },
        "「九九式艦爆(江草隊)」搭載空母を第一艦隊旗艦に配備した状態で、新たに「彗星」を2つ廃棄せよ！" => { tr => "Have flagship equipped with Type 99 \\nDive Bomber (Egusa Squadron), \\nthen scrap 2 Suisei.", desc => "mst_quest.xml" },
        "「伊勢」型戦艦姉妹の全２隻を編成せよ！" => { tr => "Form the Ise-class!", desc => "mst_quest.xml" },
        "「伊勢改」「日向改」「扶桑改二」「山城改二」と直衛駆逐艦2隻の精強航空戦艦戦隊を編成せよ！" => { tr => "Have Ise Kai, Hyuga Kai, Fuso Kai-Ni, \\nand 2 DDs in a fleet. ", desc => "mst_quest.xml" },
        "「伊良湖」の準備" => { tr => "Preparation for Irako", desc => "mst_quest.xml" },
        "「初春」「子日」「若葉」「初霜」4隻による第二一駆逐隊を編成せよ！" => { tr => "Have only Hatsuharu, Nenohi, Wakaba, \\nand Hatsushimo in your main fleet.", desc => "mst_quest.xml" },
        "「北号作戦」を実施せよ！" => { tr => "Operation Hoku-Gou!", desc => "mst_quest.xml" },
        "「北号作戦」を継続実施せよ！" => { tr => "Strengthen Operation Hoku-Gou!", desc => "mst_quest.xml" },
        "「南雲機動部隊」を編成せよ！" => { tr => "Organize the Nagumo Task Force!", desc => "mst_quest.xml" },
        "「古鷹」「加古」「青葉」「衣笠」ら「第六戦隊」基幹の艦隊で、オリョール海東部の敵を撃滅せよ！" => { tr => "Deploy Furutaka, Kako, Aoba, Kinugasa, \\nand up to two additional ships to World V11-3 in \\nthe Central Western Sea and score an S rank \\nvictory at the Boss node.", desc => "mst_quest.xml" },
        "「古鷹」「加古」「青葉」「衣笠」を基幹とした第六戦隊を編成せよ！" => { tr => "Have Furutaka, Kako, Aoba, and Kinugasa \\nin your main fleet.", desc => "mst_quest.xml" },
        "「名取」を旗艦として「五十鈴」「鬼怒」を擁する、第十六戦隊(第二次)を編成せよ！" => { tr => "Have Natori as flagship, Isuzu and Kinu \\nin your fleet.", desc => "mst_quest.xml" },
        "「囮機動部隊支援作戦」を実施し、これを成功させよ！" => { tr => " Dispatch a fleet for the 6th expedition \\n[Decoy Mobile Fleet Support Operations] \\nof the South Connecting Sea!", desc => "mst_quest.xml" },
        "「大型艦建造」の準備！(その壱)" => { tr => "Preparation for Large Ship Construction \\n(Part I)", desc => "mst_quest.xml" },
        "「大型艦建造」の準備！(その弐)" => { tr => "Preparation for Large Ship \\nConstruction!(Part 2)", desc => "mst_quest.xml" },
        "「天龍」「龍田」を基幹とした「第十八戦隊」を南方航路正面に展開、同海域警備を実施せよ！" => { tr => "Tenryuu, Tatsuta, and at least 2 \\nother ships to World V9-1 in the Southern \\nConnecting Sea and S-rank the Boss node.", desc => "mst_quest.xml" },
        "「天龍」型軽巡姉妹の全２艦を編成せよ！" => { tr => "Form the Tenryuu-class!", desc => "mst_quest.xml" },
        "「妙高」「那智」「羽黒」を基幹とした第五戦隊を編成せよ！" => { tr => "Have Myoukou, Nachi, and Haguro in \\nyour fleet.", desc => "mst_quest.xml" },
        "「妙高」型重巡姉妹の全４隻を編成せよ！" => { tr => "Form the Myoukou-class!", desc => "mst_quest.xml" },
        "「対抗演習」を実施せよ！" => { tr => "Carry Out the Rival Exercise!", desc => "mst_quest.xml" },
        "「対潜戦演習」を実施せよ！" => { tr => "Carry Out the Anti-Submarine \\nWarfare Exercise!", desc => "mst_quest.xml" },
        "「対潜戦演習」を強化せよ！" => { tr => "Intensify the Anti-Submarine \\nWarfare Excercise!", desc => "mst_quest.xml" },
        "「小沢艦隊」を中部西海域沖ノ島沖に展開し、侵攻する敵機動部隊を捕捉、これを撃滅せよ！" => { tr => "Sortie Zuikaku Kai as flagship, Zuihou Kai, \\nChitose and Chiyoda (both as CVL), Ise Kai \\nand Hyuuga Kai to World V11-4 in the Central \\nWestern Sea and score an S-rank victory at the Boss.", desc => "mst_quest.xml" },
        "「小沢艦隊」を編成せよ！" => { tr => "Organize Ozawa's Fleet!", desc => "mst_quest.xml" },
        "「小沢艦隊」出撃せよ！" => { tr => "Sortie the Ozawa's fleet!", desc => "mst_quest.xml" },
        "「川内」型軽巡姉妹の全３艦を編成せよ！" => { tr => "Form the Sendai class!", desc => "mst_quest.xml" },
        "「工廠」でボーキサイトなどの資材を使って、新しい装備を「開発」せよ！" => { tr => "Develop one piece of equipment", desc => "mst_quest.xml" },
        "「工廠」で不要な艦の艤装を「解体」せよ！" => { tr => "Dismantle a ship you don't need \\nat the factory!", desc => "mst_quest.xml" },
        "「工廠」で不要な装備をいくつか「廃棄」して、新型給糧艦召喚の準備をしましょう！" => { tr => "Scrap equipment 10 times", desc => "mst_quest.xml" },
        "「工廠」で余剰の装備アイテムをなるべく多く「廃棄」して、鋼材の再利用に努めよ！" => { tr => "Scrap 20 pieces of equipment", desc => "mst_quest.xml" },
        "「工廠」で新たに装備の「開発」に挑戦せよ！" => { tr => "Craft a piece of equipment", desc => "mst_quest.xml" },
        "「工廠」で艦娘を新たに「建造」せよ！" => { tr => "Construct a new ship girl today \\nat the factory!", desc => "mst_quest.xml" },
        "「工廠」で装備の「開発」を今月中に新たに5回実施せよ！" => { tr => "Craft 5 pieces of equipment (Failures are OK)", desc => "mst_quest.xml" },
        "「工廠」で装備を「廃棄」せよ！" => { tr => "Scrap a piece of equipment", desc => "mst_quest.xml" },
        "「工廠」で装備を3つ「廃棄」して、輸送用のドラム缶を準備せよ！" => { tr => "Scrap 3 pieces of equipment", desc => "mst_quest.xml" },
        "「工廠」で装備アイテムを7つ「廃棄」して、「試製甲板カタパルト」を準備せよ！" => { tr => "Scrap equipment 7 times", desc => "mst_quest.xml" },
        "「工廠」で鋼材などの資材を使って、新しい艦を「建造」せよ！" => { tr => "Construct one Ship", desc => "mst_quest.xml" },
        "「愛宕」「高雄」「鳥海」「摩耶」を基幹とした第四戦隊を編成せよ！" => { tr => "Have Atago, Takao, Choukai, and \\nMaya in your main fleet.", desc => "mst_quest.xml" },
        "「愛宕」「高雄」「鳥海」「摩耶」を基幹とする第四戦隊で、近海諸島防衛線の敵を撃滅せよ！" => { tr => "Deploy a fleet with Atago, Takao, Choukai, \\nMaya and any 2 ships. Score a victory \\nagainst the V1-4 Boss.", desc => "mst_quest.xml" },
        "「戦艦」出撃せよ！" => { tr => "Deploy a Battleship!", desc => "mst_quest.xml" },
        "「戦艦部隊」北方海域に突入せよ！" => { tr => qq["Battleship Squadron" Charge \\ninto the Northern Sea Region!], desc => "mst_quest.xml" },
        "「扶桑」「山城」「最上」「時雨」「満潮」を基幹とした西村艦隊を編成せよ！" => { tr => "Have Fusou, Yamashiro, Mogami, Shigure, \\nand Michishio in your main fleet.", desc => "mst_quest.xml" },
        "「扶桑」「山城」「最上」「時雨」を基幹とした西村艦隊を編成せよ！" => { tr => "Have Fusou, Yamashiro, Mogami, and \\nShigure in your main fleet.", desc => "mst_quest.xml" },
        "「扶桑」「山城」「最上」「時雨」を基幹とする西村艦隊で、南方航路西部の敵を撃破せよ！" => { tr => "Deploy Fusou, Yamashiro, Mogami, Shigure, \\nand 2 additional ships to the World V9-4 in /nthe Southern Connecting Sea and defeat the \\nBoss with a B rank victory.", desc => "mst_quest.xml" },
        "「扶桑」型戦艦姉妹の全２隻を編成せよ！" => { tr => "Form the Fusou-class!", desc => "mst_quest.xml" },
        "「改修工廠」で装備の改修強化に努めよ！" => { tr => "Do equipment modernization 1 time", desc => "mst_quest.xml" },
        "「改修工廠」で装備を改修せよ！工作艦明石さん、お願いします！" => { tr => "Do equipment modernization 1 time", desc => "mst_quest.xml" },
        "「改装防空重巡」出撃せよ！" => { tr => "Deploy the Remodeled Anti-Air \\nHeavy Cruiser!", desc => "mst_quest.xml" },
        "「新型正規空母」を配備せよ！" => { tr => "Deploy the New Unryuu-class \\nAircraft Carriers", desc => "mst_quest.xml" },
        "「新編成航空戦隊」を北方アルフォンシーノ列島沖へ展開、同海域の敵艦隊を撃滅せよ！" => { tr => "Sortie 2CV, 2DD and 1BBV or 2CAV \\nin the first fleet to world V3-4 in the \\nNorthern Sea and beat the boss \\nwith an S rank!", desc => "mst_quest.xml" },
        "「新編成航空戦隊」を編成せよ！" => { tr => "Organize the New Carrier Division!", desc => "mst_quest.xml" },
        "「暁」「響」「雷」「電」による第六駆逐隊、出撃せよ！" => { tr => "Deploy a fleet with ONLY Akatsuki, \\nHibiki/Вер, Inazuma, and Ikazuchi.", desc => "mst_quest.xml" },
        "「暁」「響」「雷」「電」4隻による第六駆逐隊を編成せよ！" => { tr => "Have ONLY Akatsuki, Hibiki, Inazuma, \\nand Ikazuchi in your main fleet.", desc => "mst_quest.xml" },
        "「暁改二」を旗艦とした「響」「雷」「電」4隻による第六駆逐隊を編成せよ！" => { tr => "Have Akatsuki Kai-Ni as Flagship with \\nHibiki/Bep, Ikazuchi, Inazuma in \\nyour fleet", desc => "mst_quest.xml" },
        "「朝潮」「満潮」「大潮」「荒潮」4隻による第八駆逐隊を編成せよ！" => { tr => "Have Asashio, Michishio, Ooshio, \\nand Arashio in your fleet.", desc => "mst_quest.xml" },
        "「東京急行」系遠征を継続的に反復実施、今月中に鼠輸送を6回成功せさよ！" => { tr => "Carry out the [Tokyo Express] \\nmissions of  the Southern Sea and \\nclear them 6 times.", desc => "mst_quest.xml" },
        "「比叡」「霧島」「長良」「暁」「雷」「電」の艦隊で、南方ソロモン海域への突入作戦を実施せよ！" => { tr => "Sortie Hiei, Kirishima, Nagara, Akatsuki, \\nIkazuchi, Inazuma to V5-3 in the \\nSouthern Sea and clear the stage \\nwith an S-rank.", desc => "mst_quest.xml" },
        "「水上反撃部隊」突入せよ！" => { tr => qq["Surface Counterattack Fleet" Charge!], desc => "mst_quest.xml" },
        "「水上打撃部隊」南方へ！" => { tr => qq["Surface Strike Fleet" to the S\\nouth!], desc => "mst_quest.xml" },
        "「水上機母艦」を配備せよ！" => { tr => "Ready a Seaplane Tender!", desc => "mst_quest.xml" },
        "「水雷戦隊」を編成せよ！" => { tr => "Form a Torpedo Squadron!", desc => "mst_quest.xml" },
        "「水雷戦隊」バシー島沖緊急展開" => { tr => "The Torpedo Squadron Bashi \\nIsland Emergency Deployment!", desc => "mst_quest.xml" },
        "「水雷戦隊」出撃せよ！" => { tr => "Deploy the Torpedo Squadron!", desc => "mst_quest.xml" },
        "「水雷戦隊」南西へ！" => { tr => "Torpedo Squadron, toward Southwest!", desc => "mst_quest.xml" },
        "「演習」を実施し、夜戦練度を高めよ！" => { tr => "Carry out an Exercise to Increase \\nNight Battle Proficiency!", desc => "mst_quest.xml" },
        "「潜水母艦」と複数の潜水艦(4隻以上)からなる潜水艦隊「第六艦隊」を編成せよ！" => { tr => "Have a submarine tender and 4 \\n(or more) submarines in your fleet.", desc => "mst_quest.xml" },
        "「潜水艦隊」出撃せよ！" => { tr => qq[Deploy the "Submarine Fleet"!], desc => "mst_quest.xml" },
        "「瑞鶴改」を旗艦とし、航空母艦「瑞鳳」「千歳」「千代田」を加えた4隻の空母部隊を編成せよ！" => { tr => "Have Zuikaku Kai as flagship, Zuihou, \\nChitose, and Chiyoda (both as CVL, not AV) \\nin your main fleet.", desc => "mst_quest.xml" },
        "「瑞鶴改」旗艦、空母「瑞鳳改」「千歳」「千代田」及び「伊勢改」「日向改」を配備せよ！" => { tr => "Have Zuikaku Kai as flagship, Zuihou Kai, \\nChitose and Chiyoda (both as CVL), \\nIse Kai and Hyuuga Kai in your main fleet!", desc => "mst_quest.xml" },
        "「皐月」「文月」「長月」他1隻計駆逐艦4隻による第二二駆逐隊を編成せよ！" => { tr => "Have only Satsuki, Fumizuki, Nagatsuki, \\nand 1 more DD in your main fleet.", desc => "mst_quest.xml" },
        "「睦月」「如月」「弥生」「望月」4隻による第三十駆逐隊(第一次)を編成せよ！" => { tr => "Have ONLY Mutsuki, Kisaragi, Yayoi, \\nand Mochizuki in your fleet.", desc => "mst_quest.xml" },
        "「睦月」「弥生」「卯月」「望月」4隻による第三十駆逐隊(第二次)を編成せよ！" => { tr => "Have only Mutsuki, Yayoi, Uzuki, \\nand Mochizuki in your fleet.", desc => "mst_quest.xml" },
        "「砲戦演習」を実施せよ！" => { tr => "Carry Out the Shelling Exercise!", desc => "mst_quest.xml" },
        "「砲戦演習」を強化せよ！" => { tr => "Carry Out the Shelling Exercise!", desc => "mst_quest.xml" },
        "「砲戦演習」を継続実施せよ！" => { tr => "Continue Carrying Out the \\nShelling Exercise!", desc => "mst_quest.xml" },
        "「礼号作戦」実施せよ！" => { tr => qq[Carry Out "Operation Rei-go"!], desc => "mst_quest.xml" },
        "「空母機動部隊」を編成せよ！" => { tr => "Form a Carrier Task Force!", desc => "mst_quest.xml" },
        "「空母機動部隊」抜錨せよ！" => { tr => "Deploy a Carrier Task Force!", desc => "mst_quest.xml" },
        "「空母機動部隊」西へ！" => { tr => "Mobile Carrier Fleet to the West!", desc => "mst_quest.xml" },
        "「第一水雷戦隊」を編成せよ！" => { tr => "Form the Torpedo Squadron 1!", desc => "mst_quest.xml" },
        "「第一水雷戦隊」ケ号作戦、突入せよ！" => { tr => "Deploy the [First Torpedo Squadron] \\nfor operation K-Go!", desc => "mst_quest.xml" },
        "「第一水雷戦隊」北方ケ号作戦、再突入！" => { tr => "[First Torpedo Squadron], advance \\nagain to the Northern K-Go Operation", desc => "mst_quest.xml" },
        "「第一水雷戦隊」北方再突入準備！" => { tr => "1st Torpedo Squadron, Prepare for \\nAnother Rush to the Northern Sea!", desc => "mst_quest.xml" },
        "「第一水雷戦隊」北方突入準備！" => { tr => "1st Torpedo Squadron, Prepare for \\na Rush to the Northern Sea!", desc => "mst_quest.xml" },
        "「第三十駆逐隊」出撃せよ！" => { tr => "Deploy the Destroyer Division 30 \\n(First Generation)!", desc => "mst_quest.xml" },
        "「第三十駆逐隊」対潜哨戒！" => { tr => qq["30th Destroyer Division" \\nAnti-Submarine Patrol!], desc => "mst_quest.xml" },
        "「第三十駆逐隊(第一次)」を含む艦隊で出撃し、キス島沖の主力艦隊と交戦せよ！" => { tr => "Deploy a fleet that consists of Mutsuki, \\nKisaragi, Yayoi, Mochizuki and up to 2 \\nadditional DDs or 1 DD with 1 CL as flagship to World \\nV3-2 in the Northern Sea and encounter the Boss. \\nC rank or above is required.", desc => "mst_quest.xml" },
        "「第三十駆逐隊(第一次)」を編成せよ！" => { tr => "Form the Destroyer Division 30 \\n(First Generation)!", desc => "mst_quest.xml" },
        "「第三十駆逐隊(第二次)」は直ちに抜錨！南方トラック泊地の対潜哨戒を実施せよ！" => { tr => "Deploy Mutsuki, Yayoi, Uzuki and \\nMochizuki to World V7-1 in the South Anchorage Sea \\nand achieve atleast an A Rank Victory \\nagainst the Boss.", desc => "mst_quest.xml" },
        "「第三十駆逐隊(第二次)」を編成せよ！" => { tr => "Form the 30th Destroyer Fleet \\n(Second Generation).", desc => "mst_quest.xml" },
        "「第三航空戦隊」を編成せよ！" => { tr => "Organize the 3rd Carrier Division.", desc => "mst_quest.xml" },
        "「第三航空戦隊」近海諸島防衛線に出撃！" => { tr => "Sortie the Third Aeronautical Squadron!", desc => "mst_quest.xml" },
        "「第二一駆逐隊」を含む艦隊で出撃し、北方海域モーレイ海の敵を撃滅せよ！" => { tr => "Deploy Hatsuharu, Hatsushimo, Nenohi, Wakaba \\nand two additional ships to World V3-1 \\nin the Northern Sea and score \\nan S rank victory at the Boss node.", desc => "mst_quest.xml" },
        "「第二一駆逐隊」を編成せよ！" => { tr => "Organise the 21st Destroyer Division!", desc => "mst_quest.xml" },
        "「第二一駆逐隊」出撃せよ！" => { tr => "Deploy the 21st Destroyer Division!", desc => "mst_quest.xml" },
        "「第二二駆逐隊」を含む艦隊で近海諸島防衛線に出撃、敵主力艦隊を撃滅せよ！" => { tr => "Deploy Satsuki, Fumizuki, Nagatsuki, 1 more DD \\nand up to two additional ships to \\nWorld V1-4 in the Naval District Sea and \\nscore an S rank victory at the Boss node.", desc => "mst_quest.xml" },
        "「第二二駆逐隊」を編成せよ！" => { tr => "Organise the 22nd Destroyer Division!", desc => "mst_quest.xml" },
        "「第二二駆逐隊」出撃せよ！" => { tr => qq[Deploy the "22nd Destroyer Division!], desc => "mst_quest.xml" },
        "「第二戦隊」を基幹とした艦隊でカレー洋に進出、反復出撃により敵海上兵力を撃滅せよ！" => { tr => "With a fleet consisting of  Nagato, \\nMutsu, Fusou, and Yamashiro obtain an \\nS-rank victory 2 times at the \\nBoss node of World V4-1 in the Western Sea.", desc => "mst_quest.xml" },
        "「第二戦隊」抜錨！" => { tr => qq["2nd Squadron" Weigh Anchor!], desc => "mst_quest.xml" },
        "「第五戦隊」は沖ノ島沖の戦闘哨戒を実施、敵艦隊主力を捕捉、これを撃滅せよ！" => { tr => "Deploy Myoukou, Nachi, Haguro, \\n+3 ships to World V11-4 in the Central Western Sea \\nand achieve an S-rank the Boss node", desc => "mst_quest.xml" },
        "「第五戦隊」を編成せよ！" => { tr => "Form the 5th Fleet!", desc => "mst_quest.xml" },
        "「第五戦隊」出撃せよ！" => { tr => qq[Deploy the "5th Squadron"!], desc => "mst_quest.xml" },
        "「第五航空戦隊」を再編成せよ！" => { tr => "Reorganize the 5th Carrier Division!", desc => "mst_quest.xml" },
        "「第五航空戦隊」出撃せよ！" => { tr => "Deploy the 5th Carrier Division!", desc => "mst_quest.xml" },
        "「第五航空戦隊」珊瑚諸島沖に出撃せよ！" => { tr => qq[Sortie the "5th Carrier Division \\nto the South], desc => "mst_quest.xml" },
        "「第五艦隊」を編成せよ！" => { tr => "Form the 5th Fleet!", desc => "mst_quest.xml" },
        "「第八駆逐隊」を編成せよ！" => { tr => "Form the Destroyer Division 8!", desc => "mst_quest.xml" },
        "「第八駆逐隊」出撃せよ！" => { tr => "Sortie the 8th Destroyer Squadron!", desc => "mst_quest.xml" },
        "「第六○一航空隊」発艦せよ！" => { tr => "Deploy the 601st Naval Air Group", desc => "mst_quest.xml" },
        "「第六戦隊」をもって出撃し、オリョール海東部の敵と交戦、これに「完全勝利」せよ！" => { tr => "Deploy Aoba, Furutaka, Kako, Kinugasa, and \\n2 additional ships to World V11-3 in the \\nCentral Western Sea and obtain an S-Rank \\nat the Boss.", desc => "mst_quest.xml" },
        "「第六戦隊」を編成せよ！" => { tr => "Form the Cruiser Division 6!", desc => "mst_quest.xml" },
        "「第六戦隊」オリョール海へ出撃せよ！" => { tr => "Deploy the 6th Squadron to the \\nOrel Sea!", desc => "mst_quest.xml" },
        "「第六戦隊」出撃せよ！" => { tr => "Deploy the 6th Cruiser Division!", desc => "mst_quest.xml" },
        "「第六駆逐隊」を含む対潜哨戒部隊で南方連絡航路へ再展開、敵潜水艦部隊を痛打せよ！" => { tr => "With Akatsuki Kai-Ni, Hibiki/Вер Ikazuchi, \\nInazuma and two other ships, obtain A-rank \\nat the Boss node of World V9-1 \\nin the Southern Connecting Sea.", desc => "mst_quest.xml" },
        "「第六駆逐隊」を含む艦隊で南方連絡航路へ展開、同航路の対潜哨戒を実施せよ！" => { tr => "Sortie Akatsuki, Hibiki/Вер, Ikazuchi, and \\nInazuma to V9-2 in \\nthe Southern Connecting Sea and obtain a \\nC-Rank or better at the Boss, Akatsuki must \\nbe flagship.", desc => "mst_quest.xml" },
        "「第六駆逐隊」を編成せよ！" => { tr => "Form the Destroyer Division 6!", desc => "mst_quest.xml" },
        "「第六駆逐隊」出撃せよ！" => { tr => "Deploy the 6th Destroyer Division!", desc => "mst_quest.xml" },
        "「第六駆逐隊」対潜哨戒なのです！" => { tr => qq["6th Destroyer Division" \\nAnti-Submarine Patrol!], desc => "mst_quest.xml" },
        "「第六駆逐隊」対潜哨戒を徹底なのです！" => { tr => qq["6th Destroyer Division" Thorough \\nAnti-Submarine Patrol!], desc => "mst_quest.xml" },
        "「第十一駆逐隊」を含む艦隊で出撃し、中部西海域バシー島沖の敵艦隊を撃破せよ！" => { tr => "With Fubuki, Shirayuki, Hatsuyuki and Murakumo \\nobtain a A-rank or better result \\nat the Boss node of World V11-1 in the \\nCentral Western Sea.", desc => "mst_quest.xml" },
        "「第十一駆逐隊」を編成せよ！" => { tr => "Organise the 11th Destroyer Division!", desc => "mst_quest.xml" },
        "「第十一駆逐隊」出撃せよ！" => { tr => qq[Deploy the "11th Destroyer Division"!], desc => "mst_quest.xml" },
        "「第十八戦隊」を新編成せよ！" => { tr => "Organize the 18th Squadron!", desc => "mst_quest.xml" },
        "「第十八駆逐隊」を編成せよ！" => { tr => "Form the Destroyer Division 18!", desc => "mst_quest.xml" },
        "「第十八駆逐隊」出撃せよ！" => { tr => qq[Deploy the "18th Destroyer Division"!], desc => "mst_quest.xml" },
        "「第十六戦隊」を幌筵泊地正面に展開、同泊地の警備を実施せよ！" => { tr => "Sortie Ashigara(Flagship), Kuma, Nagara \\nand up to 3 additional ships to World 8-3 \\nin the North Anchorage Sea and clear the stage.", desc => "mst_quest.xml" },
        "「第十六戦隊」を編成せよ！" => { tr => "Organize the 16th Squadron!", desc => "mst_quest.xml" },
        "「第十六戦隊(第一次)」出撃せよ！" => { tr => "Sortie the 16th Squadron!", desc => "mst_quest.xml" },
        "「第十六戦隊(第二次)」を編成せよ！" => { tr => "Organize the 16th Squadron \\n(Second Generation)!", desc => "mst_quest.xml" },
        "「第十六戦隊(第二次)」を西方海域ベーグル湾に展開、べーグル湾通商破壊戦を実施せよ！" => { tr => "Sortie Natori as flagship, Isuzu, Kinu \\nand up to 3 additional ships to World V4-2 in \\nthe Western Sea and score an S-rank at the Boss.", desc => "mst_quest.xml" },
        "「第十六戦隊(第二次)」出撃せよ！" => { tr => "Sortie the 16th Squadron \\n(Second Generation)!", desc => "mst_quest.xml" },
        "「第四戦隊」を編成せよ！" => { tr => "Form the Cruiser Division 4!", desc => "mst_quest.xml" },
        "「第四戦隊」出撃せよ！" => { tr => "Deploy the 4th Cruiser Division!", desc => "mst_quest.xml" },
        "「第四航空戦隊」を編成せよ！" => { tr => "Organize the 4th Carrier Division!", desc => "mst_quest.xml" },
        "「総合演習」を実施せよ！" => { tr => "Carry Out the All-Rounded \\nExercise!", desc => "mst_quest.xml" },
        "「翔鶴」「瑞鶴」と随伴駆逐艦「朧」「秋雲」を基幹とした第五航空戦隊を再編成せよ！" => { tr => "Have Shoukaku, Zuikaku, Oboro and \\nAkigumo in your main fleet.", desc => "mst_quest.xml" },
        "「翔鶴」「瑞鶴」を基幹とし、駆逐艦2隻を加えた第五航空戦隊を編成せよ！" => { tr => "Have Shoukaku, Zuikaku, and 2 DD \\nin your main fleet.", desc => "mst_quest.xml" },
        "「翔鶴」「瑞鶴」を基幹とする第五航空戦隊で、沖ノ島海域の敵を邀撃せよ！" => { tr => "Deploy Shoukaku, Zuikaku, and 4 additional \\nships to V11-4  in the Central Western Sea \\nand defeat the Boss with an A rank victory.", desc => "mst_quest.xml" },
        "「翔鶴」に艦攻「村田隊」を配置転換せよ！" => { tr => "Assign the KanOsamu Corps to \\nShokaku!", desc => "mst_quest.xml" },
        "「翔鶴」または「赤城」を第一艦隊旗艦にした状態で、新たに「九七式艦攻」を3つ廃棄せよ！" => { tr => "Have Shoukaku or Akagi as flagship \\nand then scrap 3 Type 97 Torpedo Bomber", desc => "mst_quest.xml" },
        "「翔鶴」を旗艦として、「瑞鶴」「瑞鳳」及び随伴艦を配備した第三艦隊を編成せよ！" => { tr => "Form a fleet with Shokaku as Flagship \\nalong with Zuikaku, and Zuihou.", desc => "mst_quest.xml" },
        "「航空戦演習」を実施せよ！" => { tr => "Carry Out the Aerial Battle \\nExercise!", desc => "mst_quest.xml" },
        "「航空戦演習」を強化せよ！" => { tr => "Intensify the Aerial \\nBattle Exercise!", desc => "mst_quest.xml" },
        "「航空戦艦」抜錨せよ！" => { tr => qq["Aviation Battleship" Weigh Anchor!], desc => "mst_quest.xml" },
        "「航空水上打撃艦隊」出撃せよ！" => { tr => "Deploy an Aviation Surface \\nAttack Fleet!", desc => "mst_quest.xml" },
        "「艦娘」出撃！" => { tr => qq["First Sortie!"], desc => "mst_quest.xml" },
        "「艦隊行動演習」及び「雷撃戦演習」を継続して実施せよ！" => { tr => "Do Fleet Movement Exercise three times and \\nTorpedo Exercise three times", desc => "mst_quest.xml" },
        "「蒼龍改二」(※旗艦)及び「飛龍改二」を基幹とした二航戦(要駆逐艦2隻)を編成せよ！" => { tr => "Have Souryuu Kai-Ni as flagship \\nwith Hiryuu Kai-Ni, and 2 \\nDDs in your fleet.", desc => "mst_quest.xml" },
        "「西村艦隊」を再編成せよ！" => { tr => "Organise the Nishimura Fleet!", desc => "mst_quest.xml" },
        "「西村艦隊」を南方海域に進出させ、敵主力艦隊へ突入、これを撃滅せよ！" => { tr => " With Fusou, Yamashiro, Mogami, \\nShigure, and Michishio and an additional \\nship obtain S-rank victory at the \\nBoss node of World V5-1 in the Southern Sea.", desc => "mst_quest.xml" },
        "「西村艦隊」を編成せよ！" => { tr => "Form the Nishimura Fleet!", desc => "mst_quest.xml" },
        "「西村艦隊」出撃せよ！" => { tr => "Deploy the Nishimura Fleet!", desc => "mst_quest.xml" },
        "「西村艦隊」南方海域へ進出せよ！" => { tr => qq[Advance the "Nishimura Fleet" \\nto the Southern Sea Region!], desc => "mst_quest.xml" },
        "「赤城」に艦攻「村田隊」を配属せよ！" => { tr => "Assign the KanOsamu Murata Corps to \\nAkagi！", desc => "mst_quest.xml" },
        "「足柄」を旗艦として「球磨」「長良」を擁する、第十六戦隊(第一次)を編成せよ！" => { tr => "Have Ashigara as flagship, \\nKuma and Nagara in your fleet.", desc => "mst_quest.xml" },
        "「軽空母」戦隊、出撃せよ！" => { tr => qq["Light Carrier Squadron", \\nDeploy!], desc => "mst_quest.xml" },
        "「近代化改修」を実施せよ！" => { tr => "Carry Out Ship Modernizations", desc => "mst_quest.xml" },
        "「近代化改修」を進め、戦備を整えよ！" => { tr => "Proceed with Modernization, \\nand Prepare for War", desc => "mst_quest.xml" },
        "「遠征」を継続して実施せよ！" => { tr => "Fleet Expedition implementation 2", desc => "mst_quest.xml" },
        "「遠洋潜水艦作戦」を反復実施し、潜水艦隊による敵艦隊漸減に努めよ！" => { tr => qq[Carry out "Distant Ocean Submarine Operation" \\nto increase the submarine fleet's \\nexperience and reduce the enemy fleet! twice], desc => "mst_quest.xml" },
        "「遠洋練習航海」及び「南洋方面遠洋練習航海」を実施、これを成功させよ！" => { tr => "Sortie fleets for 4th expedition \\n[Cross-Oceanic Training Trip] of the Central Sea \\nand the 4th expedition [South-East Asian \\nCross-Oceanic Training Trip] of FS Sea!", desc => "mst_quest.xml" },
        "「那智」「足柄」「多摩」「木曾」を中核とした「第五艦隊」を編成せよ！" => { tr => "Have Nachi, Ashigara, Tama, and Kiso \\nin your fleet.", desc => "mst_quest.xml" },
        "「那智戦隊」抜錨せよ！" => { tr => qq[Weigh Anchor, "Nachi Squadron"!], desc => "mst_quest.xml" },
        "「那智改二」「足柄改二」及び「多摩」「木曾」を基幹とした、第二一戦隊を編成せよ！" => { tr => "Have Nachi Kai-Ni, Ashigara Kai-Ni, \\nTama and Kiso in your main fleet.", desc => "mst_quest.xml" },
        "「重巡戦隊」を編成せよ！" => { tr => "Form a Heavy Cruiser Squadron!", desc => "mst_quest.xml" },
        "「重巡洋艦」出撃せよ！" => { tr => "Deploy a Heavy Cruiser!", desc => "mst_quest.xml" },
        "「金剛」型による高速戦艦部隊を編成せよ！" => { tr => "Form the Kongou-class!", desc => "mst_quest.xml" },
        "「鉄底海峡」を越えて" => { tr => "Beyond Iron Bottom Straight!", desc => "mst_quest.xml" },
        "「防空射撃演習」を反復実施し、艦隊の防空能力を高めよ！" => { tr => "Complete the 4th Naval Base \\nExpedition [Anti-aircraft Drill] 2 times", desc => "mst_quest.xml" },
        "「阿武隈」「曙」「潮」「霞」「不知火」を中核とした「第一水雷戦隊」を編成せよ！" => { tr => "Have Abukuma, Akebono, Ushio, Kasumi \\nand Shiranui in your fleet.", desc => "mst_quest.xml" },
        "「阿武隈」を旗艦として「響」「初霜」「若葉」「五月雨」「島風」による一水戦を編成せよ！" => { tr => "Have Abukuma as flagship with Hibiki/Вер, \\nHatsushimo, Wakaba, Samidare and \\nShimakaze in your main fleet", desc => "mst_quest.xml" },
        "「阿武隈改二」を旗艦として「響」「夕雲」「長波」「秋雲」「島風」の一水戦を再編成せよ！" => { tr => "Have Abukuma Kai-Ni as flagship with \\nHibiki/Вер, Yuugumo, Naganami, Akigumo and \\nShimakaze in your main fleet.", desc => "mst_quest.xml" },
        "「零戦21型(熟練)」搭載空母を第一艦隊旗艦に配備した状態で、新たに「零戦52型」を2つ廃棄せよ！" => { tr => qq[Equip a Type 0 Fighter Model 21 (Skilled) \\non a Carrier secretary, then scrap 2 \\nType 0 Fighter Model 52"], desc => "mst_quest.xml" },
        "「零戦52型丙(六〇一空)」搭載空母を第一艦隊旗艦に配備した状態で、新たに「烈風」を2つ廃棄せよ！" => { tr => "Have flagship equipped with Zero Fighter \\nType 52 Type C (601 Air Group), \\nthen scrap 2 Reppuu", desc => "mst_quest.xml" },
        "「雷撃戦演習」を実施せよ！" => { tr => "Carry Out the Torpedo Exercise!", desc => "mst_quest.xml" },
        "「霞」「霰」「陽炎」「不知火」4隻による第十八駆逐隊を編成せよ！" => { tr => "Have ONLY Kasumi, Arare, Kagerou, \\nand Shiranui in your fleet.", desc => "mst_quest.xml" },
        "「飛龍改二」(※旗艦)及び「蒼龍」を基幹とした二航戦(要駆逐艦2隻)を編成せよ！" => { tr => "Have Hiryuu Kai Ni as the flagship, \\nSouryuu, and 2 DDs in \\nyour fleet.", desc => "mst_quest.xml" },
        "「駆逐隊」を編成せよ！" => { tr => "Form a Destroyer Squadron!", desc => "mst_quest.xml" },
        "「鳥海」「青葉」「加古」「古鷹」「天龍」を含む高速艦隊を編成せよ！" => { tr => "Have Choukai, Aoba, Kako, Furutaka, \\nTenryuu, and a FAST ship in your main fleet.", desc => "mst_quest.xml" },
        "「鳥海」「青葉」「衣笠」「加古」「古鷹」「天龍」からなる三川艦隊を編成せよ！" => { tr => "Have Choukai, Aoba, Kinugasa, Kako, \\nFurutaka, and Tenryuu in your main fleet.", desc => "mst_quest.xml" },
        "あ号作戦" => { tr => "Operation A-gou!", desc => "mst_quest.xml" },
        "い号作戦" => { tr => "Operation I-gou!", desc => "mst_quest.xml" },
        "はじめての「廃棄」！" => { tr => "The First Scrapping", desc => "mst_quest.xml" },
        "はじめての「建造」！" => { tr => qq[Your First "Construction"!], desc => "mst_quest.xml" },
        "はじめての「演習」！" => { tr => qq[Your First "Exercise"!], desc => "mst_quest.xml" },
        "はじめての「編成」！" => { tr => "First Formation!", desc => "mst_quest.xml" },
        "はじめての「装備改修」！" => { tr => "The First Equipment \\nImprovement", desc => "mst_quest.xml" },
        "はじめての「補給」！" => { tr => qq[Your First "Resupply"!], desc => "mst_quest.xml" },
        "はじめての「解体」！" => { tr => qq[Your First "Dismantling"!], desc => "mst_quest.xml" },
        "はじめての「近代化改修」！" => { tr => "The First Modernization", desc => "mst_quest.xml" },
        "はじめての「遠征」！" => { tr => qq[Your First "Expedition"], desc => "mst_quest.xml" },
        "はじめての「開発」！" => { tr => qq[Your First "Development"!], desc => "mst_quest.xml" },
        "はじめての演習！「艦隊行動演習」を実施せよ！" => { tr => "Do the Fleet Movement Exercise", desc => "mst_quest.xml" },
        "ろ号作戦" => { tr => "Operation Ro-gou!", desc => "mst_quest.xml" },
        "オリョール海西部に進出せよ！" => { tr => "Advance to the Western Region of \\nOrel Bay!", desc => "mst_quest.xml" },
        "カレー洋作戦、開始せよ！" => { tr => "Calais Ocean Manuevers", desc => "mst_quest.xml" },
        "カレー洋正面海域に艦隊を展開、同海域の敵艦隊を撃破し、カレー洋作戦を実施せよ！" => { tr => "Sortie to World V4-1 in the Western Sea \\nand defeat the Boss node", desc => "mst_quest.xml" },
        "ソロモン海域に突入せよ！" => { tr => "Sortie the surface attack fleet!", desc => "mst_quest.xml" },
        "ソロモン海域深部に艦隊を突入、同方面の敵艦隊を撃破、「鉄底海峡」を突破せよ！" => { tr => "Sortie a fleet to World V5-4 in \\nthe Southern Sea and defeat the Boss.", desc => "mst_quest.xml" },
        "トラック泊地を防衛せよ！" => { tr => "Defend the Anchorage", desc => "mst_quest.xml" },
        "トラック泊地周辺の対潜哨戒を実施せよ！" => { tr => "Anti Submarine Patrol Track \\nAnchorage!", desc => "mst_quest.xml" },
        "トラック泊地周辺警備を実施せよ！" => { tr => "Truk Anchorage Patrol", desc => "mst_quest.xml" },
        "一航戦「赤城」「加賀」二航戦「飛龍」「蒼龍」からなる第一機動部隊を編成せよ！" => { tr => "Have ONLY Akagi, Kaga, Hiryuu, and \\nSouryuu in your main fleet.", desc => "mst_quest.xml" },
        "中規模潜水艦隊を編成せよ！" => { tr => "Form a Medium-Sized Submarine Fleet!", desc => "mst_quest.xml" },
        "中部西海域潜水艦哨戒を実施せよ！" => { tr => "Central Western sea submarine patrol", desc => "mst_quest.xml" },
        "主力戦艦部隊「第二戦隊」を編成せよ！" => { tr => "Organise the Main Battleship Fleet: \\nthe 2nd Squadron!", desc => "mst_quest.xml" },
        "二つ目の艦隊、第2艦隊の旗艦を指定して、第2艦隊を編成せよ！" => { tr => "Have a flagship in your second fleet.", desc => "mst_quest.xml" },
        "二人でする初めての任務！" => { tr => "A Couple's First Quest!", desc => "mst_quest.xml" },
        "今月中に「対抗演習」を5回以上実施し、式への気持ちを整理しよう！" => { tr => "Do 5 battles in Rival Exercises in a month", desc => "mst_quest.xml" },
        "今月中に「遠征」を継続実施、これを10回成功させよ！" => { tr => "Perform 10 successful expeditions \\nby the end of the month！", desc => "mst_quest.xml" },
        "今月中に「遠征」を３回成功させよ！" => { tr => "Perform 3 successful expeditions \\nby the end of the month", desc => "mst_quest.xml" },
        "今月中に全力出撃を行い、可能な限り多くの敵艦隊を捕捉、これを迎撃せよ！" => { tr => "Deploy your fleet several times and \\ndefeat 10 to 12 Bosses in a month.", desc => "mst_quest.xml" },
        "今月中に南方からの「資源輸送系遠征」を継続実施、12回以上成功させよ！" => { tr => "Do 12 successful transport fleet \\nexpeditions in Southern Connecting Sea \\nduring the same month ", desc => "mst_quest.xml" },
        "今月中に可能な限り敵輸送船団を捕捉、敵輸送艦を撃滅し、敵補給線を寸断せよ！" => { tr => "Sink as many enemy transport ships \\nas you can in a month.", desc => "mst_quest.xml" },
        "今月中に敵輸送艦を5隻以上撃沈せよ！" => { tr => "Sink 5 or more Enemy Transport Ships \\nin a month.", desc => "mst_quest.xml" },
        "今月中に艦を10隻以上ドック入りさせ、艦隊の大規模な整備を実施せよ！" => { tr => "Repair 10 Ships", desc => "mst_quest.xml" },
        "任意の艦を近代化改修して、能力を強化せよ！" => { tr => "Perform a successful modernization", desc => "mst_quest.xml" },
        "伊勢型戦艦「伊勢」「日向」を同一艦隊に配属せよ！" => { tr => "Have Ise and Hyuuga in your \\nmain fleet.", desc => "mst_quest.xml" },
        "伊号潜水艦2隻からなる潜水艦隊を編成せよ！" => { tr => "Have 2 SS in your main fleet.", desc => "mst_quest.xml" },
        "伊号潜水艦2隻以上からなる潜水艦隊でオリョール海西部の敵艦隊を撃破せよ！" => { tr => "Deploy a fleet with 2 or more SS. \\nScore a B Rank victory against the \\nWorld V11-2 Boss in the Central Western Sea.", desc => "mst_quest.xml" },
        "伊号潜水艦3隻以上からなる潜水艦隊を編成せよ！" => { tr => "Have 3 SS in your main fleet.", desc => "mst_quest.xml" },
        "作戦前に艦隊の練度向上を図る！今月中に「対抗演習」を3回以上実施せよ！" => { tr => "Perform Opposition Training 3 times \\nin a month", desc => "mst_quest.xml" },
        "作戦前に艦隊練度向上を図れ！" => { tr => "Improve Fleet discipline \\nbefore maneuvers", desc => "mst_quest.xml" },
        "全6隻で構成される主力艦隊を編成せよ！" => { tr => "Have 6 ships in your main fleet.", desc => "mst_quest.xml" },
        "再編成「第二航空戦隊」を強化せよ！" => { tr => "Reorganise the Strengthened \\n2nd Carrier Division.", desc => "mst_quest.xml" },
        "再編成した「第五航空戦隊」を珊瑚諸島沖に展開、敵機動部隊を捕捉撃滅せよ！" => { tr => "Sortie Shoukaku, Zuikaku, Oboro, Akigumo \\nand up to 2 additional ships to World V5-2 in the \\nSouthern Sea and score an S-rank \\nvictory at the Boss node.", desc => "mst_quest.xml" },
        "北方再突入に備え、練度向上に努めよ！" => { tr => "Preparing to retake the north, \\nimprove fleet discipline!", desc => "mst_quest.xml" },
        "北方再突入準備の新編「一水戦」で北方キス島に再突入を敢行、同撤収作戦を完遂せよ！" => { tr => "Abukuma(flagship), Hibiki, Yuugumo, Naganami, \\nAkigumo, and Shimakaze in the same fleet. \\nGet at least an S rank at the Boss \\nof World V3-2 in the Northern Sea.", desc => "mst_quest.xml" },
        "北方海域の哨戒を実施せよ！" => { tr => "Patrol the Northern Sea!", desc => "mst_quest.xml" },
        "北方海域の深部に出撃し、敵北方艦隊の主力艦隊を捕捉、これを撃滅せよ！" => { tr => "Deploy to World V3-3 and V3-4 in \\nthe Northern Sea and defeat the Bosses.", desc => "mst_quest.xml" },
        "北方海峡の警備を実施せよ！" => { tr => "Patrol the Northern Strait!", desc => "mst_quest.xml" },
        "北方突入準備を完了した「一水戦」で北方キス島に突入！包囲網を破り、友軍を救出せよ！" => { tr => "Abukuma(flagship), Hibiki, Yuugumo, Naganami, \\nAkigumo, and Shimakaze in the same fleet. \\nGet at least an S rank at \\nthe Boss of World V3-2 in the Northern Sea.", desc => "mst_quest.xml" },
        "北方AL海域において、「AL作戦」を実施せよ！" => { tr => "Sortie to World V13-2 and V13-3 in \\nthe AL Sea and Score S rank \\nvictories against both Bosses.", desc => "mst_quest.xml" },
        "南方からの資源輸送作戦を強化せよ！" => { tr => "Strengthen southern transport \\noperations", desc => "mst_quest.xml" },
        "南方トラック泊地は前線の要だ。トラック泊地周辺警備を実施して、工作艦の前線投入を準備せよ！" => { tr => "Sortie to Southern Harbor V7-2 in \\nthe South Anchorage Sea and clear it", desc => "mst_quest.xml" },
        "南方泊地海域方面に接近中敵艦隊を撃破、同方面及びトラック泊地を防衛せよ！" => { tr => "Defeat 3 Boss Nodes in \\nWest Sea.", desc => "mst_quest.xml" },
        "南方海域への鼠輸送を実施せよ！" => { tr => "Carry out a [Tokyo Express] \\nto the southern sea!", desc => "mst_quest.xml" },
        "南方海域への鼠輸送を継続実施せよ！" => { tr => "Continue the [Tokyo Express] \\nto the southern sea!", desc => "mst_quest.xml" },
        "南方海域珊瑚諸島沖に反復出撃し、敵機動部隊本隊を捕捉撃滅、制海権を確保せよ！" => { tr => "Deploy to World V5-2 in the \\nSouthern Sea and defeat the Boss \\ntwo times with an S Rank Victory.", desc => "mst_quest.xml" },
        "南方海域珊瑚諸島沖の制空権を握れ！" => { tr => "Gain Air Superiority at the Coral \\nIslands in the Southern Sea Region!", desc => "mst_quest.xml" },
        "南方航路西部に主力艦隊を展開、敵戦力を撃破して同海域の制海権を確保せよ！" => { tr => "Deploy to the World V9-4 in the Southern \\nConnecting Sea and get at least \\nan A rank at the Boss", desc => "mst_quest.xml" },
        "南方連絡海域の制海権を確立せよ！" => { tr => "Establish Naval Supremacy in \\nthe Souther Waters!", desc => "mst_quest.xml" },
        "南方連絡海域正面の制海権を確保せよ！" => { tr => "Control South Connecting Sea zone!", desc => "mst_quest.xml" },
        "南方連絡線制海権を確保せよ！" => { tr => "Ensure the South Contact Line.", desc => "mst_quest.xml" },
        "南方連絡航路対潜哨戒を実施せよ！" => { tr => "South Contact Waters Anti \\nSub Patrol！", desc => "mst_quest.xml" },
        "南西海域ズンダ海峡付近の敵戦力を撃破して同海峡を制圧、資源地帯の制海権を確保せよ！" => { tr => "Deploy to the World V2-3 in the \\nNansei Islands and clear it.", desc => "mst_quest.xml" },
        "囮機動部隊支援作戦を実施せよ！" => { tr => "Decoy Mobile Fleet Support \\nOperation!!", desc => "mst_quest.xml" },
        "多数の水上偵察機を運用する「水上機母艦」を艦隊に配備せよ！" => { tr => "Have a Seaplane Tender in your \\nmain fleet.", desc => "mst_quest.xml" },
        "夜戦練度向上を図る！「艦隊行動演習」及び「雷撃戦演習」を継続実施せよ！" => { tr => "Do both Movement and Torpedo \\nexercises 5 times each.", desc => "mst_quest.xml" },
        "大和型・長門型・伊勢型・扶桑型のいずれか3隻と軽巡1隻他の水上打撃部隊を配備せよ！" => { tr => "Have 3 BBs (Nagato-class, Ise-class, \\nFusou-class, or Yamato-class) and 1 CL in a fleet", desc => "mst_quest.xml" },
        "大型艦建造の準備をします！「工廠」で任意の装備を5つ「廃棄」せよ！" => { tr => "Scrap 5 pieces of equipment", desc => "mst_quest.xml" },
        "大型艦/新型艦建造のための準備を行う。任意の艦で近代化改修を4回成功させよ！" => { tr => "Perform 4 successful modernizations", desc => "mst_quest.xml" },
        "大規模艦隊を編成せよ！" => { tr => "Form a Six Ship Fleet!", desc => "mst_quest.xml" },
        "天龍型軽巡洋艦「天龍」「龍田」を同一艦隊に配属せよ！" => { tr => "Have Tenryuu, and Tatsuta in your \\nmain fleet.", desc => "mst_quest.xml" },
        "妙高型重巡洋艦「妙高」「那智」「足柄」「羽黒」を同一艦隊に配属せよ！" => { tr => "Have Myoukou, Nachi, Ashigara, and \\nHaguro in your main fleet.", desc => "mst_quest.xml" },
        "完全編成した「三川艦隊」をもって、トラック泊地の警備を実施、同方面の制海権を確保せよ！" => { tr => "Deploy Choukai, Furutaka, Kako, Aoba, \\nKinugasa, and Tenryuu to \\nSouth Anchorage Sea V7-2.", desc => "mst_quest.xml" },
        "対潜水艦戦練度の向上を図る！「対潜戦演習」を継続実施せよ！" => { tr => "Do the Anti-Submarine Warfare Exercise \\nthree times", desc => "mst_quest.xml" },
        "対潜能力の充実した艦隊で出撃、敵潜水艦狩りを実施せよ！" => { tr => "Sink 4 enemy submarines in a month.", desc => "mst_quest.xml" },
        "少し艦隊規模が大きくなりすぎました！「工廠」で新たに艦を2隻「解体」せよ！" => { tr => "Scrap 2 ships", desc => "mst_quest.xml" },
        "川内型軽巡洋艦「川内」「神通」「那珂」を同一艦隊に配属せよ！" => { tr => "Have Sendai, Jintsuu, and Naka in your \\nmain fleet.", desc => "mst_quest.xml" },
        "式の準備をします！「工廠」で装備を3つ「廃棄」して身の回りの整理を！" => { tr => "Scrap 3 pieces of equipment", desc => "mst_quest.xml" },
        "式の準備！(その参)" => { tr => "In Preparation of Love! \\n(Part 3)", desc => "mst_quest.xml" },
        "式の準備！(その壱)" => { tr => "Preparation for the Ceremony \\n(Part I)", desc => "mst_quest.xml" },
        "式の準備！(その弐)" => { tr => "Prepare for the Ceremony! \\n(Part 2)", desc => "mst_quest.xml" },
        "式の準備！(最終)" => { tr => "Prepare for the Ceremony Final!", desc => "mst_quest.xml" },
        "強い絆を結んだ艦娘を旗艦とした第一艦隊でリランカ島へ出撃、敵中枢を撃滅せよ！" => { tr => "Score an S rank victory over the Boss \\nin the World V4-3 in the Western Sea with a \\nlevel 100+ flagship in your first fleet.", desc => "mst_quest.xml" },
        "戦いで「補給」はとても重要です！燃料・弾薬を艦に「補給」せよ！" => { tr => "Resupply a Ship.", desc => "mst_quest.xml" },
        "戦艦「比叡」「霧島」軽巡「長良」駆逐艦「暁」「雷」「電」による海上突入部隊を編成せよ！" => { tr => "Have Hiei, Kirishima, Nagara, Akatsuki, \\nIkazuchi, Inazuma in your fleet", desc => "mst_quest.xml" },
        "戦艦と重巡による主力艦隊を編成せよ！" => { tr => "Form the Main Fleet with \\na BB and CA!", desc => "mst_quest.xml" },
        "戦艦を主力とした水上打撃部隊を編成せよ！" => { tr => "Organise a Surface Attack Fleet with \\nBattleships", desc => "mst_quest.xml" },
        "戦艦1隻以上、重巡2隻以上を主力とした水上打撃艦隊を編成せよ！" => { tr => "Have a BB and 2 CA in your \\nmain fleet.", desc => "mst_quest.xml" },
        "戦艦2隻と直援軽空母1隻(正規空母無し)基幹の艦隊で、北方キス島後方海域に突入せよ！" => { tr => "With a fleet containg atleast 2 BBs and 1 CVL obtain an \\nS-rank victory at the Boss node \\nof World V3-3 in the Northern Sea.", desc => "mst_quest.xml" },
        "戦艦3隻軽巡1隻他を基幹とした水上打撃部隊で南方海域へ進出、敵艦隊を撃滅せよ！" => { tr => "Deploy a fleet with only 3 of the following classes: \\nYamato-class, Nagato-class, Ise-class and Fusou-class \\nSlow Battleships, 1 CL and 2 additional ships \\nto World V5-1 in the Southern Sea and defeat the Boss.", desc => "mst_quest.xml" },
        "戦闘で傷ついた艦を「入渠」させて損傷部分の修理、次の出撃に備えよ！" => { tr => "Repair a Ship.", desc => "mst_quest.xml" },
        "扶桑型戦艦「扶桑」「山城」を同一艦隊に配属せよ！" => { tr => "Have Fusou and Yamashiro in your \\nmain fleet.", desc => "mst_quest.xml" },
        "抜錨！「第十八戦隊」" => { tr => "Deploy the 18th Squadron!", desc => "mst_quest.xml" },
        "接近する「敵前衛艦隊」を迎撃せよ！" => { tr => "Intercept Approaching Enemy \\nVanguard Fleet!", desc => "mst_quest.xml" },
        "摩耶改または摩耶改二及び駆逐3隻を含む艦隊で南方トラック泊地の警備を実施せよ！" => { tr => "Deploy Maya (Kai or Kai ni), and 3 DDs \\n(you may add additional ships) to V7-2 in the \\nSouth Anchorage Sea and obtain an S-Rank \\nat the Boss.", desc => "mst_quest.xml" },
        "改二改装を終えた翔鶴型航空母艦2隻と同護衛艦による新航空戦隊を新編成せよ！" => { tr => "Have Zuikaku Kai Ni, Shoukaku Kai Ni \\nand two DDs in your fleet.", desc => "mst_quest.xml" },
        "改修工廠を準備せよ！" => { tr => "Prepare the Arsenal for Renovations.", desc => "mst_quest.xml" },
        "敵北方艦隊主力を撃滅せよ！" => { tr => "Eliminate Enemy Northern Fleet \\nMain Force！", desc => "mst_quest.xml" },
        "敵東方中枢艦隊を撃破せよ！" => { tr => "Destroy Enemy Eastern Fleet!", desc => "mst_quest.xml" },
        "敵機動部隊を捕捉し、これを邀撃、敵空母を撃沈せよ！" => { tr => "Sink an enemy aircraft carrier.", desc => "mst_quest.xml" },
        "敵機動部隊を撃破せよ！" => { tr => "Crush The Enemy Task Force!", desc => "mst_quest.xml" },
        "敵潜水艦を制圧せよ！" => { tr => "Suppress the Enemy Submarines!", desc => "mst_quest.xml" },
        "敵空母を撃沈せよ！" => { tr => "Sink Enemy Carriers!", desc => "mst_quest.xml" },
        "敵艦隊を全力邀撃せよ！" => { tr => "Ambush the Enemy Fleet With \\nAll Your Might!", desc => "mst_quest.xml" },
        "敵艦隊を撃破せよ！" => { tr => "Crush the Enemy Fleet!", desc => "mst_quest.xml" },
        "敵艦隊を邀撃、敵戦力の漸減を図れ！" => { tr => "Ambush an Enemy Fleet!", desc => "mst_quest.xml" },
        "敵補給ラインを寸断せよ！" => { tr => "Shred Enemy Supply lines!", desc => "mst_quest.xml" },
        "敵輸送船団を叩け！" => { tr => "Strike the Enemy Transport Group!", desc => "mst_quest.xml" },
        "新「三川艦隊」を編成せよ！" => { tr => "Form the New Mikawa Fleet!", desc => "mst_quest.xml" },
        "新「三川艦隊」出撃せよ！" => { tr => "Deploy the New Mikawa Fleet!", desc => "mst_quest.xml" },
        "新たなる旅立ち！" => { tr => "A New Voyage!", desc => "mst_quest.xml" },
        "新たに編成した「第2艦隊」を出撃させよ！" => { tr => "Deploy your 2nd Fleet on a combat \\nmission.", desc => "mst_quest.xml" },
        "新型「艦戦」の改良" => { tr => "Model Conversion: Reppuu \\n(Strong Gale)", desc => "mst_quest.xml" },
        "新型正規空母、雲龍型航空母艦を第一艦隊旗艦に配備せよ！" => { tr => "Have Unryuu, Amagi or Katsuragi in \\nyour first fleet as flagship", desc => "mst_quest.xml" },
        "新型電探を配備せよ！" => { tr => "Test the new RADAR!", desc => "mst_quest.xml" },
        "新型電探運用試験のため、第一艦隊の旗艦に「妙高改二」を配備せよ！" => { tr => "Have Myoukou Kai-Ni as the flagship \\nof your main fleet.", desc => "mst_quest.xml" },
        "新編「三川艦隊」ソロモン方面へ！" => { tr => qq[Newly-Formed "Mikawa Fleet" to \\nthe Solomon Region!], desc => "mst_quest.xml" },
        "新編「二航戦」を基幹とした艦隊で、珊瑚諸島沖に出撃、敵機動部隊を撃滅せよ！" => { tr => "Deploy Hiryuu Kai Ni as the flagship, \\nSouryuu and two DDs to World V5-2 in the Southern Sea. You may add 2 other ships. \\nScore an S rank victory against the Boss.", desc => "mst_quest.xml" },
        "新編「第二一戦隊」を基幹とする艦隊を展開、北方AL諸島沖を遊弋する敵を撃滅せよ！" => { tr => "Sortie Nachi(Kai-2), Ashigara(Kai-2), Tama, \\nKiso and up to 2 additional ships to \\nV13-2 in the AL Sea and S-Rank the Boss.", desc => "mst_quest.xml" },
        "新編「第二一戦隊」出撃準備！" => { tr => "Prepare the New 21st Squadron \\nfor Sortie！", desc => "mst_quest.xml" },
        "新編「第二一戦隊」北方へ出撃せよ！" => { tr => "Sortie the New 21st Squadron \\nto the North!", desc => "mst_quest.xml" },
        "新編「第二航空戦隊」を編成せよ！" => { tr => "Form the new 2nd Carrier Division!", desc => "mst_quest.xml" },
        "新編「第二航空戦隊」出撃せよ！" => { tr => qq[Deploy the Newly-Formed \\n"2nd Carrier Division"!], desc => "mst_quest.xml" },
        "新編「第六駆逐隊」を編成せよ！" => { tr => "Organize the new 6th \\nDestroyer Division!", desc => "mst_quest.xml" },
        "新編成した「三川艦隊」で出撃せよ！" => { tr => "Deploy Choukai, Aoba, Kako, Furutaka, \\nand Tenryuu, with one additional \\nfast ship to any stage.", desc => "mst_quest.xml" },
        "新編成航空戦隊、北方へ進出せよ！" => { tr => "New Carrier Division, \\nAdvance to the North!", desc => "mst_quest.xml" },
        "新航空戦隊を編成せよ！" => { tr => "Organize the New Carrier Division!", desc => "mst_quest.xml" },
        "新装備「開発」指令" => { tr => "Instructions to Develop \\nNew Equipment", desc => "mst_quest.xml" },
        "新設第2艦隊、抜錨せよ！" => { tr => "Second Fleet Sortie!", desc => "mst_quest.xml" },
        "新造艦「建造」指令" => { tr => qq[New Ship "Construction" \\nOrder], desc => "mst_quest.xml" },
        "旗艦「大和」出撃する！MI諸島近海に展開し、その巨砲で敵MI島基地守備隊を粉砕せよ！" => { tr => "Sortie Yamato as flagship and 5 additional \\nships to V12-3 in the MI Sea and \\ndefeat the Boss", desc => "mst_quest.xml" },
        "旗艦「那智」及び「初霜」「霞」「潮」「曙」他1隻の艦隊でバシー島沖の敵を撃滅せよ！" => { tr => "With Nachi (as flagship), Hatsushimo, Kasumi, \\nUshio, Akebono, and 1 other ship. \\nObtain S-rank victory at the Boss node \\nof World V11-1 in the Central Western Sea.", desc => "mst_quest.xml" },
        "旗艦に練度80以上、僚艦も全て練度40以上の精鋭潜水艦隊を編成せよ！" => { tr => "Have a level 80 Submarine as flagship \\nwith atleast 3 other lvl 40 \\nSubmarines in any of your fleets", desc => "mst_quest.xml" },
        "月月火水木金金！「砲戦演習」を継続して実施せよ！" => { tr => "Carry Out the Shelling Exercise \\n5 times!", desc => "mst_quest.xml" },
        "有力な対潜能力を持つ海上護衛隊によって、可能な限り多くの敵潜水艦を撃滅せよ！" => { tr => "Sink 8 Submarines.", desc => "mst_quest.xml" },
        "有力な母艦航空隊で全力出撃を行い、今月中に可能な限り多くの敵空母を撃滅せよ！" => { tr => "Sink as many enemy carriers as you \\ncan in a month.", desc => "mst_quest.xml" },
        "有力な潜水艦隊派遣による海外艦との接触、同救援を継続的に実施せよ！" => { tr => "Sortie a fleet for the 3rd expedition \\n[Contacting Foreign Ship] of the Western Sea and clear it 5 times!", desc => "mst_quest.xml" },
        "有力な潜水艦隊派遣による海外艦との接触作戦を成功させよ！" => { tr => "Complete the third expedition \\n[Submarine Voyage Drill] in the Southwestern \\nSea", desc => "mst_quest.xml" },
        "有力な艦隊を中部西海域に展開、オリョール海進出を図れ！" => { tr => "Deploy to World V11-2 in the \\nCentral Western Sea and get at least \\nan S rank on the Boss.", desc => "mst_quest.xml" },
        "有力な艦隊を北方海峡に展開、同海峡の警備を複数回実施せよ！" => { tr => "Deploy to World V8-2 in the North \\nAnchorage Sea and score 3 S rank \\nvictories against the Boss. ", desc => "mst_quest.xml" },
        "有力な艦隊を南方海域正面に展開、敵戦力を撃滅して同海域の制海権を確保せよ！" => { tr => "Deploy to World V9-2 in the South \\nConnecting Sea and Achieve B+ Rank \\nat the Boss Node.", desc => "mst_quest.xml | unclear whether this is V9-1 or V9-2 ???" },
        "機動部隊で「MO作戦」及び「敵母港空襲作戦」を実施、これを成功させよ！" => { tr => "Sortie fleets for the 4th expedition \\n[Operation MO] of the Southern Sea and 2nd expedition \\n[Airstrike Operation Against Enemy Homeport] \\nin the Western Sea!", desc => "mst_quest.xml" },
        "機動部隊出撃！ポートワインを痛打せよ！" => { tr => "Crush Port Wine!", desc => "mst_quest.xml" },
        "機種転換" => { tr => "Model Conversion", desc => "mst_quest.xml" },
        "決戦！「FS作戦」、発動せよ！" => { tr => "Decisive Battle Operation FS!", desc => "mst_quest.xml" },
        "海上の覇者、戦艦を旗艦とした艦隊を編成、これを出撃させよ！" => { tr => "Deploy a BB!", desc => "mst_quest.xml" },
        "海上突入部隊を編成せよ！" => { tr => "Organize the surface attack fleet!", desc => "mst_quest.xml" },
        "海上護衛・対潜作戦を強化せよ！" => { tr => "Strengthen maritime escort \\nanti submarine operations", desc => "mst_quest.xml" },
        "海上護衛遠征及び対潜作戦遠征を継続実施せよ！" => { tr => "Perform the maritime escort and anti-submarine expeditions！", desc => "mst_quest.xml" },
        "海上通商破壊作戦" => { tr => "Maritime Trade Disrupt Operation!", desc => "mst_quest.xml" },
        "深海運河に潜水空母艦隊等を派遣し、同運河への戦略攻撃を実施せよ！" => { tr => "Sortie to World V16-3 in the Deep Sea Canal \\nand defeat the Boss.", desc => "mst_quest.xml" },
        "深海運河戦略攻撃" => { tr => "Abyssal Canal Offensive!", desc => "mst_quest.xml" },
        "演習を強化、艦隊の練度向上に努めよ！" => { tr => "Strengthen fleet discipline", desc => "mst_quest.xml" },
        "潜水艦戦力を中核とした艦隊で中部海域哨戒線へ反復出撃、敵戦力を漸減せよ！" => { tr => "Deploy a fleet with only 3 or more Submarines \\nto world V6-1 in the Central Sea \\nand score an S rank at the Boss node \\n3 times.", desc => "mst_quest.xml" },
        "潜水艦派遣による技術入手を強化せよ！" => { tr => "Strengthen the technology available \\nby submarine dispatch! ", desc => "mst_quest.xml" },
        "潜水艦派遣による海外艦との接触作戦" => { tr => "Contact Foreign Ship through \\nSubmarine Dispatch", desc => "mst_quest.xml" },
        "潜水艦派遣作戦による技術入手の継続！" => { tr => "Obtain Technology through \\nSubmarine Dispatch Operations", desc => "mst_quest.xml" },
        "潜水艦派遣作戦による海外艦救援！" => { tr => "Overseas ship relief by submarine \\ndispatch operations!", desc => "mst_quest.xml" },
        "潜水艦派遣作戦を継続して成功させ、他国製技術の導入に努めよ！" => { tr => "Sortie a fleet for the 4th expedition \\n[Submarine Voyage] of the Southwest Sea and clear it 10 times!", desc => "mst_quest.xml" },
        "潜水艦隊「第六艦隊」を編成せよ！" => { tr => "Form the 6th Submarine Fleet", desc => "mst_quest.xml" },
        "潜水艦隊を編成せよ！" => { tr => "Form a Submarine Fleet!", desc => "mst_quest.xml" },
        "激戦海域である南方海域への「東京急行」系遠征を敢行、これを成功させよ！" => { tr => "Send a fleet of a CL as core \\nand destroyers with drum canisters for \\n[Tokyo Express] expedition in the Southern Sea", desc => "mst_quest.xml" },
        "特I型駆逐艦「吹雪」「白雪」「初雪」「叢雲」4隻による第十一駆逐隊を編成せよ！" => { tr => "Have the 4 Special-type destroyers: Fubuki, \\nShirayuki, Hatsuyuki, and Murakumo in your \\nmain fleet. \\nOne of them should be the flagship.", desc => "mst_quest.xml" },
        "発動！「MI作戦」" => { tr => "Forward! Operation MI!", desc => "mst_quest.xml" },
        "秘書艦を航空母艦「翔鶴」として、同艦に艦攻「村田隊」を配置転換せよ！" => { tr => "Have Shokaku as your Secretary ship \\nand asign the Murata Corps to her.", desc => "mst_quest.xml" },
        "秘書艦を航空母艦「赤城」とし、同艦に艦攻「村田隊」を配属せよ！" => { tr => "Have Akagi as your Secretary ship and \\nasign the Murata Corps to her.", desc => "mst_quest.xml" },
        "空母機動部隊「第三艦隊」を編成せよ！" => { tr => "Organize the Third Fleet Task Force!", desc => "mst_quest.xml" },
        "空母機動部隊を積極運用せよ！" => { tr => "Actively Manage the Aircraft \\nCarrier Division!", desc => "mst_quest.xml" },
        "空母1隻とその護衛艦艇で構成した空母機動部隊を出撃させよ！" => { tr => qq["Deploy a fleet with CV(L) as flagship \\nand 5 DD/CL/AV for the escorts.], desc => "mst_quest.xml" },
        "空母1隻以上を旗艦とし、その護衛艦艇と共に、空母機動部隊を編成せよ！" => { tr => "Have a CV/CVL as a flagship and 3 DD \\nin your main fleet.", desc => "mst_quest.xml" },
        "空母2隻+航空戦艦/航空巡洋艦2隻+駆逐艦2隻の新航空戦隊を編成せよ！" => { tr => "Have 2 CV, 2 BBV/CAV and 2 DD \\nin your fleet.", desc => "mst_quest.xml" },
        "第一艦隊において、「鳥海改ニ」を旗艦とする「三川艦隊」を編成せよ！" => { tr => "Have Choukai Kai-Ni as the flagship and \\nany five of Aoba, Kinugasa, Kako, Furutaka, \\nTenryuu, Yuubari in your main fleet.", desc => "mst_quest.xml" },
        "第一艦隊に編成した「三川艦隊」を南方海域に進出させ、同方面の敵艦隊を撃滅せよ！" => { tr => "With Choukai Kai Ni (flagship) plus 5 ships \\nfrom the following: Furutaka, Kako, Aoba, \\nKinugasa, Yuubari and Tenryuu. Obtain S-rank \\nvictory at the Boss node of World V5-1 in the \\nSouthern Sea.", desc => "mst_quest.xml" },
        "第一艦隊の旗艦に工作艦「明石」を配備、改修工廠の準備を実施せよ！" => { tr => "Have Akashi as your flagship in \\nyour main fleet.", desc => "mst_quest.xml" },
        "第一艦隊旗艦に強い絆を結んだLv.100以上の艦娘を配備した6隻の艦隊を編成せよ！" => { tr => "Organize a fleet of 6 ships with your \\nnewly bonded ship of Lv.100 or more as flagship!", desc => "mst_quest.xml" },
        "第一艦隊旗艦に練度の高い(Lv.90以上～99以下)艦娘を配備して気持ちを整理せよ！" => { tr => "Have a level 90 to 99 ship as your \\nflagship in your first fleet", desc => "mst_quest.xml" },
        "第一艦隊旗艦に練度max「烈風」搭載空母を配備した状態で、「烈風」x1「零戦52型」x1を廃棄せよ！" => { tr => "Equip a rank 7 Reppuu (Strong Gale) on a \\nCarrier secretary in your first fleet, \\nthen scrap 1 Reppuu (Strong Gale) and \\n1 Type 0 Fighter Model 52", desc => "mst_quest.xml" },
        "第一艦隊旗艦に練度max「瑞雲(六三四空)」搭載艦を配備した状態で、「瑞雲12型」x1「瑞雲」x2を廃棄せよ！" => { tr => "Equip a rank 7(max) Zuiun(634 Air Group) \\nto secretary ship (BBV or CAV) and \\nscrap a Zuiun Model 12 and 2 Zuiun.", desc => "mst_quest.xml" },
        "第１次潜水艦派遣作戦を実施、これを成功させよ！" => { tr => "Complete the fourth expedition \\n[Submarine Voyage] in the Southwestern Sea", desc => "mst_quest.xml" },
        "第１次潜水艦派遣作戦" => { tr => "Submarine Dispatch Operations", desc => "mst_quest.xml" },
        "第２次潜水艦派遣作戦を成功させよ！" => { tr => "Complete the fourth expedition \\n[Submarine Voyage] in the Southwestern Sea \\none more time", desc => "mst_quest.xml" },
        "第２次潜水艦派遣作戦" => { tr => "2nd Submarine dispatch Operations", desc => "mst_quest.xml" },
        "第３次及び第４次潜水艦派遣作戦を成功させ、他国製技術の導入に努めよ！" => { tr => "Complete the fourth expedition \\n[Submarine Voyage]in the Southwestern Sea \\ntwo more times", desc => "mst_quest.xml" },
        "第2艦隊で空母機動部隊を編成せよ！" => { tr => "Form a Carrier Task Force in the \\nSecond Fleet!", desc => "mst_quest.xml" },
        "第2艦隊に空母を配備して、空母機動部隊を編成せよ！" => { tr => "Have a CV/CVL and 3 DD in your \\nsecond fleet.", desc => "mst_quest.xml" },
        "第2艦隊を編成せよ！" => { tr => "Form the Second Fleet!", desc => "mst_quest.xml" },
        "精強「航空戦艦」戦隊を編成せよ！" => { tr => qq[Organize a powerful \\n"Aviation Battleship" squadron!], desc => "mst_quest.xml" },
        "精強な「水上反撃部隊」で、中部西海域オリョール海西部に突入！敵艦隊を撃滅せよ！" => { tr => " Kasumi (as flagship), Ashigara, Ooyodo, \\nAsashimo, and Kiyoshimo. You may add 1 other ship. \\nObtain an S-rank victory at the Boss \\nnode of World V11-2 in the Central Western Sea.", desc => "mst_quest.xml" },
        "精強な「水上反撃部隊」を再編成せよ！" => { tr => "Organise a Forced High-speed \\nTransport Fleet!", desc => "mst_quest.xml" },
        "精強な「潜水艦隊」を編成せよ！" => { tr => "Organize a powerful \\nSubmarine Fleet!", desc => "mst_quest.xml" },
        "精鋭「九七式艦攻」部隊の編成" => { tr => "Organize the Elite Type 97 \\nTorpedo Bomber Force", desc => "mst_quest.xml" },
        "精鋭「新型瑞雲」部隊の編成" => { tr => "Organize the elite New-Type \\nZuiun squad!", desc => "mst_quest.xml" },
        "精鋭「第二航空戦隊」抜錨せよ！" => { tr => qq[Elite "2nd Carrier Division" \\nWeigh Anchor!], desc => "mst_quest.xml" },
        "精鋭「艦戦」隊の新編成" => { tr => "Organize the New Elite \\nFighter Force", desc => "mst_quest.xml" },
        "精鋭「艦攻」部隊の編成" => { tr => "Model Conversion: \\nType 97 Torpedo Bomber", desc => "mst_quest.xml" },
        "精鋭「艦爆」部隊の編成" => { tr => "Model Conversion: \\nType 99 Dive Bomber", desc => "mst_quest.xml" },
        "編成した「第三航空戦隊」を近海諸島防衛線に展開、敵侵攻艦隊を捕捉撃滅せよ！" => { tr => "Sortie Zuikaku Kai as flagship, Zuihou, \\nChitose Carrier and Chiyoda Carrier \\n(both as CVL and you can add 2 more ships) to \\nV1-4 in the Naval District Sea and score an \\nS-rank victory at the Boss.", desc => "mst_quest.xml" },
        "編成した「第八駆逐隊」を含む艦隊で出撃し、オリョール海西部の敵艦隊を撃滅せよ！" => { tr => "Sortie Asashio, Michishio, Oshio, Arashio and \\nup to 2 additional ships to V11-2 in the \\nCentral Western Sea and score an \\nS-Rank victory against the Boss.", desc => "mst_quest.xml" },
        "編成した「第十八駆逐隊」を含む艦隊で出撃し、北方海域モーレイ海の敵を撃滅せよ！" => { tr => "Deploy Arare, Kagerou, Kasumi, Shiranui, \\nand 2 additional ships to World V3-1 in the Northern Sea \\nand Score an S Rank Victory against the Boss.", desc => "mst_quest.xml" },
        "練度の高い艦隊で「観艦式」本番を実施する。「観艦式」を成功させよ！" => { tr => "Sortie a fleet for the 6th expedition \\n[Fleet Review] of the Naval District Sea \\nand clear it!", desc => "mst_quest.xml" },
        "練度の高い(Lv.90～99)第一艦隊旗艦で出撃し、オリョール海西部の暁に勝利を刻め！" => { tr => "Obtain S-rank victory at the Boss node \\nof World V11-2 in the Central Western \\nSea with a ship between Lv90 and 99 \\nas the first fleet flagship.", desc => "mst_quest.xml" },
        "航空戦艦「伊勢改」及び「日向改」を基幹戦力とした第四航空戦隊を編成せよ！" => { tr => "Have Ise Kai and Hyuuga Kai in your \\nmain fleet.", desc => "mst_quest.xml" },
        "航空戦艦2隻と航空巡洋艦2隻を基幹とする艦隊で、幌筵泊地沖の敵艦隊を邀撃せよ！" => { tr => "Deploy 2 CAVs, 2 BBVs, and 2 additional \\nships to World V8-4 in the North Anchorage Sea\\nand Score an S rank victory against the Boss.", desc => "mst_quest.xml" },
        "航空戦艦2隻と航空巡洋艦2隻を基幹とする艦隊を編成せよ！" => { tr => "Have 2 BBV and 2 CAV in your main fleet.", desc => "mst_quest.xml" },
        "航空戦艦2隻を基幹とする艦隊を西方海域カレー洋に展開、同海域の敵勢力を撃破せよ！" => { tr => "Have 2 BBV ships in your main fleet \\nand score a victory against \\nWorld V4-1 Boss in the Western Sea", desc => "mst_quest.xml" },
        "航空戦艦2隻を投入する強行資源輸送作戦、「北号作戦」を実施せよ！" => { tr => "Send a fleet with 2 BBVs as \\nits core and DDs to the 4th expedition \\nof the Nansei Islands", desc => "mst_quest.xml" },
        "航空戦艦2隻を投入する強行資源輸送作戦、「北号作戦」を継続実施せよ！" => { tr => "Send a fleet with 2 BBVs as \\nits core and DDs to the 4th \\nexpedition of the Nansei Islands \\nand clear it 3 times.", desc => "mst_quest.xml" },
        "航空母艦を旗艦とした空母機動部隊をポートワイン沖に展開、同地敵戦力を痛打せよ！" => { tr => "With a Carrier as your flagship deploy to \\nWorld V2-4 in the Nansei Islands \\nand score an A rank victory against the Boss.", desc => "mst_quest.xml" },
        "航空母艦2隻(随伴駆逐艦2隻)を基幹とする機動部隊で、カレー洋の敵艦隊を撃滅せよ！" => { tr => "With 2 Carriers (CV, CVL, or Taihou) and 2 DD.\\nYou may add 2 additional ships.\\nObtain S-rank victory at the Boss node \\nof World V4-1 in the Western Sea.", desc => "mst_quest.xml" },
        "航空水上打撃艦隊を編成せよ！" => { tr => "Form a Naval Aviation \\nStrike Fleet!", desc => "mst_quest.xml" },
        "艦娘を「入渠」で修理！" => { tr => qq["First Docking"], desc => "mst_quest.xml" },
        "艦娘大規模「建造」計画！" => { tr => "Strengthen the Fleet by \\nConstructing Ship Girls", desc => "mst_quest.xml" },
        "艦隊の「遠征」を実施せよ！" => { tr => "Fleet Expedition implementation", desc => "mst_quest.xml" },
        "艦隊のさらなる練度向上を図る！今月中に「対抗演習」を4回以上実施せよ！" => { tr => "Continue opposition practice 4 or \\nmore times times this month", desc => "mst_quest.xml" },
        "艦隊の夜戦練度向上に努めよ！" => { tr => "Strive to Increase the Fleet's \\nNight Battle Proficiency!", desc => "mst_quest.xml" },
        "艦隊の対潜戦練度を向上させるため、「対潜戦演習」を実施せよ！" => { tr => "Do the Anti-Submarine Warfare \\nExercise", desc => "mst_quest.xml" },
        "艦隊の総合的な練度向上を図る！「総合演習」を継続実施せよ！" => { tr => "Perform 3 comprehensive fleet \\nexercises", desc => "mst_quest.xml" },
        "艦隊の練度向上に努めよ！" => { tr => "Strive for proficiency!", desc => "mst_quest.xml" },
        "艦隊の脅威となる敵空母群。これを捕捉し、同2隻を確実に撃沈せよ！" => { tr => "Sink 2 Enemy Carriers.", desc => "mst_quest.xml" },
        "艦隊の航空戦練度を向上させるため、「航空戦演習」を実施せよ！" => { tr => "Do the Aerial Battle Exercise!!", desc => "mst_quest.xml" },
        "艦隊の航空戦練度向上を図る！「航空戦演習」を継続実施せよ！" => { tr => "Do the Aerial Battle Exercise \\nthree times", desc => "mst_quest.xml" },
        "艦隊を「遠征」に出発させよ！" => { tr => "Send a fleet on an expedition.", desc => "mst_quest.xml" },
        "艦隊を出撃させ、前衛艦隊を排除し、敵艦隊「主力」を捕捉！これを撃破せよ！" => { tr => "Defeat an enemy fleet.", desc => "mst_quest.xml" },
        "艦隊を出撃させ、敵艦隊と交戦せよ！" => { tr => "Deploy your main fleet on a combat \\nmission.", desc => "mst_quest.xml" },
        "艦隊を出撃させ、敵艦隊を捕捉、これを撃滅せよ！" => { tr => "Defeat an enemy fleet.", desc => "mst_quest.xml" },
        "艦隊を出撃させ、敵輸送艦を捕捉、これを3隻以上撃沈し、敵補給ラインを寸断せよ！" => { tr => "Sink 3 enemy transport ships.", desc => "mst_quest.xml" },
        "艦隊を北方海域に展開、モーレイ海の哨戒を実施せよ！" => { tr => "Sortie to World V3-1 in the \\nNorthern Sea and defeat the Boss.", desc => "mst_quest.xml" },
        "艦隊を南方泊地に進出させ、トラック泊地対潜哨戒を実施せよ！" => { tr => "Deploy to World V7-1 in the South Anchorage Sea and destroy \\nenemy submarines.", desc => "mst_quest.xml" },
        "艦隊を南方連絡海域に全力出撃させ今月中に敵艦隊を撃滅、同方面の制海権を確立せよ！" => { tr => "Achieve 4 A Rank Boss battle victories \\nin a month in the South Anchorage Sea.", desc => "mst_quest.xml" },
        "艦隊を鎮守府海域外縁部に展開、近海諸島防衛線を支援せよ！" => { tr => "Deploy to World V1-4 and Achieve a \\nB+ Rank at the Boss Node.", desc => "mst_quest.xml" },
        "艦隊全力出撃！今月中に艦隊を8回以上出撃、遊弋する敵艦隊を邀撃せよ！" => { tr => "Sortie 8 times before the end of \\nthe month", desc => "mst_quest.xml" },
        "艦隊再突入に備え、艦隊練度向上を図る！「艦隊行動演習」を継続実施せよ！" => { tr => "Do fleet movement exercise 3 times.", desc => "mst_quest.xml" },
        "艦隊同士の「対抗演習」を実施せよ！" => { tr => "Carry Out a Rival Exercise \\nAmong Friends!", desc => "mst_quest.xml" },
        "艦隊同士の模擬戦闘演習を実施する！「対抗演習」を実施せよ！" => { tr => "Do the Rival Exercise!", desc => "mst_quest.xml" },
        "艦隊同士の演習を実施する！今月中に「対抗演習」を5回以上実施せよ！" => { tr => "Do Rival Exercises 5 times", desc => "mst_quest.xml" },
        "艦隊大整備！" => { tr => "The Fleet's Large Maintenance", desc => "mst_quest.xml" },
        "艦隊強化のため、「工廠」で艦娘を今月中に新たに5隻「建造」せよ！" => { tr => "Construct 5 ships", desc => "mst_quest.xml" },
        "艦隊戦の練度を向上させるため、「砲戦演習」を実施せよ！" => { tr => "Do the Shelling Exercise", desc => "mst_quest.xml" },
        "艦隊戦の練度を向上させるため、「砲戦演習」を継続して実施せよ！" => { tr => "Do the Shelling Excercise 3 times", desc => "mst_quest.xml" },
        "艦隊戦の練度を向上させるため、「雷撃戦演習」を実施せよ！" => { tr => "Do the Torpedo Exercise", desc => "mst_quest.xml" },
        "艦隊戦の練度を総合的に向上させるため、「総合演習」を実施せよ！" => { tr => "Do the All-Rounded Exercise", desc => "mst_quest.xml" },
        "艦隊旗艦、戦艦「大和」出撃せよ！" => { tr => "The Battleship Yamato Sorties!", desc => "mst_quest.xml" },
        "艦隊酒保祭り！今月中に各艦に延べ30回以上の補給を実施せよ！" => { tr => "Perform resupply to 30 or more ships!", desc => "mst_quest.xml" },
        "艦隊酒保祭り！" => { tr => "Fleet Bartender's Festival!", desc => "mst_quest.xml" },
        "装備「開発」集中月間！" => { tr => "Intensify the Concentration \\nin Developing Equipment", desc => "mst_quest.xml" },
        "装備の改修強化" => { tr => "Reinforce Equipment \\nImprovement", desc => "mst_quest.xml" },
        "複数の輸送艦を撃沈し、敵の補給路を寸断せよ！" => { tr => "Sink 2 enemy Transport Ships in a \\nmonth.", desc => "mst_quest.xml" },
        "西南海域要塞沖に主力艦隊を投入、敵東洋艦隊を撃破した後、西南要塞攻略を実施せよ！" => { tr => "Deploy to World V10-3 in the \\nSouthwestern Sea and clear it.", desc => "mst_quest.xml" },
        "西南要塞を攻略せよ！" => { tr => "Capture the SW Fortress!", desc => "mst_quest.xml" },
        "西方海域に西部方面派遣艦隊を派遣し、同方面の再集結中の敵増援艦隊を叩け！" => { tr => "Sortie to World V4 in the Western Sea \\nand defeat all 4 Bosses with \\natleast an A rank Victory.", desc => "mst_quest.xml" },
        "西方海域カレー洋深部に突入し、敵秘匿泊地を攻撃、同泊地周辺の敵戦力を痛打せよ！" => { tr => "Deploy to World V4-4 in the \\nWestern Sea and defeat the Boss \\nwith at least an A Rank Victory.", desc => "mst_quest.xml" },
        "西部方面派遣艦隊、出撃せよ！" => { tr => "The Western Dispatch Fleet Sorties！", desc => "mst_quest.xml" },
        "要「熟練搭乗員」任務：第一艦隊旗艦に練度max「九七式艦攻」搭載空母を配備した状態で、「九七式艦攻」x2を廃棄せよ！" => { tr => "Have a Skilled Crew Member in your item page \\nand Equip a rank 7 Type 97 Torpedo Bomber on a \\nCarrier Secretary in your first fleet, \\nthen scrap 2 Type 97 Torpedo Bomber.", desc => "mst_quest.xml" },
        "要「熟練搭乗員」任務：第一艦隊旗艦に練度max「九九式艦爆」搭載空母を配備した状態で、「九九式艦爆」x2を廃棄せよ！" => { tr => "Have a Skilled Crew Member in your item page \\nand Equip a rank 7 Type 99 Dive Bomber on a \\nCarrier Secretary in your first fleet, \\nthen scrap 2 Type 99 Dive Bomber.", desc => "mst_quest.xml" },
        "要「熟練搭乗員」任務：練度max「零戦21型」搭載「鳳翔」を第一艦隊旗艦に配備し、「零戦21型」x2「九六艦戦」x1廃棄せよ！" => { tr => "Have Skilled Crew Member, Equip Rank 7 \\nType 0 Fighter Model 21 on Houshou Secretary, \\nthen scrap 2 Type 0 Fighter Model 21 \\nand a Type 96 Fighter", desc => "mst_quest.xml" },
        "観艦式を実施する。準備として「観艦式予行」を実施、これを2回成功させよ！" => { tr => "Prepare a fleet for the 5th expedition \\n[Fleet Review Rehearsal] of the Naval District \\nSea and clear it 2 times!", desc => "mst_quest.xml" },
        "観艦式を敢行せよ！" => { tr => "Perform the Fleet Review!", desc => "mst_quest.xml" },
        "観艦式予行を実施せよ！" => { tr => "Perform the Fleet Review \\nRehearsal!", desc => "mst_quest.xml" },
        "試作艤装の準備" => { tr => "Preparation of the \\nPrototype Equipment", desc => "mst_quest.xml" },
        "資源の再利用" => { tr => "Recycling Resources", desc => "mst_quest.xml" },
        "資源地帯の制海権を確保せよ！" => { tr => "Control the Sea Resources!", desc => "mst_quest.xml" },
        "軍縮条約対応！" => { tr => "Response to Disarmament Treaty", desc => "mst_quest.xml" },
        "軽巡を旗艦とした水雷戦隊(軽巡最大2隻他駆逐艦)でバシー島沖の敵を撃滅せよ！" => { tr => "Deploy 1-2 CLs (with 1 as flagship) and \\n4-5 DDs, and no ships from any other classes. \\nObtain S-rank victory at the Boss node of \\nWorld V11-1 in the Central Western Sea. ", desc => "mst_quest.xml" },
        "軽巡旗艦の水雷戦隊(軽巡最大3隻他駆逐艦)を急派、近海諸島防衛線で敵を撃滅せよ！" => { tr => "Deploy 1-3 CLs, with one as \\nflagship, and 3-5 DDs to World V1-4 in \\nthe Naval District Sea and \\nobtain an S-Rank at the Boss", desc => "mst_quest.xml" },
        "軽巡洋艦「天龍」「龍田」を基幹戦力とした「第十八戦隊」を4隻以上で新編成せよ！" => { tr => "Have Tenryuu, Tatsuta, and 2 or more \\nother ships in your fleet.", desc => "mst_quest.xml" },
        "軽巡洋艦を旗艦とし、数隻の駆逐艦で構成される「水雷戦隊」を編成せよ！" => { tr => "Have a CL as a flagship and 4 DD in \\nyour main fleet.", desc => "mst_quest.xml" },
        "軽巡洋艦1隻を旗艦とし、複数の駆逐艦からなる水雷戦隊で出撃せよ！" => { tr => "Deploy a fleet with a CL as flagship and \\n3 DD as escorts.", desc => "mst_quest.xml" },
        "軽巡洋艦2隻を擁する高速艦隊を編成せよ！" => { tr => "Have 2 CL in your main fleet.", desc => "mst_quest.xml" },
        "軽巡2隻を擁する隊を編成せよ！" => { tr => "Form a Squadron with Two Light Cruisers!", desc => "mst_quest.xml" },
        "軽快な「水上反撃部隊」を編成せよ！" => { tr => "Organise the Counterattack Squadron!", desc => "mst_quest.xml" },
        "軽空母1～2隻、軽巡1隻、駆逐艦3～4隻の艦隊でバシー島の敵を撃滅せよ！" => { tr => "Deploy 1-2 CVLs, 1 CL, and 3-4 DDs \\nto World V11-1 in the Central Western Sea \\nand score an S rank victory \\nover the Boss!", desc => "mst_quest.xml" },
        "輸送用ドラム缶の準備" => { tr => "Preparing Drum Canisters for \\nTransportation", desc => "mst_quest.xml" },
        "近代化改修を実施して、今月中に2回以上これを成功させよ！" => { tr => "Perform 2 successful modernizations \\nby the end of the month", desc => "mst_quest.xml" },
        "近代化改修を継続実施し、今月中に10回改修を成功させよ！" => { tr => "Perform 10 successful modernizations \\nby the end of the month", desc => "mst_quest.xml" },
        "近海諸島防衛線を支援せよ！" => { tr => "Support the Defense Line!", desc => "mst_quest.xml" },
        "遠洋潜水艦作戦を実施せよ！" => { tr => "Carry Out Distant Ocean \\nSubmarine Operation!", desc => "mst_quest.xml" },
        "遠洋練習航海を実施せよ！" => { tr => "Carry out the Overseas \\nPractice Voyage!", desc => "mst_quest.xml" },
        "重巡洋艦を旗艦とした艦隊を編成、これを出撃させよ！" => { tr => "Deploy a fleet with a CA as its \\nflagship.", desc => "mst_quest.xml" },
        "重巡洋艦2隻を擁する重巡艦隊を編成せよ！" => { tr => "Have 2 CA in your main fleet.", desc => "mst_quest.xml" },
        "金剛型戦艦「金剛」「比叡」「榛名」「霧島」全4隻の高速戦艦を集中配備せよ！" => { tr => "Have Kongou, Hiei, Haruna, and \\nKirishima in your main fleet.", desc => "mst_quest.xml" },
        "錬成を終え再編成「二航戦」を基幹とした艦隊で、敵リランカ島を空襲、破砕せよ！" => { tr => "Deploy Souryuu Kai Ni as the flagship, \\nHiryuu Kai Ni and two DDs to World V4-3 \\nin the Western Sea. You may add 2 other ships. \\nScore an S rank victory against the Boss.", desc => "mst_quest.xml" },
        "鎮守府正面海域に艦隊を出撃させ、敵艦の跳梁を阻止せよ！" => { tr => "Deploy to World V1-1 in the \\nNaval District Sea and clear the stage.", desc => "mst_quest.xml" },
        "鎮守府正面海域を護れ！" => { tr => "Guard the Sea in Front of the \\nNaval Base!", desc => "mst_quest.xml" },
        "鎮守府海域沖に接近する「敵前衛艦隊」を捕捉、これを撃破せよ！" => { tr => "Deploy to World V1-2 (again) in the\\nNaval District Sea and clear the stage", desc => "mst_quest.xml" },
        "鎮守府海域沖に艦隊を出撃させ、同方面の警備を強化せよ！" => { tr => "Deploy to World V1-2 in the\\nNaval District Sea and clear the stage", desc => "mst_quest.xml" },
        "鎮守府海域沖を警備せよ！" => { tr => "Guard the sea near Naval \\nPrefecture!", desc => "mst_quest.xml" },
        "長門型2隻及び扶桑型2隻の計4隻の主力戦艦からなる第二戦隊を編成せよ！" => { tr => "Have Nagato, Mutsu, Fusou, and \\nYamashiro in your main fleet.", desc => "mst_quest.xml" },
        "防空射撃演習を継続実施せよ！" => { tr => "Perform the Air Defense Exercises!", desc => "mst_quest.xml" },
        "陽動作戦！「AL作戦」を実施せよ！" => { tr => "Feint Maneuver, Excute operation AL!", desc => "mst_quest.xml" },
        "雲龍型航空母艦旗艦の機動部隊で南方泊地沖で敵機動部隊を迎撃、これを撃滅せよ！" => { tr => "Deploy Unryuu, Amagi or Katsuragi as \\nflagship with 5 additional ships to the \\nWorld 7-3 in the South Anchorage Sea and \\nscore an S rank victory against the Boss！", desc => "mst_quest.xml" },
        "駆逐艦「霞」を旗艦とした重巡「足柄」及び軽巡1隻駆逐艦4隻の水上挺身部隊を編成せよ！" => { tr => "Have Kasumi as the flagship, Ashigara, \\n1 CL and 3 more DDs in your \\nmain fleet.", desc => "mst_quest.xml" },
        "駆逐艦「霞」旗艦、「足柄」「大淀」「朝霜」「清霜」他の水上反撃部隊を再編成せよ！" => { tr => "Have Sendai Kai Ni as flagship, \\nKawakaze Kai, Shigure Kai Ni and \\ntwo other DDs in your fleet.", desc => "mst_quest.xml" },
        "駆逐艦旗艦の重巡1隻軽巡1隻駆逐艦2隻を含む水上反撃部隊を編成、沖ノ島沖に突入せよ！" => { tr => "Deploy 2 DD(Flag) + 1 CA + 1 CL + 2 ships to \\n Central Western Sea V11-4 and score an \\nS-rank the Boss node.", desc => "mst_quest.xml" },
        "駆逐艦4隻以上で構成される「駆逐隊」を編成せよ！" => { tr => "Have 4 DD in your main fleet.", desc => "mst_quest.xml" },
        "2隻以上の艦で構成される「艦隊」を編成せよ！" => { tr => "Have 2 ships in your main fleet.", desc => "mst_quest.xml" },
        "FS海域方面の戦略拠点攻略を実施する。「FS作戦」を発動、これを完遂せよ！" => { tr => "Sortie to V14-4 in the FS Sea \\nand defeat the Boss with atleast \\na B rank victory.", desc => "mst_quest.xml" },
        "MI海域において「MI作戦」を実施、同作戦を完遂せよ！" => { tr => "Sortie to all four stages of World V12 \\nin the MI Sea and clear them \\nwith atleast an A rank Victory on \\neach Boss.", desc => "mst_quest.xml" },

        # YOMI here are occasionally used to decide code branches, might require care
        "Верный" => { tr => "Verniy", desc => "mst_ship.xml" },
        "あがの" => { tr => "", desc => "mst_ship.xml" },
        "あやなみ" => { tr => "", desc => "mst_ship.xml" },
        "あらし" => { tr => "", desc => "mst_ship.xml" },
        "いそなみ" => { tr => "", desc => "mst_ship.xml" },
        "い168" => { tr => "", desc => "mst_ship.xml" },
        "い401" => { tr => "", desc => "mst_ship.xml" },
        "い58" => { tr => "", desc => "mst_ship.xml" },
        "うみかぜ" => { tr => "", desc => "mst_ship.xml" },
        "うらかぜ" => { tr => "", desc => "mst_ship.xml" },
        "おおい" => { tr => "", desc => "mst_ship.xml" },
        "かざぐも" => { tr => "", desc => "mst_ship.xml" },
        "かしま" => { tr => "", desc => "mst_ship.xml" },
        "かわかぜ" => { tr => "", desc => "mst_ship.xml" },
        "きたかみ" => { tr => "", desc => "mst_ship.xml" },
        "くろしお" => { tr => "", desc => "mst_ship.xml" },
        "さざなみ" => { tr => "", desc => "mst_ship.xml" },
        "しきなみ" => { tr => "", desc => "mst_ship.xml" },
        "すずかぜ" => { tr => "", desc => "mst_ship.xml" },
        "たにかぜ" => { tr => "", desc => "mst_ship.xml" },
        "ちよだ" => { tr => "", desc => "mst_ship.xml" },
        "てるづき" => { tr => "", desc => "mst_ship.xml" },
        "ときつかぜ" => { tr => "", desc => "mst_ship.xml" },
        "とね" => { tr => "", desc => "mst_ship.xml" },
        "のしろ" => { tr => "", desc => "mst_ship.xml" },
        "のわき" => { tr => "", desc => "mst_ship.xml" },
        "はぎかぜ" => { tr => "", desc => "mst_ship.xml" },
        "はつかぜ" => { tr => "", desc => "mst_ship.xml" },
        "はまかぜ" => { tr => "", desc => "mst_ship.xml" },
        "はやすい" => { tr => "", desc => "mst_ship.xml" },
        "みかづき" => { tr => "", desc => "mst_ship.xml" },
        "みくま" => { tr => "", desc => "mst_ship.xml" },
        "みずほ" => { tr => "", desc => "mst_ship.xml" },
        "みゆき" => { tr => "", desc => "mst_ship.xml" },
        "ゆうだち" => { tr => "", desc => "mst_ship.xml" },
        "ゆら" => { tr => "", desc => "mst_ship.xml" },
        "りゅうじょう" => { tr => "", desc => "mst_ship.xml" },
        "マックス・シュルツ" => { tr => "", desc => "mst_ship.xml" },
        "リベッチオ" => { tr => "", desc => "mst_ship.xml" },
        "レーベレヒト・マース" => { tr => "", desc => "mst_ship.xml" },
        "中枢棲姫" => { tr => "Central Princess", desc => "mst_ship.xml" },
        "中間棲姫" => { tr => "Midway Princess", desc => "mst_ship.xml" },
        "初霜改二" => { tr => "Hatsushimo Kai Ni", desc => "mst_ship.xml" },
        "北方棲姫" => { tr => "Northern Princess", desc => "mst_ship.xml" },
        "南方棲戦姫" => { tr => "Southern War Princess", desc => "mst_ship.xml" },
        "南方棲戦鬼" => { tr => "Southern War Demon", desc => "mst_ship.xml" },
        "南方棲鬼" => { tr => "Southern Demon", desc => "mst_ship.xml" },
        "夏夕立改二" => { tr => "Summer Yuudachi Kai Ni", desc => "mst_ship.xml" },
        "夏天龍" => { tr => "Summer Tenryuu", desc => "mst_ship.xml" },
        "夏明石改" => { tr => "Summer Akashi Kai", desc => "mst_ship.xml" },
        "夏時雨改二" => { tr => "Summer Shigure Kai Ni", desc => "mst_ship.xml" },
        "夏曙" => { tr => "Summer Akebono", desc => "mst_ship.xml" },
        "夏朧" => { tr => "Summer Oboro", desc => "mst_ship.xml" },
        "夏村雨改" => { tr => "Summer Murasame Kai", desc => "mst_ship.xml" },
        "夏漣" => { tr => "Summer Sazanami", desc => "mst_ship.xml" },
        "夏潮改二" => { tr => "Summer Ushio Kai Ni", desc => "mst_ship.xml" },
        "夏潮" => { tr => "Summer Ushio", desc => "mst_ship.xml" },
        "夏白露改" => { tr => "Summer Shiratsuyu Kai", desc => "mst_ship.xml" },
        "夏龍田" => { tr => "Summer Tatsuta", desc => "mst_ship.xml" },
        "夏Italia" => { tr => "Summer Italia", desc => "mst_ship.xml" },
        "夏Littorio" => { tr => "Summer Littorio", desc => "mst_ship.xml" },
        "嵐" => { tr => "Arashi", desc => "mst_ship.xml" },
        "年末曙" => { tr => "Year-end Akebono", desc => "mst_ship.xml" },
        "戦艦タ級" => { tr => "Battleship Ta-Class", desc => "mst_ship.xml" },
        "戦艦ル級改" => { tr => "Battleship Ru-Class Kai", desc => "mst_ship.xml" },
        "戦艦ル級" => { tr => "Battleship Ru-Class", desc => "mst_ship.xml" },
        "戦艦レ級" => { tr => "Battleship Re-Class", desc => "mst_ship.xml" },
        "戦艦棲姫" => { tr => "Battleship Princess", desc => "mst_ship.xml" },
        "戦艦水鬼" => { tr => "Battleship Water Demon", desc => "mst_ship.xml" },
        "暁" => { tr => "Akatsuki", desc => "mst_ship.xml" },
        "曙" => { tr => "Akebono", desc => "mst_ship.xml" },
        "朧" => { tr => "Oboro", desc => "mst_ship.xml" },
        "梅雨村雨改" => { tr => "Rainy Season Murasame Kai", desc => "mst_ship.xml" },
        "梅雨祥鳳" => { tr => "Rainy Season Shouhou", desc => "mst_ship.xml" },
        "梅雨高波" => { tr => "Rainy Season Takanami", desc => "mst_ship.xml" },
        "正月夕立改二" => { tr => "New Year Yuudachi Kai Ni", desc => "mst_ship.xml" },
        "正月大淀改" => { tr => "New Year Ooyodo Kai", desc => "mst_ship.xml" },
        "正月大淀" => { tr => "New Year Ooyodo", desc => "mst_ship.xml" },
        "正月明石改" => { tr => "New Year Akashi Kai", desc => "mst_ship.xml" },
        "正月明石" => { tr => "New Year Akashi", desc => "mst_ship.xml" },
        "水母棲姫" => { tr => "Seaplane Tender Princess", desc => "mst_ship.xml" },
        "泊地棲姫" => { tr => "Anchorage Princess", desc => "mst_ship.xml" },
        "泊地棲鬼" => { tr => "Anchorage Demon", desc => "mst_ship.xml" },
        "泊地水鬼" => { tr => "Anchorage Water Demon", desc => "mst_ship.xml" },
        "浮遊要塞" => { tr => "Floating Fortress", desc => "mst_ship.xml" },
        "港湾棲姫" => { tr => "Harbour Princess", desc => "mst_ship.xml" },
        "港湾水鬼" => { tr => "Harbour Water Demon", desc => "mst_ship.xml" },
        "漣" => { tr => "Sazanami", desc => "mst_ship.xml" },
        "潜水カ級" => { tr => "Submarine Ka-Class", desc => "mst_ship.xml" },
        "潜水ソ級" => { tr => "Submarine So-Class", desc => "mst_ship.xml" },
        "潜水ヨ級" => { tr => "Submarine Yo-Class", desc => "mst_ship.xml" },
        "潜水棲姫" => { tr => "Submarine Princess", desc => "mst_ship.xml" },
        "潮" => { tr => "Ushio", desc => "mst_ship.xml" },
        "秋名取" => { tr => "Autumn Natori", desc => "mst_ship.xml" },
        "秋多摩" => { tr => "Autumn Tama", desc => "mst_ship.xml" },
        "秋大淀改" => { tr => "Autumn Ooyodo Kai", desc => "mst_ship.xml" },
        "秋朧" => { tr => "Autumn Oboro", desc => "mst_ship.xml" },
        "秋江風" => { tr => "Autumn Kawakaze", desc => "mst_ship.xml" },
        "秋浜風" => { tr => "Autumn Hamakaze", desc => "mst_ship.xml" },
        "秋浦風" => { tr => "Autumn Urakaze", desc => "mst_ship.xml" },
        "秋球磨" => { tr => "Autumn Kuma", desc => "mst_ship.xml" },
        "秋瑞穂" => { tr => "Autumn Mizuho", desc => "mst_ship.xml" },
        "秋磯風改" => { tr => "Autumn Isokaze Kai", desc => "mst_ship.xml" },
        "秋磯風" => { tr => "Autumn Isokaze", desc => "mst_ship.xml" },
        "秋神通改二" => { tr => "Autumn Jintsuu Kai Ni", desc => "mst_ship.xml" },
        "秋長良" => { tr => "Autumn Nagara", desc => "mst_ship.xml" },
        "秋雷" => { tr => "Autumn Ikazuchi", desc => "mst_ship.xml" },
        "秋電" => { tr => "Autumn Inazuma", desc => "mst_ship.xml" },
        "秋Z1" => { tr => "Autumn Z1", desc => "mst_ship.xml" },
        "空母ヲ級改" => { tr => "Standard Carrier Wo-Class Kai", desc => "mst_ship.xml" },
        "空母ヲ級" => { tr => "Standard Carrier Wo-Class", desc => "mst_ship.xml" },
        "空母棲姫" => { tr => "Aircraft Carrier Princess", desc => "mst_ship.xml" },
        "空母棲鬼" => { tr => "Aircraft Carrier Demon", desc => "mst_ship.xml" },
        "空母水鬼" => { tr => "Aircraft Carrier Water Demon", desc => "mst_ship.xml" },
        "装甲空母姫" => { tr => "Armored Carrier Princess", desc => "mst_ship.xml" },
        "装甲空母鬼" => { tr => "Armored Carrier Demon", desc => "mst_ship.xml" },
        "護衛要塞" => { tr => "Escort Fortress", desc => "mst_ship.xml" },
        "軽巡ツ級" => { tr => "Light Cruiser Tsu-Class", desc => "mst_ship.xml" },
        "軽巡ト級" => { tr => "Light Cruiser To-Class", desc => "mst_ship.xml" },
        "軽巡ヘ級" => { tr => "Light Cruiser He-Class", desc => "mst_ship.xml" },
        "軽巡ホ級" => { tr => "Light Cruiser Ho-Class", desc => "mst_ship.xml" },
        "軽巡棲姫" => { tr => "Light Cruiser Princess", desc => "mst_ship.xml" },
        "軽巡棲鬼" => { tr => "Light Cruiser Demon", desc => "mst_ship.xml" },
        "軽母ヌ級" => { tr => "Light Carrier Nu-Class", desc => "mst_ship.xml" },
        "輸送ワ級" => { tr => "Transport Ship Wa-Class", desc => "mst_ship.xml" },
        "運河棲姫" => { tr => "Canal Princess", desc => "mst_ship.xml" },
        "重巡ネ級" => { tr => "Heavy Cruiser Ne-Class", desc => "mst_ship.xml" },
        "重巡リ級改" => { tr => "Heavy Cruiser Ri-Class Kai", desc => "mst_ship.xml" },
        "重巡リ級" => { tr => "Heavy Cruiser Ri-Class", desc => "mst_ship.xml" },
        "防空棲姫" => { tr => "Air Defense Princess", desc => "mst_ship.xml" },
        "離島棲鬼" => { tr => "Isolated Island Demon", desc => "mst_ship.xml" },
        "雷巡チ級" => { tr => "Torpedo Cruiser Chi-Class", desc => "mst_ship.xml" },
        "雷" => { tr => "Ikazuchi", desc => "mst_ship.xml" },
        "電" => { tr => "Inazuma", desc => "mst_ship.xml" },
        "霞" => { tr => "Kasumi", desc => "mst_ship.xml" },
        "霰" => { tr => "Arare", desc => "mst_ship.xml" },
        "響" => { tr => "Hibiki", desc => "mst_ship.xml" },
        "飛行場姫" => { tr => "Airfield Princess", desc => "mst_ship.xml" },
        "駆逐イ級後期型" => { tr => "Destroyer I-Class Late Model", desc => "mst_ship.xml" },
        "駆逐イ級" => { tr => "Destroyer I-Class", desc => "mst_ship.xml" },
        "駆逐ニ級後期型" => { tr => "Destroyer Ni-Class Late Model", desc => "mst_ship.xml" },
        "駆逐ニ級" => { tr => "Destroyer Ni-Class", desc => "mst_ship.xml" },
        "駆逐ハ級後期型" => { tr => "Destroyer Ha-Class Late Model", desc => "mst_ship.xml" },
        "駆逐ハ級" => { tr => "Destroyer Ha-Class", desc => "mst_ship.xml" },
        "駆逐ロ級後期型" => { tr => "Destroyer Ro-Class Late Model", desc => "mst_ship.xml" },
        "駆逐ロ級" => { tr => "Destroyer Ro-Class", desc => "mst_ship.xml" },
        "駆逐棲姫" => { tr => "Destroyer Princess", desc => "mst_ship.xml" },
        "-" => { tr => "", desc => "mst_ship.xml" },
        "Valentine叢雲" => { tr => "Valentine Murakumo", desc => "mst_ship.xml" },
        "Valentine如月" => { tr => "Valentine Kisaragi", desc => "mst_ship.xml" },
        "Valentine時雨改二" => { tr => "Valentine Shigure Kai Ni", desc => "mst_ship.xml" },
        "Valentine浜風" => { tr => "Valentine Hamakaze", desc => "mst_ship.xml" },
        "Valentine睦月" => { tr => "Valentine Mutsuki", desc => "mst_ship.xml" },
        "Xmas時雨改二" => { tr => "Xmas Shigure Kai Ni", desc => "mst_ship.xml" },
        "Xmas漣" => { tr => "Xmas Sazanami", desc => "mst_ship.xml" },
        "Xmas那珂改二" => { tr => "Xmas Naka Kai Ni", desc => "mst_ship.xml" },
        "Xmas那珂" => { tr => "Xmas Naka", desc => "mst_ship.xml" },
        "Xmas龍驤改二" => { tr => "Xmas Ryuujou Kai Ni", desc => "mst_ship.xml" },
        "Xmas龍驤" => { tr => "Xmas Ryuujou", desc => "mst_ship.xml" },
        "elite" => { tr => "", desc => "mst_ship.xml" },
        "flagship" => { tr => "", desc => "mst_ship.xml" },

        "三式潜航輸送艇" => { tr => "Type 3 Submergence Transport Vehicle", desc => "mst_ship_class.xml" },
        "伊勢型" => { tr => "Ise-class", desc => "mst_ship_class.xml" },
        "初春型" => { tr => "Hatsuharu-class", desc => "mst_ship_class.xml" },
        "利根型" => { tr => "Tone-class", desc => "mst_ship_class.xml" },
        "加賀型" => { tr => "Kaga-class", desc => "mst_ship_class.xml" },
        "千歳型" => { tr => "Chitose-class", desc => "mst_ship_class.xml" },
        "古鷹型" => { tr => "Furutaka-class", desc => "mst_ship_class.xml" },
        "吹雪型" => { tr => "Fubuki-class", desc => "mst_ship_class.xml" },
        "夕張型" => { tr => "Yuubari-class", desc => "mst_ship_class.xml" },
        "夕雲型" => { tr => "Yuugumo-class", desc => "mst_ship_class.xml" },
        "大和型" => { tr => "Yamato-class", desc => "mst_ship_class.xml" },
        "大淀型" => { tr => "Ooyodo-class", desc => "mst_ship_class.xml" },
        "大鯨型" => { tr => "Taigei-class", desc => "mst_ship_class.xml" },
        "大鳳型" => { tr => "Taihou-class", desc => "mst_ship_class.xml" },
        "天龍型" => { tr => "Tenryuu-class", desc => "mst_ship_class.xml" },
        "妙高型" => { tr => "Myoukou-class", desc => "mst_ship_class.xml" },
        "島風型" => { tr => "Shimakaze-class", desc => "mst_ship_class.xml" },
        "川内型" => { tr => "Sendai-class", desc => "mst_ship_class.xml" },
        "巡潜乙型改二" => { tr => "Junsen Type B Kai Ni-class", desc => "mst_ship_class.xml" },
        "巡潜乙型" => { tr => "Junsen Type B-class", desc => "mst_ship_class.xml" },
        "巡潜３型" => { tr => "Junsen 3-class", desc => "mst_ship_class.xml" },
        "扶桑型" => { tr => "Fusou-class", desc => "mst_ship_class.xml" },
        "改風早型" => { tr => "Kazahaya Kai-class", desc => "mst_ship_class.xml" },
        "明石型" => { tr => "Akashi-class", desc => "mst_ship_class.xml" },
        "暁型" => { tr => "Akatsuki-class", desc => "mst_ship_class.xml" },
        "最上型" => { tr => "Mogami-class", desc => "mst_ship_class.xml" },
        "朝潮型" => { tr => "Asashio-class", desc => "mst_ship_class.xml" },
        "海大VI型" => { tr => "HaidaVI-class", desc => "mst_ship_class.xml" },
        "潜特型" => { tr => "Sentoku-class", desc => "mst_ship_class.xml" },
        "特殊船丙型" => { tr => "Hei-class", desc => "mst_ship_class.xml" },
        "球磨型" => { tr => "Kuma-class", desc => "mst_ship_class.xml" },
        "瑞穂型" => { tr => "Mizuho-class", desc => "mst_ship_class.xml" },
        "白露型" => { tr => "Shiratsuyu-class", desc => "mst_ship_class.xml" },
        "睦月型" => { tr => "Mutsuki-class", desc => "mst_ship_class.xml" },
        "祥鳳型" => { tr => "Shouhou-class", desc => "mst_ship_class.xml" },
        "秋月型" => { tr => "Akizuki-class", desc => "mst_ship_class.xml" },
        "秋津洲型" => { tr => "Akitsushima-class", desc => "mst_ship_class.xml" },
        "綾波型" => { tr => "Ayanami-class", desc => "mst_ship_class.xml" },
        "翔鶴型" => { tr => "Shoukaku-class", desc => "mst_ship_class.xml" },
        "蒼龍型" => { tr => "Souryuu-class", desc => "mst_ship_class.xml" },
        "赤城型" => { tr => "Akagi-class", desc => "mst_ship_class.xml" },
        "金剛型" => { tr => "Kongou-class", desc => "mst_ship_class.xml" },
        "長良型" => { tr => "Nagara-class", desc => "mst_ship_class.xml" },
        "長門型" => { tr => "Nagato-class", desc => "mst_ship_class.xml" },
        "阿賀野型" => { tr => "Agano-class", desc => "mst_ship_class.xml" },
        "陽炎型" => { tr => "Kagerou-class", desc => "mst_ship_class.xml" },
        "雲龍型" => { tr => "Unryuu-class", desc => "mst_ship_class.xml" },
        "霧の艦隊" => { tr => "Fleet of Fog", desc => "mst_ship_class.xml" },
        "青葉型" => { tr => "Aoba-class", desc => "mst_ship_class.xml" },
        "飛鷹型" => { tr => "Hiyou-class", desc => "mst_ship_class.xml" },
        "飛龍型" => { tr => "Hiryuu-class", desc => "mst_ship_class.xml" },
        "香取型" => { tr => "Katori-class", desc => "mst_ship_class.xml" },
        "高雄型" => { tr => "Takao-class", desc => "mst_ship_class.xml" },
        "鳳翔型" => { tr => "Houshou-class", desc => "mst_ship_class.xml" },
        "龍驤型" => { tr => "Ryuujou-class", desc => "mst_ship_class.xml" },
        "龍鳳型" => { tr => "Ryuuhou-class", desc => "mst_ship_class.xml" },
        "Admiral Hipper級" => { tr => "Admiral Hipper-class", desc => "mst_ship_class.xml" },
        "Bismarck級" => { tr => "Bismarck-class", desc => "mst_ship_class.xml" },
        "Graf Zeppelin級" => { tr => "Graf Zeppelin-class", desc => "mst_ship_class.xml" },
        "Iowa級" => { tr => "Iowa-class", desc => "mst_ship_class.xml" },
        "Maestrale級" => { tr => "Maestrale-class", desc => "mst_ship_class.xml" },
        "UボートIXC型" => { tr => "Type IXC U-boat-class", desc => "mst_ship_class.xml" },
        "V.Veneto級" => { tr => "V.Veneto-class", desc => "mst_ship_class.xml" },
        "Z1型" => { tr => "Z1-class", desc => "mst_ship_class.xml" },

        "あ、あの…磯波と申します。\\nよろしくお願いいたします。" => { tr => "U-um... my name is Isonami.\\nPleased to meet you.", desc => "mst_shiptext.xml" },
        "あたいは夕雲型駆逐艦、その十六番艦、朝霜さ。よーく覚えとおくんだよ。\\n戦況が悪化した頃にデビューしたんだ。でも、その末期の戦線を、文字通り縦横無尽に駆けまわったぜ。やるだけ…やったさ！" => { tr => "I'm the 16th Destroyer of the Yuugumo Class, Asashimo. Remember it well.\\nI made my debut when the war situation got worse. I ran about freely at the front lines of the end stage. I did...all I could!", desc => "mst_shiptext.xml" },
        "あたし、文月っていうの。\\nよろしくぅ～。" => { tr => "I'm Fumizuki.\\nNice to meet you.", desc => "mst_shiptext.xml" },
        "あたしが水上機母艦、秋津洲よ！\\nそう、大型飛行艇の運用支援や洋上補給のために建造された、飛行艇母艦。え、迷彩が厚化粧？　ホントに失礼かも。二式大艇ちゃんはあげないからね！" => { tr => qq[I'm the Seaplane Tender Akitsushima!\\nThat's right, I'm a Flying Boat Tender constructed for the sake of assisting the Large-sized Flying Boat and refueling at sea, among other things! Eh? Is my "makeup" too heavy? You're rude, maybe! I'm not letting you have Type 2 Taitei-chan, 'kay!], desc => "mst_shiptext.xml" },
        "あなたが司令官ですね。三日月です。\\nどうぞお手柔らかにお願いします。" => { tr => "You're the commander, right? I'm Mikazuki.\\nI hope you welcome me warmly into your fleet.", desc => "mst_shiptext.xml" },
        "あなたが提督？ふうん。いいけど。\\n伊勢型戦艦２番艦、日向よ。一応覚えておいて。" => { tr => "You're the Admiral? I see. Anyway. Second\\nship of the Ise class, Hyuuga. Remember\\nme, if you would.", desc => "mst_shiptext.xml" },
        "あの……軽巡洋艦、神通です。\\nどうか、よろしくお願い致します……" => { tr => "Uh, I'm the Light Cruiser, Jintsuu.\\nSo, I would appreciate your favor...", desc => "mst_shiptext.xml" },
        "あら。自己紹介まだでしたかー。\\n私、荒潮です。" => { tr => "Oh, I haven't introduced myself yet, have I?\\nMy name is Arashio.", desc => "mst_shiptext.xml" },
        "あんたが司令官ね。\\nま、せいぜい頑張りなさい！" => { tr => "So you're the commander, huh.\\nWell, you better try your hardest!", desc => "mst_shiptext.xml" },
        "いい風きてる？\\n次世代型駆逐艦のプロトタイプ、\\nあたし、天津風の出番ね。" => { tr => "Is a nice breeze coming? It's time for me,\\nthe next generation destroyer prototype,\\nAmatsukaze, to debut.", desc => "mst_shiptext.xml" },
        "うち、浦風じゃ、よろしくね！" => { tr => "It's me, Urakaze, nice to meet 'ya!", desc => "mst_shiptext.xml" },
        "おはようございます、改装済み大鳳です。\\n甲板装甲を強化、防御力もさらに向上、\\n提督のために…露天駐機で艦載機数も充実です！" => { tr => "Good morning! It's the remodelled Taihou!\\nReinforced deck armour! Even higher\\ndefense! An increase in open-air planes\\nto boost capacity just for you, Admiral!", desc => "mst_shiptext.xml" },
        "おはようございます！\\n航空機搭載給油艦、速吸、頑張ります！\\n艦載機も出撃用意、ばっちりです！" => { tr => "Good morning!\\nAircraft carrying oiler, Hayasui, will do her best.\\nPreparations for sortie of aircraft are perfect!", desc => "mst_shiptext.xml" },
        "おはようございます！\\n航空機搭載給油艦、速吸です！\\n皆さんのサポート、頑張ります！" => { tr => "Good morning!\\nI'm Hayasui, an oiler equipped with seaplanes!\\nI'll do my best to support everyone!", desc => "mst_shiptext.xml" },
        "おはようございます～。\\n朝潮型駆逐艦六番艦、山雲、入ります～。" => { tr => "Good morning. Asashio Destroyer number\\nsix, Yamagumo. Please treat me well!", desc => "mst_shiptext.xml" },
        "おはようございます～。\\n朝潮型駆逐艦六番艦、山雲です～。\\nよろしくお願い致します～。" => { tr => "Good morning.\\nAsashio Destroyer number six, Yamagumo.\\nPlease treat me well!", desc => "mst_shiptext.xml" },
        "きたきたぁ！　鬼怒、いよいよ到着しましたよ！" => { tr => "Yeah, yeah, yeah!\\nFinally, Kinu has arrived!", desc => "mst_shiptext.xml" },
        "こ、こんにちは、軽巡、阿武隈です。" => { tr => "H-hello, I'm Abukuma, a light cruiser.", desc => "mst_shiptext.xml" },
        "こんにちは、白露型駆逐艦「夕立」よ。\\nよろしくね！" => { tr => "Hi, I'm Yuudachi, a Shiratsuyu-class\\ndestroyer. Nice to meet you!", desc => "mst_shiptext.xml" },
        "こんにちは。高雄です。\\n貴方のような素敵な提督で良かったわ。" => { tr => "Good day. I'm Takao. It's great that\\nyou look like an excellent Admiral.", desc => "mst_shiptext.xml" },
        "こんにちはー。軽巡洋艦、大井です。\\nどうぞ、よろしくお願い致しますね。" => { tr => "Hello. I'm Light Cruiser Ooi. Pleased\\nto make your acquaintance.", desc => "mst_shiptext.xml" },
        "こんにちはーっ！\\n最新鋭軽巡の阿賀野でーすっ。ふふ。" => { tr => "Hello! I'm the latest light cruiser Agano.\\n*giggle*", desc => "mst_shiptext.xml" },
        "こんにちは！陽炎型駆逐艦、舞風です。\\n暗い雰囲気は苦手です！" => { tr => "Hello! Kagerou-class destroyer, Maikaze!\\nI'm not good in gloomy atmospheres!", desc => "mst_shiptext.xml" },
        "こんにちは！ 伊五十八です。\\nゴーヤって呼んでもいいよ！苦くなんかないよぉ！" => { tr => "Hello! I-58 here!\\nYou can call me Goya. I'm not bitter!", desc => "mst_shiptext.xml" },
        "こんにちわあ。潜水母艦大鯨です。\\n不束者ですが、よろしくお願い致します。" => { tr => "Good day, I'm Submarine Tender Taigei.\\nI may be inexperienced, but I am glad to\\nbe of service.", desc => "mst_shiptext.xml" },
        "ごきげんよう、三隈です。\\n最上さんはどこにいらっしゃるのかしら？" => { tr => "Greetings, I'm Mikuma.\\nI wonder where Mogami could be hiding?", desc => "mst_shiptext.xml" },
        "ごきげんよう、\\nわたくしが重巡、熊野ですわ！" => { tr => "Good day to you.\\nI am the heavy cruiser Kumano.", desc => "mst_shiptext.xml" },
        "ごきげんよう。\\n特型駆逐艦、綾波と申します。" => { tr => "Nice to meet you.\\nI'm Ayanami, a special class destroyer.", desc => "mst_shiptext.xml" },
        "そう…私が大鳳。\\n出迎え、ありがとうございます。\\n提督…貴方と機動部隊に勝利を！" => { tr => "Yes... I am Taihou. Thank you for your\\nreception. Admiral... I shall bring victory\\nto you and your task force!", desc => "mst_shiptext.xml" },
        "ちわ！涼風だよ。\\n私が艦隊に加われば百人力さ！" => { tr => "'ello! I'm Suzukaze. If I join the fleet\\nit will be equivalent to 100 ships!", desc => "mst_shiptext.xml" },
        "どうも！夕雲型の最終艦、清霜です。\\n到着遅れました、よろしくお願いです！" => { tr => "Hello! Last of the Yuugumo-class, it's Kiyoshimo!\\nI'm a bit late, but I'll be in your care!", desc => "mst_shiptext.xml" },
        "ども、恐縮です、青葉ですぅ！\\n一言お願いします！" => { tr => "Hi, thanks for your time, I'm Aoba!\\nPlease can I have some words!", desc => "mst_shiptext.xml" },
        "はいはーい！白露型駆逐艦「村雨」だよ。\\nみんな、よろしくね！" => { tr => "Yes, yes! I'm the Shiratsuyu-class destroyer\\n'Murasame'! Everyone, nice to meet you!", desc => "mst_shiptext.xml" },
        "はじめまして、利根型２番艦、筑摩と申します。" => { tr => "Pleased to meet you.\\n2nd of the Tone-class, Chikuma.", desc => "mst_shiptext.xml" },
        "はじめまして吹雪です。\\nよろしくお願い致します。" => { tr => "Nice to meet you, I'm Fubuki.\\nThanks for having me today as well.", desc => "mst_shiptext.xml" },
        "はーい、お待たせ？\\n兵装実験軽巡、夕張、到着いたしました！" => { tr => "Okay, thanks for waiting! The experimental\\narmament cruiser 'Yuubari' has arrived!", desc => "mst_shiptext.xml" },
        "はーいっ！衣笠さんの登場よ！\\n青葉ともども、よろしくね！" => { tr => "Yes, It's Miss Kinugasa's debut! Together\\nwith Aoba, take good care of me!", desc => "mst_shiptext.xml" },
        "ぴゃん♪　阿賀野型軽巡四番艦、酒匂です！\\n司令、よろしくね！" => { tr => "Pyan♪ The fourth Agano class Light Cruiser,\\nSakawa! Commander, nice to meet you!", desc => "mst_shiptext.xml" },
        "また…来てしまったのね、この海に。\\n夕雲型駆逐艦、早霜…着任しました。" => { tr => "I've... come again, to these seas.\\nYuugumo-class destroyer, Hayashimo... reporting for duty.", desc => "mst_shiptext.xml" },
        "まるゆは海軍工廠出身じゃないので、同郷のお友達がいないんです。皆さんとちょっと違うっていうか…木曾さんには第一声で「何だお前、潜れるのか？」なんて言われちゃうし…まるゆ、ここで上手くやっていけるのかなあ…。" => { tr => qq[Maruyu isn't from the Navy shipyards, so I don't have any friends from home. I'm a little different from everyone else... I mean, the first thing Kiso-san said to me was "What are you. Can you actually go underwater?"... I'm starting to wonder if Maruyu can survive out here...], desc => "mst_shiptext.xml" },
        "やったぁ！ でたっぴょん！ 卯月でっす！ \\nうーちゃんって呼ばれてまっす！" => { tr => "Yay! I arrived-pyon! My name is Uzuki,\\nyou can call me U-chan!", desc => "mst_shiptext.xml" },
        "やっと会えた！　陽炎よ。\\nよろしくねっ！" => { tr => "We've finally met! I'm Kagerou.\\nTreat me well!", desc => "mst_shiptext.xml" },
        "や！　陽炎型駆逐艦、十六番艦、嵐だ！\\n司令、よろしくな！　逢えて嬉しいぜ！" => { tr => "Yo, I'm the 16th Kagerou-class Destroyer, Arashi!\\nCommander, take care of me, 'kay? It's great 'ta meet 'ya!", desc => "mst_shiptext.xml" },
        "よお！　あたいは、夕雲型駆逐艦、十六番艦の朝霜さ。\\n覚えといてよ。忘れんなよ……なあ！" => { tr => "Yo! I'm Asashimo, 16th Destroyer of the Yuugumo Class.\\nPlease remember. Don't forget about me... ok?", desc => "mst_shiptext.xml" },
        "よお！　夕雲型駆逐艦、十六番艦の朝霜、\\nいつでも出撃できんぜ。\\nまだまだ、暴れよう…な、司令！" => { tr => "Yo! It's the 16th Destroyer of the\\nYuugumo-class, Asashimo. Always ready,\\nnever stop rampaging! Eh, commander?", desc => "mst_shiptext.xml" },
        "よ！アタシ、摩耶ってんだ、よろしくな。" => { tr => "Yo! Name's Maya, nice to meet you.", desc => "mst_shiptext.xml" },
        "わらわが初春じゃ。\\nよろしく頼みますぞ。" => { tr => "We are Hatsuharu.\\nWe thank you in advance.", desc => "mst_shiptext.xml" },
        "わ！びっくりした！\\n私、ドイツ生まれの重巡、プリンツ・オイゲン。\\nアドミラル・ヒッパー級3番艦です。\\nビスマルク姉さんとライン演習作戦に参加しました。\\n幸運艦…そう？　この海でも戦い抜きます！" => { tr => "Oh! You surprised me! I, German-born\\nheavy cruiser, Prinz Eugen! Admiral Hipper\\nclass, third ship. With big sister Bismarck,\\nI took part in Operation Rheinübung.\\nLucky fleet...really? I will keep fighting\\nin this sea too!", desc => "mst_shiptext.xml" },
        "ん？あぁ、望月でーす。" => { tr => "Hmm? Ah, I'm Mochizuki.", desc => "mst_shiptext.xml" },
        "アタシ、綾波型駆逐艦「朧」。\\n誰にも負けない…たぶん……" => { tr => "I'm the Ayanami-class destroyer Oboro.\\nI won't lose to anyone... Probably...", desc => "mst_shiptext.xml" },
        "アタシの名は敷波。\\n以後よろしく。" => { tr => "I'm Shikinami.\\nI'll be in your care.", desc => "mst_shiptext.xml" },
        "アタシは軽巡、北上。\\nまーよろしく。" => { tr => "I'm Light Cruiser Kitakami, nice ta meet 'ya.", desc => "mst_shiptext.xml" },
        "イタリア海軍の駆逐艦、マエストラーレ級三番艦、リベッチオです。提督さん、よろしくね！\\nえ、タラント空襲？余裕です！船団護衛でも頑張りたかったけど…救助中はやめてほしいよ～！" => { tr => "Italian Navy Destroyer, 3rd Maestrale-class,\\nLibeccio. Admiral, Nice to meet you! What,\\nBattle of Taranto? That's easy! Although\\nI wanted to do my best in escort fleet,\\nI wanted to quit in the middle of the rescue.", desc => "mst_shiptext.xml" },
        "イタリア生まれの最新鋭艦よ。ヴィットリオ・ヴェネト級戦艦４番艦、ローマ。\\nそうね、あの時は姉さんと一緒だったわ。あの化け物を落とされた日。忘れないわ、あの痛み。絶対忘れないんだから。" => { tr => "The Italian-made, state of the art warship. Fourth of the Vittorio Veneto class battleships, Roma.\\nYes, I was together with my elder sister at that time. The day those monsters were dropped. I won't forget that pain. I absolutely won't forget it.", desc => "mst_shiptext.xml" },
        "オレの名は天龍。\\nフフフ、怖いか？" => { tr => "My name is Tenryuu.\\nFufufu, ya scared?", desc => "mst_shiptext.xml" },
        "カタパルトをお初装備の衣笠さんよ、よろしくね。\\nウェーク島攻略や珊瑚海海戦、そして、ソロモン海のアイアンボトムサウンドでも大活躍！\\nでも…　飛行機っての？あれはちょっと嫌ね。" => { tr => "First to have a catapult equipped,\\nMiss Kinugasa! Great to meet you.\\nI performed magnificently in the capture\\nof Wake Island and the Battle of the Coral\\nSea, and even the Solomon's Ironbottom\\nSound! But... planes, you know?\\nI'm not really a fan...", desc => "mst_shiptext.xml" },
        "クマー。\\nよろしくだクマ。" => { tr => "Kumaa.\\nNice to meet you, kuma.", desc => "mst_shiptext.xml" },
        "グーテンターク…あ、違った、ごめんなさいね…\\n「はち」と呼んでくださいね。" => { tr => qq[Guten Tag... ah, my mistake...\\nSorry, please call me "hachi".], desc => "mst_shiptext.xml" },
        "コンパクトボディに充実の重武装を施した実験艦的存在の軽巡、夕張です。私の残したデータが、様々な重武装新鋭艦開発の元になったんだから！\\n機関室に一発？何いってんの？\\nほんと…失礼しちゃうわ。" => { tr => "A compact body enriched with heavy arms,\\nthe experimental light cruiser, Yuubari.\\nThe data that I left behind, those various\\nnewly-developed naval heavy weapons were\\ncertainly the cause! A shot in the engine\\nroom? What are you talking about?\\nReally... how rude you are.", desc => "mst_shiptext.xml" },
        "スラバヤ沖海戦で、撃沈した敵艦の乗員の救助に努めた後、キスカ、ソロモン、ニューギニア、アッツ島など、各戦域を転戦しました…\\n頑張ったの…です…。" => { tr => "After helping to save the crew of the enemy\\nship sunk at Surabaya, I fought at Kiska,\\nSolomon, New Guinea and Attu Island one\\nafter the other... I did my best...", desc => "mst_shiptext.xml" },
        "スラバヤ沖海戦では駆逐艦電と一緒に協力して、沈没した敵艦隊の生存者の救助に当たったのよ。\\nただ強いだけじゃ、だめだと思うの。\\nね、司令官！" => { tr => "Together with my fellow destroyer Inazuma\\nat the Battle of Surabaya, we rescued the\\nsurvivors of the sunk enemy's ships.\\nI think that strength just isn't enough.\\nDon't you agree, Commander?!", desc => "mst_shiptext.xml" },
        "ダイエットして空母になった千歳です！\\n足も速くなったの。本でも出そうかしら！" => { tr => "I'm the girl who took a diet and became an\\naircraft carrier, Chitose. I even got faster.\\nMaybe I should write a book about it.", desc => "mst_shiptext.xml" },
        "ドイツの誇るビスマルク級超弩級戦艦のネームシップ、それが私よ。\\nドイツらしい重厚かつ美しいデザインでしょう？\\nいいのよ、もっと褒めても。\\nこの海でも縦横無尽に活躍するわ。期待しなさい！" => { tr => "It is I, the pride of Deutschland, the\\nnameship of the Bismarck super\\ndreadnoughts. Germanic designs are just\\nbeautiful and dignified, no? It's alright,\\nyou can praise me more. I shall be operating\\nfar and wide throughout this ocean. You can\\nexpect much from me!", desc => "mst_shiptext.xml" },
        "ドイツ海軍のUボート、潜水艦U-511……です。\\n頑張って、ここまで来ました。\\n皆と仲良くなれたら…いいなって…ここの文化に馴染めたらいいなって…思います。" => { tr => "I'm the... German Navy U-Boat, U-511.\\nI worked hard to come here. If I could be\\nfriends... with everyone... and get\\nacquainted with this place's culture...\\nI think that'd be nice.", desc => "mst_shiptext.xml" },
        "ドイツ海軍のUボート、U-511を日本海軍式に改装して運用した、呂号第500潜水艦です。\\n舞鶴を母港として運用されました。実戦には出なかったんだけど、対潜部隊の訓練などで活躍しました、はい！" => { tr => "I'm RO-500, the Kriegsmarine U-boat U-511 remodeled for use by the Japanese Navy.\\nI was operated from my home port of Maizuru. I may not have seen actual battle, but I did train hard with a counter-submarine fleet, yes!", desc => "mst_shiptext.xml" },
        "ドイツ海軍所属、潜水艦U-511です。\\nユーとお呼びください。\\n少し遠出してきました。よろしくお願い致します……。" => { tr => "Submarine U-511 of the German Navy, please call me Yuu.\\nI've come a long way, so I'll be in your care...", desc => "mst_shiptext.xml" },
        "ドイツ生まれの駆逐艦、その本格的な大型駆逐艦の一番艦だよ。\\n高温高圧缶や機関部のシフト配置など、技術の国ならではの設計になっているんだ。あまり外洋での艦隊戦は得意じゃないけど…　頑張るよ！" => { tr => "The German-born destroyer, the first\\ngenuine large-type. This shifted high\\ntemperature, high pressure engine, it could\\nonly have been designed in the country of\\ntechnical skills! I'm not so great at\\nopen-sea warfare though... I'll do my best!", desc => "mst_shiptext.xml" },
        "ドイツ1934年計画型駆逐艦、その三番艦よ。\\n生存性の高い設計の本格的駆逐艦だけれど…新型のタービンは少し整備に難もあるけれど。\\n今度は…大丈夫。" => { tr => "Zerstörer 1934 program, third ship. I was\\ndesigned with good survivability, but...\\nThese new turbines have a small issue with\\nmaintenance. This time... I shall be alright.", desc => "mst_shiptext.xml" },
        "パスタの国で生まれました。ヴィットリオ・ヴェネト級戦艦２番艦、リットリオです。\\n高速で兵装も充実した新鋭高速戦艦です。妹の\\nローマ共々、どうぞよろしくお願い致します。" => { tr => "I was born in the country of Pasta. Second ship of the Vittorio Veneto class battleship, Littorio.\\nArmed with high speed armaments and a state-of-the-art fast battleship.\\nI have my sister, Roma, with me. It's a pleasure to meet you.", desc => "mst_shiptext.xml" },
        "パスタの国で生まれました。ヴィットリオ・ヴェネト級戦艦２番艦、リットリオ改め、イタリアです。\\n高速で兵装も充実した新鋭高速戦艦です。妹の\\nローマ共々、どうぞよろしくお願い致します。" => { tr => "I was born in the country of Pasta. Second ship of the Vittorio Veneto class battleship, Littorio.\\nArmed with high speed armaments and a state-of-the-art fast battleship.\\nI have my sister, Roma, with me. It's a pleasure to meet you.", desc => "mst_shiptext.xml" },
        "フッ、随分待たせたようだな……。\\n大和型戦艦二番艦、武蔵。参る！" => { tr => "Hmpf, it seems that I've kept you waiting...\\nSecond of the Yamato-class battleships,\\nMusashi, has arrived!", desc => "mst_shiptext.xml" },
        "ブォンジョールノ！\\nマエストラーレ級駆逐艦、リベッチオです。\\nリベでいいよ。提督さん、よろしくね！" => { tr => "Buon giorno! I'm Libeccio, a\\nMaestrale-class destroyer!\\nJust Libe is fine. Nice to meet you Admiral!", desc => "mst_shiptext.xml" },
        "ボクが最上さ。\\n大丈夫、今度は衝突しないって。ホントだよ。" => { tr => "I'm Mogami. It's alright, I won't collide\\nwith anyone this time. Really!", desc => "mst_shiptext.xml" },
        "ボクは任務途中に何度も何度も怪我をしたけど、最後まで奮戦した睦月型駆逐艦５番艦さ。\\n緒戦の後も、船団護衛などで各海域で頑張ったんだ。\\nホントだよ。" => { tr => "I kept getting injured again and again on\\nmissions, but I fought bravely to the end\\nas the 5th of the Mutsuki-class destroyers.\\nAfter the war began, I did my best to escort\\nthe fleet and guard areas of the ocean.\\nI really did!", desc => "mst_shiptext.xml" },
        "マイク音量大丈夫…？チェック、1，2……。\\nよし。はじめまして、私、霧島です。" => { tr => "Is the microphone's volume good?\\nCheck, 1,2... Okay. Nice to meet you,\\nI'm Kirishima.", desc => "mst_shiptext.xml" },
        "マル急計画によって戦時建造された雲龍型航空母艦の長女、雲龍よ。\\n傑作中型空母の飛龍を改良した量産型正規空母なの。新生機動部隊の主力としての潜在実力は十分なのだけど…今度は見ててよね。" => { tr => "I am the elder sister of the Unryuu class aircraft carriers built under the Rapid Naval Armaments Supplement Programme during wartime.\\nWe are the improved mass-production version of the medium-sized carrier masterpiece, Hiryuu. I'll show you the immense potential of the main force of the reborn Mobile Task Force.", desc => "mst_shiptext.xml" },
        "マル4計画で建造されて戦時就航した夕雲型四番艦、長波だ。栄光の第二水雷戦隊で縦横無尽の活躍したぞ。\\nガダルカナル島では、田中頼三少将の名指揮で、敵の待ち伏せを完膚なきまでに蹴散らしてやったぜ。" => { tr => "I'm Naganami, the fourth ship of the\\nYuugumo-class destroyers, built and\\nlaunched during wartime under the Maru-4\\nproject. I rampaged all over as a member\\nof the proud 2nd Torpedo Squadron. At\\nGuadalcanal, we gave an enemy ambush\\na beatdown under the famous command\\nof Rear Admiral Tanaka Raizo.", desc => "mst_shiptext.xml" },
        "ワシントン条約制限下で設計された、世界中を驚愕させたクラスを超えた特型駆逐艦の１番艦、吹雪です。\\n私たちは、後の艦隊型駆逐艦のベースとなりました。\\nはいっ、頑張ります！ " => { tr => "I am Fubuki, the first ship of the Special\\nType destroyers designed under the\\nWashington Naval Treaty. We were superior\\nto existing ship classifications and shocked\\nthe world. Based on our design, many\\nfollowing fleet-type destroyers were built.\\nYes sir, I'll do my best!", desc => "mst_shiptext.xml" },
        "ワシントン海軍軍縮条約下で建造された重巡洋艦です。平賀譲氏設計による日本海軍の第一級の戦闘艦です。\\n現代の海上自衛隊のイージス艦にも、その名は受け継がれています。" => { tr => "A heavy cruiser built under the auspices\\nof the Washington Naval Treaty. I'm a\\nfirst-class warship of the Japanese Navy\\ndesigned by Yuzuru Hiraga. This name has\\nalso been passed on to the Aegis\\ndestroyers of the modern MSDF.", desc => "mst_shiptext.xml" },
        "ヴィットリオ・ヴェネト級戦艦二番艦、\\nリットリオ改め、イタリアです。\\nよろしくお願いしますね。" => { tr => "The second ship of the Vittorio Veneto-class battleships, Littorio.\\nI have confidence in my speed and firepower.\\nNice to meet ya.", desc => "mst_shiptext.xml" },
        "ヴィットリオ・ヴェネト級戦艦２番艦、リットリオです。\\n火力と速度には自信があるの。よろしくお願いしますね。" => { tr => "The second ship of the Vittorio Veneto-class battleships, Littorio.\\nI have confidence in my speed and firepower. Nice to meet ya.", desc => "mst_shiptext.xml" },
        "ヴィットリオ・ヴェネト級戦艦４番艦、\\nローマです、よろしく。\\n何？あまりジロジロ見ないでくださいね。" => { tr => "I'm the fourth battleship of the Vittorio Veneto-class, Roma. Nice to meet you.\\nWhat? Please don't stare at me, okay?", desc => "mst_shiptext.xml" },
        "ヴェールヌイだ。\\nその活躍ぶりから不死鳥の通り名もあるよ。" => { tr => qq[I'm Hibiki. I'm also referred to as\\n"The Phoenix" from my exploits.], desc => "mst_shiptext.xml" },
        "不知火です。\\nご指導ご鞭撻、よろしくです。" => { tr => "I'm Shiranui. I look forward to your\\nguidance and encouragement.", desc => "mst_shiptext.xml" },
        "丸一計画で建造された初春型駆逐艦２番艦の子日だよ。初春などの姉妹艦で第２１駆逐隊を編成して色々と頑張ったんだよ。\\nなに？潜水艦…？嫌いキライ！" => { tr => "I'm Nenohi, second ship of the\\nHatsuharu-class built under the\\nMaru-1 program. I'm working hard to\\norganize many things for my 21st Destroyer\\nCorps sister ships, such as the Hatsuharu\\nsister ships. What? Submarines...?\\nI REALLY hate them!", desc => "mst_shiptext.xml" },
        "九三式酸素魚雷を満載、片舷20門、全40門の魚雷発射管を誇る、重雷装艦へと改装されたスーパー北上さまだよ。\\nその威力は圧倒的と言われていたけれど、活躍する機会が微妙になかったんだよね。ちぇっ。" => { tr => "It's Super Kitakami-sama, equipped with\\ntype-93 oxygenated torpedos, with 20\\nfiring tubes on each side. It's been said\\nthat I have overpowering strength, but\\nI did not really get any chances to shine.\\nBah.", desc => "mst_shiptext.xml" },
        "五十鈴です。水雷戦隊の指揮ならお任せ。\\n全力で提督を勝利に導くわ。よろしくね。" => { tr => "I'm Isuzu. Leave the torpedo squadrons to\\nme. I'll bring victory to the Admiral with all\\nmy power. Pleased to meet you.", desc => "mst_shiptext.xml" },
        "五十鈴は、大正時代に建造された長良型軽巡の２番艦。韋駄天さはもちろんだけど、私の歴代艦長の中からは、あの山本五十六提督、山口多聞提督など後の海軍を支える人物が多数輩出されたの。凄いでしょ？" => { tr => "Isuzu was built in the Taisho period\\n(1912-1926) as the second of the\\nNagara-class light cruisers. As you might\\nexpect, my speed is top-rate; the Admirals\\nthat commanded me in history include\\nAdmiral Yamamoto Isoroku, Admiral\\nYamaguchi Tamon, and many other\\npillars of the Navy. Amazing, huh", desc => "mst_shiptext.xml" },
        "五十鈴は、大正時代に建造された長良型軽巡の２番艦。\\n韋駄天さはもちろんだけど、私の歴代艦長の中からは、あの山本五十六提督、山口多聞提督など後の海軍を支える人物が多数輩出されたの。凄いでしょ？" => { tr => "Isuzu was built in the Taisho period\\n(1912-1926) as the second of the\\nNagara-class light cruisers. As you might\\nexpect, my speed is top-rate; the Admirals\\nthat commanded me in history include\\nAdmiral Yamamoto Isoroku, Admiral\\nYamaguchi Tamon, and many other\\npillars of the Navy. Amazing, huh?", desc => "mst_shiptext.xml" },
        "五月雨っていいます！よろしくお願いします。\\n護衛任務はお任せください！" => { tr => "My name is Samidare! I look forward to\\nworking with you. Please leave any escort\\nmissions to me!", desc => "mst_shiptext.xml" },
        "五月雨です。\\n村雨・夕立・春雨とは第２駆逐隊でお友達でした。\\nそうそう、輸送任務中に白露と衝突してしまったことも…ホント、私ってば、ドジでごめんなさい。\\nでも、頑張ります！" => { tr => "I'm Samidare. My friends Murasame,\\nYuudachi and Harusame, we made up\\nDesDiv2. Oh yeah, during a transport\\nmission, I crashed into Shiratsuyu...\\nReally, I'm... sorry for being clumsy...\\nBut, I'll do my best!", desc => "mst_shiptext.xml" },
        "井上提督も愛した巡洋戦艦、比叡です。\\nぴかぴかに肌を磨いて、御召艦としても活躍したの。\\n大和型のテスト艦にもなったのよ、知ってた？\\nえ？　ソロモン海戦？　そうよ、奮闘したわ！" => { tr => "The battlecruiser that Admiral Inoue loved,\\nit's Hiei. Even though I'm a shiny Imperial\\nship, I'll work my hardest. I was even the\\ntest-ship for the Yamato class, didn't you\\nknow? Eh? The Battle of Guadalcanal?\\nYes, I fought hard.", desc => "mst_shiptext.xml" },
        "伊勢型戦艦２番艦、日向。\\nああ、そうだ。\\nあの伊勢と一緒に航空戦艦になったんだ。\\nもともとは、私の砲塔の事故もあるんだけどな。\\n呉で朽ち果てる迄、戦うつもりだ。" => { tr => "2nd of the Ise-class battleships, Hyuuga.\\nAh yes, I became an aviation battleship\\ntogether with Ise you know. That's\\noriginally because an accident\\nhappened on my 5th turret.\\nI'm fighting 'til I am sunk at Kure.", desc => "mst_shiptext.xml" },
        "伊勢型航空戦艦、日向。\\n推して参る。" => { tr => "Ise-class Aviation Battleship,\\nHyuuga... Pushing forward.", desc => "mst_shiptext.xml" },
        "伊１６８よ。何よ、言いにくいの？\\nじゃ、イムヤでいいわ…よろしくねっ！" => { tr => "I'm I-168. What? It's hard to say? OK,\\njust call me Imuya. Nice to meet you!", desc => "mst_shiptext.xml" },
        "伊４００型潜水艦二番艦、伊４０１です。\\n地球をぐるっと一周以上余裕で航行できる長大な航続力と、特殊攻撃機「晴嵐」を３機搭載する潜水空母なんです。そう、戦略的秘密兵器…秘密なんだからっ！" => { tr => qq[I'm I-401, the second ship in the I-400 submarine series.\\nI'm a submarine carrier capable of making a round trip around the world, and carries 3 units of the special attack plane "Seiran". Yes, it's a secret tactical weapon... it's a secret, okay?], desc => "mst_shiptext.xml" },
        "僕は白露型駆逐艦、「時雨」。\\nこれからよろしくね。" => { tr => "I'm Shigure, of the Shiratsuyu-class\\ndestroyers. Nice to meet you.", desc => "mst_shiptext.xml" },
        "僕は白露型駆逐艦２番艦の時雨だよ。\\nあのレイテ沖海戦では、西村艦隊に所属して、運命のスリガオ海峡に突入したんだ。\\n扶桑も山城も凄かったよ……。皆が忘れても、僕だけはずっと覚えているから……。" => { tr => "I'm Shigure, second ship of the\\nShiratsuyu-class destroyers.\\nI was in the fated battle of Surigao Strait\\nunder the Nishimura fleet in the battle of\\nLeyte Gulf. Fusou and Yamashiro were\\namazing... Even if everyone forgets,\\nI'll always remember them...", desc => "mst_shiptext.xml" },
        "八八艦隊計画の第一号艦として生まれた、長門型戦艦のネームシップ、長門だ。\\n大和型が就役するまで、連合艦隊旗艦も務めていたさ。世界のビッグ７と云われてもいたな。" => { tr => "Born as the first battleship of the 8-8\\nfleet programme, the nameship of the\\nNagato-class battleships, Nagato.Until\\nYamato was commissioned, I served as\\nthe flagship of the Combined Fleet.\\nI was called one of the 'Big 7'.", desc => "mst_shiptext.xml" },
        "初の日本独自設計による超弩級戦艦、扶桑です。\\n妹の山城ともどもよろしくお願いしますね。\\nレイテ沖？　そうね、いつか突入してみたいわ。\\nホントよ？" => { tr => "The first of the Japanese designs for the super-dreadnought battleship class, Fusou.\\nPlease remember to take care of my younger sister, Yamashiro, as well.\\nLeyte Gulf? Oh well, I would like to go there someday.\\nRight?", desc => "mst_shiptext.xml" },
        "初めまして…まるゆ着任しました。\\nえ？聞いてないって…そんなあ！" => { tr => "Nice to meet you... Maruyu, reporting for\\nduty. Huh? You haven't heard about it?\\n...Oh no...!", desc => "mst_shiptext.xml" },
        "初めまして、ねのひ、だよぉ！\\n艦名、読みづらくなんか、ないよね？ね？" => { tr => "Hello, it's Nenohi. I hope my name\\nwasn't hard to read, yes?", desc => "mst_shiptext.xml" },
        "初めまして、弥生、着任…。\\nあ、気を使わないでくれていい…です。" => { tr => "Yayoi, reporting for duty... Pleased to meet\\nyou. Please don't be too concerned about\\nme...", desc => "mst_shiptext.xml" },
        "初めまして、龍田だよ。\\n天龍ちゃんがご迷惑かけてないかなあ～。" => { tr => "Nice to meet you, I'm Tatsuta. I hope\\nTenryuu-chan hasn't been causing you\\ntrouble?", desc => "mst_shiptext.xml" },
        "初春型四番艦、初霜です。\\n皆さん、よろしくお願いします！" => { tr => "Fourth ship of the Hatsuharu class, Hatsushimo.\\nEveryone, I'm very pleased to meet you!", desc => "mst_shiptext.xml" },
        "初春型駆逐艦、１番艦の初春じゃ。\\nわらわは、北方部隊に所属。戦雲渦巻くアッツやキスカなどの北方海域で活躍したぞ。北海道周辺も好きな海域じゃな。マニラ湾やオルモック…？ああ、熱いところは苦手じゃ。" => { tr => "We are the 1st Hatsuharu-class destroyer,\\nHatsuharu. We were attached to the\\nNorthern Force. As the clouds of war\\ngathers, we did our duty in the Northern\\nseas at such places as Attu and Kiska.\\nThe seas around Hokkaido are our favorite,\\nno? The Gulf of Manila and Ormoc...\\nAh, we are weak to the heat.", desc => "mst_shiptext.xml" },
        "初春型駆逐艦の次に開発された白露型の１番艦、白露だよ！　そう、１番艦だよ、１番艦。\\n色々と改良された艦隊型駆逐艦なんだから！\\nえ？慌ててタンカーと衝突しないようにって？大丈夫！" => { tr => "Developed after the Hatsuharu-class\\ndestroyer, Shiratsuyu-class, number one,\\nI'm Shiratsuyu! Yeah, number one, the first\\nship! With lots of upgrades, I'm a true fleet\\ndestroyer, you know! Eh? 'Don't be in such\\na rush that you'll hit a tanker'?\\nDon't worry about it!", desc => "mst_shiptext.xml" },
        "初春型駆逐艦の４番艦、初霜です。\\nアリューシャン作戦、アッツ島沖海戦、キスカ島撤退作戦、マリアナ沖海戦、北号作戦、坊ノ岬沖海戦など、様々な激戦に参加しました！\\nほんと、頑張ったんです！" => { tr => "Fourth of the Hatsuharu-class destroyers,\\nHatsushimo. I was in lots of hard battles like the\\nOperation AL, the Battle of the\\nKomandorski Islands, the occupation of Kiska,\\nthe Battle of the Philippine Sea, Operation\\nHoku-Go and Ten-Ichi-Go!\\nI really did my best!", desc => "mst_shiptext.xml" },
        "初春型駆逐艦３番艦、若葉だ。\\nアッツ島沖海戦やキスカ島撤退作戦などに参加した。\\nそうだ、北方海域だ。\\nああ、濃霧には注意が必要だ。ぶつかりやすい。\\n特に「初霜」、お前は要注意だ。" => { tr => "Third of the Hatsuharu-class, Wakaba.\\nI participated in the Attu and Kiska Island\\nexit operations. Yes, the Northern forces.\\nAh, be careful of heavy fog. It's easy to get\\nhit. Especially 'Hatsushimo',\\nyou need to watch out for her.", desc => "mst_shiptext.xml" },
        "初雪……です……よろしく。" => { tr => "I'm... Hatsuyuki... nice to meet you.", desc => "mst_shiptext.xml" },
        "初風です、よろしく。\\n提督さんにとって私は何人目の私かしら？" => { tr => "I'm Hatsukaze, nice to meet you. Admiral,\\nhow many of me did you have before me,\\nI wonder?", desc => "mst_shiptext.xml" },
        "千歳です。\\n日本では初めての水上機母艦なのよ。よろしくね！" => { tr => "I'm Chitose. I'm the the first Japanese\\nseaplane tender. Nice to meet you!", desc => "mst_shiptext.xml" },
        "古鷹と言います。重巡洋艦のいいところ、\\nたくさん知ってもらえると嬉しいです。" => { tr => "I'm Furutaka. I'll be happy to show all\\nthe good points of heavy cruisers.", desc => "mst_shiptext.xml" },
        "古鷹型重巡の2番艦、加古ってんだ、よっろしくぅー！" => { tr => "Second Furutaka Class Heavy Cruiser, name's Kako! Nice to meetcha!", desc => "mst_shiptext.xml" },
        "古鷹型重巡洋艦の２番艦、加古だよぉ。\\n第一次ソロモン海戦で大活躍したんだからね！\\nあ、帰り道？ホント、行きはよいよい、帰りは怖い～ってね！" => { tr => qq[I'm the Second Furutaka Class Heavy Cruiser,\\nKako.I achieved quite a feat during the\\nBattle of Savo Islands! Ah, the way back? Well,\\nthe verse "Going in is easy, but returning\\nis scary" was no joke!], desc => "mst_shiptext.xml" },
        "名前は出雲ま…じゃなかった、飛鷹です。\\n航空母艦よ。よろしくね、提督！" => { tr => "My name is Izumo Ma... No, Hiyou. I'm\\nan aircraft carrier. Pleased to meet you,\\nAdmiral!", desc => "mst_shiptext.xml" },
        "名取といいます。\\nご迷惑をおかけしないように、が、頑張ります。" => { tr => "I'm called Natori...\\nI'll do my best not to trouble you!", desc => "mst_shiptext.xml" },
        "吾輩が利根である！\\n吾輩が艦隊に加わる以上、もう、索敵の心配はないぞ！" => { tr => "I am Tone! With my addition to the fleet,\\nthere will be no problems searching out\\nthe enemy!", desc => "mst_shiptext.xml" },
        "商船改装空母、隼鷹でーすっ！\\nひゃっはぁー！" => { tr => "Ex-merchant ship aircraft carrier, Jun'yo!\\nWoohoo!", desc => "mst_shiptext.xml" },
        "夕雲型一番艦、夕雲、着任しました。\\n提督、甘えてくれても、いいんですよ？" => { tr => "First ship of the Yuugumo-class, Yuugumo,\\nhas arrived. Admiral, it's okay to spoil me\\na bit.", desc => "mst_shiptext.xml" },
        "夕雲型駆逐艦、その十七番目、早霜です。\\n舞鶴海軍工廠生まれ。だいぶ押し迫った頃に生まれました。レイテ沖海戦にリンガ泊地から出撃して…色々な光景を見ました。" => { tr => "I'm the 17th of the Yuugumo-class Destroyer, Hayashimo.\\nI was born in the Maizuru Naval Base Factory, to times of impending troubles. I launched for the Battle of Leyte Gulf from the Lingga Naval Anchorage... And I've seen many things.", desc => "mst_shiptext.xml" },
        "夕雲型駆逐艦、三番艦の風雲よ。\\nそっか、貴方が提督なんだ。了解です。\\nご命令、どうぞ！" => { tr => "Third ship of the Yuugumo class destroyers, Kazagumo.\\nSo you're the admiral. Roger.\\nWell then, your orders!", desc => "mst_shiptext.xml" },
        "夕雲型駆逐艦、六番艦の高波です。\\nあ、あの…頑張ります！ホントかもです！" => { tr => "I'm the 6th of the Yuugumo-class destroyers, Takanami.\\nE-ehem, I will do my best! Really, probably!", desc => "mst_shiptext.xml" },
        "夕雲型駆逐艦、巻雲といいます。\\n夕雲姉さんを見習って、頑張ります！" => { tr => "Yuugumo-class destroyer, I am Makigumo.\\nFollowing Yuugumo-neesan's example, I'll\\ndo my best!", desc => "mst_shiptext.xml" },
        "夕雲型駆逐艦のラスト、十九番艦の清霜です。\\n浦賀生まれですよ。もう、そうとう辛い戦局の中で生まれたの。短い間だったけど、縦横無尽に活躍したわ。凄惨だったレイテはもちろん、あの礼号作戦にも参加したのよ！どう？" => { tr => "I'm Kiyoshimo, the 19th and last of the Yuugumo class destroyers.\\nI was born in Uraga dontcha know. And goodness, what a horrible situation it was that I was born into too. I wasn't around for long but I took part in several fleet actions. Leyte was, of course, apalling to see but I even took part in Operation Rei-gou! How's that?", desc => "mst_shiptext.xml" },
        "夕雲型駆逐艦二番艦、巻雲です。\\nホーネットの後始末、事情許さば拿捕曳航されたし…って云われても、結構無理ゲーだし…って、秋雲がこっち指差して笑ってるし。本当にもうなんなの？" => { tr => "I'm Makigumo, second ship of the\\nYuugumo-class Destroyers. While cleaning\\nup after the Hornet, 'situation permitting,\\ntow and capture it'... they said, but that was\\npretty much impossible... and now\\nAkigumo's pointing and laughing at me.\\nSeriously, what the heck?", desc => "mst_shiptext.xml" },
        "夕雲型駆逐艦四番艦、長波サマだよ！\\nさーいくぜ、オーッ！" => { tr => "I'm Naganami-sama, the 4th ship of the\\nYuugumo-class destroyers. And off we go.\\nYeah!", desc => "mst_shiptext.xml" },
        "夕雲型駆逐艦６番艦、高波です。浦賀生まれです。\\n第三十一駆逐隊に編入され、活躍したかもです。運命のルンガ沖夜戦でも警戒隊の旗艦として敵を発見…、艦隊の勝利に貢献したかも…です。はい！" => { tr => "I'm Takanami, the sixth Yuugumo-class Destroyer. Born in Uraga.\\nI was assigned to the 31st Destroyer Division, and I had done my part well. On a fateful night battle at Lunga Point, as the Leadship of the Lookouts squad, our crew first spotted the enemy fleet... and that may have brought victory to the battle... Yup!", desc => "mst_shiptext.xml" },
        "大和型二番艦、武蔵、推参する。\\nどうだ…この色、装束も似合うだろう？" => { tr => "The second ship of the Yamato-class\\nbattleships, Musashi... Barging in!\\nWhat do you think of this color?\\nDoes this look suit me as well?", desc => "mst_shiptext.xml" },
        "大和型戦艦、一番艦、大和。\\n対空火器を大幅強化致しました！" => { tr => "First of the Yamato-class battleships,\\nYamato. Now with much upgraded anti-air\\nweaponry.", desc => "mst_shiptext.xml" },
        "大和型戦艦、一番艦、大和。\\n推して参ります！" => { tr => "First of the Yamato-class battleships,\\nYamato. Heading forth!", desc => "mst_shiptext.xml" },
        "大和型戦艦一番艦、大和です。\\n艦隊決戦の切り札として、呉海軍工廠で極秘建造されました。当時の最高技術の粋を結集されたこの体、二番艦の武蔵と共に、連合艦隊の中枢戦力として頑張ります！" => { tr => "First of the Yamato-class battleships,\\nYamato.  As the trump card for the\\nDecisive Battle, I was made in utmost\\nsecrecy at the Kure Naval Yard. With the\\nmost up-to-date and sophisticated\\ntechnology concentrated in my body,\\nalong with the 2nd ship, Musashi, I'll do my\\nbest as the centre of the combined fleet!", desc => "mst_shiptext.xml" },
        "大和型戦艦二番艦、武蔵だ。\\n長崎生まれだ。よろしく頼むぞ。\\n姉妹艦の大和や信濃と同じく極秘裏に建造されたのさ。ああ、この主砲を存分に撃ち合いたかったな。今度は頼めるか…　ありがたい！" => { tr => "Second of the Yamato-class battleships,\\nMusashi. Laid down in Nagasaki. My best\\nregards to you. As with my sister ships\\nYamato and Shinano, I was constructed\\nunder strict secrecy. Ah, I really want to\\nbe able to shoot these main cannons...\\nI ask of you, may I? Excellent!", desc => "mst_shiptext.xml" },
        "大阪の民間造船所で建造された、陽炎型駆逐艦の３番艦、黒潮や。\\nこう見えても、スラバヤ沖海戦、南太平洋海戦、第三次ソロモン海戦などの激戦に参加したんやで。" => { tr => "Built in the Osaka Civilian Naval Yards,\\n3rd of the Kagerou-class Destroyers,\\nKuroshio. Even though I look like this,\\nI participated in such hard-fought battles\\nsuch as Surabaya, the South Pacific and\\nthe third Battle of Solomon, ya' know.", desc => "mst_shiptext.xml" },
        "天龍型１番艦、天龍だ。\\n駆逐艦を束ねて、殴り込みの水雷戦隊を率いるぜ。\\n相棒は、同型艦の龍田だ。\\nあいつ、ちゃんとやってるかな？ま、いいけどな。" => { tr => "First of the Tenryuu-class, Tenryuu.\\nI lead the torpedo squadron along with the destroyers.\\nMy pal is Tatsuta, of the same class.\\nIs she doing well, I wonder? Well, whatever.", desc => "mst_shiptext.xml" },
        "如月と申します。\\nおそばに置いてくださいね。" => { tr => "My name is Kisaragi.\\nPlease keep me by your side.", desc => "mst_shiptext.xml" },
        "妙高型重巡洋艦、羽黒です。\\n皆さんと共に、全力で戦線を支えます！" => { tr => "I'm Haguro. I'm the youngest of the\\nMyoukou-class heavy cruiser sisters.\\nU-um... I'm sorry!", desc => "mst_shiptext.xml" },
        "川内、参上。\\n夜戦なら任せておいて！" => { tr => "Sendai has arrived. Please leave\\nthe night battle to me.", desc => "mst_shiptext.xml" },
        "巡洋艦といえば、なんといっても、私、高雄型よね。\\n近藤中将麾下の第４戦隊に所属して、数々の海戦に参加しました。\\n激戦を戦い抜いて最期はシンガポール防衛に努めたの。" => { tr => "If you're talking about cruisers, no matter\\nhow you look at it, it has to be me, Takao!\\nAttached to Vice Admiral Kondo's 4th\\nfleet, I participated in many naval battles.\\nOvercoming these hard-fought conflicts,\\nI concluded with a diligent defence of\\nSingapore.", desc => "mst_shiptext.xml" },
        "工作艦、明石です。\\n少々の損傷だったら、私が泊地でばっちり直して\\nあげますね。お任せください！" => { tr => "I'm Repair ship Akashi. If you take a little\\ndamage, I can fix you up in the base.\\nJust leave it to me!", desc => "mst_shiptext.xml" },
        "帝国海軍の駆逐艦で初めて大型で強力な61cm魚雷を搭載しました、睦月です！\\n旧式ながら、第一線で頑張ったのです！" => { tr => "The first Imperial Navy destroyer to be loaded with the powerful large-type 61cm torpedoes, Mutsuki!\\nWhile I'm an older model, I gave it my all on the frontlines!", desc => "mst_shiptext.xml" },
        "戦時改造を前提に建造した豪華客船、橿原丸。\\nその改装した姿が空母、隼鷹さ。\\nちゃーんと戦い抜いて、最後まで生き残ったんだぜ。意外とやるでしょ？" => { tr => "Wartime remodeling based on the Luxury liner, Kashiwara Maru.\\nThe renovated appearance is the aircraft carrier, Jun'you.\\nI fought properly, and survived until the end. Ain't I surprisingly capable?", desc => "mst_shiptext.xml" },
        "扶桑型戦艦を再設計した、強力な超弩級戦艦として完成しました。戦艦、伊勢です。\\n主砲を多少とっちゃって、有名な航空戦艦モードに改造可能よ。楽しみね！" => { tr => "Based on the Fusou-class battleships,\\nthe strong firepower super-dreadnought.\\nBattleship, Ise. By taking off a few of the\\nmain cannons, I can be upgraded to the\\nfamous Aviation Battleship mode!\\nI'm looking forward to it!", desc => "mst_shiptext.xml" },
        "扶桑型戦艦姉妹、妹のほう、山城です。\\nあの、扶桑姉さま、見ませんでした？" => { tr => "Of the two Fusou-class super-dreadnought battleships, I am the younger sister, Yamashiro.\\nUmm, have you seen Fusou-onee-sama?", desc => "mst_shiptext.xml" },
        "扶桑型戦艦２番艦、山城です。\\n「欠陥戦艦」とか「艦隊にいる方が珍しい」とか、いいたい放題ね…。\\nでも、いいの。最後の時も、扶桑姉さまと一緒に戦えれば……" => { tr => "The second of the Fusou-class battleships, Yamashiro.\\nA 'faulty battleship', or 'an unusual thing to be in the fleet'... \\nEveryone said things like that... \\nBut that's okay, so long as I can fight \\nalongside Fusou-neesama until the end...", desc => "mst_shiptext.xml" },
        "扶桑型超弩級戦艦、姉の扶桑です。\\n妹の山城ともども、よろしくお願い致します。" => { tr => "Of the two Fusou-class super-dreadnought battleships, I am the elder sister, Fusou.\\nPlease take care of me and my younger sister Yamashiro.", desc => "mst_shiptext.xml" },
        "提督、お疲れさまです。\\n水上機母艦、瑞穂、推参致しました。\\nどうぞよろしくお願い申し上げます。" => { tr => "Italian Navy Destroyer, 3rd Maestrale-class,\\nLibeccio. Admiral, Nice to meet you! What,\\nBattle of Taranto? That's easy! Although\\nI wanted to do my best in escort fleet,\\nI want to quit in the middle of the rescue.", desc => "mst_shiptext.xml" },
        "提督、ごきげんよう。潜特型二番艦伊401です。\\nしおいって呼んでね。" => { tr => "Good day, Admiral. I'm I-401, the second\\nship in the special submarine series.\\nJust call me Shioi.", desc => "mst_shiptext.xml" },
        "提督、ごきげんよう。\\n潜特型二番艦伊401、改良型です！" => { tr => "A good day to you, Admiral.\\nIt's the upgraded I-401, of the special submarine class.", desc => "mst_shiptext.xml" },
        "提督、また会ったね？最上だよ。\\nボクの飛行甲板どう？似合ってる？" => { tr => "We meet again, Admiral? It's Mogami.\\nHow's my flight deck? Does it suit me?", desc => "mst_shiptext.xml" },
        "提督、三隈、新型になりましてよ" => { tr => "Admiral, I've attained a new form!", desc => "mst_shiptext.xml" },
        "提督、旗艦大淀、お供いたします。\\n前線艦隊指揮はどうぞお任せください！" => { tr => "Admiral, I, Flagship Ooyodo shall\\naccompany you. Please leave the frontline\\nfleet administration to me.", desc => "mst_shiptext.xml" },
        "提督、谷風だよ。\\nこれからお世話になるね！" => { tr => "Admiral, I'm Tanikaze!\\nI'll be in your care from now on.", desc => "mst_shiptext.xml" },
        "提督、軽巡大淀、戦列に加わりました。\\n艦隊指揮、運営はどうぞお任せください。" => { tr => "Admiral, Light Cruiser Ooyodo has joined\\nthe battle lines. Please leave the fleet\\nadministration and supervision to me.", desc => "mst_shiptext.xml" },
        "提督さん、お疲れさまです。\\n練習巡洋艦、鹿島、着任です。うふふ。" => { tr => "Admiral, thanks for your hard work.\\nTraining cruiser, Kashima, checking in! Ufufu.", desc => "mst_shiptext.xml" },
        "数ある特型駆逐艦の中で最後まで生き残ったのが、響。転戦の後、あの大和水上特攻時には修理で同行できなかったんだ。\\n賠償艦としてソ連に引き渡され「信頼できる」という意味の艦名になったんだ。" => { tr => qq[Surviving 'til the very end among the many\\nspecial-class destroyers was I, Hibiki.\\nAfter experiencing several battles, I was\\nunable to accompany the Yamato Surface\\nSpecial Attack Force due to repairs.\\nI was handed over to the Soviet Union\\nas a prize of war, and was given a name\\nthat means "Faithful" in Russian.], desc => "mst_shiptext.xml" },
        "新しい北上、それがアタシ。\\n酸素魚雷を満載して、ちょっと大人になったでしょ。" => { tr => "A brand new Kitakami... that's me, all\\nright. I feel a lot more grown up, loaded\\nto the brim with oxygen torpedoes.", desc => "mst_shiptext.xml" },
        "新鋭阿賀野型軽巡の二番艦、能代です。能代独自の飛行機運搬軌条がチャームポイントなんです。\\nレイテ沖海戦でも主力の栗田艦隊の一員として頑張りました！" => { tr => "2nd of the newly-developed Agano-class\\nLight Cruisers, Noshiro. The lone aircraft\\nrail is my charmpoint. Even in Leyte Gulf,\\nI did my best as a main member of Kurita's\\ntask force!", desc => "mst_shiptext.xml" },
        "日本海軍が完成させた最後の重巡、\\n利根型の長女、利根だ。\\n真珠湾、そして痛恨のミッドウェーでも、艦隊の眼として縦横無尽の活躍なのじゃ。最期は呉鎮守府を守る浮き砲台として刀折れ矢尽きるまで戦ったぞ。" => { tr => "The last completed heavy cruiser of the\\nJapanese Navy, oldest sister of the\\nTone-class, Tone. At Pearl Harbor\\nand Midway, as the eye for the fleet,\\nI unceasingly watched the length and\\nbreadth of the ocean. I ended out the\\nwar protecting the Kure Naval Yards as\\na floating fortress, fighting until my \\nblades were broken, arrows were depleted.", desc => "mst_shiptext.xml" },
        "暁よ。\\n一人前のレディーとして扱ってよね！" => { tr => "I'm Akatsuki! Treat me like the\\nfully-fledged lady that I am!", desc => "mst_shiptext.xml" },
        "最上型重巡洋艦１番艦。\\n最上の後部主砲を全て取り払って、代わりに水上機を運用する航空甲板を設置した、航空巡洋艦だよ。\\n水上機母艦並の航空力と火力、どうよ！" => { tr => "First of the Mogami-class heavy cruisers.\\nBy taking off my stern cannons and\\nreplacing them with an aviation deck,\\nthe Aviation Cruiser was developed!\\nEqual fire and air power, howzat!", desc => "mst_shiptext.xml" },
        "最上型１番艦のモガミンとは、とっても仲がいいのだけれど、仲が良すぎて彼女とは衝突することも多いの…　ええ、そう…物理的に…私はちゃんと前見てるのよ？" => { tr => "I get along very well with Mogamin, the first\\nship in the Mogami class, but we get along\\ntoo well sometimes and collide often...\\nYeah... literally... I do watch where I'm going,\\nokay?", desc => "mst_shiptext.xml" },
        "最初から頑張って最後まで戦ったんだよ。苦しくなってからだって、凄い重巡だって仕留めたし！\\n任務を全うして、全てが終わった後、無事に呉の母港に帰ったんだ。" => { tr => "I have fought hard from the beginning to the end. Even when the war had became harsh, I managed to take down that heavy cruiser!\\nAfter fulfilling my mission and everything was all over, I managed to make it back safely to Kure, my home port.", desc => "mst_shiptext.xml" },
        "最終量産型艦隊駆逐艦の一番艦。舞鶴生まれよ。惨敗のミッドウェー海戦が初陣よ。いいじゃない、別に。\\nあの島への鼠輸送やケ号作戦、南太平洋海戦、キスカ撤退作戦などで奮戦したわ。ふう。" => { tr => "First ship of the final mass-production\\ndestroyers. Laid down in Maizuru.\\nMy first battle was the ignominious defeat\\nat Midway. It's okay, I don't mind. In the\\nTokyo Express to that island, Operation\\nKe, the Battle of the Santa Cruz Islands\\nand the evacuation of Kiska,\\nI fought bravely, no? *sigh*", desc => "mst_shiptext.xml" },
        "朝潮型駆逐艦、朝雲、着任したわ！\\n貴方が司令…かあ。ふうーん。ま、いいわ。\\n私がやったげる！" => { tr => "Asashio-class destroyer, Asagumo, reporting in!\\nSo you're the Commander... huh. Hmm. Well, it's fine.\\nI'll do it!", desc => "mst_shiptext.xml" },
        "朝潮型駆逐艦のネームシップ、朝潮よ。\\nバランスのとれた量産型駆逐艦として建造され、戦線を支えたの。\\n私の進化改良型が陽炎型になるわね。" => { tr => "Nameship for the Asashio-class\\ndestroyers, Asashio. Made as a\\nbalanced ship, to work on the front\\nlines. My improved form became the\\nKagerou-class, you know.", desc => "mst_shiptext.xml" },
        "朝潮型駆逐艦の２番艦、大潮です！\\n各戦線で活躍した後、あのガダルカナル島撤収作戦にも3回出動しました。\\n支えてみせます！" => { tr => "Second of the Asashio-class destroyers,\\nOoshio! After being sent into the frontlines,\\nI've mobilized to Guadalcanal for\\nevacuation missions three times.\\nI'll support you!", desc => "mst_shiptext.xml" },
        "朝潮型駆逐艦五番艦、朝雲よ。\\n盟友の山雲と一緒に、様々な戦場を駆け抜けたのよ。そう、第九駆逐隊。有名でしょ？\\nえ、知らないって？私、冗談ってあまり好きじゃないの。覚えておいてよ！" => { tr => "Asashio-class destroyer number 5, Asagumo.\\nTogether with my sworn friend Yamagumo, we made it through many battlefields. That's right, the 9th DesDiv. Famous, right?\\nEh, you haven't heard of us? You know, I don't really like jokes. Remember that!", desc => "mst_shiptext.xml" },
        "朝潮型駆逐艦六番艦の山雲です～。\\n大阪生まれの横須賀育ちなの～。そうね、機雷とかは注意しないといけないわね～。\\n護衛や哨戒で活躍、そしてマリアナ、西村艦隊の一員としてレイテにも参加したわ～。" => { tr => "I'm the sixth Asashio-class destroyer, Yamagumo.\\nI was born in Osaka and raised in Yokosuka. Uh-huh, I'll have to watch out for sea mines.\\nI was active in escort and patrol missions, then deployed to the Marianas and also Leyte Gulf as part of the Nishimura fleet.", desc => "mst_shiptext.xml" },
        "木曾だ、お前に最高の勝利を与えてやる。" => { tr => "I'm Kiso. I'll bestow upon you\\nthe absolute best victory.", desc => "mst_shiptext.xml" },
        "横須賀生まれ横須賀育ちの秋雲さんだよ！陽炎型の中でも航続距離は南雲さんの目にも留まって、一航戦に入ったんだ。ていうか、自分では夕雲型だと思ってたんだけどな…ブツブツ…ま、いいや。その後、五航戦の護衛を務めたよ。翔鶴瑞鶴も描き残したかったな。" => { tr => "Yokosuka born and raised, I'm Akigumo!\\nI'm in the the Kagerou-class, but my\\noverwhelming cruising range caught the\\neye of Admiral Nagumo and so I joined the\\n1st CarDiv. I mean, I always thought I was\\na Yuugumo-class... even our uniforms are\\nthe same... *grumble, mutter*... ah,\\nwhatever. After that, I was assigned to\\nguard the 5th CarDiv. I didn't get to finish\\ndrawing Shoukaku and Zuikaku, though...", desc => "mst_shiptext.xml" },
        "次世代の水雷戦隊の旗艦として設計＆建造された阿賀野型軽巡洋艦、その長女、一番艦の阿賀野よ。とってもとっても高性能なんだから！見てよ、この洗練された体…今度はゼッタイ本領発揮しちゃうからね。" => { tr => "Designed and built as the next-generation\\nof Torpedo squad flagships, Agano-class\\nlight cruiser, the eldest, is me, Agano!\\nI've got the the high-end technology!\\nHave a look, this refined body... This time,\\nI'll certainly show off my special features!", desc => "mst_shiptext.xml" },
        "歴戦の主力駆逐艦として奮戦したわ。\\n最後は戦艦大和と共に坊ノ岬沖海戦で米艦載機の猛攻と戦ったの。\\n負けないわ！" => { tr => "I fought intensely as a main fleet\\ndestroyer in history. In the end,\\nI fought alongside the battleship\\nYamato in Operation Ten-Go against\\nthe fierce attacks of the American\\ncarrier-based aircraft. I won't lose!", desc => "mst_shiptext.xml" },
        "水上機母艦、千代田です。\\n姉の千歳が、いつも迷惑かけてないですか？" => { tr => "Seaplane tender Chiyoda. My older sister\\nChitose isn't bothering you, is she?", desc => "mst_shiptext.xml" },
        "水上機母艦、瑞穂です。千歳、千代田に続いて建造された、甲標的も運用可能な特殊水上機母艦です。新機軸の機関部があまり上手くいかなくって……でも、開戦初頭の南方作戦などに参加致しました。お役に立てるよう頑張りますね！" => { tr => "I am a Seaplane Tender, Mizuho. Together with Chitose and Chiyoda, I am capable of utilizing the Kouhyouteki midget submarine. Although I was not bestowed with the latest model engine, I managed to participate at the start of the Southern Operations. I shall do my best to meet your expectations.", desc => "mst_shiptext.xml" },
        "水上機母艦、秋津洲よ！\\nこの大艇ちゃんと一緒に覚えてよね！" => { tr => "I'm Seaplane Tender Akitsushima!\\nHave you already remembered Taitei-chan and I?", desc => "mst_shiptext.xml" },
        "水上機母艦から大改装を受けて、航空母艦にジョブチェンジした千代田です。結構ちゃんとした空母でしょ？\\n千歳お姉と一緒に敵機動部隊と戦うわ！" => { tr => "Heavily remodeled from a seaplane tender,\\nI'm the job-changed aircraft carrier\\nChiyoda. I'm quite the carrier, no?\\nI'll fight the enemy air force together\\nwith Chitose-onee!", desc => "mst_shiptext.xml" },
        "水上機母艦から空母に改装された千歳です。\\nダイエットして体も絞って、脚も速くなったのよ。これなら機動部隊の一翼を担えるわ！\\n頑張ります！" => { tr => "Renovated from a seaplane carrier to a\\ncarrier, I'm Chitose. Slimming down my\\nbody by dieting. My legs even became\\nfaster. This will let me play a part in the\\nTask Force! I'll do my best for you!", desc => "mst_shiptext.xml" },
        "水上機母艦として建造された千歳型２番艦、千代田です。\\n甲標的母艦としても運用できるようになっているのよ。千歳お姉と一緒に頑張りますね！" => { tr => "Laid down as a Seaplane Tender, 2nd of\\nthe Chitose class, Chiyoda. I was able to\\nmake use of midget subs, you know.\\nI'll do my best alongside Chitose-onee!", desc => "mst_shiptext.xml" },
        "水上機母艦千歳です。\\n水上機を沢山運用できる優れものですが、給油艦として重油を他の艦に補給もできちゃうの。後期には、航空母艦に改装され、第一線で戦ったのよ。" => { tr => "I'm the Seaplane Tender, Chitose.\\nAlthough I'm an exceptional ship\\ncapable of making use of seaplanes a lot,\\nI was used as an oiler and supplied fuel to\\nother ships. In the latter stages of the war,\\nI was remodeled into an aircraft carrier and\\nfought in the frontlines.", desc => "mst_shiptext.xml" },
        "水上機母艦千歳です。\\n水上機を沢山運用できる優れものですが、給油艦として重油を他の艦に補給もできちゃうの。\\n後期には、航空母艦に改装され、第一線で戦ったのよ。" => { tr => "I'm the Seaplane Tender, Chitose.\\nAlthough I'm an exceptional ship\\ncapable of making use of seaplanes a lot,\\nI was used as an oiler and supplied fuel to\\nother ships. In the latter stages of the\\nwar, nI was remodeled into an aircraft carrier\\nand fought in the frontlines.", desc => "mst_shiptext.xml" },
        "洋上航空戦力強化のために、主砲を一部外して、かわりに飛行甲板を設置、軽空母並の航空戦力を運用可能な航空戦艦、伊勢です。\\n海自の新鋭ＤＤＨにもその名は受け継がれているわ。" => { tr => "To obtain the power of marine aviation,\\na main cannon was removed, and in it's\\nplace, a flight deck was installed, granting\\nthe aviation power of a light aircraft carrier.\\nAviation battleship, Ise. My name was\\ntaken up by the newly-developed DDH\\nof the Marine Self Defense Force.", desc => "mst_shiptext.xml" },
        "浜風です。数々の激戦に参加しました。\\nレイテでは金剛を中心とした輪形陣。そして、武蔵や金剛、あの信濃の最期もこの目に焼き付けることになりました。運命の坊ノ岬では、雪風らと共に大和を護って奮闘します。" => { tr => "I am Hamakaze. I participated in many\\nfierce battles. At Leyte, I was in Kongou's\\nring formation. Futhermore, I seared them\\ninto my memory Musashi, Kongou and\\nShinano's last moments. At the fated\\nBounomisaki, I, Yukikaze and many others\\nstruggled to protect Yamato.", desc => "mst_shiptext.xml" },
        "涼風だよ。\\n特型駆逐艦として、数々の攻略作戦の支援に参加したんだ。\\nその後は戦艦や空母の護衛にも従事したよ。\\n頼りにしてね！最後まで戦うから！" => { tr => "I'm Suzukaze. As a Special-class\\ndestroyer, I participated in lots\\nof capture missions. After that, I escorted\\nbattleships and carriers!\\nYou can rely on me! I'll fight until the last!", desc => "mst_shiptext.xml" },
        "深雪だよ。\\nよろしくな！" => { tr => "I'm Miyuki.\\nGreat to meet you!", desc => "mst_shiptext.xml" },
        "満潮よ。\\n私、なんでこんな部隊に配属されたのかしら。" => { tr => "Michishio here. Why did I get\\nassigned to such a fleet?", desc => "mst_shiptext.xml" },
        "潜水母艦、大鯨です。\\n潜水艦隊旗艦機能と補給物資や水上偵察機を装備して、潜水艦作戦を支援します。いざという時は空母に改装できる空母予備艦として設計されました。\\n頑張ります！" => { tr => "I'm Submarine Tender Taigei. I serve as\\nflagship of submarine fleets in order to\\nsupport operations through supplies and\\nusage of scout planes. I have also been\\ndesigned as a carrier backup to be\\nconverted if it is needed. I'll do my best!", desc => "mst_shiptext.xml" },
        "潜水母艦改装空母の龍鳳です。\\n機関の換装の影響で速度は計画通りには出なかったけれど、このクラスの軽空母としては充実の飛行甲板と兵装なんです。\\n空母龍鳳、精一杯頑張ります！" => { tr => "Carrier Ryuuhou, remodeled from a\\nSubmarine Tender. My speed was not up to\\nplan specifications as there were issues\\nwith changing the boilers, but I have an\\nenhanced flight deck and armaments as this\\nLight Carrier class. Carrier Ryuuhou, giving\\nit her all!", desc => "mst_shiptext.xml" },
        "潜水母艦改装空母の龍鳳です。\\n航空母艦として、私、頑張ります！" => { tr => "Carrier Ryuuhou, remodeled from a\\nSubmarine Tender. I'll once again try\\nmy best as a carrier!", desc => "mst_shiptext.xml" },
        "潜水艦、伊一九よ。うん、イク。正規空母ワスプを自慢の酸素魚雷で仕留めたの。さらにずーっと先を航行していた戦艦や駆逐艦にも命中したの。海のスナイパー、イクさんの活躍、ずーっと覚えていてなの…ね。" => { tr => "I'm the submarine I-19. Yes, Iku! I sunk the carrier Wasp with my pride and joy, my oxygen torpedoes! I was even able to hit a battleship and destroyer that was waaaay ahead of the carrier! Don't you forget Iku, Sniper of the Ocean's great abilities... 'kay?", desc => "mst_shiptext.xml" },
        "特Ⅱ型駆逐艦２番艦の敷波。よろしく。\\nミッドウェーやソロモンの海戦に参加した後、船団護衛を務めたよ。\\n海上護衛戦は結構大変だよ…大事だし…。" => { tr => "Special Destroyer number II, Shikinami.\\nNice to meet you. After participating in\\nMidway and the Battle of Solomon, I serve\\nas a convoy escort. Being a convoy escort\\nis really rough you know...\\nBecause it's important...", desc => "mst_shiptext.xml" },
        "特Ⅲ型駆逐艦１番艦の暁よ。\\n吹雪型をベースに航行性能や航続距離を向上させたの。特型駆逐艦の最終完成形なんだから！\\nちゃんとレディーとして活躍したのよ！\\nほ、ほんとなんだからっ。" => { tr => "I'm the 1st of the special type-III\\ndestroyers, Akatsuki. Based on the\\nFubuki-class, with improved performance\\nand range, the last word in destroyers!\\nI'm quite the lady, you know!\\nR-really, I am....", desc => "mst_shiptext.xml" },
        "特型駆逐艦…綾波型の「潮」です。\\nもう下がってよろしいでしょうか…。" => { tr => "I'm Special-type Destroyer... Ayanami-class 'Ushio'.\\nIt would be nice to be dismissed soon...", desc => "mst_shiptext.xml" },
        "特型駆逐艦…３番艦…初雪…です。\\n緒戦の作戦に…いっぱい参加しました…。\\n輸送任務とかも…ん…がんばる……。" => { tr => "Special-type destroyer... 3rd ship...\\nHatsuyuki. At the start of the war...\\nI participated a lot. Transport duties...\\nYes... I'll work hard...", desc => "mst_shiptext.xml" },
        "特型駆逐艦、綾波です。\\n改良吹雪型の１番艦なんです。\\n第三次ソロモン海海戦では、駆逐艦一隻としては、特別な大活躍をお見せしました。頑張ります！" => { tr => "Special class destroyer, Ayanami.\\nI'm the first ship of the improved\\nFubuki class. In the Third Battle of the\\nSolomon Sea, I showed an outstanding\\nperformance as a destroyer.\\nI'll do my best!", desc => "mst_shiptext.xml" },
        "特型駆逐艦、綾波です。\\n改良吹雪型の１番艦なんです。\\n第三次ソロモン海海戦では、駆逐艦一隻としては、特別な大活躍をお見せしました。\\n頑張ります！" => { tr => "Special class destroyer, Ayanami.\\nI'm the first ship of the improved\\nFubuki class. In the Third Battle of the\\nSolomon Sea, I showed an outstanding\\nperformance as a destroyer.\\nI'll do my best!", desc => "mst_shiptext.xml" },
        "特型駆逐艦、２番艦、白雪です。\\n緒戦の数々の作戦に参加しました。その後、増援の部隊を輸送する第八十一号作戦に護衛隊旗艦として参加致しました。" => { tr => "Special-type destroyer, 2nd ship Shirayuki.\\nAt the start of the war, I participated in\\nmany operations. After that, I was the\\nflagship of the escort in Operation 81\\nthat transported troop reinforcements.", desc => "mst_shiptext.xml" },
        "特型駆逐艦、４番艦の深雪さまだよ！\\n演習中に他の駆逐艦とぶつかって事故っちゃったこともあるんだ。\\nまー、でもやるときゃやるぜ。みてなって！" => { tr => "4th of the special-type destroyers,\\nMiyuki-sama! During practice, I hit\\nanother destroyer and made a bit of scene.\\nEh, but I gotta do what I gotta do.\\nWatch and see!", desc => "mst_shiptext.xml" },
        "特型駆逐艦、５番艦の叢雲よ。\\nえ、知らないって？　全く、ありえないわね。\\n南方作戦や、古鷹の救援、数々の作戦に参加した名艦の私を知らないって、あんた、もぐりでしょ！" => { tr => "Special type destroyer, fifth ship Murakumo.\\nWhat? You don't know me? Really, that's impossible.\\nDon't even know a famous ship like me, who participated in the Southern Operations, relief of Furutaka, and many other operations, you really are inept!", desc => "mst_shiptext.xml" },
        "特型駆逐艦「曙」よ。\\nって、こっち見んな！　この糞提督！" => { tr => "Special-type destroyer, 'Akebono'. Hey!\\nDon't look at me, you shitty Admiral!", desc => "mst_shiptext.xml" },
        "特型駆逐艦の１９番目、綾波型でいうと、９番艦の漣だよ。\\n読みにくいって？貴方が字を知らないだけヨ。\\n南雲機動部隊が真珠湾でボコボコやってる時、ミッドウェー島砲撃を敢行したよ。何気に凄くない？" => { tr => "Special-type destroyer number 19, 9th of\\nthe Ayanami-class, Sazanami. It's hard to\\nread? Only you don't know that character,\\nyou know. I was with the Nagumo Task Force\\nwhen Pearl Harbour was burbling, and\\nheaded off to bombard Midway. Wasn't that\\nunexpectedly cool?", desc => "mst_shiptext.xml" },
        "特型駆逐艦１８番艦、綾波型の８番艦、曙よ。\\nお相撲さんではないわ。覚えておいて。\\n初の空母戦、珊瑚海海戦にも参加したわ！\\nけど、何気に潜水艦は苦手かな…。" => { tr => "Special-type destroyer number 18,\\n8th of the Ayanami-class, Akebono.\\nI'm not a sumo wrestler. Remember that.\\nI participated in the first naval air battle,\\nthe Coral Sea! But, I'm a bit\\nuneasy around subs...", desc => "mst_shiptext.xml" },
        "特型駆逐艦９番艦の磯波です。\\n数々の作戦に参加したんですけど、中破してからは後方で海上護衛や哨戒活動に従事していました。\\n頑張ります。" => { tr => "Ninth ship of the special-type destroyers,\\nIsonami. Though I participated in many\\ndifferent battles, after getting damaged,\\nI ended up in the marine guard and rear\\npatrol. I'll do my best!", desc => "mst_shiptext.xml" },
        "球磨型軽巡洋艦の１番艦、球磨だクマ。\\n佐世保生まれだクマ。ちょっと古いところもあるけど、頑張るクマー。" => { tr => "First ship of the Kuma-class light cruisers,\\nKuma kuma. Born in Sasebo kuma. I got\\nsome old parts, but I'll try my best, kumaa.", desc => "mst_shiptext.xml" },
        "球磨型軽巡洋艦の２番艦、多摩だにゃ。\\n水雷戦隊の旗艦として、ご奉公するにゃ！\\nにゃ？多摩って名前だけど、猫じゃないもん！" => { tr => "Second of the Kuma-class light cruisers,\\nTama nya. I did my duty as a torpedo\\nsquadron flagship, Nya! Nya?\\nTama's my name, but I'm not a cat!", desc => "mst_shiptext.xml" },
        "球磨型軽巡洋艦の３番艦、北上だよー。\\nんあ？そう、大井っちとは親友。\\n酸素魚雷を打ちまくる重雷装巡洋艦にステップアップできるってさ。\\nやってみる？" => { tr => "It's Kitakami, the third ship of the Kuma\\nclass. Hmm? Yeah, Ooi's my best pal.\\nI heard I can go another step and become\\na torpedo crusier that machine guns out\\noxygen torpedoes. Wanna try?", desc => "mst_shiptext.xml" },
        "球磨型軽巡洋艦の４番艦、大井よ。神戸生まれなの。\\n平時は海軍兵学校練習艦として活躍したのよ？\\nもちろん真打ちは、重雷装艦へのモデルチェンジよね？頑張るわ！" => { tr => "I'm Ooi, fourth ship in the Kuma-class light\\ncruisers. I was born in Kobe. I'm an active\\npractice ship at the Navy School, you know?\\nOf course, I'll change into a torpedo\\ncruiser if I need to fight for real.\\nNice to meet you!", desc => "mst_shiptext.xml" },
        "瑞鳳です。\\n軽空母ですが、練度があがれば、\\n正規空母並の活躍をおみせできます。" => { tr => "I'm Zuihou. I'm a light carrier, but with\\nproper experience, I'll be able to show\\nyou that I perform as well\\nas an aircraft carrier.", desc => "mst_shiptext.xml" },
        "生まれは大阪、所属は呉。真珠湾からガダルカナルまで駆けまわったんじゃ。\\n最期は金剛姉さんを護衛して台湾海峡…\\nまぁ、もうどうにもならんなぁ……。" => { tr => "Osaka-born, attached to Kure. I saw action\\nfrom Pearl Harbor to Guadalcanal. My last\\nmoments were escorting Kongou nee-san at\\nthe Taiwan Strait. Anyway, there's nothing\\nthat can be done anymore...", desc => "mst_shiptext.xml" },
        "生れは呉海軍工廠。妙高型重巡２番艦の私は、上海事変にも警備出動したぞ。\\n太平洋戦線では第五艦隊の旗艦として、暴れまわったさ。\\n敵艦載機？　ああ、あれは少し苦手だな。" => { tr => "Born at the Kure Naval Yards. I am the\\nsecond of the Myoukou Heavy Cruisers,\\nwho was the guardian of Shanghai.\\nI was rushed out to the Pacific front\\nas a flagship of the 5th fleet.\\nCarrier-based planes?\\nAh, I'm a bit bad with those.", desc => "mst_shiptext.xml" },
        "生れは呉海軍工廠。妙高型重巡２番艦の私は、上海事変にも警備出動したぞ。\\n太平洋戦線では第五艦隊の旗艦として暴れまわったさ。敵艦載機？　ああ、あれは少し苦手だな。" => { tr => "Born at the Kure Naval Yards. I am the\\nsecond of the Myoukou Heavy Cruisers,\\nwho was the guardian of Shanghai.\\nI was rushed out to the Pacific front\\nas a flagship of the 5th fleet.\\nCarrier-based planes?\\nAh, I'm a bit bad with those.", desc => "mst_shiptext.xml" },
        "生れも育ちも呉の潜水艦なの。あのミッドウェーの大海戦のあと、飛龍が最後の力で深手を負わせたヨークタウンに止めを刺したのよ！空母たちの仇はとったわ！\\nあの大変な島への輸送任務でも頑張ったの。" => { tr => "I am a submarine born and raised in Kure. After that battle of Midway, I managed to land the final blow to Yorktown who defeated Hiryuu! Our carriers were avenged!\\nI also worked hard running transport missions to that terrible island.", desc => "mst_shiptext.xml" },
        "白雪です。\\nよろしくお願いします。" => { tr => "I'm Shirayuki.\\nThanks for having me.", desc => "mst_shiptext.xml" },
        "白露型九番艦、改白露型駆逐艦の江風だ。\\nそうさ、海風の姉貴たちと同じ、マル２計画で建造されたよ。まー、働いた働いた。ソロモン海は何度も駆け回ったよ。最期は夜戦さ。敵さんの電探…ありゃー反則さ。" => { tr => "Ninth ship of the Shiratsuyu-class, the revised Shiratsuyu-class destroyer, Kawakaze.\\nWell now, I was built under the Maru 2 program, the same as Umikaze and our big sisters. Maaan, that was some hard, hard work! We sailed the Solomon's seas many times over. My last moments were during night battle. The enemy's radar... really, what foul play!", desc => "mst_shiptext.xml" },
        "白露型駆逐艦の４番艦、夕立です。\\n第三次ソロモン海戦では、けっこう頑張ったっぽい？\\nでも、何気に「アイアンボトム・サウンド」って、ホントに怖い言葉よね？" => { tr => qq[I'm Yuudachi, the fourth ship of the\\nShiratsuyu class. I worked sort of\\nhard-ish during the Third Battle of the\\nSolomons didn't I? But somehow...\\nThe term "Iron Bottom Sound"\\nis really scary, isn't it?], desc => "mst_shiptext.xml" },
        "白露型駆逐艦一番艦、「白露」です！\\nはい、一番艦ですっ！" => { tr => "First ship of the Shiratsuyu-class\\ndestroyers, 'Shiratsuyu'! Yes, the first ship!", desc => "mst_shiptext.xml" },
        "白露型駆逐艦七番艦、改白露型としては一番艦となる海風です。\\nマル２計画によって建造されました。第二水雷戦隊の一翼として、ソロモン海の戦いにも参加しました。提督、どうぞよろしくお願い致します。" => { tr => "I am Umikaze, the Seventh of the Shiratsuyu Class Destroyer and the First of the Revised Shiratsuyu Class.\\nI was built according to the second Naval Armaments Supplement Program. I participated in the Battle of Guadalcanal, as part of the Second Torpedo Squadron. I will be in your care, Admiral.", desc => "mst_shiptext.xml" },
        "白露型駆逐艦七番艦、\\nそして改白露型一番艦となる、海風です。\\n提督、どうぞよろしくお願いします！" => { tr => "I am Umikaze, the Seventh of the Shiratsuyu-class Destroyer, and the First of the Revised Shiratsuyu-class.\\nI'll be in your care, Admiral!", desc => "mst_shiptext.xml" },
        "白露型駆逐艦九番艦、\\n改白露型の江風だよ。よろしくな！\\nあ、読み方、間違えンなよ。" => { tr => "The 9th Shiratsuyu-class Destroyer, Kawakaze of the\\nrevised Shiratsuyu-class. Nice to meet you! \\nAh, about the reading of my name, do not get it wrong!", desc => "mst_shiptext.xml" },
        "白露型駆逐艦五番艦の春雨です、はい。\\n輸送作戦はお任せください……です。" => { tr => "Fifth Shiratsuyu-class destroyer, Harusame, yes.\\nLeave the transport missions to me... desu.", desc => "mst_shiptext.xml" },
        "白露型駆逐艦五番艦の春雨です。\\nおいしそう…ってその春雨とは違います！村雨や夕立姉さんたちと共に第二駆逐隊として海を駆け巡りました！輸送や護衛任務は、少し得意なんです。はい！" => { tr => "Fifth Shiratsuyu-class destroyer, Harusame.\\nDelicious, wait! a different kind of Harusame! With Murasame and big sis Yuudachi we toured the sea as Destroyer Division 2! Transportation and guarding, I'm a bit good at! Yes!", desc => "mst_shiptext.xml" },
        "白露型駆逐艦３番艦、村雨よ。\\n雨の名前の駆逐艦群なんてお洒落よね？\\n姉妹艦の夕立たちと一緒に第２駆逐隊を編成したの。鼠輸送ですって？　失礼しちゃう、ガダルカナル島輸送作戦でも活躍したわ！" => { tr => "3rd of the Shiratsuyu-class destroyers,\\nMurasame! Aren't all the Rainy destroyers\\nstylish? With my sister ship Yuudachi, we\\nformed the 2nd DesDiv. 'Rat Transport?'\\nWell, excuse me, I did great at the\\nGuadalcanal transport runs, you know!", desc => "mst_shiptext.xml" },
        "白露型駆逐艦３番艦、村雨よ。\\n雨の名前の駆逐艦群なんてお洒落よね？\\n姉妹艦の夕立たちと一緒に第2駆逐隊を編成したの。鼠輸送ですって？　失礼ちゃう、ガダルカナル島輸送作戦でも活躍したわ！" => { tr => "3rd of the Shiratsuyu-class destroyers,\\nMurasame! Aren't all the Rainy destroyers\\nstylish? With my sister ship Yuudachi, we\\nformed the 2nd DesDiv. 'Rat Transport?'\\nWell, excuse me, I did great at the\\nGuadalcanal transport runs, you know!", desc => "mst_shiptext.xml" },
        "皐月だよっ。\\nよろしくな！" => { tr => "I'm Satsuki.\\nGood to meet ya!", desc => "mst_shiptext.xml" },
        "睦月です。\\nはりきって、まいりましょー！" => { tr => "I'm Mutsuki.\\nLet's work together!", desc => "mst_shiptext.xml" },
        "睦月型駆逐艦の９番艦、菊月だ。\\n緒戦は数々の攻略作戦に参加。\\nそして、船団護衛に従事したんだ。\\nいや、護衛任務も大切なミッションだ……。" => { tr => "I'm Kikuzuki, 9th of the Mutsuki-class\\nDestroyers. In the very early part of\\nthe war, I participated in lots of capture\\noperations. And in the latter part, I engaged\\nin fleet-guard. It may not look so, but\\nfleet-guard is an important mission for\\ncertain.", desc => "mst_shiptext.xml" },
        "睦月型駆逐艦三番艦「弥生」です。\\n横須賀の浦賀生まれ。「睦月」や「望月」と艦隊を組んで色々頑張りました。爆撃機とかは嫌い。よろしくね。" => { tr => "Third of the Mutsuki-class destroyers,\\n'Yayoi'. I was born at Uraga, Yokosuka.\\nMutsuki, Mochizuki and I did our best as\\na task force. I dislike dive bombers.\\nPlease take good care of me.", desc => "mst_shiptext.xml" },
        "睦月型駆逐艦四番艦の「卯月」だぴょん。船団護衛から攻略作戦まで、頑張って働いたんでっす！\\n最後のほうは砲をいくつか下して機銃を一杯積んだよ。\\nうーちゃん、爆撃じゃ沈まないから！" => { tr => "Fourth of the Mutsuki-class destroyers,\\n'Uzuki'-pyon. From convoy escorting to\\ncapture operations, I worked really hard!\\nNear the end I was loaded up with lots of\\nmachineguns to down them all!\\nU-chan won't be sunk by bombers!", desc => "mst_shiptext.xml" },
        "睦月型駆逐艦望月でーす。\\n第30駆逐隊に所属して各攻略作戦に参加したよ。\\n何度も修理を繰り返しながら輸送任務に従事したぞ。\\n結構頑張ったっしょ？" => { tr => "Mutsuki-class destroyer Mochizuki. I took\\npart in several invasions as a member of the\\n30th Destroyer Squadron. I engaged in\\ntransport missions again and again while\\ngoing through repeated repairs.\\nWorked hard, didn't I?", desc => "mst_shiptext.xml" },
        "睦月型駆逐艦２番艦の如月と申します。\\nウェーク島では五月蠅いF4F戦闘機の攻撃を受けながら奮戦しました。\\nいやん、ほんと、髪の毛が潮風で痛んじゃう……。" => { tr => "The second ship of Mutsuki-class, Kisaragi.\\nAt Wake Island, I fought bravely under the assault of annoying F4F Fighters.\\nNooo. I mean it... the sea breeze will ruin my hair...", desc => "mst_shiptext.xml" },
        "睦月型駆逐艦７番艦の文月だよ。\\n数々の海戦に参加したんだ。\\n船団護衛中に大型船と衝突して大破…したこともあったっけ。あれはやばかったなー。" => { tr => "I'm Fumizuki, the seventh ship of the\\nMutsuki-class Destroyers. I've been\\nin many open-sea battles. I was once on a\\nfleet escort mission when I collided with a\\nlarge ship and... got really hurt.\\nIt was such a mess!", desc => "mst_shiptext.xml" },
        "睦月型８番艦だ。\\n東南アジア方面の攻略作戦後は、船団護衛を任されていた。コロンバンガラ島への揚陸作戦では敵艦の襲撃を受けながら奮戦したよ。" => { tr => "Eighth ship of the Mutsuki-class. After the\\noccupation of Southeast Asia, I was\\nassigned to escort duties. While unloading\\nat Kolombangara, I had to fend off a\\nsurprise attack by the enemy fleet.", desc => "mst_shiptext.xml" },
        "神戸娘の駆逐艦よ？　そう、名前は荒潮。\\n姉妹達とけっこう色々頑張ったのよ。\\nでも、私の煙突に爆弾落とすのだけは、ちょっとやめてほしいわ。" => { tr => "I'm the Kobe girl destroyer.\\nYes, I'm Arashio.\\nMy sisters and I worked hard in a lot of\\nplaces. The only thing is, I really do\\ndislike having my smokestack destroyed\\nby bombers.", desc => "mst_shiptext.xml" },
        "神戸生まれのお洒落な重巡といえば、わたくし、熊野ですね。マレー、ミッドウェー、ソロモン、マリアナと主要な名所、いえ激戦地に参上いたしましたのよ。\\n最期は日本に帰りたかったけれど……。" => { tr => "The stylish Kobe-born heavy cruiser, why,\\nit can only be myself, Kumano. At the\\nfamous Malaya, Midway, Solomon and\\nMarianas hard-fought battles, I, of course,\\nparticipated. I did want to return\\nto Japan at the end however...", desc => "mst_shiptext.xml" },
        "神戸生まれの鬼怒だよ。\\n舞鶴の学校で訓練に励んだんだ。色々と大変になってきた後は、南西方面で頑張ったよ…　いやぁ、大変だったなあ。球磨ちゃんには随分と助けてもらったんだ。\\nでも…パナイ島だけはマジパナイ！" => { tr => "Born in Kobe, I'm Kinu! I trained well at the\\nMaizuru School. After lots of dangerous\\nthings happened, I did my best in the\\nSouthwest... Well, that was bad too.\\nKuma-chan was suprisingly helpful too.\\nBut... Panay Island was seriously panai!", desc => "mst_shiptext.xml" },
        "神通です。近代化改装を受け、\\n第２水雷戦隊の旗艦を務めました。\\nコロンバンガラ島沖海戦では先頭に立って奮戦します。でも、みんな私の事狙うんですもの…ひどいわ……。" => { tr => "I am Jintsuu. I received a modernization\\nand was assigned as the flagship of the\\nDesRon2. I fought bravely as the\\nvanguard at the Battle of Kolombangara\\nIsland. But, everybody shot at me...\\nHow cruel...", desc => "mst_shiptext.xml" },
        "祥鳳型航空母艦１番艦です。\\n元々は潜水母艦だったんです。\\n前衛艦隊や主力じゃない小艦隊に空母を配属するなら、ぜひ私を使ってね！\\n運用によってはお役に立つはずです！" => { tr => "First of the Shouhou-class aircraft carriers.\\nOriginally, a submarine tender. If it's not\\nthe flagship or the main fleet but a small\\ntask-force, then by all means use me!\\nIf you make use of me,\\nI'll surely get good results!", desc => "mst_shiptext.xml" },
        "祥鳳型軽空母、瑞鳳です。\\n元々は高速給油艦として計画され、次に潜水母艦、最終的に軽空母として完成しました。\\n小柄なボディだけれど、機動部隊最後の日まで敢闘しました！" => { tr => "I'm the Shouhou-class light aircraft carrier,\\nZuihou. Originally planned as a high-speed\\nrefueling ship, then a submarine tender,\\nbut finally completed as a light aircraft\\ncarrier. Though my body is small,\\nI fought bravely to the last day!", desc => "mst_shiptext.xml" },
        "私、加賀は、八八艦隊三番艦として建造されました。\\n様々な運命のいたずらもあって、最終的に大型航空母艦として完成しました。\\n赤城さんと共に、栄光の第一航空戦隊、その主力を担います。" => { tr => "I, Kaga, was built as the third ship of the\\neight-eight fleet. After being played by\\nfate, time after time, I was completed\\nas a large aircraft carrier. Along with\\nAkagi-san, we are main force of the\\nglorious first air carrier division.", desc => "mst_shiptext.xml" },
        "私、加賀は、八八艦隊３番艦として建造されました。\\n様々な運命のいたずらもあって、最終的に大型航空母艦として完成しました。\\n赤城さんと共に、栄光の第一航空戦隊、その主力を担います。" => { tr => "I, Kaga, was built as the third ship of the\\neight-eight fleet. After being played by fate,\\ntime after time, I was completed as\\na large aircraft carrier. Along with\\nAkagi-san, we are main force of the\\nglorious first air carrier division.", desc => "mst_shiptext.xml" },
        "私、妙高型重巡洋艦、妙高と申します。\\n共に頑張りましょう。" => { tr => "I am Myoukou, of the Myoukou-class\\nHeavy Cruisers. Let us work on this\\ntogether.", desc => "mst_shiptext.xml" },
        "私、足柄が英国の観艦式に参加した時のことよ。\\nまるで「飢えた狼のよう」と評価されたの。\\n当然よね！この精悍なボディ！\\nえ？それは色気がないって嫌味じゃないかって？\\nそんなことあるわけ…ナイじゃない！" => { tr => "I am the Ashigara that participated in\\nthe English fleet review, you know. I was\\nacknowledged as the 'Hungry Wolf'. But\\nof course! With this fearless body! Eh?\\nThat's got nothing to do with my sex\\nappeal? And wasn't even a praise?\\nThere's... no way that's right!", desc => "mst_shiptext.xml" },
        "私が、戦艦長門だ。よろしく頼むぞ。\\n敵戦艦との殴り合いなら任せておけ。" => { tr => "I am Battleship Nagato, pleased to meet\\nyou. Leave the enemy battleships to me.", desc => "mst_shiptext.xml" },
        "私が菊月だ、共にゆこう。" => { tr => "I'm Kikuzuki, let's move out together.", desc => "mst_shiptext.xml" },
        "私が鳥海です。よろしくです。" => { tr => "I am Choukai. My best regards.", desc => "mst_shiptext.xml" },
        "私は愛宕、提督、覚えてくださいね。" => { tr => "I'm Atago, Admiral, please remember it,\\nokay?", desc => "mst_shiptext.xml" },
        "秋月型防空駆逐艦、一番艦、秋月。\\nここに推参致しました。お任せください！" => { tr => "Akizuki-class anti-air destroyer, first ship, Akizuki.\\nI'm reporting in here. Please leave it to me!", desc => "mst_shiptext.xml" },
        "秋月型防空駆逐艦、二番艦の照月よ。\\n戦艦の護衛でも、鼠輸送でも、なんでもこなしちゃうんだから！" => { tr => "I'm Takanami, the sixth Yuugumo-class\\nDestroyer. Born in Uraga. I was assigned to\\nthe 31st Destroyer Division, and I had\\ndone my part well. On a fateful night\\nbattle at Lunga Point, as the Leadship\\nof the Lookouts squad, our crew first\\nspotted the enemy fleet... and that may\\nhave brought victory to the battle... Yup!", desc => "mst_shiptext.xml" },
        "秋月型防空駆逐艦、二番艦の照月よ。\\n秋月姉さん同様、どうぞよろしくお願いします。" => { tr => "I am Teruzuki, the second ship of Akizuki-class Anti-air Destroyer.\\nAs with Akizuki-neesan, it is a great honor to be in your care.", desc => "mst_shiptext.xml" },
        "秋月型防空駆逐艦二番艦、照月よ。\\n秋月姉と第61駆逐隊を編成しました。ソロモンの激戦では、比叡さんや霧島さんと共に戦ったのよ！え？ドラム缶による鼠輸送？ああ、あれは…あれはね…。" => { tr => "2nd of Akizuki-class Anti-air Destroyer, Teruzuki.\\nWith Akizuki-nee, we're organized as Destroyer Squadron 61. In the Battle of Solomon, we fought together with Hiei-san and Kirishima-san! What? The supply drum transport? Ah... that's.... that's...", desc => "mst_shiptext.xml" },
        "秋雲、着任！\\n提督よろしくねっ！" => { tr => "Akigumo, reporting for duty!\\nLook after me Admiral!", desc => "mst_shiptext.xml" },
        "空母になった千代田です。\\nぜひ、千歳お姉と一緒に機動部隊を編制してね！" => { tr => "The girl that became an aircraft carrier,\\nChiyoda. Of course, I'll be assigned to\\nChitose-onee's fleet, yes?", desc => "mst_shiptext.xml" },
        "第四次軍備充実計画で建造された陽炎型駆逐艦、ネームシップの陽炎よ。\\n新鋭の主力駆逐艦として、ハワイ攻撃機動部隊を始め、様々な作戦に参加したわ！\\nよろしくね！" => { tr => "Constructed for the Circle-4 programme,\\nKagerou-class nameship, Kagerou.\\nAs the main power of the newly-made ships,\\nstaring off with the Hawaii attack force,\\nI was in lots of varied battles!\\nTreat me well!", desc => "mst_shiptext.xml" },
        "第４水雷戦隊のセンターも務めた那珂だよ！\\nお仕事沢山入ってて、輸送船の護衛任務や、トラック島から南方への輸送任務とか…\\n…え、地方巡業じゃんって？ そんなことないしっ！" => { tr => "Selected as the Centre of the 4thDesron,\\nit's Naka-chan! Doing lots of work, from\\nguarding transports to doing the Tokyo\\nExpress from Truk...\\nEh? Was it a Provincial tour, you ask?\\nThat is SO not what I was doing!", desc => "mst_shiptext.xml" },
        "筑摩です。\\n連装主砲４基を前甲板に集中させ、充実した索敵水偵を搭載した利根型重巡洋艦２番艦です。\\n生まれは長崎よ。利根姉さんと一緒に、あの南雲機動部隊の、大切な眼の役目を務めたの。" => { tr => "I'm Chikuma. Carrying 4 twin cannons\\non the foredeck, and with substantial\\nreconnaissance capability, I am the\\n2nd of the Tone-class heavy cruisers.\\nTogether with Tone nee-san, I acted as\\nthe important eyes of the Nagumo task\\nforce.", desc => "mst_shiptext.xml" },
        "筑摩です。\\n連装主砲4基を前甲板に集中させ、充実した索敵水偵を搭載した利根型重巡洋艦２番艦です。\\n生まれは長崎よ。利根姉さんと一緒に、あの南雲機動部隊の、大切な眼の役目を務めたの。" => { tr => "I'm Chikuma. Carrying 4 twin cannons\\non the foredeck, and with substantial\\nreconnaissance capability, I am the\\n2nd of the Tone-class heavy cruisers.\\nTogether with Tone nee-san, I acted as\\nthe important eyes of the Nagumo task\\nforce.", desc => "mst_shiptext.xml" },
        "素敵な提督で嬉しいのね。\\n伊十九なの。そう、イクって呼んでもいいの！" => { tr => "Such a great admiral makes me happy.\\nI'm I-19. Yep, calling me 'Iku' is fine!", desc => "mst_shiptext.xml" },
        "綾波型駆逐艦「漣」です、ご主人さま。\\nこう書いてさざなみと読みます。" => { tr => "Ayanami-class Destroyer 'Sazanami',\\nMaster. You write it like this, but read\\nit as 'Sazanami'.", desc => "mst_shiptext.xml" },
        "綾波型駆逐艦７番艦の朧です。\\n佐世保の海軍工廠生まれです。南方進攻作戦などに参加しました。熱いところの海の方がいいな。\\nキス…か？　じゃなくって、寒いキスカ島は…あまり近づきたくない…かな。" => { tr => "7th ship of the Ayanami-class, Oboro.\\nLaid down in the Sasebo Naval Arsenal.\\nI participated in the Southern operations.\\nHot places are better, aren't they? Kiss...?\\nNo, not that, the cold Kiska Island...\\nI don't want to get close to that... I hope.", desc => "mst_shiptext.xml" },
        "綾波型１０番艦の潮です。\\nレイテ沖海戦などの激戦を潜り抜け、運命のあの日、横須賀で御役目を終えるまで戦い抜きました。\\nあ、あの…沈めた敵艦の皆さんも…ホントはお助けしたいのです。ホントです！" => { tr => "I'm the 10th of the Ayanami-class, Ushio.\\nI survived the Battle of Leyte Gulf and many other fierce battles. After that fateful day at Leyte, I fought on dutifully till the \\nend of the war at Yokosuka. U-um...to all the \\nenemy ships that that were sunk... I really \\nwanted to spare you. Really!", desc => "mst_shiptext.xml" },
        "練習巡洋艦、香取です。\\n心配しないで…。色々と優しく、\\n指導させて頂きますから。" => { tr => "I'm Katori, a Training Cruiser. Don't you\\nworry... I'll be gentle in teaching you various\\nthings.", desc => "mst_shiptext.xml" },
        "羽黒です。妙高型重巡洋艦姉妹の末っ娘です。\\nあ、あの…ごめんなさいっ！" => { tr => "I'm Haguro. I'm the youngest of the\\nMyoukou-class heavy cruiser sisters.\\nU-um... I'm sorry!", desc => "mst_shiptext.xml" },
        "翔鶴型航空母艦１番艦、翔鶴です。\\n一航戦、二航戦の先輩方に、少しでも近づけるように\\n瑞鶴と一緒に頑張ります！" => { tr => "I'm Shoukaku, the first of the Shoukaku-class carriers.\\nAlongside Zuikaku as a remodeled Shoukaku-class, I'm hoping to be a useful source of strength for the admiral.", desc => "mst_shiptext.xml" },
        "翔鶴型航空母艦１番艦の翔鶴です。\\n海軍軍縮条約失効後に設計建造された、本格的な大型正規空母として就役しました。妹の瑞鶴と共に第五航空戦隊を編成します。あの惨劇の後は、先輩方の後を継いで戦線を支えました。" => { tr => "I'm Shoukaku, the first ship in the Shoukaku\\ncarrier series. I was designed and built as\\nthe first purpose-built large regular carrier\\nto serve after the Washington Treaty was\\nrenounced. With my sister Zuikaku,\\nwe make the fifth carrier division.\\nFollowing the tragedy, we followed in the\\nfootsteps of our seniors and continued\\nto support the frontlines.", desc => "mst_shiptext.xml" },
        "翔鶴型航空母艦１番艦の翔鶴です。\\n軍縮条約失効後に設計建造された、本格的な大型正規空母として就役しました。妹の瑞鶴と共に第五航空戦隊を編成します。あの惨劇の後は、先輩方の後を継いで戦線を支えました。そして今、マリアナを超えて、提督と共に翔び続けたいと思います。" => { tr => "I'm Shoukaku, the first ship in the Shoukaku carrier series.\\nI was designed and built as the first purpose-built large regular carrier to serve after the Washington Treaty was renounced. With my sister Zuikaku, we make the fifth carrier division. Following the tragedy, we followed in the footsteps of our seniors and continued to support the front lines. And now, having gotten over Mariana, I wish to continue taking a leap forward with the admiral.", desc => "mst_shiptext.xml" },
        "翔鶴型航空母艦２番艦、妹の瑞鶴です。\\n幸運の空母ですって？そうじゃないの、一生懸命やってるだけ…よ。艦載機がある限り、負けないわ！" => { tr => "Second of the Shoukaku-class aircraft carriers, the younger sister, Zuikaku.\\nThe lucky carrier, you say? That's not it—I just fight with all my might... you see? As long as I still have planes, I won't lose!", desc => "mst_shiptext.xml" },
        "翔鶴型航空母艦２番艦、妹の瑞鶴です。\\n幸運の空母ですって？そうじゃないの、一生懸命やってる\\nだけ…よ。艦載機がある限り、負けないわ！" => { tr => "Second of the Shoukaku-class aircraft\\ncarriers, the younger sister Zuikaku.\\nThe lucky carrier, you say? That's not it,\\nI just fight with all my might...\\nAs long as I have planes, I won't lose!", desc => "mst_shiptext.xml" },
        "翔鶴型航空母艦２番艦、瑞鶴です。\\n翔鶴姉と共に、ミッドウェーの後の第一機動部隊の中核として、矢尽き刀折れるまで奮戦しました。文字通り、最後の機動部隊が壊滅する、その日まで…。" => { tr => "Second of the Shoukaku-class aircraft\\ncarriers, Zuikaku. After Midway, I formed\\nthe core of the 1st carrier division with\\nShoukaku, where I fought tooth and nail.\\nQuite literally, until the day that\\nthe Kidou-butai was destroyed...", desc => "mst_shiptext.xml" },
        "翔鶴型航空母艦２番艦、瑞鶴です。\\n翔鶴姉と共にミッドウェーの後の第一機動部隊の中核として、矢尽き刀折れるまで奮戦しました。文字通り、最後の機動部隊が壊滅する、その日まで。でも、今度は違うの。改装された本格正規空母の力、存分に魅せるわ！翔鶴姉、やろう！" => { tr => "Second of the Shoukaku-class aircraft carriers, Zuikaku.\\nFollowing the battle of Midway, I occupied a core position in the First Mobile Fleet along with Shoukaku-nee. I fought until the very last arrow was fired... which was literally the day the Mobile Fleet was completely annihilated. ...However, this time will be different! I will show you the strength and potential of a fully remodeled aircraft carrier! Shoukaku-nee, let's do this!", desc => "mst_shiptext.xml" },
        "自分、あきつ丸であります。\\n艦隊にお世話になります。" => { tr => "I'm Akitsu Maru, sir.\\nIt is an honor to be part of this fleet, sir.", desc => "mst_shiptext.xml" },
        "自分、航空兵力を充実させてみたのであります。\\nこれはもう空母…であります…。" => { tr => "I have enhanced myself for air combat\\npotential, sir. I am now a carrier, sir.", desc => "mst_shiptext.xml" },
        "自分は、陸軍の特種船…その丙型の「あきつ丸」であります。\\n輸送や上陸戦ならお任せ頂きたいのであります。\\n自慢はこの大発であります。ネズミやモグラな輸送とは訳が違うのであります。" => { tr => "I am the class-3 of Army's special\\ntransport 'Akitsu Maru', sir.\\nPlease leave transportation and landing\\ncombat to me, sir. My pride is this\\nDaihatsu, sir. I'm different from the\\nmouse and mole, sir.", desc => "mst_shiptext.xml" },
        "自分は、陸軍の特種船丙型の「あきつ丸」であります。強襲揚陸艦の先駆けのような自分でありますが、新兵器のオートジャイロなども運用して、対潜戦でも奮闘したいのであります。何卒お願いするのであります。" => { tr => "I am Akitsu Maru, of the Army's Hei class,\\nsir. I was the pioneer of the modern\\namphibious assault vessel, able to operate\\nnew weapons such as auto-gyros, sir. We\\nmay not do so well in anti-submarine\\nwarfare. I most humbly look forward\\nto working with you, sir.", desc => "mst_shiptext.xml" },
        "航空戦艦、伊勢です。\\n後部飛行甲板と、カタパルト２基で\\n航空戦力を運用可能よ！" => { tr => "I'm the aviation battleship 'Ise'! With a\\nrear-facing flight deck and 2 catapults,\\nI can make use of the power of aviation!", desc => "mst_shiptext.xml" },
        "航空母艦、加賀です。\\n貴方が私の提督なの？　それなりに期待はしているわ。" => { tr => "I'm aircraft carrier, Kaga. Are you my\\nAdmiral?... I have fairly high expectations\\nof you.", desc => "mst_shiptext.xml" },
        "航空母艦、蒼龍です。\\n真珠湾攻撃から始まって、緒戦の重要な戦いに、主力空母の一隻として参加しました。\\nえ？なに、ミッドウェー？なにそれ、美味しいの？" => { tr => "Aircraft carrier Souryuu. Starting from the\\nPearl Harbor attack, an important battle of\\nthe war, I became the flagship. Huh?\\nMidway? What's that? Is it tasty?", desc => "mst_shiptext.xml" },
        "航空母艦、蒼龍です。\\n空母機動部隊を編制するなら、私もぜひ入れてね！" => { tr => "I'm aircraft carrier Souryuu. If you're making\\na carrier task force, count me in!", desc => "mst_shiptext.xml" },
        "航空母艦、赤城です。\\n空母機動部隊の主力として快進撃を支えます。\\n日頃鍛錬を積んだ自慢の艦載機との組み合わせは、無敵艦隊とも言われたんです。慢心…ですって？\\nううん、そうかなあ……気をつけますね。" => { tr => "I'm the aircraft carrier, Akagi. As part\\nof the core of the Mobile Strike Force,\\nI support the victorious advances.\\nTogether with my pride experienced\\nplanes, we were called the invincible fleet.\\nOverconfident, you say...?\\nHmm, perhaps so... I'll keep that in mind.", desc => "mst_shiptext.xml" },
        "航空母艦、赤城です。\\n空母機動部隊を編制するなら、私にお任せくださいませ。" => { tr => "I'm the aircraft carrier Akagi. If you're\\nforming a carrier division, just leave it\\nto me.", desc => "mst_shiptext.xml" },
        "航空母艦、飛龍です。\\n空母戦ならお任せ！どんな苦境でも戦えます！" => { tr => "I'm aircraft carrier Hiryuu. Leave the carrier\\nbattles to me, I can fight on against any and\\nall adversity.", desc => "mst_shiptext.xml" },
        "航空母艦、鳳翔です。\\nふつつか者ですが、よろしくお願い致します。" => { tr => "Aircraft carrier, Houshou. Although I'm\\ninexperienced, I look forward to your\\nguidance.", desc => "mst_shiptext.xml" },
        "航空母艦、鳳翔と申します。\\n最初から空母として建造された、世界で初めての航空母艦なんです。\\n小さな艦ですが、頑張りますね。" => { tr => "I am aircraft carrier Houshou. Built as CV\\nfrom the beginning, I'm the world's first\\naircraft carrier. I am a petite ship,\\nbut I'll do my best.", desc => "mst_shiptext.xml" },
        "航空母艦「大鳳」です。\\n飛行甲板まで十分な防御を施された最新鋭の正規空母です。密閉型の格納庫も素敵でしょ？\\nえ？　ガスが溜りやすい…ですって…失礼しちゃう。こ、今度は絶対に大丈夫！" => { tr => "I'm the Armoured Carrier, Taihou. I'm the\\nnewest and most advanced standard carrier\\nthat is armed with a flight deck. Aren't\\nthese enclosed hangars great? Hmm?\\nYou say that gas builds up easily?\\nHow rude. I-it'll be fine this time!", desc => "mst_shiptext.xml" },
        "航空母艦「大鳳」です。\\n飛行甲板まで十分な防御を施された最新鋭の正規空母です。密閉型の格納庫やハリケーン・バウもいい感じでしょ？　装甲甲板もお化粧直ししてみたわ。どう？似合う？" => { tr => "I am aircraft carrier Taihou. State-of-the-\\nart carrier with reinforced armour all round,\\nincluding the flight deck. My enclosed\\nhangers and Hurricane Bow look good,\\ndon't they? My armored flight deck has\\nalso been redecorated. How does it look?\\nDo you think it suits me?", desc => "mst_shiptext.xml" },
        "航空運用能力を付与された航空戦艦、日向だ。\\nレイテでも奮戦したぞ。\\n戦略物資輸送作戦「北号作戦」も思い出深いな。\\nああ、そうだ、海自のＤＤＨ「ひゅうが」に名は受け継がれている。" => { tr => qq[I'm Hyuuga. I got the ability of carrying\\naircrafts, and now I am an aviation\\nbattleship. I fought bravely in Battle of\\nLeyte Gulf.An operation of transporting\\ntactical goods "Operation Hoku-Go",\\nit is one with a lot of memories for me.\\nAh yes, JMSDF's DDH "Hyuuga"\\nsucceeds to my name.], desc => "mst_shiptext.xml" },
        "艦隊のアイドル、那珂（なか）ちゃんだよー！\\nよっろしくぅ！" => { tr => "The fleet's idol, Naka-chan!\\nNice to meet you!", desc => "mst_shiptext.xml" },
        "艦隊型駆逐艦、夕雲型駆逐艦の三番艦、風雲よ、よろしく。\\nあのミッドウェーからソロモンまで、主戦場を駆けたのよ。運命の日の夜、燃える空母を見上げたの。龍の最期、忘れない。" => { tr => "Fleet type destroyer, Yuugumo class, Kazagumo.\\nRegards. From Midway to Solomon, I advanced around the main battlefields. On that fateful night, I looked upon the burning aircraft carrier. I'll never forget the dragon's last moments.", desc => "mst_shiptext.xml" },
        "艦隊型駆逐艦の最高峰を目指して開発された、高速で重雷装の駆逐艦、島風型よ。\\n40ノット以上の快速なんだから。\\nでも、量産には向かなくって、私一隻しか建造されなかったの。" => { tr => "I am Shimakaze, the Shimakaze-class\\nship that was developed as the pinnacle\\nof destroyers, fast and armed with\\nheavy torpedoes. After all, I can go\\nfaster than 40 knots. However, we were\\nnot suited for mass production so I was\\nthe only one built.", desc => "mst_shiptext.xml" },
        "艦隊旗艦として特化設計された新鋭軽巡洋艦、\\n大淀です。\\n搭載予定の新型水偵の失敗や戦局の変化もあって、連合艦隊旗艦としてはあまり活躍できなかったの。でも、北号作戦や礼号作戦では活躍したのよ。私も前線で、頑張りますね。" => { tr => "Designed as a cutting edge C and C flagship,\\nthe newest light cruiser, Ooyodo. There was\\na problem with the installation of the\\nspecified new model recon and the battle\\nsituation changed, so I wasn't really able\\nto undertake my role as the combined fleet\\nflagship. However, I participated in the\\nNorthern Operation and the Battle of\\nMindoro. I, too, will do my best\\non the frontlines.", desc => "mst_shiptext.xml" },
        "艦隊防空のために建造された乙型一等駆逐艦、秋月型駆逐艦一番艦、秋月です。\\n４基８門の長10cm砲と高射装置を備えた防空艦として僚艦の初月らと共に第61駆逐隊を編成しました。頑張ります！" => { tr => "Designed for the fleet's anti-air, Type-B first class destroyer, Akizuki-class 1st destroyer, Akizuki.\\nAs an anti-air ship equipped with 4x 8-barrel Long 10cm guns and anti-aircraft fire director, along with Hatsuzuki and the others, we formed the 61st DesDiv. I'll do my best!", desc => "mst_shiptext.xml" },
        "艦隊随伴型の給油艦、速吸です。よろしくお願いします！\\n様々な物資を補給できる多用途給油艦でありながら、航空機の運用が可能な設計です。ミッドウェー海戦後の計画変更で流星の発進も可能となりました！" => { tr => "Fleet escort oiler, Hayasui. Best regards!\\nI'm a multi-purpose refuel vessel that can supply a variety of different materials and am also designed to carry carrier-based aircraft. With a change of plans after the Battle of Midway, I also became able to launch Ryuusei.", desc => "mst_shiptext.xml" },
        "英国で生まれた帰国子女の金剛デース。\\nヨロシクオネガイシマース！" => { tr => "It's the English-born returnee, Kongou!\\nNice to meet you!", desc => "mst_shiptext.xml" },
        "谷風さんだよ。\\nあのミッドウェー海戦では、飛龍を助けようとしてたらくそ敵機から雨あられの集中爆撃…。あんときゃまいったけど、勝見艦長がすげえんだ、マジで。" => { tr => "Madam Tanikaze here! I was helpin' out\\nHiryuu during the Battle of Midway, damn\\nenemy planes were dropping bombs on us\\nlike rain... Back then, c'mmander Katsumi\\nwas amazin' like, seriously.", desc => "mst_shiptext.xml" },
        "貴様が司令官か。\\n私は那智。よろしくお願いする。" => { tr => "You are my commander? I'm Nachi.\\nI appreciate your contribution.", desc => "mst_shiptext.xml" },
        "超弩級戦艦、伊勢型の１番艦、伊勢。\\n参ります！" => { tr => "Super-dreadnought, 1st of the\\nIse-class, Ise. Setting off!", desc => "mst_shiptext.xml" },
        "超弩級戦艦として建造技術導入を兼ねて英国ヴィッカース社で建造された、金剛デース！\\n太平洋戦域でも持前の高速力を活かして大活躍デース！期待してネ！" => { tr => "The super-dreadnought fitted with\\nWestern technology at Vickers in England,\\nKongou has arrived! Even in the Pacific\\nTheatre, I'll use the power of my speed\\nto be of great use! Look forward to it!", desc => "mst_shiptext.xml" },
        "足柄よ。砲雷撃戦が得意なの。\\nふふ、よろしくね。" => { tr => "I'm Ashigara. My specialty is surface\\ncombat. Nice to meet you.", desc => "mst_shiptext.xml" },
        "軽巡、多摩です。\\n猫じゃないにゃ。" => { tr => "Light cruiser, Tama.\\nI'm not a cat, meow.", desc => "mst_shiptext.xml" },
        "軽巡、長良です。\\nよろしくお願いします！" => { tr => "Light Cruiser Nagara!\\nPlease take good care of me!", desc => "mst_shiptext.xml" },
        "軽巡洋艦、天龍型２番艦の龍田よ。\\n生まれは佐世保なの。\\n天龍ちゃんがみんなに迷惑かけてない？\\n心配よね～。え？私？私は潜水艦が、ちょっと鬼門だわ～。" => { tr => "Light cruiser Tatsuta, second of the\\nTenryuu class. I come from Sasebo.\\nI hope Tenryuu-chan hasn't been causing\\neverybody trouble? You really can't take\\nyour eyes off that girl, right? Huh?\\nMe? Well, I'm not particularly fond of\\nsubmarines.", desc => "mst_shiptext.xml" },
        "軽巡洋艦、天龍型２番艦の龍田よ。\\n生まれは佐世保なの。\\n天龍ちゃんがみんなに迷惑かけてない？\\n心配よね～。\\nえ？私？私は潜水艦が、ちょっと鬼門だわ～。" => { tr => "Light cruiser Tatsuta, second of the\\nTenryuu class. I come from Sasebo.\\nI hope Tenryuu-chan hasn't been causing\\neverybody trouble? You really can't take\\nyour eyes off that girl, right? Huh?\\nMe? Well, I'm not particularly fond of\\nsubmarines.", desc => "mst_shiptext.xml" },
        "軽巡矢矧、着任したわ。\\n提督、最後まで頑張っていきましょう！" => { tr => "Light Cruiser Yahagi, reporting for duty.\\nLet's work at it together to the end,\\nAdmiral!", desc => "mst_shiptext.xml" },
        "軽空母、祥鳳です。はい、ちょっと小柄ですけど、\\nぜひ提督の機動部隊に加えてくださいね！" => { tr => "I'm the light aircraft carrier, Shouhou.\\nYes, I'm a little small, but please make\\na place for me on your fleet!", desc => "mst_shiptext.xml" },
        "軽空母、龍驤や。独特なシルエットでしょ？\\nでも、艦載機を次々繰り出す、\\nちゃーんとした空母なんや。期待してや！" => { tr => "Light aircraft carrier, Ryuujou! Ain't my\\nsilhouette distinctive? But, launching\\ncarrier planes one-after-another makes\\nme a proper carrier, ya know!\\nYou can count on me!", desc => "mst_shiptext.xml" },
        "軽空母だけど、結構歴戦の空母なんよ、うち。\\nああ、あの岩手沖での第四艦隊事件のこと？あれはきつかったー。\\n波浪で艦橋圧壊…いや、ホントありえへん。" => { tr => "I'm a light aircraft carrier, but with a long\\nrecord, ya' know? Oh, that Fourth Fleet\\nincident thing, off Iwate? That was tough.\\nThe waves made my bridge collapse...\\nMan, I just couldn't believe it.", desc => "mst_shiptext.xml" },
        "軽空母のエスコートや船団護衛に従事した睦月型駆逐艦三日月です。\\n激戦のソロモン海域にも出撃しました。旧式だけど速力を生かして強行輸送任務も奮闘しました。" => { tr => "I am Mikazuki, the Mutsuki class destroyer\\nthat participated in escorting light carriers\\nand other fleets. I even sortied to that\\nfierce battle of the Solomon Islands.\\nAlthough I'm an old model, utilizing my fast\\nspeed I even participated in some transport\\nmissions.", desc => "mst_shiptext.xml" },
        "連合艦隊唯一の工作艦、明石です。\\nトラック泊地に進出し、前線で損傷した艦艇の修理を担当したわ。トラック泊地が壊滅するその日まで、前線の艦隊を陰で支えたのよ。\\nよろしくね。" => { tr => "I'm Akashi, the only dedicated repair ship\\nin the combined fleet. I was in charge of\\nrepairing ships damaged in the frontlines\\nwhen I was stationed in the Truk Anchorage.\\nI supported the fleet from behind right up\\nuntil the destruction of the Anchorage.\\nPleased to meet you.", desc => "mst_shiptext.xml" },
        "遣独潜水艦作戦の第二次遣独艦として、かの地に向かったのよ。そして、Uボートをもらったの。この作戦は5回行われたんだけど、機雷とか色々あって、無事往復できたのは私だけなんですって…そうね、機雷なんてダイッキライ！" => { tr => "I made it to Germany as the second submarine sent on the transoceanic voyage. Then, I received a U-boat. This operation was carried out 5 times, but because of mines and other events, I was the only one who was able to successfully complete the return trip... yeah, I really hate mines!", desc => "mst_shiptext.xml" },
        "重巡洋艦、古鷹です。\\n三川提督率いる第８艦隊の一員として、第一次ソロモン海戦では敵艦多数を撃破したんですよ！\\nこれが、重巡なんです！" => { tr => "Heavy cruiser, Furutaka. Selected by\\nVice Admiral Mikawa to be a member\\nof the 8th fleet, I took out a lot of\\nenemies at the 1st Battle of Solomon!\\nThis is what a heavy cruiser can do!", desc => "mst_shiptext.xml" },
        "重巡洋艦、最上型のネームシップ、最上だよ。\\n三連主砲がいい感じでしょ？\\nそうそう、ボク、ちょっと他の艦とよくブツかっちゃう癖があるんだけど、なんでだろ？" => { tr => "I'm the heavy cruiser Mogami-class\\nnameship, Mogami. Aren't Three-barreled\\nmain guns great? Yeah, yeah, I've got\\na habit of bumping into the other ships,\\nI wonder why?", desc => "mst_shiptext.xml" },
        "重雷装艦として、生まれ変わった大井です。\\nお久しぶりです！" => { tr => "", desc => "mst_shiptext.xml" },
        "重雷装艦バージョンの大井です。\\n圧倒的な水雷戦力を期待されたけど、\\n出番がなかなかなかったの。\\n今度は活躍してみせるわ。見ていてね！" => { tr => "It's Ooi, torpedo cruiser edition.\\nMy torpedo powers were counted in,\\nbut I didn't have much of the limelight.\\nI'll show you what I'm made of this time.\\nKeep your eyes open!", desc => "mst_shiptext.xml" },
        "金剛お姉さまの妹分、比叡です。\\n経験を積んで、姉さまに少しでも近づきたいです。" => { tr => "I'm Hiei, Kongou Onee-sama's sister.\\nI'm looking forward to gaining experience\\nand getting closer to my sister's brilliance.", desc => "mst_shiptext.xml" },
        "鈴谷だよ！にぎやかな艦隊だね！\\nよろしくね！" => { tr => "I'm Suzuya! What a lively fleet it is.\\nI'll be in your care!", desc => "mst_shiptext.xml" },
        "鈴谷は、最上型重巡洋艦の３番艦。横須賀海軍工廠生まれなんだよ～、ふふ～ん。巡洋艦の名前は川由来なんだけど、鈴谷は樺太の鈴谷川がその由来なの。知ってた？" => { tr => "Suzuya's number 3 of the Mogami-class\\nheavy cruisers. I was born at the Yokosuka\\nNaval Arsenal, heheh. See, cruiser names\\ncome from rivers, so 'Suzuya' comes from \\nthe Suzuya river in Sakhalin.\\nDid ya know?", desc => "mst_shiptext.xml" },
        "長崎で生まれたの。\\nスラバヤ沖海戦、珊瑚海海戦、ミッドウェー海戦、第二次ソロモン海戦、マリアナ海戦など数々の海戦に参加しました。\\nあの…頑張ります！" => { tr => "I was born in Nagasaki. I participated in\\nmany battles, in the Battle of the Java Sea,\\nthe Battle of the Coral Sea, the Battle\\nof Midway, the Battle of the Eastern\\nSolomons, and the Battle of the\\nPhilippine Sea. Um... I try my best!", desc => "mst_shiptext.xml" },
        "長月だ。\\n駆逐艦と侮るなよ。役に立つはずだ。" => { tr => "Nagatsuki here. Don't take me lightly just\\nbecause I'm a destroyer. I'm useful.", desc => "mst_shiptext.xml" },
        "長良型軽巡四番艦の「由良」です。\\nどうぞ、よろしくお願いいたしますっ！" => { tr => "Fourth ship of the Nagara-class Light\\nCruisers, 'Yura'. Pleased to make your\\nacquaintance!", desc => "mst_shiptext.xml" },
        "長良型軽巡洋艦の阿武隈です。\\nはい…正直いって、北上さんは苦手です。なに、あの人…でも、艦首もきれいに直して頑張りました！\\n潮ちゃんも…ありがとね…。" => { tr => "I'm Abukuma of Nagara-class light cruisers.\\nYes... to be honest, I don't like Kitakami.\\nWhat's with her... but, I endured and fixed\\nmy beautiful bow! Ushio too...thanks...", desc => "mst_shiptext.xml" },
        "長良型軽巡洋艦の阿武隈です。\\nはい…正直いって、北上さんは苦手です。なにあの人…でも、艦首もきれいに直して頑張りました！\\n潮ちゃんも…ありがとね…。" => { tr => "I'm Abukuma of Nagara-class light cruisers.\\nYes... to be honest, I don't like Kitakami.\\nWhat's with her... but, I endured and fixed\\nmy beautiful bow! Ushio too...thanks...", desc => "mst_shiptext.xml" },
        "長良型軽巡４番艦の由良です。\\n私たちの中では、初めて水上偵察機を搭載したの。\\n水雷戦隊や潜水戦隊の旗艦として、活躍したのよ？\\nドーントレスとかB17とかそういうのはちょっと苦手。" => { tr => "I'm Yura, the fourth ship of the Nagara-type\\nLight Cruisers. I was the first out of all of\\nus to be equipped with seaplanes. I've\\nserved as the flagship of torpedo and\\nsubmarine squadrons. I'm not so good\\nwith Dauntless and B17 planes.", desc => "mst_shiptext.xml" },
        "長良型３番艦の名取です。\\nちょっと古いモデルっていわれるけれど、高速軽巡洋艦として使い方はあるはず…\\nそ、そう、水雷戦隊には、ぜひ配属してくださいね。\\nが、頑張りますから！" => { tr => "Third ship of the Nagara-class, Natori.\\nI'm a bit of an older model, but there\\nis much use for a high-speed light cruiser\\ntoo... Y-yes, a Destroyer squadron, it'd\\nbe best if I was assigned to one,\\nplease. I-I'll do my best!", desc => "mst_shiptext.xml" },
        "長門型戦艦の２番艦として生まれた陸奥よ。\\nもちろん、世界のビッグ７の一艦になるわね。\\nえ？主砲火薬庫爆発事故？\\nまあ、隠してもしょうがないわね。今度は大丈夫よ！" => { tr => "Battleship Nagato class's second ship\\nand from there referring to her name,\\nMutsu. Of course, I'm part of the world's\\nBig 7. Ehh? The gunpowder explosion\\naccident? Well, can't cover it up\\nanymore right? This time will be fine!", desc => "mst_shiptext.xml" },
        "長門型戦艦２番艦の陸奥よ。よろしくね。\\nあまり火遊びはしないでね…お願いよ。" => { tr => "Battleship Nagato class's 2nd ship,\\nMutsu. Pleased to meet you. Don't play with\\nfire too much, okay? Please...", desc => "mst_shiptext.xml" },
        "阿賀野型軽巡の三番艦、矢矧よ。\\nマリアナ、レイテ、坊ノ岬と、後半の大きな海戦にはほとんど参加したわ。そうよ、最後の最後まで暴れてみせたの。私の記憶の途切れた後、大和はどうなったのかしら。ま、いいわ…　今度は全てを護りきるから！" => { tr => "Yahagi, the third ship of the Agano-class\\nlight cruisers. I've participated in most of\\nthe major sea battles during the latter part\\nof the war, including the Mariana Straits,\\nLeyte Gulf, and Bonomisaki. That's right,\\nI fought it out to the very end. I wonder\\nwhat happened to Yamato, after my\\nmemories trailed off. Oh well...\\nThis time, I'm going to protect everything!", desc => "mst_shiptext.xml" },
        "阿賀野型軽巡二番艦、能代。\\n着任しました。よろしくどうぞ！" => { tr => "Second light cruiser of the Agano-class,\\nNoshiro, has arrived. Glad to meet you!", desc => "mst_shiptext.xml" },
        "阿賀野型軽巡姉妹の末っ子、四番艦の酒匂だよ。\\n生まれるのが遅すぎたかな、あまりお外にはいけなかった。矢矧ちゃんと一緒に行きたかったけど…舞鶴でお留守番したの。" => { tr => "I'm Sakawa, the 4th ship and the youngest\\nof the Agano-class light cruiser sisters.\\nI was born too late, so I couldn't go outside\\nmuch. I wanted to go together with\\nYahagi-chan... but I ended up guarding\\nMaizuru.", desc => "mst_shiptext.xml" },
        "陽炎型十番艦の時津風だよ。\\n雪風、初風、天津風とで第十六駆逐隊を編成、仲良く色々と頑張ったんだよ。二水戦にもいたんだよ、ほんとほんと。\\nでも、制海権の無い海は…ちょっと嫌かなーって。" => { tr => "Tenth Kagerou-class Destroyer,\\nTokitsukaze. I worked hard in the 16th\\nDestroyer Division with my friends\\nYukikaze, Hatsukaze, and Amatsukaze.\\nI was also in the 2nd Torpedo Squadron\\nyou know, really, really.\\nBut...an uncontrolled sea seems...\\nKinda unpleasant.", desc => "mst_shiptext.xml" },
        "陽炎型駆逐艦、初風よ。\\nブーゲンビルで妙高姉さんとぶつかって、艦首をばっさり切断…　で、航行不能になったところを集中砲火くらって…\\n怖い…怖すぎる妙高姉さん…" => { tr => "Kagerou-class destroyer, Hatsukaze.\\nMyoukou-neesan and I crashed into each\\nother off Bougainville, and my bow got\\ntorn off... Crippled and unable to move,\\nI was the target of concentrated fire and\\nthen... I'm scared....I'm so scared,\\nMyoukou-neesan...", desc => "mst_shiptext.xml" },
        "陽炎型駆逐艦、十七番艦、萩風。参りました。\\n司令、ご指示をお願いします。" => { tr => "Hagikaze, 17th Ship of the Kagerou-class Destroyer, reporting!\\nCommander, please give me your orders!", desc => "mst_shiptext.xml" },
        "陽炎型駆逐艦、野分。参上しました。\\nさあ、司令。いきましょう。" => { tr => "Kagerou-class Destroyer, Nowaki, reporting in.\\nWell, Commander. Let us proceed.", desc => "mst_shiptext.xml" },
        "陽炎型駆逐艦の舞風よ。\\nミッドウェーから南方作戦まで、戦場で舞い続けたの。同じ陽炎型の野分とは仲良しよ。あのトラック島が襲撃された時も近くにいてくれたわ。" => { tr => "Kagerou-class destroyer Maikaze! From\\nMidway to the Southern Operations,\\nI continued to dance across the battlefield.\\nI'm good friends with Nowaki, a fellow\\nKagerou-class. When Truk Island was\\nattacked, I almost made it.", desc => "mst_shiptext.xml" },
        "陽炎型駆逐艦九番艦の天津風です。\\n次世代の艦隊型駆逐艦のための新型高温高圧缶のテストベッドを務めたのよ。データはしっかりとって、島風に渡したわ。幾多のピンチも頑張って乗り越えたのよ。\\n大変だったんだから！" => { tr => "I'm Amatsukaze, the Ninth Kagerou-class\\nDestroyer. I was tasked with being the test\\nbed of a new type of high-temperature,\\nhigh pressure boiler meant for the next\\ngeneration of destroyer. With the data\\nin tow, I was able to hand this over to\\nShimakaze. I was in many tight spots, but\\nI have been able to constantly overcome\\nthem. It was really tough!", desc => "mst_shiptext.xml" },
        "陽炎型駆逐艦十七番艦、萩風です。浦賀生まれです。嵐と一緒に第四駆逐隊で頑張りました。南雲機動部隊の直衛、ソロモンの死闘を経験しました。最期の夜も…嵐と一緒です。私たち、四駆のこと、覚えていてくださいね。" => { tr => "I am Hagikaze, the 17th ship of the Kagerou-class Destroyer.  I was born in Uraga. I worked diligently as part of the 4th Destroyer Division with Arashi. Being the escort of the Nagumo Taskforce, I took part in the unforgiving battle in the Solomon Islands. I was with Arashi on my last night too. Please remember us, the 4th Destroyer Division.", desc => "mst_shiptext.xml" },
        "陽炎型駆逐艦十二番艦、磯風。\\n司令、共に進もう…心配はいらない。" => { tr => "12th Kagerou-class destroyer, Isokaze.\\nCommander, let's proceed together.\\nYou do not need to worry.", desc => "mst_shiptext.xml" },
        "陽炎型駆逐艦十二番艦、磯風。\\n大丈夫、私が護ってあげる。" => { tr => "12th Kagerou-class destroyer, Isokaze.\\nDon't worry, I will protect you.", desc => "mst_shiptext.xml" },
        "陽炎型駆逐艦十二番艦、磯風だ。\\n戦歴ならあの雪風にも遅れはとらぬ。数々の海戦、決戦に参加し、戦い抜いたんだ。大和・武蔵・金剛・大鳳…彼女達の最期もこの目に焼き付いている。今度こそ…護り抜くさ。" => { tr => "12th Kagerou-class destroyer, Isokaze. If\\nit's about combat experience, I won't fall\\nbehind that Yukikaze. I've fought again and\\nagain, participated in decisive battles, and\\nfought to the bitter end. Yamato, Musashi,\\nKongou, Taihou... their last moments have\\nbeen etched into my eyes.\\nThis time... I will protect them.", desc => "mst_shiptext.xml" },
        "陽炎型駆逐艦十五番艦、野分です。舞鶴生まれです。\\n舞風と一緒に第四駆逐隊に所属しました。\\n緒戦は那珂さん率いる四水戦と共に南方作戦、そしてミッドウェー、マリアナ、レイテにも参加。できること…全力で頑張りました。" => { tr => "Kagerou-class destroyer number 15, Nowaki. Born in Maizuru.\\nI was with Maikaze in the 4th DesDiv.\\nAt the start of the war, I participated in the Southern Operation in the 4th Torpedo Squadron under Naka-san, as well as Midway, Mariana, and Leyte. I will do my best with whatever I can.", desc => "mst_shiptext.xml" },
        "陽炎型駆逐艦十六番艦、嵐だ。第四駆逐隊を編成して、四水戦で活躍したぜ。ミッドウェーでは、南雲機動部隊の護りについたんだ。その後も最前線を縦横無尽に駆け抜けて……最期の時は、暗い海での前線の輸送作戦。僚艦の萩風と一緒さ。嵐、そして四駆の仲間たち……覚えていてくれよな。頼むぜ。" => { tr => "I'm the 16th ship in the Kagerou-class Destroyer line. I was part of the 4th Destroyer Squadron, and was an asset to the 4th Torpedo Squadron. At Midway, I was assigned as an escort to the Nagumo Carrier Task Force. After that, I also did occasional stints at the frontline as needed...... Remember me... and my comrades of the 4th Destroyer Squadron. Please.", desc => "mst_shiptext.xml" },
        "陽炎型駆逐艦十番艦。\\n時津風……出るよ。" => { tr => "Kagerou-class Destroyer tenth ship.\\nTokitsukaze... has arrived!", desc => "mst_shiptext.xml" },
        "陽炎型駆逐艦２番艦、不知火です。\\n陽炎らと共にハワイ作戦部隊の護衛も務めました。\\n運命のレイテ沖海戦では志摩艦隊に所属、スリガオ海峡に突入しました。" => { tr => "Second Kagerou-class destroyer, Shiranui.\\nAlong with the other Kagerous, I served as\\nthe escort for the Hawaiian Operational\\nForces.In the fated Battle of Leyte Gulf,\\nI was attached to Shima's fleet and\\nrushed to the Surigao Strait.", desc => "mst_shiptext.xml" },
        "陽炎型駆逐艦８番艦、雪風です。\\nどうぞ、よろしくお願いしますっ！" => { tr => "The eighth ship of Kagerou-class destroyer,\\nI'm Yukikaze. I'll be in your care!", desc => "mst_shiptext.xml" },
        "陽炎型駆逐艦８番艦の雪風です。\\n私たち主力艦隊型駆逐艦の中で、十数回以上の主要海戦に参加しながらも、唯一ほとんど無傷で終戦まで生き残りました。\\n奇跡の駆逐艦って？ううん、奇跡じゃないですっ！" => { tr => "I'm Yukikaze, eighth ship of the\\nKagerou-class destroyer.\\nAmong the destroyers of the main fleet,\\nwhile taking part in over 10 major naval\\nbattles, I'm the only one to have survived\\nthe war with barely any damage.\\nMiracle destroyer?\\nNope, it was no miracle!", desc => "mst_shiptext.xml" },
        "隊長、もっとまるゆに頑張らせてくださいね。" => { tr => "Sir, please let Maruyu keep working hard.", desc => "mst_shiptext.xml" },
        "雲龍型航空母艦、その二番艦、天城です。戦時急造計画であるマル急計画により、建造されました。\\n空母機動部隊として運用されることは叶いませんでしたが、呉空襲時の対空戦で奮闘しました。" => { tr => "I'm Amagi, 2nd Carrier of the Unryuu-class.\\nMy construction following the Rapid Naval\\nArmaments Supplement Program. Even\\nthough I couldn't join the Mobile Striking\\nForce, I did my best in the air\\nraid at Kure Naval base.", desc => "mst_shiptext.xml" },
        "雲龍型航空母艦、三番艦、葛城よ！\\nえ？　水上防空砲台ですって？\\nち、違うわよ！　提督、何いってんの！" => { tr => "Aircraft carrier Katsuragi, heading forth!\\nEh? 'A floating anti-air gun platform'?\\nI-It's not like that...! What are you saying!", desc => "mst_shiptext.xml" },
        "雲龍型航空母艦、天城です。\\n提督、天城、今なら十分活躍できます！" => { tr => "I'm Amagi, an Unryuu-class Carrier!\\nAdmiral, this time Amagi can play an active role!", desc => "mst_shiptext.xml" },
        "雲龍型航空母艦、天城と申します。\\n提督、どうぞよろしくお願い致します。\\n天城、精進致します！" => { tr => "I'm Amagi, an Unryuu-class Carrier.\\nThanks for your recruitment, Admiral.\\nAmagi will concentrate!", desc => "mst_shiptext.xml" },
        "雲龍型航空母艦、雲龍、参ります。\\n提督、新生機動部隊はお任せください！" => { tr => "Unryuu class aircraft carrier, Unryuu is here.\\nAdmiral, please leave the future of the task force to me!", desc => "mst_shiptext.xml" },
        "雲龍型航空母艦、雲龍、推参しました。\\n提督、よろしくお願いしますね。" => { tr => "Unryuu class aircraft carrier, Unryuu, has arrived.\\nAdmiral, it's nice to meet you.", desc => "mst_shiptext.xml" },
        "雲龍型航空母艦の三番艦、葛城よ。そう、正規空母。\\nちょっと生まれるのが遅かったみたい。でも、戦いが終わった後で、私は全力で働いたの。ある意味、私が一番なんだから。ホントよ？ホントなんだから。" => { tr => "I'm Katsuragi, the third ship of the Unryuu-Class Carriers!\\nYes, a standard aircraft carrier. Looks like I was late. But after the battle was over, I was working at full power. In a sense, I am the best. It's the truth! Really it's true!", desc => "mst_shiptext.xml" },
        "雷よ！　かみなりじゃないわ！\\nそこのとこもよろしく頼むわねっ！" => { tr => "I'm Ikazuchi! Not 'Kaminari'! Please\\ntake care of that part too, okay!", desc => "mst_shiptext.xml" },
        "電です。\\nどうか、よろしくお願いいたします。" => { tr => "I'm Inazuma.\\nPleased to meet you.", desc => "mst_shiptext.xml" },
        "霞よ。\\nガンガンいくわよ。ついてらっしゃい。" => { tr => "I'm Kasumi, charging forth.\\nFollow me.", desc => "mst_shiptext.xml" },
        "霧島です。姉妹艦の榛名には、頭脳は負けないわよ？\\n純国産高速戦艦として、奮戦するんだからっ！\\n現代の海自イージス艦にもその名は受け継がれたの。" => { tr => "Kirishima here. I won't lose to my\\nsister ship Haruna's brains! As a\\ndomestically-produced fast battleship,\\nI'll work hard! One of the Aegis ships\\nof the modern JMSDF succeeds my name.", desc => "mst_shiptext.xml" },
        "霰です…\\nんちゃ…とかはいいません…よろしく…" => { tr => "Arare... I won't say 'ncha-'...\\nLook after me...", desc => "mst_shiptext.xml" },
        "霰は、マル２計画で建造された最後の駆逐艦…。\\n朝潮型シリーズの…最終艦でも…あるの…。\\nこの後は…陽炎型だから…" => { tr => "Arare, the last destroyer constructed\\nunder the Maru-2 programme...\\nAsashio-class series'... final ship but...\\nthere's more... After that... Kagero-class...", desc => "mst_shiptext.xml" },
        "青葉です。トラック諸島方面へ進出して、\\n中部太平洋作戦を支えました。\\n従軍作家さんも乗り込んで青葉のスタッフの仕事振りを取材したことも。最期の時は、呉の港で。\\n動かす油もなかったけど、青葉、頑張りました！" => { tr => "I'm Aoba. Advancing into the Truk Islands\\narea, I supported the Pacific Front. With\\na war correspondent on board, the staff\\nalso had reporting as part of their job.\\nAt my last moment, I was at Kure.\\nEven without fuel, I did my best!", desc => "mst_shiptext.xml" },
        "響だよ。\\nその活躍ぶりから不死鳥の通り名もあるよ。" => { tr => qq[I'm Hibiki. I'm also referred to as\\n"The Phoenix" from my exploits.], desc => "mst_shiptext.xml" },
        "飛鷹よ。\\n北米航路用の新造客船「出雲丸」を建造途中で改装した商船改造空母なの。\\nでも、正規空母並の活躍を見せたんだから。ホントよ。" => { tr => "I'm Hiyou! Converted from the Northern\\nline passenger liner 'Izumo-maru' into a\\ncarrier. But, I was able to operate at\\nthe same level as a full aircraft carrier.\\nIt's the truth!", desc => "mst_shiptext.xml" },
        "飛龍型航空母艦、飛龍です。…ん？蒼龍型改じゃないかって？いいじゃん、そんなこと。\\nそれより、索敵は大切にねッ。空母戦は先手必勝！\\n慢心はダメ、ゼッタイ。慎重に、そして、大胆に戦い抜こうよ！" => { tr => "Hiryuu-class aircraft carrier, Hiryuu.\\nHuh? Am I not an improved version\\nof the Souryuu-class, you say? Don't worry\\nabout the details. More importantly,\\nscouting is paramount. In carrier warfare,\\nthe first to strike wins! Don't let pride\\nblind you. Let's carefully, and also\\nboldly, fight on through!", desc => "mst_shiptext.xml" },
        "香取型練習巡洋艦一番艦の香取です。\\nはい、練習遠洋航海の指揮は、お任せください。必ずや艦隊の練度向上にお力添えできると思います。え、戦艦との砲撃戦…ですか？それは用兵的にどうなのでしょうか。" => { tr => "First of the Katori-class training cruisers,\\nKatori. Right, leave the ocean navigation\\ntraining to me. I believe I'll be a great help\\nin furthering what the fleet attains out of\\nits drills, for sure. Eh, my firepower in\\ncomparison to a battleship... is it?\\nI wonder, tactics-wise, how it is.", desc => "mst_shiptext.xml" },
        "香取型練習巡洋艦二番艦、妹の鹿島です。平和の海で、次代の艦隊を育てるために建造されました。その本来の役目を果たせる時間はあまり長くはありませんでしたが、艦隊旗艦や船団護衛、精一杯頑張りました。戦いが終わった後も、未来のために、私、頑張りました！　鹿島のこと、覚えていてくださいね。" => { tr => "Second of the Katori-class training cruisers—the little sister, Kashima. I was built at a time of peaceful waters in order to raise a new generation of capable fleet ships. The time spent on my original duty wasn't long, but I gave my very best both as a fleet flagship and escort. After the battle ended, for the sake of the future, I worked very hard! Please don't forget about my services, okay?", desc => "mst_shiptext.xml" },
        "駆逐艦、大潮です～！\\n小さな体に大きな魚雷！　お任せください。" => { tr => "Destroyer class, Ooshio! A small body\\nwith large torpedoes! Leave it to me.", desc => "mst_shiptext.xml" },
        "駆逐艦、朝潮です。\\n勝負ならいつでも受けて立つ覚悟です。" => { tr => "I'm Asashio, a destroyer.\\nI'm always ready for a battle.", desc => "mst_shiptext.xml" },
        "駆逐艦、浜風です。\\nこれより貴艦隊所属となります。" => { tr => "Destroyer, Hamakaze.\\nHenceforth I shall be attached to your fleet.", desc => "mst_shiptext.xml" },
        "駆逐艦、満潮よ。\\n姉妹艦の朝潮、大潮、荒潮とは、第８駆逐隊で腐れ縁の仲。でも、最後は離れ離れ。\\n私は西村艦隊の一員として、レイテに突入を図ったわ。" => { tr => "I'm a destroyer, Michishio. I and my\\nsisters Asashio, Ooshio, and Arashio\\nwere somehow assigned to the 8th\\ndestroyer squadron. But, we were\\nseparated in the end. Finally I broke into\\nLeyte, as a member of Nishimura fleet.", desc => "mst_shiptext.xml" },
        "駆逐艦、若葉だ。" => { tr => "Destroyer, Wakaba.", desc => "mst_shiptext.xml" },
        "駆逐艦島風です。スピードなら誰にも負けません。\\n速きこと、島風の如し、です！" => { tr => "I'm Destroyer Shimakaze. When it comes\\nto speed I'm the best there is, swift like\\nthe island breeze!", desc => "mst_shiptext.xml" },
        "高速の巡洋戦艦、榛名です。\\n国産の四一式36センチ砲を装備しました。\\n呉鎮守府の江田島で最後まで空を睨んで奮戦したわ。\\n高速戦艦四姉妹で最期まで、戦い抜いた榛名のこと、覚えていてね。" => { tr => "I'm the fast battleship, Haruna. I was\\nequipped with a set of four domestically\\nmade 36cm cannons. I stayed bravely\\nwatching the sky over Etajima village's\\nKure naval base till the end. Please\\nremember Haruna who, of all four\\nfast battleship sisters,\\nhad fought 'til the bitter end.", desc => "mst_shiptext.xml" },
        "高速戦艦、榛名、着任しました。\\nあなたが提督なのね？　よろしくお願い致します。" => { tr => "Fast battleship, Haruna, reporting for duty.\\nYou're the admiral, correct? I'm looking\\nforward to working with you.", desc => "mst_shiptext.xml" },
        "高雄型の２番艦、愛宕よ、うふふ。\\n呉海軍工廠で生まれたの。\\nバランスがとれた重武装ボディでしょ？\\nレイテ沖の決戦では、第一遊撃部隊の旗艦として出撃したんだけど……ま、そんなこともあるわよね。" => { tr => "Second of the Takao-class, Atago!\\n*giggle*\\nI was born at the Kure Naval Arsenal.\\nDon't I have a balanced and heavily-armed\\nbody? At the decisive Battle of Leyte Gulf,\\nI deployed as the flagship of the First\\nMobile Striking Force...\\nWell, such things happen, you know?", desc => "mst_shiptext.xml" },
        "高雄型の４番艦、鳥海です。\\nマレー、ソロモン、マリアナ、レイテと数々の作戦に参加しました。\\n鳥海の名は、現在、海自のイージス護衛艦、その４番艦に受け継がれています。" => { tr => "Fourth of the Takao-class ships, Choukai.\\nDeployed to Malaya, Solomon, Marianas\\nand Leyte Gulf for many operations.\\nMy name is now given to a JSDF\\nAEGIS-equipped escort vessel,\\n4th in its class.", desc => "mst_shiptext.xml" },
        "高雄型の４番艦、鳥海です。\\nマレー、ソロモン、マリアナ、レイテと数々の作戦に参加しました。\\n鳥海の名は、現在、海自のイージス護衛艦、その4番艦に受け継がれています。" => { tr => "Fourth of the Takao-class ships, Choukai.\\nDeployed to Malaya, Solomon, Marianas and Leyte Gulf for many operations.\\nMy name is now given to a JSDF AEGIS-equipped escort vessel, fourth in its class.", desc => "mst_shiptext.xml" },
        "高雄型重巡洋艦３番艦の摩耶さまだ。\\n生まれは神戸。南方作戦や激戦のソロモン海で暴れまくってやったぜ！\\nああん？　レイテ？　んだよ、潜水艦って奴は苦手だよ。" => { tr => "Third of the Takao-class heavy cruisers,\\nMaya-sama! Kobe-built. I went hard in the\\nSouthern Ops and Solomon battles!\\nHaah? Leyte? Nah, I'm not great with subs.", desc => "mst_shiptext.xml" },
        "高雄型重巡洋艦３番艦の摩耶さまだ。\\n生まれは神戸。南方作戦や激戦のソロモン海で暴れまくってやったぜ！\\nああん？　レイテ？\\nんだよ、潜水艦って奴は苦手だよ。" => { tr => "Third of the Takao-class heavy cruisers,\\nMaya-sama! Kobe-built. I went hard in the\\nSouthern Ops and Solomon battles!\\nHaah? Leyte? Nah, I'm not great with subs.", desc => "mst_shiptext.xml" },
        "黒潮や、よろしゅうな。" => { tr => "I'm Kuroshio, nice to meet 'cha!", desc => "mst_shiptext.xml" },
        "5500トン型の軽巡洋艦、球磨型の木曾だ。\\nよろしくな。\\nやれ、滑走台だ、カタパルトだ、そんなもんはいらねえな。\\n戦いは敵の懐に飛び込んでやるもんよ。なあ？" => { tr => "5500 ton light cruiser, Kuma-class 'Kiso'.\\nMy regards. Runways and catapults, nah,\\nI don't need those. Battle is all about\\nbringing it right to the enemy! Right?", desc => "mst_shiptext.xml" },
        "5500トン級の軽巡洋艦の最終タイプ、それが私、川内型よ。\\n熟成された軽巡の魅力、たっぷり教えてあげるから。\\nもちろん、夜戦でね！" => { tr => "I am the culmination of the 5500-ton\\nlight cruisers, the Sendai-class.\\nI'll fully teach you the appeal of\\na mature light cruiser. Of course,\\nit'll be with a night battle!", desc => "mst_shiptext.xml" },
        "5500トン級軽巡洋艦、長良型の１番艦、長良よ。\\nちょっとモデルは古いけど、高速・魚雷発射主兵装・水雷戦隊指揮能力と、駆逐艦仕切るにはバッチリでしょ？ソロモン海での激闘でも奮戦したんだから！" => { tr => "Weighing in as a 5500 ton light cruiser, first\\nship of the Nagara-class, Nagara! I'm a bit\\nof an old model, but I'm a high-speed\\ntorpedo-armed team-leading machine,\\nso I'm just perfect to command destroyers,\\nyou know? I even fought hard in the difficult\\nBattle of the Solomons!", desc => "mst_shiptext.xml" },
        "Graf Zeppelin級航空母艦一番艦、Graf Zeppelinだ。立体的な通商破壊戦を展開できる重武装の本格空母だ。建造には日本の空母「赤城」の技術も参考にしたらしい。日本の艦隊…か……楽しみだな。" => { tr => "First of the Graf Zeppelin-class Carriers, Graf Zeppelin. Capable of undertaking three-dimensional commerce raiding, I am a heavily-armed genuine carrier. It seems that the technology of the Japanese carrier, Akagi, was also referenced in my construction. A Japanese fleet...huh...... I'm looking forward to it.", desc => "mst_shiptext.xml" },
        "Guten Morgen！\\n私は、重巡プリンツ・オイゲン。よろしくね！" => { tr => "Good morning! I'm the heavy cruiser\\nPrinz Eugen. Nice to meet you!", desc => "mst_shiptext.xml" },
        "Guten Morgen!　私が航空母艦、Graf Zeppelin だ。\\n貴方がこの艦隊を預かる提督なのだな。\\nそうか……了解だ。" => { tr => "Guten Morgen!　I am the carrier, Graf Zeppelin.\\nYou are the Admiral overseeing this fleet, yes?\\nIs that so...... Roger.", desc => "mst_shiptext.xml" },
        "Guten Morgen.\\n僕の名前はレーベレヒト・マース。\\nレーベでいいよ…うん。" => { tr => "Guten Morgen. I'm Leberecht Maass.\\nLebe is fine, yep.", desc => "mst_shiptext.xml | the Lebe might be a pun as 'leben' is life" },
        "Guten Tag.\\n私はビスマルク型戦艦のネームシップ、ビスマルク。\\nよおく覚えておくのよ。" => { tr => "Guten Tag. I am Bismarck, the nameship\\nof the Bismarck-class battleships.\\nYou should remember it well.", desc => "mst_shiptext.xml" },
        "Guten Tag.\\n私は駆逐艦マックス・シュルツよ。\\nマックス…でもいいけれど。よろしく。" => { tr => "Good day. I am the Destroyer Max Schultz.\\nBut, Max is fine. Pleased to meet you.", desc => "mst_shiptext.xml" },
        "Hi！　Iowa級戦艦Name Ship、Iowaよ。高速戦艦で、この重兵装。Battle shipの最終形ともいえる完成度。USAが生んだ最後の戦艦級として、この艦隊でも頑張るわ。よろしくね！" => { tr => "Hi! I'm the name ship of the Iowa-class battleships, Iowa. Although I'm a high-speed battleship, I'm heavily armed, and could be said to be the penultimate form of battleship. As the last of the battleship classes born in the USA, I will work hard for the fleet. Take good care of me!", desc => "mst_shiptext.xml" },
        "Hi！ MeがIowa級戦艦、Iowaよ。\\nYouがこの艦隊のAdmiralなの？ いいじゃない！\\n私たちのこともよろしく！" => { tr => "Hi! I am the Iowa-class battleship, Iowa.\\nYou are the Admiral of this fleet? Not bad!\\nTake care of us too!", desc => "mst_shiptext.xml" },
        "UボートU-511改め、呂号第500潜水艦です。\\nユーちゃん改め、ローちゃんです。\\nテイトク、よろしくお願いしまーす！" => { tr => "Submarine RO500, formerly U-boat U-511.\\nI'm Ro, formerly called Yuu!\\nAdmiral? I will be in your care!", desc => "mst_shiptext.xml" },
        "初春型駆逐艦の４番艦、初霜です。\\nアリューシャン作戦、アッツ島沖海戦、キスカ島撤退作戦、マリアナ沖海戦、北号作戦、坊ノ岬沖海戦など\\n様々な激戦に参加しました！\\nほんと、頑張ったんです！" => { tr => "Fourth of the Hatsuharu-class destroyers,\\nHatsushimo. I was in lots of hard battles\\nlike the Operation AL, the Battle of the\\nKomandorski Islands, the occupation of\\nKiska, the Battle of the Philippine Sea,\\nOperation Hoku-Go and Ten-Ichi-Go!\\nI really did my best!", desc => "mst_shiptext.xml" },
        "五月雨です。\\n村雨・夕立・春雨とは第2駆逐隊でお友達でした。\\nそうそう、輸送任務中に白露と衝突してしまったことも…ホント、私ってば、ドジでごめんなさい。\\nでも、頑張ります！" => { tr => "I'm Samidare. My friends Murasame,\\nYuudachi and Harusame, we made up\\nDesDiv2. Oh yeah, during a transport\\nmission, I crashed into Shiratsuyu...\\nReally, I'm... sorry for being clumsy...\\nBut, I'll do my best!", desc => "mst_shiptext.xml" },

        "カ号観測機" => { tr => "Ka Type Observation Autogyro", desc => "mst_slotitem.xml" },
        "ドラム缶(輸送用)" => { tr => "Drum Canister (Transport Use)", desc => "mst_slotitem.xml" },
        "プリエーゼ式水中防御隔壁" => { tr => "Pugliese Underwater Protection Bulkhead", desc => "mst_slotitem.xml" },
        "一式徹甲弾" => { tr => "Type 1 Armor Piercing Shell", desc => "mst_slotitem.xml" },
        "三式弾" => { tr => "Type 3 Shell", desc => "mst_slotitem.xml" },
        "三式指揮連絡機(対潜)" => { tr => "Type 3 Command Liaison Aircraft (ASW)", desc => "mst_slotitem.xml" },
        "三式水中探信儀" => { tr => "Type 3 Active Sonar", desc => "mst_slotitem.xml" },
        "三式爆雷投射機" => { tr => "Type 3 Depth Charge Projector", desc => "mst_slotitem.xml" },
        "九一式徹甲弾" => { tr => "Type 91 Armor Piercing Shell", desc => "mst_slotitem.xml" },
        "九七式艦攻" => { tr => "Type 97 Torpedo Bomber", desc => "mst_slotitem.xml" },
        "九七式艦攻(九三一空)" => { tr => "Type 97 Torpedo Bomber (931 Air Group)", desc => "mst_slotitem.xml" },
        "九七式艦攻(友永隊)" => { tr => "Type 97 Torpedo Bomber (Tomonaga Squadron)", desc => "mst_slotitem.xml" },
        "九七式艦攻(村田隊)" => { tr => "Type 97 Torpedo Bomber (Murata Squadron)", desc => "mst_slotitem.xml" },
        "九七式艦攻(熟練)" => { tr => "Type 97 Torpedo Bomber (Skilled)", desc => "mst_slotitem.xml" },
        "九三式水中聴音機" => { tr => "Type 93 Passive Sonar", desc => "mst_slotitem.xml" },
        "九九式艦爆" => { tr => "Type 99 Dive Bomber", desc => "mst_slotitem.xml" },
        "九九式艦爆(江草隊)" => { tr => "Type 99 Dive Bomber (Egusa Squadron)", desc => "mst_slotitem.xml" },
        "九九式艦爆(熟練)" => { tr => "Type 99 Dive Bomber (Skilled)", desc => "mst_slotitem.xml" },
        "九八式水上偵察機(夜偵)" => { tr => "Type 98 Reconnaissance Seaplane (Night Recon)", desc => "mst_slotitem.xml" },
        "九六式艦戦" => { tr => "Type 96 Fighter", desc => "mst_slotitem.xml" },
        "九四式爆雷投射機" => { tr => "Type 94 Depth Charge Projector", desc => "mst_slotitem.xml" },
        "二式大艇" => { tr => "Type 2 Large Flying Boat", desc => "mst_slotitem.xml" },
        "二式艦上偵察機" => { tr => "Type 2 Reconnaissance Aircraft", desc => "mst_slotitem.xml" },
        "劣化徹甲弾" => { tr => "Deterioration Armor Piercing Shell", desc => "mst_slotitem.xml" },
        "四式水中聴音機" => { tr => "Type 4 Passive Sonar", desc => "mst_slotitem.xml" },
        "増設バルジ(中型艦)" => { tr => "Anti-torpedo Bulge (Medium)", desc => "mst_slotitem.xml" },
        "増設バルジ(大型艦)" => { tr => "Anti-torpedo Bulge (Large)", desc => "mst_slotitem.xml" },
        "大発動艇" => { tr => "Daihatsu Landing Craft", desc => "mst_slotitem.xml" },
        "天山一二型(友永隊)" => { tr => "Tenzan Model 12 (Tomonaga Squadron)", desc => "mst_slotitem.xml" },
        "天山一二型(村田隊)" => { tr => "Tenzan Model 12 (Murata Squadron)", desc => "mst_slotitem.xml" },
        "天山" => { tr => "Tenzan", desc => "mst_slotitem.xml" },
        "天山(九三一空)" => { tr => "Tenzan (931 Air Group)", desc => "mst_slotitem.xml" },
        "天山(六〇一空)" => { tr => "Tenzan (601 Air Group)", desc => "mst_slotitem.xml" },
        "対空レーダ― Mark.I" => { tr => "Air Radar Mark.I", desc => "mst_slotitem.xml" },
        "対空レーダ― Mark.II" => { tr => "Air Radar Mark.II", desc => "mst_slotitem.xml" },
        "対空散弾" => { tr => "Anti-Air Dispersal Shell", desc => "mst_slotitem.xml" },
        "強化型深海缶" => { tr => "Enhanced Abyssal Boiler", desc => "mst_slotitem.xml" },
        "強化型艦本式缶" => { tr => "Enhanced Kanhon Type Boiler", desc => "mst_slotitem.xml" },
        "彗星一二型甲" => { tr => "Suisei Model 12A", desc => "mst_slotitem.xml" },
        "彗星" => { tr => "Suisei", desc => "mst_slotitem.xml" },
        "彗星(六〇一空)" => { tr => "Suisei (601 Air Group)", desc => "mst_slotitem.xml" },
        "彗星(江草隊)" => { tr => "Suisei (Egusa Squadron)", desc => "mst_slotitem.xml" },
        "彩雲" => { tr => "Saiun", desc => "mst_slotitem.xml" },
        "戦闘糧食" => { tr => "Combat Ration", desc => "mst_slotitem.xml" },
        "探照灯" => { tr => "Searchlight", desc => "mst_slotitem.xml" },
        "改良型深海タービン" => { tr => "Improved Abyssal Turbine", desc => "mst_slotitem.xml" },
        "改良型艦本式タービン" => { tr => "Improved Kanhon Type Turbine", desc => "mst_slotitem.xml" },
        "新型高温高圧缶" => { tr => "New Model High Temperature High Pressure Boiler", desc => "mst_slotitem.xml" },
        "毘式40mm連装機銃" => { tr => "Bi Type 40mm Twin Autocannon Mount", desc => "mst_slotitem.xml" },
        "水上レーダ― Mark.I" => { tr => "Surface Radar Mark.I", desc => "mst_slotitem.xml" },
        "水上レーダ― Mark.II" => { tr => "Surface Radar Mark.II", desc => "mst_slotitem.xml" },
        "流星改" => { tr => "Ryuusei Kai", desc => "mst_slotitem.xml" },
        "流星" => { tr => "Ryuusei", desc => "mst_slotitem.xml" },
        "流星(六〇一空)" => { tr => "Ryuusei (601 Air Group)", desc => "mst_slotitem.xml" },
        "深海ソナー Mk.II" => { tr => "Abyssal Sonar Mk.II", desc => "mst_slotitem.xml" },
        "深海ソナー" => { tr => "Abyssal Sonar", desc => "mst_slotitem.xml" },
        "深海地獄艦爆改" => { tr => "Abyssal Hell Dive Bomber Kai", desc => "mst_slotitem.xml" },
        "深海地獄艦爆" => { tr => "Abyssal Hell Dive Bomber", desc => "mst_slotitem.xml" },
        "深海対空レーダ―" => { tr => "Abyssal Air Radar", desc => "mst_slotitem.xml" },
        "深海復讐艦攻改" => { tr => "Abyssal Revenge Torpedo Bomber Kai", desc => "mst_slotitem.xml" },
        "深海復讐艦攻" => { tr => "Abyssal Revenge Torpedo Bomber", desc => "mst_slotitem.xml" },
        "深海探照灯" => { tr => "Abyssal Searchlight", desc => "mst_slotitem.xml" },
        "深海棲艦偵察機" => { tr => "Abyssal Reconnaissance Plane", desc => "mst_slotitem.xml" },
        "深海棲艦戦 Mark.II" => { tr => "Abyssal Fighter Mark.II", desc => "mst_slotitem.xml" },
        "深海棲艦戦 Mark.III" => { tr => "Abyssal Fighter Mark.III", desc => "mst_slotitem.xml" },
        "深海棲艦戦" => { tr => "Abyssal Fighter", desc => "mst_slotitem.xml" },
        "深海棲艦攻 Mark.II" => { tr => "Abyssal Torpedo Bomber Mark.II", desc => "mst_slotitem.xml" },
        "深海棲艦攻 Mark.III" => { tr => "Abyssal Torpedo Bomber Mark.III", desc => "mst_slotitem.xml" },
        "深海棲艦攻" => { tr => "Abyssal Torpedo", desc => "mst_slotitem.xml" },
        "深海棲艦爆 Mark.II" => { tr => "Abyssal Dive Bomber Mark.II", desc => "mst_slotitem.xml" },
        "深海棲艦爆" => { tr => "Abyssal Dive Bomber", desc => "mst_slotitem.xml" },
        "深海水上レーダー" => { tr => "Abyssal Surface Radar", desc => "mst_slotitem.xml" },
        "深海水上攻撃機改" => { tr => "Abyssal Attack Seaplane Kai", desc => "mst_slotitem.xml" },
        "深海水上攻撃機" => { tr => "Abyssal Attack Seaplane", desc => "mst_slotitem.xml" },
        "深海烏賊魚雷" => { tr => "Abyssal Cuttlefish Torpedo", desc => "mst_slotitem.xml" },
        "深海爆雷投射機 Mk.II" => { tr => "Abyssal Depth Charge Projector Mk.II", desc => "mst_slotitem.xml" },
        "深海爆雷投射機" => { tr => "Abyssal Depth Charge Projector", desc => "mst_slotitem.xml" },
        "深海猫艦戦改" => { tr => "Abyssal Cat Fighter Kai", desc => "mst_slotitem.xml" },
        "深海猫艦戦" => { tr => "Abyssal Cat Fighter", desc => "mst_slotitem.xml" },
        "深海FCS+CIC" => { tr => "Abyssal FCS + CIC", desc => "mst_slotitem.xml" },
        "潜水艦53cm艦首魚雷(8門)" => { tr => "Submarine 53cm Bow Torpedo Mount (8 tubes)", desc => "mst_slotitem.xml" },
        "烈風改" => { tr => "Reppuu Kai", desc => "mst_slotitem.xml" },
        "烈風" => { tr => "Reppuu", desc => "mst_slotitem.xml" },
        "烈風(六〇一空)" => { tr => "Reppuu (601 Air Group)", desc => "mst_slotitem.xml" },
        "照明弾" => { tr => "Star Shell", desc => "mst_slotitem.xml" },
        "熟練艦載機整備員" => { tr => "Skilled Carrier-based Aircraft Maintenance Personnel", desc => "mst_slotitem.xml" },
        "熟練見張員" => { tr => "Skilled Lookouts", desc => "mst_slotitem.xml" },
        "瑞雲" => { tr => "Zuiun", desc => "mst_slotitem.xml" },
        "瑞雲(六三四空)" => { tr => "Zuiun (634 Air Group)", desc => "mst_slotitem.xml" },
        "瑞雲12型" => { tr => "Zuiun Model 12", desc => "mst_slotitem.xml" },
        "瑞雲12型(六三四空)" => { tr => "Zuiun Model 12 (634 Air Group)", desc => "mst_slotitem.xml" },
        "甲標的" => { tr => "Kouhyouteki", desc => "mst_slotitem.xml" },
        "秋刀魚の缶詰" => { tr => "Canned Mackerel", desc => "mst_slotitem.xml" },
        "紫雲" => { tr => "Shiun", desc => "mst_slotitem.xml" },
        "紫電改二" => { tr => "Shiden Kai 2", desc => "mst_slotitem.xml" },
        "艦艇修理施設" => { tr => "Ship Repair Facility", desc => "mst_slotitem.xml" },
        "艦隊司令部施設" => { tr => "Fleet Command Facility", desc => "mst_slotitem.xml" },
        "試製南山" => { tr => "Prototype Nanzan", desc => "mst_slotitem.xml" },
        "試製景雲(艦偵型)" => { tr => "Prototype Keiun (Carrier-based Reconnaissance Model)", desc => "mst_slotitem.xml" },
        "試製晴嵐" => { tr => "Prototype Seiran", desc => "mst_slotitem.xml" },
        "試製35.6cm三連装砲" => { tr => "Prototype 35.6cm Triple Gun Mount", desc => "mst_slotitem.xml" },
        "試製41cm三連装砲" => { tr => "Prototype 41cm Triple Gun Mount", desc => "mst_slotitem.xml" },
        "試製46cm連装砲" => { tr => "Prototype 46cm Twin Gun Mount", desc => "mst_slotitem.xml" },
        "試製51cm連装砲" => { tr => "Prototype 51cm Twin Gun Mount", desc => "mst_slotitem.xml" },
        "零式水上偵察機" => { tr => "Type 0 Reconnaissance Seaplane", desc => "mst_slotitem.xml" },
        "零式水上観測機" => { tr => "Type 0 Observation Seaplane", desc => "mst_slotitem.xml" },
        "零式水中聴音機" => { tr => "Type 0 Passive Sonar", desc => "mst_slotitem.xml" },
        "零式艦戦21型" => { tr => "Type 0 Fighter Model 21", desc => "mst_slotitem.xml" },
        "零式艦戦21型(熟練)" => { tr => "Type 0 Fighter Model 21 (Skilled)", desc => "mst_slotitem.xml" },
        "零式艦戦52型" => { tr => "Type 0 Fighter Model 52", desc => "mst_slotitem.xml" },
        "零式艦戦52型(熟練)" => { tr => "Type 0 Fighter Model 52 (Skilled)", desc => "mst_slotitem.xml" },
        "零式艦戦53型(岩本隊)" => { tr => "Type 0 Fighter Model 53 (Iwamoto Squadron)", desc => "mst_slotitem.xml" },
        "零式艦戦62型(爆戦)" => { tr => "Type 0 Fighter Model 62 (Fighter-bomber)", desc => "mst_slotitem.xml" },
        "零戦21型(付岩本小隊)" => { tr => "Zero Fighter Model 21 (w/ Iwamoto Flight)", desc => "mst_slotitem.xml" },
        "零戦52型丙(付岩井小隊)" => { tr => "Zero Fighter Model 52C (w/ Iwai Flight)", desc => "mst_slotitem.xml" },
        "零戦52型丙(六〇一空)" => { tr => "Zero Fighter Model 52C (601 Air Group)", desc => "mst_slotitem.xml" },
        "零戦52型甲(付岩本小隊)" => { tr => "Zero Fighter Model 52A (w/ Iwamoto Flight)", desc => "mst_slotitem.xml" },
        "零戦62型(爆戦/岩井隊)" => { tr => "Zero Fighter Model 62 (Fighter-bomber / Iwai Squadron)", desc => "mst_slotitem.xml" },
        "震電改" => { tr => "Shinden Kai", desc => "mst_slotitem.xml" },
        "飛び魚偵察機" => { tr => "Flying Fish Reconnaissance Plane", desc => "mst_slotitem.xml" },
        "飛び魚艦戦" => { tr => "Flying Fish Fighter", desc => "mst_slotitem.xml" },
        "飛び魚艦爆" => { tr => "Flying Fish Dive Bomber", desc => "mst_slotitem.xml" },
        "高速深海魚雷" => { tr => "High-speed Abyssal Torpedo", desc => "mst_slotitem.xml" },
        "10.5cm連装砲" => { tr => "10.5cm Twin Gun Mount", desc => "mst_slotitem.xml" },
        "10cm連装高角砲(砲架)" => { tr => "10cm Twin High-angle Gun Mount (Carriage)", desc => "mst_slotitem.xml" },
        "10cm連装高角砲+高射装置" => { tr => "10cm Twin High-angle Gun Mount + AACI", desc => "mst_slotitem.xml" },
        "12.5inch連装副砲" => { tr => "12.5inch Twin Secondary Gun Mount", desc => "mst_slotitem.xml" },
        "12.7cm単装高角砲" => { tr => "12.7cm Single High-angle Gun Mount", desc => "mst_slotitem.xml" },
        "12.7cm連装砲" => { tr => "12.7cm Twin Gun Mount", desc => "mst_slotitem.xml" },
        "12.7cm連装高角砲" => { tr => "12.7cm Twin High-angle Gun Mount", desc => "mst_slotitem.xml" },
        "12.7cm高角砲+高射装置" => { tr => "12.7cm High-angle Gun + AAFD", desc => "mst_slotitem.xml" },
        "12.7mm単装機銃" => { tr => "12.7mm Single Machine Gun Mount", desc => "mst_slotitem.xml" },
        "12.7mm機銃" => { tr => "12.7mm Machine Gun", desc => "mst_slotitem.xml" },
        "120mm連装砲" => { tr => "120mm Twin Gun Mount", desc => "mst_slotitem.xml" },
        "12cm単装砲" => { tr => "12cm Single Gun Mount", desc => "mst_slotitem.xml" },
        "12cm30連装噴進砲" => { tr => "12cm 30-tube Rocket Launcher", desc => "mst_slotitem.xml" },
        "13号対空電探改" => { tr => "Type 13 Air Radar Kai", desc => "mst_slotitem.xml" },
        "13号対空電探" => { tr => "Type 13 Air Radar", desc => "mst_slotitem.xml" },
        "14号対空電探" => { tr => "Type 14 Air Radar", desc => "mst_slotitem.xml" },
        "14cm単装砲" => { tr => "14cm Single Gun Mount", desc => "mst_slotitem.xml" },
        "14cm連装砲" => { tr => "14cm Twin Gun Mount", desc => "mst_slotitem.xml" },
        "14inch連装砲" => { tr => "14inch Twin Gun Mount", desc => "mst_slotitem.xml" },
        "15.2cm単装砲" => { tr => "15.2cm Single Gun Mount", desc => "mst_slotitem.xml" },
        "15.2cm連装砲改" => { tr => "15.2cm Twin Gun Mount Kai", desc => "mst_slotitem.xml" },
        "15.2cm連装砲" => { tr => "15.2cm Twin Gun Mount", desc => "mst_slotitem.xml" },
        "15.5cm三連装副砲" => { tr => "15.5cm Triple Secondary Gun Mount", desc => "mst_slotitem.xml" },
        "15.5cm三連装砲" => { tr => "15.5cm Triple Gun Mount", desc => "mst_slotitem.xml" },
        "15cm連装副砲" => { tr => "15cm Twin Secondary Gun Mount", desc => "mst_slotitem.xml" },
        "15inch要塞砲" => { tr => "15inch Coastal Artillery", desc => "mst_slotitem.xml" },
        "15m二重測距儀+21号電探改二" => { tr => "15m Duplex Rangefinder + Type 21 Radar Kai Ni", desc => "mst_slotitem.xml" },
        "16inch三連装砲 Mk.7" => { tr => "16inch Triple Gun Mount Mk.7", desc => "mst_slotitem.xml" },
        "16inch三連装砲" => { tr => "16inch Triple Gun Mount", desc => "mst_slotitem.xml" },
        "16inch連装砲" => { tr => "16inch Twin Gun Mount", desc => "mst_slotitem.xml" },
        "20.3cm連装砲" => { tr => "20.3cm Twin Gun Mount", desc => "mst_slotitem.xml" },
        "20.3cm(2号)連装砲" => { tr => "20.3cm (No.2) Twin Gun Mount", desc => "mst_slotitem.xml" },
        "20.3cm(3号)連装砲" => { tr => "20.3cm (No.3) Twin Gun Mount", desc => "mst_slotitem.xml" },
        "20inch連装砲" => { tr => "20inch Twin Gun Mount", desc => "mst_slotitem.xml" },
        "20mm機銃" => { tr => "20mm Autocannon", desc => "mst_slotitem.xml" },
        "21号対空電探改" => { tr => "Type 21 Air Radar Kai", desc => "mst_slotitem.xml" },
        "21号対空電探" => { tr => "Type 21 Air Radar", desc => "mst_slotitem.xml" },
        "21inch魚雷前期型" => { tr => "21inch Torpedo Early Model", desc => "mst_slotitem.xml" },
        "21inch魚雷後期型" => { tr => "21inch Torpedo Late Model", desc => "mst_slotitem.xml" },
        "22号対水上電探改四" => { tr => "Type 22 Surface Radar Kai 4", desc => "mst_slotitem.xml" },
        "22号対水上電探" => { tr => "Type 22 Surface Radar", desc => "mst_slotitem.xml" },
        "25mm三連装機銃 集中配備" => { tr => "25mm Triple Autocannon Mount (Concentrated Deployment)", desc => "mst_slotitem.xml" },
        "25mm三連装機銃" => { tr => "25mm Triple Autocannon Mount", desc => "mst_slotitem.xml" },
        "25mm単装機銃" => { tr => "25mm Single Autocannon Mount", desc => "mst_slotitem.xml" },
        "25mm連装機銃" => { tr => "25mm Twin Autocannon Mount", desc => "mst_slotitem.xml" },
        "2cm 四連装FlaK 38" => { tr => "2cm Flakvierling 38", desc => "mst_slotitem.xml" },
        "3.7cm FlaK M42" => { tr => "", desc => "mst_slotitem.xml" },
        "32号対水上電探改" => { tr => "Type 32 Surface Radar Kai", desc => "mst_slotitem.xml" },
        "32号対水上電探" => { tr => "Type 32 Surface Radar", desc => "mst_slotitem.xml" },
        "33号対水上電探" => { tr => "Type 33 Surface Radar", desc => "mst_slotitem.xml" },
        "35.6cm連装砲" => { tr => "35.6cm Twin Gun Mount", desc => "mst_slotitem.xml" },
        "381mm/50 三連装砲改" => { tr => "381mm/50 Triple Gun Mount Kai", desc => "mst_slotitem.xml" },
        "381mm/50 三連装砲" => { tr => "381mm/50 Triple Gun Mount", desc => "mst_slotitem.xml" },
        "38cm連装砲改" => { tr => "38cm Twin Gun Mount Kai", desc => "mst_slotitem.xml" },
        "38cm連装砲" => { tr => "38cm Twin Gun Mount", desc => "mst_slotitem.xml" },
        "3inch単装高角砲" => { tr => "3inch Single High-angle Gun Mount", desc => "mst_slotitem.xml" },
        "40mm二連装機関砲" => { tr => "40mm Twin Autocannon Mount", desc => "mst_slotitem.xml" },
        "40mm四連装機関砲" => { tr => "40mm Quadruple Autocannon Mount", desc => "mst_slotitem.xml" },
        "41cm連装砲" => { tr => "41cm Twin Gun Mount", desc => "mst_slotitem.xml" },
        "46cm三連装砲" => { tr => "46cm Triple Gun Mount", desc => "mst_slotitem.xml" },
        "4inch連装両用砲+CIC" => { tr => "4inch Twin Dual Purpose Gun Mount + CIC", desc => "mst_slotitem.xml" },
        "53cm艦首(酸素)魚雷" => { tr => "53cm Bow (Oxygen) Torpedo Mount", desc => "mst_slotitem.xml" },
        "5inch単装砲" => { tr => "5inch Single Gun Mount", desc => "mst_slotitem.xml" },
        "5inch単装高射砲" => { tr => "5inch Single Anti-Aircraft Gun Mount", desc => "mst_slotitem.xml" },
        "5inch連装両用莢砲" => { tr => "5inch Twin Dual Purpose Gun Mount", desc => "mst_slotitem.xml" },
        "5inch連装砲" => { tr => "5inch Twin Gun Mount", desc => "mst_slotitem.xml" },
        "61cm三連装魚雷" => { tr => "61cm Triple Torpedo Mount", desc => "mst_slotitem.xml" },
        "61cm三連装(酸素)魚雷" => { tr => "61cm Triple (Oxygen) Torpedo Mount", desc => "mst_slotitem.xml" },
        "61cm五連装(酸素)魚雷" => { tr => "61cm Quintuple (Oxygen) Torpedo Mount", desc => "mst_slotitem.xml" },
        "61cm四連装魚雷" => { tr => "61cm Quadruple Torpedo Mount", desc => "mst_slotitem.xml" },
        "61cm四連装(酸素)魚雷" => { tr => "61cm Quadruple (Oxygen) Torpedo Mount", desc => "mst_slotitem.xml" },
        "6inch単装砲" => { tr => "6inch Single Gun Mount", desc => "mst_slotitem.xml" },
        "6inch連装速射砲" => { tr => "6inch Twin Rapid Fire Gun Mount", desc => "mst_slotitem.xml" },
        "7.7mm機銃" => { tr => "7.7mm Machine Gun", desc => "mst_slotitem.xml" },
        "8cm高角砲" => { tr => "8cm High-angle Gun", desc => "mst_slotitem.xml" },
        "8inch三連装砲 " => { tr => "8inch Triple Gun Mount", desc => "mst_slotitem.xml" },
        "90mm単装高角砲" => { tr => "90mm Single High-angle Gun Mount", desc => "mst_slotitem.xml" },
        "91式高射装置" => { tr => "Type 91 Anti-Aircraft Fire Director", desc => "mst_slotitem.xml" },
        "94式高射装置" => { tr => "Type 94 Anti-Aircraft Fire Director", desc => "mst_slotitem.xml" },
        "96式150cm探照灯" => { tr => "Type 96 150cm Searchlight", desc => "mst_slotitem.xml" },
        "Ar196改" => { tr => "Ar196 Kai", desc => "mst_slotitem.xml" },
        "Bf109T改" => { tr => "Bf 109T Kai", desc => "mst_slotitem.xml" },
        "FuMO25 レーダー" => { tr => "FuMO25 Radar", desc => "mst_slotitem.xml" },
        "Fw190T改" => { tr => "Fw 190T Kai", desc => "mst_slotitem.xml" },
        "Ju87C改" => { tr => "Ju 87C Kai", desc => "mst_slotitem.xml" },
        "OTO 152mm三連装速射砲" => { tr => "OTO 152mm Triple Rapid Fire Gun Mount", desc => "mst_slotitem.xml" },
        "SKC34 20.3cm連装砲" => { tr => "SKC34 20.3cm Twin Gun Mount", desc => "mst_slotitem.xml" },
        "WG42 (Wurfgerät 42)" => { tr => "", desc => "mst_slotitem.xml" },

        "オートジャイロ" => { tr => "Autogyro", desc => "mst_slotitem_equiptype.xml" },
        "ソナー" => { tr => "Sonar", desc => "mst_slotitem_equiptype.xml" },
        "上陸用舟艇" => { tr => "Daihatsu", desc => "mst_slotitem_equiptype.xml" },
        "中口径主砲" => { tr => "Primary Armament", desc => "mst_slotitem_equiptype.xml" },
        "副砲" => { tr => "Secondary Armament", desc => "mst_slotitem_equiptype.xml" },
        "司令部施設" => { tr => "Fleet Command", desc => "mst_slotitem_equiptype.xml" },
        "大口径主砲（II）" => { tr => "Large-Calibur Main Gun (II)", desc => "mst_slotitem_equiptype.xml" },
        "大口径主砲" => { tr => "Primary Armament", desc => "mst_slotitem_equiptype.xml" },
        "大型ソナー" => { tr => "Large Sonar", desc => "mst_slotitem_equiptype.xml" },
        "大型探照灯" => { tr => "Large Searchlight", desc => "mst_slotitem_equiptype.xml" },
        "大型電探（II）" => { tr => "Large Radar (II)", desc => "mst_slotitem_equiptype.xml" },
        "大型電探" => { tr => "Large Radar", desc => "mst_slotitem_equiptype.xml" },
        "大型飛行艇" => { tr => "Large Flying Boat", desc => "mst_slotitem_equiptype.xml" },
        "対地装備" => { tr => "Rocket Artillery", desc => "mst_slotitem_equiptype.xml" },
        "対潜哨戒機" => { tr => "AntiSubmarine Patrol", desc => "mst_slotitem_equiptype.xml" },
        "対空強化弾" => { tr => "AA Shell", desc => "mst_slotitem_equiptype.xml" },
        "対空機銃" => { tr => "AA Gun", desc => "mst_slotitem_equiptype.xml" },
        "対艦強化弾" => { tr => "AP Shell", desc => "mst_slotitem_equiptype.xml" },
        "小口径主砲" => { tr => "Primary Armament", desc => "mst_slotitem_equiptype.xml" },
        "小型電探" => { tr => "Small Radar", desc => "mst_slotitem_equiptype.xml" },
        "機関部強化" => { tr => "Engine Upgrades", desc => "mst_slotitem_equiptype.xml" },
        "水上偵察機" => { tr => "Reconnaissance", desc => "mst_slotitem_equiptype.xml" },
        "水上爆撃機" => { tr => "Reconnaissance", desc => "mst_slotitem_equiptype.xml" },
        "水上艦要員" => { tr => "Picket Crew", desc => "mst_slotitem_equiptype.xml" },
        "潜水艦魚雷" => { tr => "Submarine Torpedo", desc => "mst_slotitem_equiptype.xml" },
        "爆雷" => { tr => "Depth Charge", desc => "mst_slotitem_equiptype.xml" },
        "特殊潜航艇" => { tr => "Midget Submarine", desc => "mst_slotitem_equiptype.xml" },
        "簡易輸送部材" => { tr => "Supply", desc => "mst_slotitem_equiptype.xml" },
        "航空要員" => { tr => "Maintenance Team", desc => "mst_slotitem_equiptype.xml" },
        "艦上偵察機（II）" => { tr => "Ship-borne Reconnaissance Seaplane (II)", desc => "mst_slotitem_equiptype.xml" },
        "艦上偵察機" => { tr => "Reconnaissance", desc => "mst_slotitem_equiptype.xml" },
        "艦上戦闘機" => { tr => "Carrier-Based Aircraft", desc => "mst_slotitem_equiptype.xml" },
        "艦上攻撃機" => { tr => "Carrier-Based Aircraft", desc => "mst_slotitem_equiptype.xml" },
        "艦上爆撃機" => { tr => "Carrier-Based Aircraft", desc => "mst_slotitem_equiptype.xml" },
        "補給物資" => { tr => "Supply", desc => "mst_slotitem_equiptype.xml" },
        "追加装甲" => { tr => "Supply", desc => "mst_slotitem_equiptype.xml" },
        "追加装甲(中型)" => { tr => "Extension Armor", desc => "mst_slotitem_equiptype.xml" },
        "追加装甲(大型)" => { tr => "Extension Armor", desc => "mst_slotitem_equiptype.xml" },
        "高射装置" => { tr => "AA Director", desc => "mst_slotitem_equiptype.xml" },
        "魚雷" => { tr => "Torpedo", desc => "mst_slotitem_equiptype.xml" },
        "VT信管" => { tr => "Maintenance Team", desc => "mst_slotitem_equiptype.xml" },

        "工作艦" => { tr => "Repair Ship", desc => "mst_stype.xml" },
        "戦艦" => { tr => "Battleship", desc => "mst_stype.xml" },
        "揚陸艦" => { tr => "Amphibious Assault Ship", desc => "mst_stype.xml" },
        "正規空母" => { tr => "Standard Aircraft Carrier", desc => "mst_stype.xml" },
        "水上機母艦" => { tr => "Seaplane Tender", desc => "mst_stype.xml" },
        "海防艦" => { tr => "Escort Ship", desc => "mst_stype.xml" },
        "潜水母艦" => { tr => "Submarine Tender", desc => "mst_stype.xml" },
        "潜水空母" => { tr => "Submarine Aircraft Carrier", desc => "mst_stype.xml" },
        "潜水艦" => { tr => "Submarine", desc => "mst_stype.xml" },
        "練習巡洋艦" => { tr => "Training Cruiser", desc => "mst_stype.xml" },
        "航空巡洋艦" => { tr => "Aviation Cruiser", desc => "mst_stype.xml" },
        "航空戦艦" => { tr => "Aviation Battleship", desc => "mst_stype.xml" },
        "装甲空母" => { tr => "Armored Aircraft Carrier", desc => "mst_stype.xml" },
        "補給艦" => { tr => "Supply Ship", desc => "mst_stype.xml" },
        "超弩級戦艦" => { tr => "Super Dreadnought", desc => "mst_stype.xml" },
        "軽巡洋艦" => { tr => "Light Cruiser\t", desc => "mst_stype.xml" },
        "軽空母" => { tr => "Light Aircraft Carrier", desc => "mst_stype.xml" },
        "重巡洋艦" => { tr => "Heavy Cruiser", desc => "mst_stype.xml" },
        "重雷装巡洋艦" => { tr => "Torpedo Cruiser", desc => "mst_stype.xml" },
        "駆逐艦" => { tr => "Destroyer", desc => "mst_stype.xml" },

        "ドック開放キー" => { tr => "Dock Key", desc => "mst_useitem.xml" },
        "プレゼント箱" => { tr => "Present Box", desc => "mst_useitem.xml" },
        "司令部要員" => { tr => "Headquarters Personnel", desc => "mst_useitem.xml" },
        "家具コイン" => { tr => "Furniture Coin", desc => "mst_useitem.xml" },
        "家具箱（中）" => { tr => "Furniture Box (Medium)", desc => "mst_useitem.xml" },
        "家具箱（大）" => { tr => "Furniture Box (Large)", desc => "mst_useitem.xml" },
        "家具箱（小）" => { tr => "Furniture Box (Small)", desc => "mst_useitem.xml" },
        "改修資材" => { tr => "Improvement Material", desc => "mst_useitem.xml" },
        "改装設計図" => { tr => "Remodeling Blueprint", desc => "mst_useitem.xml" },
        "熟練搭乗員" => { tr => "Skilled Crew Member", desc => "mst_useitem.xml" },
        "甲種勲章" => { tr => "First Class Medal", desc => "mst_useitem.xml" },
        "秋刀魚" => { tr => "Mackerel", desc => "mst_useitem.xml" },
        "艦娘からのチョコ" => { tr => "Valentine Chocolate", desc => "mst_useitem.xml" },
        "菱餅" => { tr => "Hishimochi", desc => "mst_useitem.xml" },
        "補強増設" => { tr => "Reinforcement Expansion", desc => "mst_useitem.xml" },
        "試製甲板カタパルト" => { tr => "Prototype Flight Deck Catapult", desc => "mst_useitem.xml" },
    );
}
